Vue.use(VueLoading);
var vm = new Vue({
    el: '#fileManager',
    data() {
        return {
            dropzoneOptions: {
                url: 'loader_ajax.php?ajax=filemanager&acc=uploadFiles',
                addRemoveLinks: true,
                createImageThumbnails:false,
                maxFilesize:1024
            },
            path: "/",
            lastPath:"/",
            otherPathId:"/",
            itemPath:[],
            files: [],
            lisFind: [],
            rowsSelected:[],
            option: {
                root: {}
            },
            optionActual: {
                rootActual: {}
            },
            pathSelected:"",
            titlecopymove:"",
            contentCopymove:"",
            newPathcm:"",
            statusTree:"",
            typeMC:"",
            nameFile: "",
            nameFileCompress: "",
            nameDirectory:"",
            currentFile:'',
            titleFile: "New File",
            titleDirectory: "New Directory",
            editFileV:"",
            currentSort:'typeFile',
            currentSortDir:'asc',
            searchValue:"",
            recursive:"",
            t_total:"755",
            dragging: -1,
            owner4:"",
            owner2:"",
            owner1:"",
            group4:"",
            group2:"",
            group1:"",
            other4:"",
            other2:"",
            other1:"",
            sym_total:"",
            form: {
                chosenAction: ''
            },
            loader:"",
            currentBack:"",
            pathCompress:"",
            typeSearch:"",
            contextMenuWidth: null,
            contextMenuHeight: null,
            contextDelete:false,
            contextRename:false,
            contextDownload:false,
            contextEditor:false,
            contextDescompress:false,
            fileActual:"",
            nfiles:"0",
            nfolder:"0",
            iconsTrashha:"",
            icontrash:"inline",
            iconRestorefil:"none",
            skiptrash:"",
            skiptrashMultiple:"",
            classTrash:"label label-default",
            resolveIds:1
        }
    },
    mounted: function () {
        this.listFiles("/");
        this.listFolders("/");
        this.octalchange();
    },
    methods: {
        resolveId:function(){
            if(this.resolveIds==0){
                this.resolveIds=1;
            }else{
                this.resolveIds=0;
            }
            this.listFiles(this.otherPathId);
        },
        startLoading:function(){
            this.loader = this.$loading.show({
                // Optional parameters
                container:  null,
                canCancel: false
            });
        },
        closeLoading:function(){
            this.loader.hide();
        },
        example: function(file, message, xhr){
            console.log(file);
            console.log(message);

        },
        createPath: function(rou){
            if(rou !="/"){
                var itemPathssplit= rou.split("/");
                var namePath="";
                this.itemPath = [];
                namePath = itemPathssplit[0] + "/";
                for(var i=1; i < itemPathssplit.length ; i ++){
                    namePath += itemPathssplit[i] + "/";
                    this.itemPath.push({ name: itemPathssplit[i], pathwf: namePath});
                }
            }

        },
        editorFile:function(file){
            this.rowsSelected = [];
            window.open("codeEditor.php?filename="+encodeURI(file.pathwf), "_blank");

        },
        download:function(file){
            this.startLoading();
            window.location.href='fileManager_v2.php?action=download&file='+this.path+'/'+file.name;
            this.closeLoading();
        },
        descompressFile:function(file){
            if(file==undefined){
                file= this.currentFile;
            }
            $("#descompressFile").modal("hide");
            this.startLoading();
            var url = 'loader_ajax.php?ajax=filemanager&acc=descompress';
            const formData = new FormData();
            formData.append('fileName', file.pathwf);
            formData.append('patho', this.path);
            axios.post(url, formData).then(response => {
                this.closeLoading();
                this.listFiles(this.path);
                this.rowsSelected = [];

            });

        },
        compressFile:function(){
            if(this.rowsSelected.length==0){
                $("#ErrorModal").modal("show");
            }else{
                $("#compressFileModal").modal("show");
                this.nameFileCompress="name.zip";
                this.pathCompress=this.path;
            }

        },
        sendcompressFile:function(file){
            this.startLoading();
            var url = 'loader_ajax.php?ajax=filemanager&acc=compressFile';
            const formData = new FormData();
            formData.append('fileName', this.rowsSelected);
            formData.append('nameFile', this.nameFileCompress);
            formData.append('patho', this.pathCompress);
            formData.append('pathcomp', this.path);
            axios.post(url, formData).then(response => {
                this.closeLoading();
                this.listFiles(this.pathCompress);
                this.rowsSelected = [];
                this.nameFileCompress="";
                $("#compressFileModal").modal("hide");

            });

        },
        sort:function(s) {
            //if s == current sort, reverse
            if(s === this.currentSort) {
                this.currentSortDir = this.currentSortDir==='asc'?'desc':'asc';
            }
            this.currentSort = s;
        },
        changeNmae:function(valor,text){
            if(valor==1){
                this.titleDirectory=text;
            }else{
                this.titleFile=text;
            }
        },
        editFile: function(node){
            // this.currentFile=this.path+node.name;
            if(node.typeFile=='file'){
                this.titleFile="Rename File";
            }else{
                this.titleFile="Rename Directory";
            }
            this.editFileV=this.path+"/"+node.name;
            $("#create").modal("show");
            this.nameFile  = node.name;
            this.rowsSelected = [];
        },
        cleanValues:function(){
            this.editFileV="";
            this.nameFile  = "";
            this.nameFileCompress="";
            this.rowsSelected = [];
        },
        changeCompression:function(valueInp){
            var changevalue=this.nameFileCompress;
            var res = changevalue.split('.');
            this.nameFileCompress=res[0]+valueInp;
        },
        createDirectory: function () {
            this.startLoading();
            var url = 'loader_ajax.php?ajax=filemanager&acc=createDirectory';
            const formData = new FormData();
            formData.append('nameDirectory', this.nameDirectory);
            formData.append('patho', this.path);
            axios.post(url, formData).then(response => {
                this.closeLoading();
                this.listSubtwo(this.path);
                this.listFiles(this.path);
                this.nameDirectory="";
                $('#createDir').modal('hide');
                this.rowsSelected = [];

            });
        },
        createFile: function () {
            this.startLoading();
            const formData = new FormData();
            if(this.editFileV!=""){
                var url = 'loader_ajax.php?ajax=filemanager&acc=renameFile';
                formData.append('editFile', this.editFileV);
            }else{
                var url = 'loader_ajax.php?ajax=filemanager&acc=createFile';
            }


            formData.append('fileName', this.nameFile);
            formData.append('patho', this.path);
            axios.post(url, formData).then(response => {
                this.nameFile="";
                this.editFileV="";
                this.closeLoading();
                this.listFiles(this.path);
                $('#create').modal('hide');
                this.rowsSelected = [];

            });
            //alert('Create File');
        },
        remove: function () {
            this.startLoading();
            var url = 'loader_ajax.php?ajax=filemanager&acc=remove';
            const formData = new FormData();
            formData.append('fileName', this.currentFile);
            formData.append('patc', this.path);
            formData.append('skiptrash',this.skiptrash);
            axios.post(url, formData).then(response => {
                this.currentFile="";
                this.closeLoading();
                this.listFiles(this.path);
                this.listFolders("/");
                $('#deleteDir').modal('hide');
                this.rowsSelected = [];
                this.skiptrash=false;
            });

        },
        findFiles:function(){
            this.startLoading();
            var url = 'loader_ajax.php?ajax=filemanager&acc=findFiles';
            const formData = new FormData();
            formData.append('searchValue', this.searchValue);
            formData.append('typeSearch', this.typeSearch);
            formData.append('current', this.path+"/");
            axios.post(url, formData).then(response => {
                $('#listFind').modal('show');
                this.lisFind=response.data.filesList;
                this.closeLoading();
            });
        },
        deleteFile: function (node){
            this.currentFile=this.path+"/"+node.name;
            $("#deleteDir").modal("show");
            this.rowsSelected = [];
        },
        openDescompress: function(file){
            this.currentFile=file;
            $("#descompressFile").modal("show");
            //this.descompressFile(fileActual);
        },
        contextAction:function(value){
            if(value=='delete'){
                this.deleteFile(fileActual);
            }
            if(value=='rename'){
                this.editFile(fileActual);
            }
            if(value=='download'){
                this.download(fileActual);
            }
            if(value=='editor'){
                this.editorFile(fileActual);
            }
            if(value=='descompress'){
                this.openDescompress(fileActual);
            }

            if(value=='move'){
                this.unselectAllRow();
                this.selectOneRow(fileActual);
                this.copymoveMultipleFile('Moved');
            }
            if(value=='copy'){
                this.unselectAllRow();
                this.selectOneRow(fileActual);
                this.copymoveMultipleFile('Copy');
            }
            if(value=='permissions'){
                this.unselectAllRow();
                this.selectOneRow(fileActual);
                this.changeModalPerm();
            }

            this.hideContextMenu();
            fileActual="";
        },
        restoreFileTrash: function(){
            if(this.rowsSelected.length==0){
                $("#ErrorModal").modal("show");
            }else{
                $("#restoreTrashone").modal("show");
            }
        },
        restoreTrash: function(){
            this.startLoading();
            var url = 'loader_ajax.php?ajax=filemanager&acc=restoreTrash';
            const formData = new FormData();
            formData.append('fileName', this.rowsSelected);
            formData.append('patho', this.path);
            axios.post(url, formData).then(response => {

                this.statusTree="";
                this.rowsSelected = [];
                $('#restoreTrashone').modal('hide');
                this.closeLoading();
                this.listFiles(this.path);
            });
        },
        changeModalPerm:function(){
            if(this.rowsSelected.length==0){
                $("#ErrorModal").modal("show");
            }else{
                if(this.rowsSelected.length==1){
                    for (let i in this.files) {
                        if(this.files[i].name ==this.rowsSelected[0]){
                            this.t_total=this.files[i].p;
                        }

                    }
                }else{
                    this.t_total="755";
                }

                $("#changepermision").modal("show");
                this.octalchange();
            }
        },
        deleteMultipleFile:function(){
            if(this.rowsSelected.length==0){
                $("#ErrorModal").modal("show");
            }else{
                $("#deleteDirMultiple").modal("show");
            }

        },
        calc_chmod:function(nototals) {
            var users = new Array("owner", "group", "other");
            var totals = new Array("","","");
            var syms = new Array("","","");

            for (var i=0; i<users.length; i++)
            {
                var user=users[i];
                var field4 = user + "4";
                var field2 = user + "2";
                var field1 = user + "1";
                //var total = "t_" + user;
                var symbolic = "sym_" + user;
                var number = 0;
                var sym_string = "";

                if ($("#"+field4).prop("checked") == true) { number += 4; }
                if ($("#"+field2).prop("checked") == true) { number += 2; }
                if ($("#"+field1).prop("checked") == true) { number += 1; }

                if ($("#"+field4).prop("checked") == true) {
                    sym_string += "r";
                } else {
                    sym_string += "-";
                }
                if ($("#"+field2).prop("checked") == true) {
                    sym_string += "w";
                } else {
                    sym_string += "-";
                }
                if ($("#"+field1).prop("checked") == true) {
                    sym_string += "x";
                } else {
                    sym_string += "-";
                }
                totals[i] = totals[i]+number;
                syms[i] =  syms[i]+sym_string;

            }
            if (!nototals) this.t_total = totals[0] + totals[1] + totals[2];
            this.sym_total = "-" + syms[0] + syms[1] + syms[2];
        },
        octalchange: function (){

            var val = this.t_total;
            var ownerbin = parseInt(val.charAt(0)).toString(2);
            while (ownerbin.length<3) { ownerbin="0"+ownerbin; };
            var groupbin = parseInt(val.charAt(1)).toString(2);
            while (groupbin.length<3) { groupbin="0"+groupbin; };
            var otherbin = parseInt(val.charAt(2)).toString(2);
            while (otherbin.length<3) { otherbin="0"+otherbin; };

            $("#owner4").prop("checked",parseInt(ownerbin.charAt(0)));
            $("#owner2").prop("checked",parseInt(ownerbin.charAt(1)));
            $("#owner1").prop("checked",parseInt(ownerbin.charAt(2)));

            $("#group4").prop("checked",parseInt(groupbin.charAt(0)));
            $("#group2").prop("checked",parseInt(groupbin.charAt(1)));
            $("#group1").prop("checked",parseInt(groupbin.charAt(2)));

            $("#other4").prop("checked",parseInt(otherbin.charAt(0)));
            $("#other2").prop("checked",parseInt(otherbin.charAt(1)));
            $("#other1").prop("checked",parseInt(otherbin.charAt(2)));

            this.calc_chmod(1);
        },
        changePermision:function(){
            this.startLoading();
            var url = 'loader_ajax.php?ajax=filemanager&acc=changePerm';
            const formData = new FormData();
            formData.append('fileName', this.rowsSelected);
            formData.append('currentPath', this.path);
            formData.append('recursive', this.recursive);
            formData.append('t_total', this.t_total);
            axios.post(url, formData).then(response => {
                this.rowsSelected = [];
                this.closeLoading();
                this.listFiles(this.path);
                $('#changepermision').modal('hide');

            });
        },
        copyMovemultiple:function(){
            this.startLoading();
            $('#copymoveMultiple').modal('hide');
            var url = 'loader_ajax.php?ajax=filemanager&acc='+this.typeMC;
            const formData = new FormData();
            formData.append('fileName', this.rowsSelected);
            formData.append('currentPath', this.path);
            formData.append('newPath', this.newPathcm);
            axios.post(url, formData).then(response => {

                this.statusTree="";
                this.rowsSelected = [];

                this.closeLoading();
                this.listFiles(this.newPathcm);
                this.newPathcm="";
            });
        },
        restartValues:function(){
            this.newPathcm="";
            this.statusTree="";
            $("#copymoveMultiple").modal("hide");
            $("#movedragdrop").modal("hide");
        },
        copymoveMultipleFile:function(typed){
            if(this.rowsSelected.length==0){
                $("#ErrorModal").modal("show");
            }else {
                if (typed == 'Moved') {
                    this.titlecopymove = "Move Selected Files";
                    this.contentCopymove = "Are you sure you move the following files?";
                    this.typeMC = "movefiles";
                } else {
                    this.titlecopymove = "Copy Selected Files";
                    this.contentCopymove = "Are you sure you copy the following files?";
                    this.typeMC = "copyfiles";
                }
                this.statusTree = 1;
                $("#copymoveMultiple").modal("show");
            }
        },
        removeMultiple: function () {
            this.startLoading();
            var url = 'loader_ajax.php?ajax=filemanager&acc=removeMultiple';
            const formData = new FormData();
            formData.append('fileName', this.rowsSelected);
            formData.append('patho', this.path);
            formData.append('skiptrash',this.skiptrashMultiple);
            axios.post(url, formData).then(response => {
                this.closeLoading();
                this.listFiles(this.path);
                this.listFolders("/");
                $('#deleteDirMultiple').modal('hide');
                this.rowsSelected = [];
                this.skiptrashMultiple=false;
            });
        },
        dragEnter(ev){
            //console.log("me acitve dragEnter");
            this.currentBack=ev.target.parentElement.style.background;
            ev.target.parentElement.classList.add('enterDrag');
        },
        dragLeave(ev){
            //console.log("me acitve dragLeave");
            $("li.parent_li ul").css("background","none");
            $("li.parent_li").css("background","none");
            $("li.parent_li span").css("background","none");
            $("li.parent_li span a").css("background","none");
            ev.target.parentElement.classList.remove('enterDrag');
        },
        moveDrag:function(){
            this.startLoading();
            var url = 'loader_ajax.php?ajax=filemanager&acc=movefiles';
            const formData = new FormData();
            formData.append('fileName', this.rowsSelected);
            formData.append('currentPath', this.path);
            formData.append('newPath', this.pathSelected);
            axios.post(url, formData).then(response => {
                this.closeLoading();
                this.rowsSelected = [];
                this.pathSelected="";
                this.listFiles(this.path);
                this.listFolders("/");
                $('#movedragdrop').modal('hide');
                $("li.parent_li ul").css("background","none");
                $("li.parent_li").css("background","none");
                $("li.parent_li span").css("background","none");
                $("li.parent_li span a").css("background","none");
                $("#user-table tr").removeClass("enterDrag");

            });
        },
        selectOneRowDgrag:function(file){
            if(file.selected){
                file.selected=true;
            }else{
                file.selected=true;
                this.rowsSelected.push(file.name);
            }
        },
        selectOneRow:function(file){
            if(file.selected){
                file.selected=false;
                this.rowsSelected.splice(this.rowsSelected.indexOf(file.name), 1);
            }else{
                file.selected=true;
                this.rowsSelected.push(file.name);
            }
        },
        selectAllRow:function(){
            this.rowsSelected = [];
            //if (!this.selectAll) {
            for (let i in this.files) {
                this.files[i].selected=true;
                this.rowsSelected.push(this.files[i].name);
            }

            //  }
        },
        unselectAllRow:function(){
            this.rowsSelected = [];
            //if (!this.selectAll) {
            for (let i in this.files) {
                this.files[i].selected=false;
                this.rowsSelected=[];
            }

            //  }
        },
        listFolders: function (currentDirF){

            var url = 'loader_ajax.php?ajax=filemanager&acc=lisFolder&dir=' + currentDirF;
            axios.get(url).then(response => {
                this.option.root = response.data.folderList;
            });

        },
        listSubtwo: function (dir){
            var url = 'loader_ajax.php?ajax=filemanager&acc=lisSub&dir=' + dir;

            Object.values(option).forEach(val => {
                console.log(val);
            });
           /* node._loading = true;

            axios.get(url).then(response => {
                var results = response.data["folderList"];
                node._loading = false; //Finish Ajax
                Vue.set(node, 'children', []); // Clean old data
                for(var i = 0; i < results.length; i++){
                    // console.log(results[i].name);
                    node.children.push({ name: results[i].name,isParent:true,showLoading:true, isOpen:false,openedIcon:"fa fa-folder-open",closedIcon:"fa fa-folder",id:results[i].id, parent: node,isParent: true,children: []});
                }

            });*/
        },
        listSub: function (node,flagi){
            var fla=0;
            if(flagi==1 &&  this.statusTree==1){
                fla=1;
            }
            var url = 'loader_ajax.php?ajax=filemanager&acc=lisSub&dir=' + node.id;
            node._loading = true;
            axios.get(url).then(response => {
                var results = response.data["folderList"];
                node._loading = false; //Finish Ajax
                Vue.set(node, 'children', []); // Clean old data
                for(var i = 0; i < results.length; i++){
                    // console.log(results[i].name);
                    node.children.push({ name: results[i].name,isParent:true,showLoading:true, isOpen:false,openedIcon:"fa fa-folder-open",closedIcon:"fa fa-folder",id:results[i].id, parent: node,isParent: true,children: []});
                }
                if(fla==0){
                    this.path=node.id;
                }
            });
        },
        emptytrash: function (currentDir,other) {
            this.startLoading();
            var url = 'loader_ajax.php?ajax=filemanager&acc=emptyTrash&currentDir=/.trash';
            axios.get(url).then(response => {
                this.listFiles('/.trash');
                $('#deleteDirTrash').modal('hide');
            });
            this.path='/.trash';
            this.createPath(this.path);
            this.closeLoading();
        },
        listFiles: function (currentDir,other) {
            //var currentDir = ;
            if(currentDir.indexOf("/.trash/") !="-1" || currentDir.indexOf("/.trash")!="-1"){
                this.icontrash="none";
                this.iconRestorefil="inline";
                this.iconsTrashha="none";
            }else{
                this.iconRestorefil="none";
                this.icontrash="inline"
                this.iconsTrashha="block";
            }
            this.lastPath=this.path;
            if(this.statusTree!="1"){
                this.rowsSelected = [];
                if(other!='file'){
                    this.startLoading();
                    var url = 'loader_ajax.php?ajax=filemanager&acc=listFiles&resolveIds='+this.resolveIds+'&currentDir=' + currentDir;
                    axios.get(url).then(response => {
                        this.currentSort='typeFile';
                        this.currentSortDir='asc';
                       // this.files = response.data.filesList;
                        this.files= [];
                        let contador=0;

                        for (let i = 0; i < response.data.filesList.length; i++) {
                            this.files.push(response.data.filesList[i]);

                            if(i== 10000){
                                break;
                            }
                        }
                        this.rowsSelected = [];
                        this.unselectAllRow();
                        $('#listFind').modal('hide');
                        this.closeLoading();
                        $('#lisfiledos').show();
                        this.nfiles=response.data.nfile;
                        this.nfolder=response.data.nfolder;
                        if(response.data.trashFiles>=1){
                            this.classTrash="label label-danger";
                        }else{
                            this.classTrash="label label-default";
                        }
                    });
                    this.path=currentDir;
                    this.createPath(this.path);
                    // this.closeLoading();
                }
                this.rowsSelected = [];
                this.unselectAllRow();
                $('.dz-preview').empty();
                $('.dz-message').show();
                this.otherPathId=currentDir;
            }else{
                //statusTree="";
                this.newPathcm=currentDir;
            }
        },
        regenerate:function(file){
            file.rname=file.name;
        },
        Testing:function(file){
            if(file.name != file.rname){

                this.startLoading();
                const formData = new FormData();
                var url = 'loader_ajax.php?ajax=filemanager&acc=renameFile';
                formData.append('editFile', this.path+"/"+file.name);
                formData.append('fileName', file.rname);
                formData.append('patho', this.path);
                axios.post(url, formData).then(response => {
                    this.closeLoading();
                    this.listFiles(this.path);
                    this.rowsSelected = [];
                });


            }

        },
        dragado:function(fileDra,fileType) {

            if(fileType=='directory') {
                var res = fileDra;
                var resdos = res.replace("//", "/");
                this.pathSelected = resdos;
                $("#movedragdrop").modal("show");
                $("li.parent_li").css("background", "none");
                $("li.parent_li span").css("background", "none");
                $("li.parent_li span a").css("background", "none");
                $("li.parent_li ul").css("background", "none");
                $("#user-table").removeClass("table-striped");
                $("#user-table").addClass("table-striped");
            }
        },
        showContextMenu: (event,file) => {
            this.fileActual=file;
            document.getElementById("contextDelete").style.display=(file.delete=='inline')?"block":file.delete;
            document.getElementById("contextDownload").style.display=(file.downloads=='inline')?"block":file.downloads;
            document.getElementById("contextEditor").style.display=(file.edit=='inline')?"block":file.edit;
            document.getElementById("contextDescompress").style.display=(file.decompress=='inline')?"block":file.decompress;
            document.getElementById("contextRename").style.display=(file.rename=='inline')?"block":file.rename;
            var menu = document.getElementById("context-menu");
            if(!this.contextMenuWidth || !this.contextMenuHeight) {
                menu.style.visibility = "hidden";
                menu.style.display = "block";
                this.contextMenuWidth = menu.offsetWidth;
                this.contextMenuHeight = menu.offsetHeight;
                menu.removeAttribute("style");
            }

            var body = document.body,
                html = document.documentElement;

            var height = Math.max( body.scrollHeight, body.offsetHeight,
                html.clientHeight, html.scrollHeight, html.offsetHeight );

            if(this.event.pageY+178 >= height){
                menu.style.top = (this.event.pageY - 210) + "px";
            }else{
                menu.style.top = (this.event.pageY - 75 ) + "px";
            }
            menu.style.left = (this.event.pageX - 230 ) + "px";


            menu.classList.add('active');
        },
        hideContextMenu: () => {

            document.getElementById("context-menu").classList.remove('active');
        }
    },
    computed:{
        sortedCats:function() {
            return this.files.sort((a,b) => {
                let modifier = 1;
                if(this.currentSortDir === 'desc') modifier = -1;

                if(this.currentSort=='datet'){

                    if(a[this.currentSort]==''){
                        var variableA='01/01/90 00:00';
                    }else{
                        var variableA=a[this.currentSort];
                    }
                    if(b[this.currentSort]==''){
                        var variableB='01/01/90 00:00';
                    }else{
                        var variableB=b[this.currentSort];
                    }

                    var datumA = variableA.split(' ');
                    var fechaA = datumA[0].split('/');
                    var aDate= fechaA[2]+"-"+fechaA[1]+"-"+fechaA[0]+" "+datumA[1];

                    var datumB = variableB.split(' ');
                    var fechaB = datumB[0].split('/');
                    var bDate= fechaB[2]+"-"+fechaB[1]+"-"+fechaB[0]+" "+datumB[1];

                    if(aDate < bDate) return -1 * modifier;
                    if(aDate > bDate) return 1 * modifier;
                }else{
                    if(a[this.currentSort] < b[this.currentSort]) return -1 * modifier;
                    if(a[this.currentSort] > b[this.currentSort]) return 1 * modifier;
                }
                return 0;

            });
        },
        computedAction: function() {
            return 'loader_ajax.php?ajax=filemanager&acc=uploadFiles&path='+this.path
        }
    },
    directives: {
        focus: {
            inserted (el) {
                el.focus()
            }
        }
    }
})
