const LOADER_HTML = '<div class="action-loader">' +
                        '<span><i class="fa fa-circle-o-notch fa-spin"></i></span>' +
                        '<h5 id="">{{lang.LABAPACHEB13}}...</h5>' +
                    '</div>';
let compiling_log_lines = [];
let compiling_log_timeout = null;
let current_version = '{{mod_vars.apache_info.exact_version}}';
const INTERVAL_CHECK_STATUS = 1500;
function showLoadedModules(){
    $('#_modal_apache_modules_ .modal-body').html(LOADER_HTML);
    $('#_modal_apache_modules_').modal('show');
    loadApacheModules(function(response){
        $('#_modal_apache_modules_ .modal-body .action-loader').fadeOut('fast', function(){
            $('#_modal_apache_modules_ .modal-body').html('<div id="_modal_apache_modules_container_"><h5>{{lang.LABAPACHEB19}}:</H5>' + response.modules + '</div>');
        });
    }, function(){
        $('#_modal_apache_modules_').modal('hide');
    });
}
let addons_editor = null;
function confirmApacheRebuild(){
    $('#_btn_start_apache_rebuild_').prop('disabled', true);
    let version = $('#_apache_version_select_').val();
    $('#_modal_apache_confirm_rebuild_ .modal-header .modal-title').text('Apache ' + version + ' & suPHP 0.7.2 Compiler');
    $('#_modal_apache_rebuild_options_').hide();
    $('#_modal_apache_rebuild_loader_').show()
    $('#_modal_apache_confirm_rebuild_').modal('show');
    loadOptionsForBuild($('#_apache_version_select_').val(), function(response){
        $('#_modal_apache_rebuild_options_').html('<h5>{{lang.LABAPACHEB20}}: <a href="http://forum.centos-webpanel.com/apache/apache-compiler/" target="_blank">{{lang.LABAPACHEB21}}</a></h5>' + 
                                                    '<h5>{{lang.LABAPACHEB22}}:</h5>' +
                                                    '<input type="hidden" value="' + version + '" id="_apache_build_version_selected_">' +
                                                    '<textarea id="_modal_apache_rebuild_options_textarea_" class="">' + response.addons + '</textarea>' +
                                                    '<div class="checkbox-flv-builder"><input type="checkbox" name="mod_h264" id="_checkbox_mod_h264_" value="h264"> <label for="_checkbox_mod_h264_">{{lang.LABAPACHEB23}}</label></div>'
                                                    );
        addons_editor = CodeMirror.fromTextArea(document.getElementById("_modal_apache_rebuild_options_textarea_"), {
            lineNumbers: true,
            matchBrackets: true,
            styleActiveLine: true,
            theme: "ambiance",
        });
        
        $('#_modal_apache_rebuild_loader_').fadeOut('fast', function(){
            $('#_modal_apache_rebuild_options_').fadeIn('fast', function(){
                addons_editor.refresh();
                addons_editor.focus();
            });
        });
        $('#_btn_start_apache_rebuild_').prop('disabled', false);
    }, function(){ 
        $('#_modal_apache_confirm_rebuild_').modal('hide');
    });
}
function startApacheBuild(elem){
    $('#_modal_apache_confirm_rebuild_ .modal-footer .btn-warning').prop('disabled', true);
    handleButtons(elem, 'fa-check');
    let data_rebuild = 'version=' + $('#_apache_build_version_selected_').val() + '&addons=' + 
                        encodeURIComponent(addons_editor.getValue()) + "&mod_h264=" + ($('#_checkbox_mod_h264_').is(':checked') ? '1' : '0')
    function reEnable(){
        $('#_modal_apache_confirm_rebuild_ .modal-footer .btn-warning').prop('disabled', false);
        handleButtons(elem, 'fa-check', true);
    }
    sendStartApacheBuild(data_rebuild, function(){
        $.gritter.add({
            title: '{{lang.LABAPACHEB24}}',
            text: '{{lang.LABAPACHEB25}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        reEnable();
        $('#_modal_apache_confirm_rebuild_').modal('hide');
        compileStarted();
    }, function(){
        reEnable();
    });
}
function compileStarted(){
    $('.installer-selector-container').fadeOut('fast', function(){
        $('#_compiling_loader_wrapper_').fadeIn('fast');
    });
    $('#_modal_compiling_log_container_').html('');
    $('#_modal_apache_compiling_log_ .compiling-loader').show();
    checkCompilingStatus();
}
function viewCompilingLog() {
    $('#_modal_apache_compiling_log_').modal('show');
}
function handleButtons(elem, icon_fa, type) {
    let icon = $(elem).find('.fa');
    if (type == undefined) {
        $(elem).addClass('disabled');
        $(elem).prop('disabled', true);
        icon.removeClass(icon_fa);
        icon.addClass('fa-spinner fa-spin');
    } else {
        icon.removeClass('fa-spinner fa-spin');
        icon.addClass(icon_fa);
        $(elem).removeClass('disabled');
        $(elem).prop('disabled', false);
    }
}
function rederStatusCompile(response) {
    compilingLogHandler(response);
    if (response.status == 'running') {
        setTimeout(function () {
            checkCompilingStatus();
        }, INTERVAL_CHECK_STATUS);
    }
}
function renderLogLine() {
    let log_line = '<p>' + compiling_log_lines[0] + '</p>';
    compiling_log_lines.shift();
    $('#_modal_compiling_log_container_').append(log_line);
    $("#_modal_compiling_log_container_ p").last().attr("tabindex", -1).focus();
}
function compilingLogHandler(response) {
    function addLineToLog() {
        if (compiling_log_lines.length > 0) {
            if (compiling_log_lines.length > 1000) {
                $('#_modal_compiling_log_container_').append('<p>' + compiling_log_lines.slice(0, 1000).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 1000);
            } else if (compiling_log_lines.length > 500) {
                $('#_modal_compiling_log_container_').append('<p>' + compiling_log_lines.slice(0, 500).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 500);
            } else if (compiling_log_lines.length > 400) {
                $('#_modal_compiling_log_container_').append('<p>' + compiling_log_lines.slice(0, 400).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 400);
            } else if (compiling_log_lines.length > 300) {
                $('#_modal_compiling_log_container_').append('<p>' + compiling_log_lines.slice(0, 300).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 300);
            } else if (compiling_log_lines.length > 200) {
                $('#_modal_compiling_log_container_').append('<p>' + compiling_log_lines.slice(0, 200).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 200);
            } else if (compiling_log_lines.length > 100) {
                $('#_modal_compiling_log_container_').append('<p>' + compiling_log_lines.slice(0, 100).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 100);
            } else {
                $('#_modal_compiling_log_container_').append('<p>' + compiling_log_lines[0] + '</p>');
                $("#_modal_compiling_log_container_ p").last().attr("tabindex", -1).focus();
                compiling_log_lines.shift();
            }
            let time_interval = 10;
            /*if (compiling_log_lines.lenght > 100 && compiling_log_lines.lenght < 500){
                time_interval = 6
            } else if (compiling_log_lines.lenght >= 500 && compiling_log_lines.lenght < 900){
                time_interval = 2
            }else{
                time_interval = 1
            }*/
            setTimeout(function () {
                addLineToLog();
            }, time_interval)
        } else {
            compiling_log_timeout = null;
            if (response.status != 'running') {
                endCompile();
            }
        }
    }
    function endCompile() {
        $.gritter.add({
            title: '{{lang.LABAPACHEB24}}',
            text: '{{lang.LABAPACHEB26}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        $('#_modal_apache_compiling_log_ .compiling-loader').fadeOut('fast');
        $('#_compiling_loader_wrapper_').fadeOut('fast', function () {
            $('#_apache_version_select_ option:contains("' + current_version + '")').text('Apache ' + current_version + ' & suPHP 0.7.2');
            $('#_apache_version_select_ option:contains("' + response.apache_info.exact_version + '")').text('Apache ' + response.apache_info.exact_version + ' & suPHP 0.7.2 (current version)');
            $('.installer-selector-container').fadeIn('fast');
        });
        $('#_dashboard_apache_version_container').text(response.apache_info.version);
        $('#_dashboard_apache_date_container').text(response.apache_info.compile_date);
        //php_versions_installed = response.php_versions_installed;
        //$('#_btn_view_last_build_log_').fadeIn('fast');
        //renderPHpVersionList();
    }
    compiling_log_lines = compiling_log_lines.concat(response.lines);

    if (compiling_log_timeout === null) {
        addLineToLog()
    }
}
$(document).ready(function () {
    {% if mod_vars.is_apache_compiling == true %}
    checkCompilingStatus();
    {% endif %}
    $('html').on('mouseup', function (e) {
        if (!$(e.target).closest('.popover').length) {
            $('.popover').each(function () {
                $(this.previousSibling).popover('hide');
            });
        }
    });
});
{% include 'js/apache_builder_services.js' %}