function sendStartApacheBuild(data_rebuild, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=apache_builder&acc=start_builder",
        data: data_rebuild,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: 'Error',
                    text: 'Unknown error ocurred.',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = 'Unknown error ocurred.';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = 'Apache re-building already running.';
                    }else if (resp_data.code == 2) {
                        message_error = 'Invalid version.';
                    }
                }
                $.gritter.add({
                    title: 'Error',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function loadOptionsForBuild(version, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=apache_builder&acc=get_build_options",
        data: 'apache_version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: 'Error',
                    text: 'Unknown error ocurred.',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = 'Unknown error ocurred.';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: 'Error',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function loadApacheModules(success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=apache_builder&acc=get_modules",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: 'Error',
                    text: 'Unknown error ocurred.',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = 'Unknown error ocurred.';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: 'Error',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function checkCompilingStatus() {
    function localCall() {
        setTimeout(function () {
            checkCompilingStatus();
        }, INTERVAL_CHECK_STATUS);
    }
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=apache_builder&acc=check_compile_status",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                localCall();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                rederStatusCompile(resp_data);
            } else {
                localCall();
            }
        }
    });
}