const LOADER_HTML = '<div class="module-policy-loader">' +
                        '<div class="action-loader">' +
                            '<span><i class="fa fa-circle-o-notch fa-spin"></i></span>' +
                            '<h5 id="">{{lang.LABKERNEL32}}...</h5>' +
                        '</div>' +
                    '</div>';
let policies_tables_map = {};
let all_policies_status = null;
let installed_rules_version = {{mod_vars.installed_rules_version}};
let lastest_rules_version = {{mod_vars.lastest_rules_version}};
function loadModulePolicies(module, tab, unlist){
    $(tab + ' .policy-container').html(LOADER_HTML);
    $(tab + ' .policy-container .module-policy-loader').fadeIn('fast', function(){
        getModulePolicies(module, function (response) {
            renderModulePolicies(response.policies, module, tab, unlist);
        }, function () {
            errorModulePolicies(module, tab, unlist);
        }, unlist);
    });
    
}

function errorModulePolicies(module, tab, unlist){
    let html_content = '<div id="_kernel_empty_module_' + module + '_" class="empty-policies-container">' +
                            '<i class="fa fa-exclamation-triangle text-warning empty-policies-container-ico"></i>' +
                            '<h4>' + (unlist === undefined ? '{{lang.LABKERNEL33}}' : '{{lang.LABKERNEL34}}') + '</h4>' + 
                            '<button onclick="retryGetModulePolicies(\'' + module + '\', \'' + tab + '\', ' + unlist + ')" class="btn btn-primary btn-md">' +
                                '<i class="fa fa-refresh"></i> {{lang.LABKERNEL35}}' 
                            '</button>'
                        '</div>';
    $(tab + ' .policy-container .module-policy-loader').fadeOut('fast', function(){
        $(tab + ' .policy-container').html(html_content);
    });
}
function retryGetModulePolicies(module, tab, unlist){
    $('#_kernel_empty_module_' + module + '_').fadeOut('fast', function(){
        loadModulePolicies(module, tab, unlist);
    });
}
function policyTabChanged(tab_elem){
    if(tab_elem.data('module') != 'unlist'){
        if (!policies_tables_map.hasOwnProperty(tab_elem.data('module'))) {
            loadModulePolicies(tab_elem.data('module'), tab_elem.attr('href'));
        }
    }else{
        let module_name = $('#_unlist_rules_tabs_ .active a').data('module');
        let tab_ref = $('#_unlist_rules_tabs_ .active a').attr('href');
        if (!policies_tables_map.hasOwnProperty(module_name + '_unlist')) {
            loadModulePolicies(module_name, tab_ref, true);
        }
        
    } 
}
function unlistTabChanged(tab_elem){
    if (!policies_tables_map.hasOwnProperty(tab_elem.data('module') + '_unlist')) {
        loadModulePolicies(tab_elem.data('module'), tab_elem.attr('href'), true);
    }
}
function notificationEmailChanged(elem){
    if($(elem).is(':checked')){
        $('#_noti_check_email_input_').slideDown('fast');
    }else{
        $('#_noti_check_email_input_').slideUp('fast');
    }
}
function changedRuleStatus(elem){
    let check_active = $(elem).is(':checked');
    let module = $(elem).data('module');
    let file_name = $(elem).data('file');
    let loader = $(elem).closest('.toggle-custom').find('.checkbox-status-change-loader-container');
    //console.log($(elem).parent().find('.checkbox-status-change-loader-container'));
    loader.fadeIn('fast', function(){
        sendRuleStatusChange(module, file_name, (check_active ? 'enable' : 'disable'), function(){
            $.gritter.add({
                title: '{{lang.LABKERNEL36}}',
                text: '{{lang.LABKERNEL37}}',
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-checkmark',
                class_name: 'success-notice'
            });
            if($(elem).data('unlisted') === undefined){
                delete policies_tables_map[module + '_unlist'];
            } else if ($(elem).data('unlisted') !== undefined && check_active === true) {
                $(elem).closest('.policy-module-tr').slideUp('fast', function () {
                    policies_tables_map[module + '_unlist'].row(this).remove().draw();
                    if (policies_tables_map.hasOwnProperty(module)) {
                        delete policies_tables_map[module];
                    }
                });
            }
            loader.fadeOut('fast');
            $('#_kernel_apply_changes_btn_').prop('disabled', false);
        }, function(){
            loader.fadeOut('fast');
            $(elem).prop('checked', !check_active);
        });
    });
}
function showNotificationsConfig(){
    $('#_modal_kernel_notifications_').modal('show');
}
function renderModulePolicies(policies, module, tab, unlist){
    let html_policies = '';
    if(policies.length > 0){
        let index = 0;
        let uniq_module = module + (unlist === true ? '_unlist' : '');
        policies.forEach(function (policy) {
            let checked_status = '';
            if (policy.status === true) {
                checked_status = 'checked';
            }
            html_policies += '<tr class="policy-module-tr" id="_policy_' + uniq_module + '_' + index + '_">' +
                                '<td>' + 
                                    /*'<span data-toggle="tooltip" data-placement="top" data-title="Click to view details">' +
                                        '<span class="fa-stack info-policy fa-sm" data-toggle="popover" data-content="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam porttitor nulla a ante aliquet lobortis. Pellentesque nec finibus nisl." data-placement="top" title="Policy Details">' +
                                            '<i class="fa fa-circle text-primary fa-stack-2x"></i>' +
                                            '<i class="fa fa-info fa-stack-1x fa-inverse"></i>' +
                                        '</span>' + 
                                    '</span>' + */
                                    policy.name_policy + 
                                '</td>' +
                                '<td>' +
                                    '<div class="toggle-custom toggle-inline">' +
                                        '<div class="checkbox-status-change-loader-container">' + 
                                            '<div class="checkbox-status-change-loader">' +
                                                '<i class="fa fa-circle-o-notch fa-spin text-primary"></i>' + 
                                            '</div>' +
                                        '</div>' +  
                                        '<label class="toggle tip" data-original-title="ON/OFF" data-on="ON" data-off="OFF">' +
                                        '<input class="checkbox-policy-item" ' + (unlist === true ? 'data-unlisted="true"' : '') + ' type="checkbox" id="st_' + policy.file_name + '" ' + checked_status + ' onchange="changedRuleStatus(this)" data-file="' + (module != 'web_servers' ? module : 'web-server') + '_' + policy.file_name + '.domain" data-module="' + module + '">' +
                                        '<span class="button-checkbox"></span>' +
                                        '<input type="hidden" id="val_' + policy.file_name + '" value="' + policy.status + '">' +
                                        '</label>' +
                                    '</div>' +
                                '</td>' 
                            '</tr>';
            index++;
        });
        let html_list = (unlist === undefined ? '<h4 class="module-policies-title">' + $(tab).data('list-title') + ' {{lang.LABKERNEL76}}</h4>' : '') +
                        '<table class="table table-striped table-bordered table-hover" id="_kernel_policies_table_' + uniq_module + '_">' +
                            '<thead>' +
                                '<tr role="row">' +
                                    '<th>{{lang.LABKERNEL38}}</th>' +
                                    '<th style="width:95px">{{lang.LABKERNEL39}}</th>' +
                                '</tr>' +
                            '</thead>' +
                            '<tbody id="contenttr">' +
                                html_policies +
                            '</tbody>' +
                        '</table>';
        $(tab + ' .policy-container').html(html_list);
        policies_tables_map[uniq_module] = $('#_kernel_policies_table_' + uniq_module + '_').DataTable({
            "autoWidth": false,
            "drawCallback": function (settings) {
                //console.log('Get your');
            }
        });
        $('[data-toggle="tooltip"]').tooltip();
        $('[data-toggle="popover"]').popover({
            container: 'body'
        }).on('show.bs.popover', function () {
            $("[data-toggle='tooltip']").tooltip('hide');
        });
    }else{
        $(tab + ' .policy-container').html('<div class="empty-policies-tab">' +
                                                '<i class="fa fa-ban text-warning"></i>' + 
                                                '<h5>' + (unlist === true ? '{{lang.LABKERNEL40}}' : '{{lang.LABKERNEL41}}') + '</h5>' +
                                            '</div>')
    }
}
function showCWPKernelInfo(){
    $('#_modal_kernel_cwp_info_').modal('show');
}
function applyKernelChanges(btn_apply){
    $('#_modal_kernel_apply_changes_').modal('show');
    $('#_btn_kernel_apply_changes_modal_').unbind('click').click(function () {
        let btn_modal = $(this);
        handleButtons(btn_modal, 'fa-check');
        sendKernelApplyChanges(function(){
            $.gritter.add({
                title: '{{lang.LABKERNEL36}}',
                text: '{{lang.LABKERNEL42}}',
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'success-notice'
            });
            btn_apply.prop('disabled', true);
            $('#_modal_kernel_apply_changes_').modal('hide');
            handleButtons(btn_modal, 'fa-check', true);
        }, function(){
            handleButtons(btn_modal, 'fa-check', true);
        });
    });
}
function clickChangeAllPoliciesBtn(elem){
    let action = $(elem).data('action');
    $('#_modal_kernel_all_type').text(action === 'enable' ? '{{lang.LABKERNEL66}}' : '{{lang.LABKERNEL67}}');
    $('#_btn_kernel_change_all_').unbind('click').click(function(){
        let btn_modal = $(this);
        handleButtons(btn_modal, 'fa-check');
        let module_active = $('#_kernel_tabs_ .active a').data('module');
        let tab_ref = $('#_kernel_tabs_ .active a').attr('href');
        let unlist = undefined;
        if (module_active == 'unlist') {
            module_active = $('#_unlist_rules_tabs_ .active a').data('module');
            unlist = true;
            tab_ref = $('#_unlist_rules_tabs_ .active a').attr('href');
        }
        sendChangeAllPolicies(action, module_active, unlist, function(response){
            let new_title = '{{lang.LABKERNEL3}}';
            let new_ico = 'fa-ban';
            let new_action = 'disable';
            let checkbox_item_status = true;
            if(action != 'enable'){
                new_title = '{{lang.LABKERNEL2}}';
                new_ico = 'fa-check';
                new_action = 'enable';
                checkbox_item_status = false;
            }
            policies_tables_map = {};
            renderModulePolicies(response.policies, module_active, tab_ref, unlist);
            $(elem).find('i').removeClass().addClass('fa ' + new_ico);
            $(elem).find('span').text(new_title);
            $(elem).data('action', new_action);
            $.gritter.add({
                title: '{{lang.LABKERNEL36}}',
                text: '{{lang.LABKERNEL42}}',
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'success-notice'
            });
            $('#_modal_kernel_change_all_').modal('hide');
            $('#_kernel_apply_changes_btn_').prop('disabled', false);
            handleButtons(btn_modal, 'fa-check', true);
        }, function(){
            handleButtons(btn_modal, 'fa-check', true);
        });
    });
    $('#_modal_kernel_change_all_').modal('show');
}
function clickChangeLogStatus(elem){
    let action = $(elem).data('action');
    $('#_modal_kernel_log_status_type_').text(action === 'enable' ? '{{lang.LABKERNEL66}}' : '{{lang.LABKERNEL67}}');
    $('#_btn_kernel_log_status_').unbind('click').click(function () {
        let btn_modal = $(this);
        handleButtons(btn_modal, 'fa-check');
        sendLogStateChange(action, function () {
            let new_title = '{{lang.LABKERNEL4}}';
            let new_ico = 'fa-ban';
            let new_ico_alert = 'fa-check';
            let new_action = 'disable';
            let new_title_gritter = '{{lang.LABKERNEL43}}'; //CHANGE ON LANG
            let new_title_alert = '{{lang.LABKERNEL5}}'; //CHANGE ON LANG
            let new_class_alert = 'success';
            $('#_kernel_log_noti_monitoring_status_').hide();
            $('#_kernel_log_notifications_manager_').show();
            $('#_btn_kernel_save_notifications_').show();
            if (action != 'enable') {
                new_title = '{{lang.LABKERNEL6}}';
                new_ico = 'fa-check';
                new_action = 'enable';
                new_title_gritter = '{{lang.LABKERNEL44}}'; //CHANGE ON LANG
                new_title_alert = '{{lang.LABKERNEL7}}'; //CHANGE ON LANG
                new_class_alert = 'warning';
                new_ico_alert = 'fa-ban';
                $('#_kernel_log_noti_monitoring_status_').show();
                $('#_kernel_log_notifications_manager_').hide();
                $('#_btn_kernel_save_notifications_').hide();
            }
            $(elem).find('i').removeClass().addClass('fa ' + new_ico);
            $(elem).find('span').text(new_title);
            $(elem).data('action', new_action);
            $('#_kernel_log_monitoring_status_').removeClass().addClass('label label-' + new_class_alert);
            $('#_kernel_log_monitoring_status_').find('span').text(new_title_alert);
            $('#_kernel_log_monitoring_status_').find('i').removeClass().addClass('fa ' + new_ico_alert);
            $.gritter.add({
                title: '{{lang.LABKERNEL36}}',
                text: new_title_gritter,
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'success-notice'
            });
            $('#_modal_kernel_log_status_').modal('hide');
            handleButtons(btn_modal, 'fa-check', true);
        }, function () {
            handleButtons(btn_modal, 'fa-check', true);
        });
    });
    $('#_modal_kernel_log_status_').modal('show');
}
function handleButtons(elem, icon_fa, type) {
    let icon = $(elem).find('.fa');
    if (type == undefined) {
        $(elem).addClass('disabled');
        $(elem).prop('disabled', true);
        icon.removeClass(icon_fa);
        icon.addClass('fa-spinner fa-spin');
    } else {
        icon.removeClass('fa-spinner fa-spin');
        icon.addClass(icon_fa);
        $(elem).removeClass('disabled');
        $(elem).prop('disabled', false);
    }
}
function updateRulesClicked(){
    handleButtons('.btn-rule-updater', 'fa-download');
    $('#_btn_modal_info_close_').prop('disabled', true);
    let module_active = $('#_kernel_tabs_ .active a').data('module');
    let tab_ref = $('#_kernel_tabs_ .active a').attr('href');
    let unlist = undefined;
    if (module_active == 'unlist') {
        module_active = $('#_unlist_rules_tabs_ .active a').data('module');
        unlist = true;
        tab_ref = $('#_unlist_rules_tabs_ .active a').attr('href');
    }
    requestRulesUpdate('ssh', unlist,function (response) {
        $.gritter.add({
            title: '{{lang.LABKERNEL36}}',
            text: '{{lang.LABKERNEL45}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'success-notice'
        });
        policies_tables_map = {};
        renderModulePolicies(response.policies, module_active, tab_ref, unlist);
        $('#_modal_info_rules_version_').text(response.version);
        handleButtons('.btn-rule-updater', 'fa-download', false);
        $('#_btn_modal_info_close_').prop('disabled', false);
        $('.hide-on-update').fadeOut('fast');
        $('#_modal_kernel_cwp_info_').modal('hide');
    }, function () {
        handleButtons('.btn-rule-updater', 'fa-download', true);
        $('#_btn_modal_info_close_').prop('disabled', false);
    });
}
{% if mod_vars.cwp_kernel_installed == true %}
    $(document).ready(function () {
        loadModulePolicies('cron', '#_kernel_manager_tab_cron_');
        $('body').on('click', function (e) { // ADD LISTENER TO CLOSE POPOVER
            $('[data-toggle="popover"]').each(function () {
                //the 'is' for buttons that trigger popups
                //the 'has' for icons within a button that triggers a popup
                /*if (!$(this).is(e.target) && $(this).has(e.target).length === 0 && $('.popover').has(e.target).length === 0) {
                    $(this).popover('hidemodule');
                }*/
            });
        });
        if (installed_rules_version < lastest_rules_version){
            $('.btn-rule-updater').click(function(){
                updateRulesClicked();
            });
            $('#_modal_kernel_cwp_info_').modal('show');
        }
        $('#_kernel_tabs_ a').on('show.bs.tab', function () {
            policyTabChanged($(this));
        });
        $('#_unlist_rules_tabs_ a').on('show.bs.tab', function () {
            unlistTabChanged($(this));
        });
        $('#_kernel_apply_changes_btn_').click(function () {
            applyKernelChanges($(this));
        });
        // setInputFilter(document.getElementById("_modal_tomcat_sessions_time_"), function (value) {
        //     return /^\d*$/.test(value); // Allow digits and '.' only, using a RegExp
        // });
        // setInputFilter(document.getElementById("_tomcat_app_context_path_"), function (value) {
        //     return /^[A-Za-z0-9_\/]*$/.test(value); // Allow digits and '.' only, using a RegExp
        // });
    });
    {% include 'js/kernel_services.js' %}
    {% include 'js/kernel_logs_handler.js' %}
{% endif %}