//let system_users = ['cecolio','carmen','skkssk','carbon'];
let system_users = JSON.parse('{{mod_vars.system_users_map|json_encode|raw}}');
let kernel_incidents_table = null;
let kernel_detailed_incidents_table = null;
let last_log_type = 'frequent';
function kernelLogsWindow() {
    let window_to_show = '#_kernel_logs_panel_';
    let window_to_hide = '#_kernel_main_panel_';
    let must_load = false;
    if (!$('#_kernel_main_panel_').is(':visible')) {
        window_to_show = '#_kernel_main_panel_';
        window_to_hide = '#_kernel_logs_panel_';
    } else {
        must_load = true;
        $('#_kernel_logs_panel_table_container').html('<div class="log-viewer-loader">' +
            '<div class="action-loader">' +
            '<span><i class="fa fa-circle-o-notch fa-spin"></i></span>' +
            '<h5 id="">{{lang.LABKERNEL32}}...</h5>' +
            '</div>' +
            '</div>');
    }
    $(window_to_hide).slideUp('fast', function () {
        $(window_to_show).slideDown('fast');
    });
    if (must_load == true) {
        kernel_incidents_table = null;
        requestKernelLogs('frequent',function (response) {
            kernelRenderLogsTable(response.incidents, 'frequent');
        }, function () {
            $(window_to_show).slideUp('fast', function () {
                $(window_to_hide).slideDown('fast');
            });
        });
    }
}
function kernelRenderLogsTable(incidents, type_log){
    let html_incidents = '';
    if(incidents.length > 0){
        /*incidents.forEach(function(item){
            html_incidents += '<tr>' +
                                '<td>' + item.qty + '</td>' +
                                '<td>' + item.incident + '</td>' +
                                '<td class="text-center"><button class="btn btn-primary btn-sm" data-toggle="tooltip" data-placement="top" data-title="Click to view details"><i class="fa fa-info-circle"></i> Details</button></td>' +
                            '</tr>';
        });*/
        if (kernel_incidents_table === null){
            html_incidents = '<table class="table table-striped table-bordered table-hover" id="_kernel_logs_table_">' +
                                '<thead>' +
                                    '<tr role="row">' +
                                        '<th style="width:90px">{{lang.LABKERNEL82}}</th>' +
                                        '<th>{{lang.LABKERNEL83}}</th>' +
                                        '<th style="width:100px">{{lang.LABKERNEL39}}</th>' +
                                    '</tr>' +
                                '</thead>' +
                                '<tbody id="contenttr">' +
                                //html_incidents +
                                '</tbody>' +
                            '</table>';
            $('#_kernel_logs_panel_table_container').html(html_incidents);
            kernel_incidents_table = $('#_kernel_logs_table_').DataTable({
                "autoWidth": false,
                "order": [[0, "desc"]],
                columnDefs: [
                    { orderable: false, targets: [1, 2] }
                ],
                "dom": "<'row'<'col-sm-2'l><'#_btn_recent_table_logs_.col-sm-3'><'#_user_select_table_logs_.col-sm-4'><'col-sm-3'f>>" +
                    "<'row'<'col-sm-12'tr>>" +
                    "<'row'<'col-sm-5'i><'col-sm-7'p>>",
            });
            renderExtraControlTable();
        }else{
            kernel_incidents_table.rows('tr').remove();
        }
        if (type_log != 'frequent'){
            kernel_incidents_table.column(0).visible(false);
        }else{
            kernel_incidents_table.column(0).visible(true);
        }
        kernel_incidents_table.rows.add(incidents).draw();
        $('[data-toggle="tooltip"]').tooltip();

    }else{
        html_incidents = '<div class="empty-kernel-incidents-list">' +
                            '<i class="fa fa-check-circle text-success" aria-hidden="true"></i>' +
                            '<h4>{{lang.LABKERNEL84}}</h4>' +
                            '<button class="btn btn-primary btn-lg" onclick="kernelLogsWindow()"><i class="fa fa-ban"></i> {{lang.LABKERNEL79}}</button>' +
                        '</div>';
        $('#_kernel_logs_panel_table_container').html(html_incidents);
    }
}
function renderExtraControlTable(){
    $('#_kernel_logs_table__length select').addClass('form-control')
    $('#_kernel_logs_table__filter input').addClass('form-control')
    renderTableLogsUsersSelect();
    $('#_btn_recent_table_logs_').html('<select name="recent" class="form-control" onchange="kernelLogTypeChanged(this)">' +
                                            '<option value="frequent" selected>{{lang.LABKERNEL85}}</option>' +
                                            '<option value="recent">{{lang.LABKERNEL86}}</option>' +
                                            '<option value="user">{{lang.LABKERNEL87}}</option>' +
                                        '</select>');
}
function kernelLogTypeChanged(elem){
    let type_selected = $(elem).val();
    if (type_selected == 'user'){
        $('#_per_user_logs_select_').val('');
        $('#_per_user_logs_select_').trigger('change');
        $('#_user_select_table_logs_wrapper_').fadeIn('fast');
    } else{
        //last_log_type = $(elem).val();
        $('#_user_select_table_logs_wrapper_').fadeOut('fast');
        if (last_log_type != type_selected){
            requestLogsFromFilter(type_selected);
        }
    }
}
function requestLogsFromFilter(type_selected){
    $('#_kernel_logs_table__wrapper').append('<div class="log-table-loader"><i class="fa fa-circle-o-notch fa-spin text-primary"></i></div>');
    requestKernelLogs(type_selected, function (response) {
        kernelRenderLogsTable(response.incidents, type_selected);
        last_log_type = type_selected;
        $('.log-table-loader').remove();
    }, function () {
        $('#_kernel_logs_panel_').slideUp('fast', function () {
            $('#_kernel_main_panel_').slideDown('fast');
        });
    });
}
function renderTableLogsUsersSelect(){
    let html_select = '';
    system_users.forEach(function(user){
        html_select += '<option value="' + user + '">' + user + '</option>';
    });
    $('#_user_select_table_logs_').html('<div id="_user_select_table_logs_wrapper_">' +
                                            '<select id="_per_user_logs_select_">' + 
                                                '<option value=""></option>' +
                                                html_select + 
                                            '</select>' +
                                        '</div>');
    $("#_per_user_logs_select_").select2({
        placeholder: "{{lang.LABKERNEL88}}",
        allowClear: true
    }).on('select2-selected', function (e) {
        requestLogsFromFilter('peruser&user=' + e.val);
    });
}
const HIDDEN_DETAILS_COLUMNS = [3, 4, 5, 6, 7, 8, 9];
function showDetailEntry(elem){
    console.log($(elem).data('raw')); //parse html tags
    $('#_detailed_logs_raw_container_').html($(elem).data('raw').replace('<', '&lt;').replace('>', '&gt;'));
    $('#_modal_kernel_log_raw_detailed_').modal('show');
}
function kernelRenderDetailsLogsTable(details) {
    let html_details = '';
    if (details.length > 0) {
        details.forEach(function (detail_item, index){
            let test = '&lt;kernel&gt;';
            html_details += '<tr>' +
                                '<td>' + detail_item.date + '</td>' +
                                '<td>' + detail_item.profile + '</td>' +
                                '<td>' + detail_item.pid + '</td>' +
                                '<td>' + detail_item.ppid + '</td>' +
                                '<td>' + detail_item.gid + '</td>' +
                                '<td>' + detail_item.ino + '</td>' +
                                '<td>' + detail_item.major + '</td>' +
                                '<td>' + detail_item.minor + '</td>' +
                                '<td>' + detail_item.perm + '</td>' +
                                '<td>' + detail_item.type + '</td>' +
                                '<td>' + detail_item.mode + '</td>' +
                                '<td>' + (detail_item.granted == true ? 'YES' : 'NO') + '</td>' +
                                '<td>' + detail_item.user + '</td>' +
                                '<td>' + detail_item.command + '</td>' +
                                '<td>' +
                                        '<button data-test="' + test + '" data-raw="' + detail_item.output + '" onclick="showDetailEntry(this)" class="btn btn-primary btn-sm">' +
                                            '<i class="fa fa-eye"></i>{{lang.LABKERNEL89}}' +
                                        '</button>' +
                                '</td>' +
                            '</tr>';
        });
        html_details = '<table class="table table-striped table-bordered table-hover display nowrap" id="_kernel_logs_detail_table_">' +
                            '<thead>' +
                                '<tr role="row">' +
                                    '<th style="width:120px">{{lang.LABKERNEL90}}</th>' +
                                    '<th style="width:80px">{{lang.LABKERNEL91}}</th>' +
                                    '<th style="width:80px">Pid</th>' +
                                    '<th style="width:80px">ppid</th>' +
                                    '<th style="width:80px">gid</th>' +
                                    '<th style="width:80px">Ino</th>' +
                                    '<th style="width:80px">{{lang.LABKERNEL92}}</th>' +
                                    '<th style="width:80px">{{lang.LABKERNEL93}}</th>' +
                                    '<th style="width:80px">Perm</th>' +
                                    '<th>{{lang.LABKERNEL94}}</th>' +
                                    '<th style="width:100px">{{lang.LABKERNEL95}}</th>' +
                                    '<th style="width:80px">{{lang.LABKERNEL96}}</th>' +
                                    '<th style="width:120px">{{lang.LABKERNEL97}}</th>' +
                                    '<th>{{lang.LABKERNEL98}}</th>' +
                                    '<th style="width:90px">&nbsp;</th>' +
                                '</tr>' +
                            '</thead>' +
                            '<tbody id="contenttr">' +
                                html_details +
                            '</tbody>' +
                        '</table>';
        $('#_kernel_logs_details_wrapper_').html(html_details);
        kernel_detailed_incidents_table = $('#_kernel_logs_detail_table_').DataTable({
            "autoWidth": false,
            "order": [[0, "desc"]],
            columnDefs: [
                { orderable: false, targets: [1, 2] }
            ],
            "dom": "<'row'<'#_detailed_log_view_all_columns_.col-sm-3 col-sm-offset-6'>'<'col-sm-3'f>>" +
                "<'row'<'col-sm-12 scrollable-table'tr>>" +
                "<'row'<'col-sm-5'i>>",
            pageLength: 20,
            "initComplete": function (settings, json) {
                //$("#_kernel_logs_details_wrapper_").wrap("<div style='overflow:auto; width:100%;position:relative;'></div>");
            },
            "columnDefs": [
                {
                    "targets": HIDDEN_DETAILS_COLUMNS,
                    "visible": false
                },
                {
                    "targets": 14,
                    "orderable": false
                } 
            ]
        });
        $('#_detailed_log_view_all_columns_').html('<div class="toggle-custom toggle-inline">' +
                                                        '<label class="toggle tip" data-original-title="ON/OFF" data-on="ON" data-off="OFF">' +
                                                            '<input id="view_all_columns_check" type="checkbox" onchange="toggleViewAllColumns(this)">' +
                                                            '<span class="button-checkbox"></span>' +
                                                        '</label>' +
                                                        '<label for="view_all_columns_check">{{lang.LABKERNEL99}}</label>' +
                                                    '</div>');
    } else {
        html_incidents = '<div class="empty-kernel-incidents-list">' +
            '<i class="fa fa-check-circle text-success" aria-hidden="true"></i>' +
            '<h4>Fortunately, no incidents were found!</h4>' +
            '<button class="btn btn-primary btn-lg" onclick="kernelLogsWindow()"><i class="fa fa-ban"></i> {{lang.LABKERNEL79}}</button>' +
            '</div>';
        $('#_kernel_logs_panel_table_container').html(html_incidents);
    }
}
function toggleViewAllColumns(elem){
    HIDDEN_DETAILS_COLUMNS.forEach(function (col_index) {
        let column = kernel_detailed_incidents_table.column(col_index);
        column.visible(!column.visible());
    });
}
function returnFromDetailedLog(){
    $('#_kernel_logs_details_panel_').slideUp('fast', function () {
        $('#_kernel_logs_panel_').slideDown('fast');
    });
}
function showkernelLogDetails(elem){
    $('#_kernel_logs_details_wrapper_').html('<div class="log-viewer-loader">' +
                                                '<div class="action-loader">' +
                                                    '<span><i class="fa fa-circle-o-notch fa-spin"></i></span>' +
                                                    '<h5 id="">{{lang.LABKERNEL32}}...</h5>' +
                                                '</div>' +
                                            '</div>');
    let command_detailed = $(elem).data('command');
    $('#_kernel_log_detailed_command_').text(command_detailed);
    $('#_kernel_logs_panel_').slideUp('fast', function () {
        $('#_kernel_logs_details_panel_').slideDown('fast');
        requestKernelDetailedLogs(command_detailed, function (response) {
            kernelRenderDetailsLogsTable(response.details);
            /*last_log_type = type_selected;
            $('.log-table-loader').remove();*/
        }, function () {
            $('#_kernel_logs_details_panel_').slideUp('fast', function () {
                $('#_kernel_logs_panel_').slideDown('fast');
            });
        });
    });
}