function sendRuleStatusChange(module, file_name, action, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=kernel&acc=change_rule_status",
        data: "action=" + action + '&module=' + module + '&file_name=' + file_name,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABKERNEL46}}',
                    text: '{{lang.LABKERNEL47}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABKERNEL47}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{lang.LABKERNEL48}}';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABKERNEL49}}';
                    } else if (resp_data.code == 3) {
                        message_error = '{{lang.LABKERNEL50}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABKERNEL46}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function requestKernelLogs(log_type,success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=kernel&acc=get_kernel_logs",
        data: 'log_type=' + log_type,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABKERNEL46}}',
                    text: '{{lang.LABKERNEL47}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABKERNEL47}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = 'Can not read file due to exceeding allowed size.';
                    } else if (resp_data.code == 1) {
                        message_error = 'Can not find the log file.';
                    } else if (resp_data.code == 3) {
                        message_error = 'Invalid user selected.';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABKERNEL46}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function requestKernelDetailedLogs(command, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=kernel&acc=get_kernel_detailed_logs",
        data: 'command=' + command,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABKERNEL46}}',
                    text: '{{lang.LABKERNEL47}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABKERNEL47}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = 'Can not read file due to exceeding allowed size.';
                    } else if (resp_data.code == 1) {
                        message_error = 'Can not find the log file.';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABKERNEL46}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendLogStateChange(action, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=kernel&acc=change_log_status",
        data: "action=" + action,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABKERNEL46}}',
                    text: '{{lang.LABKERNEL47}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABKERNEL47}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABKERNEL50}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABKERNEL46}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function requestRulesUpdate(module, unlist, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=kernel&acc=update_policies_version",
        data: "module=" + module + "&unlist=" + (unlist === true ? 'unlist' : ''),
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABKERNEL46}}',
                    text: '{{lang.LABKERNEL47}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABKERNEL47}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABKERNEL51}}';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABKERNEL52}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABKERNEL46}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendChangeAllPolicies(action, module, unlist, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=kernel&acc=change_all_policies",
        data: "action=" + action + "&module=" + module + "&unlist=" + (unlist === true ? 'unlist' : ''),
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABKERNEL46}}',
                    text: '{{lang.LABKERNEL47}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABKERNEL47}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABKERNEL50}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABKERNEL46}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendKernelApplyChanges(success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=kernel&acc=apply_changes",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABKERNEL46}}',
                    text: '{{lang.LABKERNEL47}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABKERNEL47}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABKERNEL53}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABKERNEL46}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function getModulePolicies(module, success, cleaner, unlist) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=kernel&acc=" + (unlist === undefined ? 'list_policies_module' : 'unlist_policies_module'),
        data: "module=" + module,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABKERNEL46}}',
                    text: '{{lang.LABKERNEL47}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABKERNEL47}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABKERNEL49}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABKERNEL46}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
