let common_settings = JSON.parse('{{mod_vars.common_settings|json_encode|raw}}');
function BindCommonSettings(){
    $('#_cwp_messenger_from_name_settings_').val(common_settings.sender_name);
    $('#_cwp_messenger_from_email_settings_').val(common_settings.sender_address);
    $('#_cwp_messenger_reply_to_settings_').val(common_settings.reply);
    $('#_cwp_messenger_admin_email_settings_').val(common_settings.admin_email);
}
function saveCommonSettings(elem){
    let settings_data = validateSettingsData();
    if (settings_data){
        handleButtons(elem, 'fa-trash');
        sendCommonSetingsToSave(settings_data, function(){
            $.gritter.add({
                title: '{{lang.LABMESS88}}',
                text: '{{lang.LABMESS108}}',
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-quill-2',
                class_name: 'success-notice'
            });
            handleButtons(elem, 'fa-trash', true);
        }, function(){
            handleButtons(elem, 'fa-trash', true);
        });
    }else{
        $.gritter.add({
            title: '{{lang.LABMESS103}}',
            text: '{{lang.LABMESS109}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
    }
}
function validateSettingsData(){
    let valid = true;
    let from_name = $('#_cwp_messenger_from_name_settings_').val();
    let from_email = $('#_cwp_messenger_from_email_settings_').val();
    let reply_to = $('#_cwp_messenger_reply_to_settings_').val();
    let admin_email = $('#_cwp_messenger_admin_email_settings_').val();
    if (from_name == ''){
        valid = false;
        $('#_cwp_messenger_from_name_settings_').addClass('error-picker');
    }else{
        $('#_cwp_messenger_from_name_settings_').removeClass('error-picker');
    }
    if (!validateEmail(reply_to)){
        valid = false;
        $('#_cwp_messenger_reply_to_settings_').addClass('error-picker');
    }else{
        $('#_cwp_messenger_reply_to_settings_').removeClass('error-picker');
    }
    if (!validateEmail(from_email)){
        valid = false;
        $('#_cwp_messenger_from_email_settings_').addClass('error-picker');
    }else{
        $('#_cwp_messenger_from_email_settings_').removeClass('error-picker');
    }
    if (!validateEmail(admin_email)){
        valid = false;
        $('#_cwp_messenger_admin_email_settings_').addClass('error-picker');
    }else{
        $('#_cwp_messenger_admin_email_settings_').removeClass('error-picker');
    }
    return valid === false ? false : {
        reply: reply_to,
        sender_name : from_name, 
        sender_address: from_email,
        admin_email: admin_email,
    };
}
function validateEmail(email) {
    const re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
}
function sendCommonSetingsToSave(settings_data, success, onerror){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=cwp_messenger&acc=save_common_settings",
        data: "settings_data=" + JSON.stringify(settings_data),
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMESS103}}',
                    text: '{{lang.LABMESS107}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMESS107}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 5) {
                        message_error = '{{lang.LABMESS109}}';
                    }else if (resp_data.code == 4) {
                        message_error = '{{lang.LABMESS110}}';
                    }else if (resp_data.code == 3) {
                        message_error = '{{lang.LABMESS111}}';
                    }else if (resp_data.code == 2) {
                        message_error = '{{lang.LABMESS112}}';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABMESS113}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMESS103}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
            }
        }
    });
}