let sent_message_list = JSON.parse('{{mod_vars.sent_list|json_encode|raw}}');
let users_list = JSON.parse('{{mod_vars.users_list|json_encode|raw}}');
let presets_list = JSON.parse('{{mod_vars.presets_list|json_encode|raw}}');
let sent_item_table = null;
let composer_addresses_settings = null;
$(document).ready(function () {
    ListSentMessages();
    renderPresetsList();
    BindComposeModal();
    BindCommonSettings();
    $('#_cwp_messenger_compose_modal_').on('hidden.bs.modal', function (e) {
        resetComposerModal();
        composer_addresses_settings = null;
    });
    $('[data-toggle="tooltip"]').tooltip();
});
function slideToggle(show, hide, callback) {
    $(hide).slideUp('fast', function () {
        if (typeof callback == 'function') {
            callback();
        }
        $(show).slideDown('fast');
    });
}
function renderReceiversOntable(receivers){
    if (jQuery.isArray(receivers)){
        return receivers.length;
    }else{
        return '{{lang.LABMESS72}}';
    }
}
function changeReceivers(elem){
    if($(elem).val() !== 'PICK'){
        $('.container-fluid-receiver').slideUp('fast');
    }else{
        $('.container-fluid-receiver').slideDown('fast');
    }
}

function hideSettinsComposerSubModal(){
    $('#_composer_settings_sub_modal').fadeOut('fast');
}
function changeMessageType(elem){
    if($(elem).is(':checked')){
        bindEditorComposer();
    }else{
        $('#_cwp_message_area_').summernote('destroy');
    }
}
function renderReceiversOnModal(selecteds){ 
    //return;
    let users_select = '';
    let usr_found = undefined;
    users_list.forEach(function(user){
        if (jQuery.isArray(selecteds)){
            usr_found = selecteds.find(function (usr) {
                return usr === user.uname; 
            });
        }
        users_select += '<option value="' + user.uname + '"' + (usr_found !== undefined ? ' selected' : '') + '>' + user.uname + ' (' + user.email + ')</option>';
    });
    $('#_cwp_messenger_receivers_wrapper_').html('<select multiple="" class="form-control" id="_cwp_messenger_receivers_select_">' +
                                                    users_select +
                                                + '</select>');
    //$('#_cwp_messenger_receivers_wrapper_').append('<span class="error-label">Select at least one user</span>')
    let list_opts = {
        nonSelectedListLabel: '{{lang.LABMESS01}}',
        selectedListLabel: '{{lang.LABMESS02}}',
        selectorMinimalHeight: 100,
        filterTextClear: '{{lang.LABMESS03}}', // the text for the "Show All" button.
        filterPlaceHolder: '{{lang.LABMESS04}}', // the placeholder for the input element for filtering elements.
        moveSelectedLabel: '{{lang.LABMESS05}}', // the label for the "Move Selected" button.
        moveAllLabel: '{{lang.LABMESS06}}', // the label for the "Move All" button.
        removeSelectedLabel: '{{lang.LABMESS07}}', // the label for the "Remove Selected" button.
        removeAllLabel: '{{lang.LABMESS08}}', // the label for the "Remove All" button.
    };
    $('#_cwp_messenger_receivers_select_').bootstrapDualListbox(list_opts);
}
function statusTranslator(status){
    let status_mess = '{{lang.LABMESS73}}';
    let style_fa = 'text-success';
    if(status == 'not_sent'){
        status_mess = '{{lang.LABMESS74}}';
        style_fa = 'text-warning';
    }else if(status == 'sent'){
        status_mess = '{{lang.LABMESS75}}';
        style_fa = 'text-primary';
    } else if (status == 'errored') {
        status_mess = '{{lang.LABMESS76}}';
        style_fa = 'text-danger';
    }
    return '<i class="fa fa-circle fa-sent-status ' + style_fa + '" aria-hidden="true"></i> ' + status_mess;
}
function cwpMessengerComposePreset(){
    $('#_modal_compser_title').text('{{lang.LABMESS77}}');
    $('.hide-on-preset').hide();
    $('#_save_preset_button_').show();
    $('#_cwp_messenger_compose_modal_').modal('show');
}
function ListSentMessages(){
    let html_list = '';
    if (sent_message_list.length > 0){
        let html_content = '';
        let index = 0;
        console.log('sent_message_list', sent_message_list);
        sent_message_list.forEach(function (message) {
            html_content += '<tr id="_cwp_messenger_sent_item_' + index + '" data-sent-item=\'' + JSON.stringify(message) + '\' class="">' +
                                '<td>' + message.subject + '</td>' +
                                '<td>' + message.created_at + '</td>' +
                                '<td>' + renderReceiversOntable(message.receivers) + '</td>' +
                                '<td>' + statusTranslator(message.status) + '</td>' +
                                // '<td><span class="users-list-role-container">' + parseRoleDisplay(user.role) + '</span></td>' +
                                '<td width="90">' +
                                    '<div class="messenger-sent-item-actions">' +
                                        '<button title="View log" ' + (message.status == 'not_sent' ? 'disabled' : '') + ' data-toggle="tooltip" data-placement="top" onclick="cwpMessengerViewLog(this, \'' + message.identifier + '\')" class="btn btn-default btn-xs"><i class="fa fa-file-text-o"></i></button>' +
                                        '<button class="btn btn-success btn-xs" ' + (message.status == 'sending' ? 'disabled' : '') + ' title="' + (message.status == 'sent' || message.status == 'errored'? '{{lang.LABMESS78}}' : '{{lang.LABMESS79}}') + '" data-toggle="tooltip" onclick="cwpMessengerResend(this, \'' + message.identifier + '\')" data-placement="top">' +
                                            '<i class="fa ' + (message.status == 'not_sent' ? 'fa-pencil-square-o' : 'fa-retweet') + '"></i>' +
                                        '</button>' +
                                        '<button class="btn btn-primary btn-xs" title="{{lang.LABMESS80}}" data-toggle="tooltip" onclick="cwpMessengerViewDetails(this)" data-placement="top"><i class="fa fa-envelope-o"></i></button>' +
                                        '<button id="btn_del_sent_item_' + index + '" class="btn btn-danger btn-xs" title="{{lang.LABMESS81}}" data-toggle="tooltip" onclick="cwpMessengerDeleteSent(this, ' + index + ')" data-placement="top"><i class="fa fa-trash"></i></button>' +
                                    '</div>' +
                                '</td>' +
                            '</tr>';
            index++;
        });
        html_list = '<table class="table cwp-messenger-sent-table table-striped table-bordered table-hover" style="width:100% !important;">' +
                        '<thead>' +
                            '<tr role="row">' +
                                '<th>{{lang.LABMESS82}}</th>' +
                                '<th>{{lang.LABMESS83}}</th>' +
                                '<th>{{lang.LABMESS84}}</th>' +
                                '<th>{{lang.LABMESS85}}</th>' +
                                '<th width="90">{{lang.LABMESS86}}</th>' +
                            '</tr>' +
                        '</thead>' +
                        '<tbody id="contenttr">' +
                            html_content +
                        '</tbody>' +
                    '</table>';
    }else{
        html_list = '<div class="not-messenger-records-wrapper"><h5>{{lang.LABMESS87}}</h5></div>';
    }
    $('#_messenger_sent_list_wrapper_').html(html_list);
    if ($('.cwp-messenger-sent-table').length > 0){
        sent_item_table = $('.cwp-messenger-sent-table').DataTable();
    }
}
function cwpMessengerDeleteSent(elem, index){
    let sent_item = $(elem).closest('tr').data('sent-item');
    $('#_sent_deleting_index_').val(index);
    $('#_sent_item_confirm_todelete').text(sent_item.subject);
    $('#_cwp_messenger_delete_sent_confirm_modal_').modal('show');
}

function sentItemDeletionConfirmed(){
    let index = $('#_sent_deleting_index_').val();
    let tr_deleting = $('#_cwp_messenger_sent_item_' + index);
    tr_deleting.addClass('deleting_tr');
    tr_deleting.find('.btn').prop('disabled', true);
    let sent_data = tr_deleting.data('sent-item');
    handleButtons('#btn_del_sent_item_' + index, 'fa-trash');
    $('#_cwp_messenger_delete_sent_confirm_modal_').modal('hide');
    sendSentItemDeletion(sent_data.identifier, function () {
        tr_deleting.slideUp('fast', function () {
            sent_item_table.row(this).remove().draw();
        });
        $.gritter.add({
            title: '{{lang.LABMESS88}}',
            text: '{{lang.LABMESS89}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
    }, function () {
        handleButtons('#btn_del_sent_item_' + index, 'fa-trash', true);
        tr_deleting.removeClass('deleting_tr');
        tr_deleting.find('.btn').prop('disabled', false);
    });

}
function cwpMessengerViewDetails(elem){
    let sent_item = $(elem).closest('tr').data('sent-item');
    if (jQuery.isArray(sent_item.receivers)){
        $('#_cwp_mesenger_sent_detail_receivers_').html(renderReceiversDetails(sent_item.receivers));
    }else{
        $('#_cwp_mesenger_sent_detail_receivers_').html(translateReceiversType(sent_item.receivers));
    }
    $('#_cwp_mesenger_sent_detail_subject_').text(sent_item.subject);
    let message_type_ico = '<i class="fa fa-square-o" aria-hidden="true"></i>';
    let message_content = sent_item.message;
    if (sent_item.message_html === true){
        message_type_ico = '<i class="fa fa-check-square-o" aria-hidden="true"></i>';
        message_content = Base64.decode(message_content)
    }
    $('#_cwp_mesenger_sent_detail_messtype_').html(message_type_ico);
    $('#_cwp_mesenger_sent_detail_message_').html(message_content);
    if(sent_item.status == 'not_sent'){
        $('#_sent_on_label_date_').text('{{lang.LABMESS90}}');
        $('#_cwp_mesenger_sent_detail_date_').html(sent_item.created_at);
    } else if (sent_item.status == 'sending'){
        $('#_sent_on_label_date_').text('{{lang.LABMESS91}}');
        $('#_cwp_mesenger_sent_detail_date_').html(sent_item.sent_start_date);
    }else{
        $('#_sent_on_label_date_').text('{{lang.LABMESS92}}');
        $('#_cwp_mesenger_sent_detail_date_').html(sent_item.sent_end_date);
    }
    
    $('#_cwp_messenger_detail_modal_').modal('show');
}
function translateReceiversType(type){
    let mess_type = '{{lang.LABMESS93}}';
    return mess_type;
}
function renderReceiversDetails(receivers){
    let html_mess = '';
    receivers.forEach(function(receiver, index){
        html_mess += '<span class="sent-details-receiver-tag' + (index > 10 ? ' sent-details-receiver-tag-hidden' : '') + '">' + receiver + '</span>';
    });
    if (receivers.length > 10) {
        let total_hidden = receivers.length - 10;
        html_mess += '<button onclick="detailsReceiversLeesMore(this)" data-total="' + total_hidden + '" class="btn btn-xs btn-default">{{lang.LABMESS94}} ' + total_hidden + '+</button>';
    }
    return html_mess;
}
function detailsReceiversLeesMore(elem){
    if ($('.sent-details-receiver-tag-hidden').is(':visible')){
        $('.sent-details-receiver-tag-hidden').fadeOut('fast');
        $(elem).text('{{lang.LABMESS94}} ' + $(elem).data('total') + '+');
    }else{
        $('.sent-details-receiver-tag-hidden').fadeIn('fast');
        $(elem).text('{{lang.LABMESS95}}');
    }
}
function cwpMessengerResend(elem){
    let sent_item = $(elem).closest('tr').data('sent-item');
    composer_addresses_settings = sent_item.hasOwnProperty('adddresses_settings') ? sent_item.adddresses_settings : common_settings;
    if (!jQuery.isArray(sent_item.receivers)){
        $('.container-fluid-receiver').hide();
        $('#_cwp_messenger_receivers_select_').val(sent_item.receivers);
        renderReceiversOnModal();
    }else{
        $('.container-fluid-receiver').show();
        $('#_cwp_messenger_receivers_type_select_').val('PICK');
        renderReceiversOnModal(sent_item.receivers);
    }
    if (sent_item.message_html === true) {
        $('#is_html_message_check').prop('checked', true);
        $('#_cwp_message_area_').summernote('code', Base64.decode(sent_item.message));
    } else {
        $('#is_html_message_check').prop('checked', false);
        $('#_cwp_message_area_').val(Base64.decode(sent_item.message));
    }
    $('#resend_from_identifier_').val(sent_item.identifier);
    $('#_single_message_per_receipt_').prop('checked', sent_item.single_send);
    $('#_cwp_messenger_compose_subject_').val(sent_item.subject);
    $('#_cwp_messenger_compose_modal_').modal('show');
}
function handleButtons(elem, icon_fa, type) {
    let icon = $(elem).find('.fa');
    if (type == undefined) {
        $(elem).addClass('disabled');
        $(elem).prop('disabled', true);
        icon.removeClass(icon_fa);
        icon.addClass('fa-spinner fa-spin');
    } else {
        icon.removeClass('fa-spinner fa-spin');
        icon.addClass(icon_fa);
        $(elem).removeClass('disabled');
        $(elem).prop('disabled', false);
    }
}
function sendSentItemDeletion(identifier, success, onerror) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=cwp_messenger&acc=delete_sent_item",
        data: "identifier=" + identifier,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: 'Error',
                    text: 'An unknown error occurred.',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = 'An unknown error occurred.';
                /*if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.DNSCLUSLAB46}}';
                    }
                }*/
                $.gritter.add({
                    title: 'Error',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
            }
        }
    });
}
{% include 'js/log_viewer.js' %}
{% include 'js/presets.js' %}
{% include 'js/base64.js' %}
{% include 'js/message_composer.js' %}
{% include 'js/common_settings.js' %}
