let composer_settings = null;
function bindEditorComposer() {
    $('#_cwp_message_area_').summernote({
        toolbar: [
            // [groupName, [list of button]]
            ['style', ['bold', 'italic', 'underline', 'clear']],
            ['font', ['strikethrough']],
            ['fontsize', ['fontsize']],
            ['color', ['color']],
            ['para', ['ul', 'ol', 'paragraph']],
            ['height', ['height']],
            ['view', ['fullscreen', 'codeview']],
        ],
        height: 180
    });
}
function resetComposerModal(){
    $('.hide-on-preset').show();
    $('#_composer_settings_sub_modal').hide();
    $('#_save_preset_button_').hide();
    $('#_cwp_mess_presets_select_').val('');
    $('#_cwp_mess_presets_select_').select2().trigger('change');
    $('#_cwp_mess_presets_select_').prop('disabled', false);
    $('#_cwp_messenger_compose_subject_').val('');
    if (!$('#is_html_message_check').is(':checked')){
        $('#_cwp_message_area_').val('');
        bindEditorComposer();
        $('#is_html_message_check').prop('checked', true);
    }else{
        $('#_cwp_message_area_').summernote("code", "");
    }
    $('#_save_message_as_preset_').prop('checked', false);
    $('#_cwp_message_area_').removeClass('error-picker');
    $('.note-editor').removeClass('error-picker');
    $('#_cwp_messenger_compose_subject_').removeClass('error-picker');
    $('.container-fluid-receiver .error-label').hide();
    $('.container-fluid-receiver').hide();
    $('#_cwp_messenger_receivers_type_select_').val('1');
    $('#resend_from_identifier_').val('');
}
function BindComposeModal() {
    bindEditorComposer();
    renderPresetSelect();
}
function cwpMessengerCompose() {
    composer_addresses_settings = common_settings;
    renderReceiversOnModal();
    $('#_cwp_messenger_compose_modal_').modal('show');
}
function saveMessageForLater(elem){
    let message_data = getMessageDataCompose();
    if (message_data !== false){
        $('.compose-btn').prop('disabled', true);
        handleButtons(elem, 'fa-floppy-o');
        sendSaveForLater(message_data, function (response) {
            sent_message_list = response.list;
            ListSentMessages();
            if (response.preset_list !== null) {
                presets_list = response.preset_list;
                renderPresetsList();
                renderPresetSelect();
            }
            handleButtons(elem, 'fa-floppy-o', true);
            $('.compose-btn').prop('disabled', false);
            $('#_cwp_messenger_compose_modal_').modal('hide');
            $.gritter.add({
                title: '{{lang.LABMESS88}}',
                text: '{{lang.LABMESS102}}',
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-quill-2',
                class_name: 'success-notice'
            });
        }, function () {
            handleButtons(elem, 'fa-floppy-o', true);
            $('.compose-btn').prop('disabled', false);
        });
    }else{
        $.gritter.add({
            title: '{{lang.LABMESS103}}',
            text: '{{lang.LABMESS104}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
    }
}
function setAddressesSettingsToComposer(){
    let data_settings = validateAddressesSettingsToComposer();
    if (data_settings){
        $('#_composer_settings_sub_modal').fadeOut('fast');
        composer_addresses_settings = data_settings;
    }else{
        $.gritter.add({
            title: '{{lang.LABMESS103}}',
            text: '{{lang.LABMESS104}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
    }
}
function validateAddressesSettingsToComposer() {
    let valid = true;
    let from_name = $('#_od_from_name_settings_').val();
    let from_email = $('#_od_from_email_settings_').val();
    let reply_to = $('#_od_reply_to_settings_').val();
    if (from_name == '') {
        valid = false;
        $('#_od_from_name_settings_').addClass('error-picker');
    } else {
        $('#_od_from_name_settings_').removeClass('error-picker');
    }
    if (!validateEmail(reply_to)) {
        valid = false;
        $('#_od_reply_to_settings_').addClass('error-picker');
    } else {
        $('#_od_reply_to_settings_').removeClass('error-picker');
    }
    if (!validateEmail(from_email)) {
        valid = false;
        $('#_od_from_email_settings_').addClass('error-picker');
    } else {
        $('#_od_from_email_settings_').removeClass('error-picker');
    }
    return valid === false ? false : {
        reply: reply_to,
        sender_name: from_name,
        sender_address: from_email,
    };
}
function setComposerDefaultSettings(){
    $('#_od_from_name_settings_').val(common_settings.sender_name);
    $('#_od_from_email_settings_').val(common_settings.sender_address);
    $('#_od_reply_to_settings_').val(common_settings.reply);
}
function hideSettingsComposerSubModal(){
    $('#_composer_settings_sub_modal').fadeOut('fast');
}
function showSettingsComposerSubModal(elem) {
    //$('.compose-btn').prop('disabled', true);
    $('#_od_from_name_settings_').val(composer_addresses_settings.sender_name);
    $('#_od_from_email_settings_').val(composer_addresses_settings.sender_address);
    $('#_od_reply_to_settings_').val(composer_addresses_settings.reply);
    $('#_composer_settings_sub_modal').fadeIn('fast');
    hideOnClickOutside('#_composer_settings_sub_modal', elem);
}
function hideOnClickOutside(selector, second) {
    let forhide = true;
    function outsideClickListener(event) {
        $target = $(event.target);
        if (!$target.closest(selector).length && !$target.closest(second).length && $(selector).is(':visible')) {
            if (forhide) {
                $(selector).fadeOut('fast');
            } else {
                $(selector).remove();
            }
            removeClickListener();
        }
    }
    function removeClickListener() {
        document.removeEventListener('click', outsideClickListener)
    }
    document.addEventListener('click', outsideClickListener)
}
function sendMessageNow(elem){
    let message_data = getMessageDataCompose();
    if (message_data !== false){
        $('.compose-btn').prop('disabled', true);
        handleButtons(elem, 'fa-floppy-o');
        sendMessageNowAction(message_data, function (response) {
            sent_message_list = response.list;
            ListSentMessages();
            if(response.preset_list !== null){
                presets_list = response.preset_list;
                renderPresetsList();
                renderPresetSelect();
            }
            handleButtons(elem, 'fa-floppy-o', true);
            $('.compose-btn').prop('disabled', false);
            $('#_cwp_messenger_compose_modal_').modal('hide');
            $.gritter.add({
                title: '{{lang.LABMESS88}}',
                text: '{{lang.LABMESS105}}',
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-quill-2',
                class_name: 'success-notice'
            });
        }, function () {
            handleButtons(elem, 'fa-floppy-o', true);
            $('.compose-btn').prop('disabled', false);
        });
    }else{
        $.gritter.add({
            title: '{{lang.LABMESS103}}',
            text: '',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
    }
}
function saveMessageAsPreset(elem){
    $('#_save_message_as_preset_').prop('checked', true);
    let data_preset = getMessageDataCompose(true);
    if (data_preset){
        $('.compose-btn').prop('disabled', true);
        handleButtons(elem, 'fa-floppy-o');
        sendSaveAsPreset(data_preset, function(response){
            presets_list = response.preset_list;
            renderPresetsList();
            renderPresetSelect();
            handleButtons(elem, 'fa-floppy-o', true);
            $('.compose-btn').prop('disabled', false);
            $('#_cwp_messenger_compose_modal_').modal('hide');
            $.gritter.add({
                title: '{{lang.LABMESS88}}',
                text: '{{lang.LABMESS106}}',
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-quill-2',
                class_name: 'success-notice'
            });
        }, function(){
            handleButtons(elem, 'fa-floppy-o', true);
            $('.compose-btn').prop('disabled', false);
        });
    }else{
        $.gritter.add({
            title: '{{lang.LABMESS103}}',
            text: '',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
    }
    
}
function getMessageDataCompose(isprest){
    let valid = true;
    let receiver_type = $('#_cwp_messenger_receivers_type_select_').val();
    let receivers_list = null;
    let subject = $('#_cwp_messenger_compose_subject_').val();
    let is_html = $('#is_html_message_check').is(':checked');
    let message_body = is_html ? $('#_cwp_message_area_').summernote('code') : $('#_cwp_message_area_').val();
    if (receiver_type == 'PICK' && isprest === undefined){
        if ($('#_cwp_messenger_receivers_select_').val() === null){
            $('#_cwp_messenger_receivers_wrapper_').addClass('error-picker');
            $('.container-fluid-receiver .error-label').slideDown('fast');
            valid = false;
        }else{
            $('#_cwp_messenger_receivers_wrapper_').removeClass('error-picker');
            $('.container-fluid-receiver .error-label').slideUp('fast');
            receivers_list = $('#_cwp_messenger_receivers_select_').val();
        }
    }
    if (subject == ''){
        $('#_cwp_messenger_compose_subject_').addClass('error-picker');
        valid = false;
    }else{
        $('#_cwp_messenger_compose_subject_').removeClass('error-picker');
    }
    if (message_body == '<p><br></p>' || message_body == ''){
        $('#_cwp_message_area_').addClass('error-picker');
        $('.note-editor').addClass('error-picker');
        valid = false;
    }else{
        //console.log('message_body', Base64.encode(message_body));
        message_body = encodeURIComponent(message_body);
        $('#_cwp_message_area_').removeClass('error-picker');
        $('.note-editor').removeClass('error-picker');
    }
    //return false;
    let resend_from = $('#resend_from_identifier_').val();
    return valid === true ? {
        receiver_type: receiver_type,
        receivers_list: receivers_list,
        subject: subject,
        single_send: $('#_single_message_per_receipt_').is(':checked'),
        message_html: is_html,
        message: message_body,
        adddresses_settings: composer_addresses_settings,
        as_preset: $('#_save_message_as_preset_').is(':checked'),
        resend_from: resend_from != '' ? resend_from : null
    } : false;
}
function sendSaveAsPreset(data_preset, success, onerror) {
    message_content = data_preset.message;
    data_preset.message = '';
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=cwp_messenger&acc=save_preset",
        data: "data_preset=" + JSON.stringify(data_preset) + '&message_content=' + message_content,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMESS103}}',
                    text: '{{lang.LABMESS107}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMESS107}}';
                /*if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.DNSCLUSLAB46}}';
                    }
                }*/
                $.gritter.add({
                    title: '{{lang.LABMESS103}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
            }
        }
    });
}
function sendSaveForLater(message_data, success, onerror) {
    message_content = message_data.message;
    message_data.message = '';
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=cwp_messenger&acc=save_draft",
        data: "message_data=" + JSON.stringify(message_data) + '&message_content=' + message_content,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMESS103}}',
                    text: '{{lang.LABMESS107}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMESS107}}';
                /*if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.DNSCLUSLAB46}}';
                    }
                }*/
                $.gritter.add({
                    title: '{{lang.LABMESS103}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
            }
        }
    });
}
function sendMessageNowAction(message_data, success, onerror) {
    message_content = message_data.message;
    message_data.message = '';
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=cwp_messenger&acc=start_send",
        data: "message_data=" + JSON.stringify(message_data) + '&message_content=' + message_content,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMESS103}}',
                    text: '{{lang.LABMESS107}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMESS107}}';
                /*if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.DNSCLUSLAB46}}';
                    }
                }*/
                $.gritter.add({
                    title: '{{lang.LABMESS103}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
            }
        }
    });
}