let preset_table = null;
function sendPresetFromList(elem){
    let preset = $(elem).closest('tr').data('preset-item');
    presetToCompose(preset);
    $('#_cwp_mess_presets_select_').val(preset.identifier);
    $('#_cwp_mess_presets_select_').select2().trigger('change');
    $('#_cwp_mess_presets_select_').prop('disabled', true);
    renderReceiversOnModal();
    $('#_cwp_messenger_compose_modal_').modal('show');
}
function presetToCompose(preset) {
    console.log('preset', preset);
    if (preset.message_html === true) {
        bindEditorComposer();
        $('#is_html_message_check').prop('checked', true);
        $('#_cwp_message_area_').summernote('code', Base64.decode(preset.message));
    } else {
        $('#is_html_message_check').prop('checked', false);
        $('#_cwp_message_area_').summernote('destroy');
        $('#_cwp_message_area_').val(Base64.decode(preset.message));
    }
    $('#_cwp_messenger_compose_subject_').val(preset.subject);
}
function renderPresetSelect(){
    let select_opts = '<option value="" selected>{{lang.LABMESS96}}</option>';
    //console.log('presets_list', presets_list);
    presets_list.forEach(function (preset, index) {
        select_opts += '<option data-index="' + index + '" value="' + preset.identifier + '">' + preset.subject + '</option>';
    });
    $('#_cwp_messenger_presets_sel_wrapper_').html('<select id="_cwp_mess_presets_select_">' + select_opts + '</select>');
    $('#_cwp_mess_presets_select_').select2({
        placeholder: "TEXT",
        allowClear: true
    });
    $('#_cwp_mess_presets_select_').on('select2-selected', function (e) {
        cwpMessengerPreSetChange($(e.choice.element[0]).data('index'));
    });
}
function cwpMessengerPreSetChange(index) {
    presetToCompose(presets_list[index]);
}
function confirmPresetDeletion(elem, index){
    let preset = $(elem).closest('tr').data('preset-item');
    $('#_preset_confirm_todelete').text(preset.subject);
    $('#_preset_deleting_index_').val(index);
    $('#_cwp_messenger_delete_preset_confirm_modal_').modal('show');
}
function renderPresetsList(){
    let html_list = '';
    if (presets_list.length > 0){
        let html_content = '';
        let index = 0;
        presets_list.forEach(function (preset) {
            html_content += '<tr id="_cwp_messenger_preset_item_' + index + '" data-index="' + index + '" data-preset-item=\'' + JSON.stringify(preset) + '\' class="">' +
                                '<td>' + preset.subject + '</td>' +
                                //'<td>' + renderReceiversOntable(preset.receivers) + '</td>' +
                                // '<td><span class="users-list-role-container">' + parseRoleDisplay(user.role) + '</span></td>' +
                                '<td>' +
                                    '<div class="messenger-sent-item-actions">' +
                                        '<button title="{{lang.LABMESS97}}" data-toggle="tooltip" data-placement="top" onclick="presetViewModalDetail(this, \'' + preset.identifier + '\')" class="btn btn-default btn-xs"><i class="fa fa-file-text-o"></i></button>' +
                                        '<button class="btn btn-success btn-xs"  title="{{lang.LABMESS98}}" data-toggle="tooltip" onclick="sendPresetFromList(this)" data-placement="top"><i class="fa fa-retweet"></i></button>' +
                                        '<button class="btn btn-danger btn-xs" id="btn_del_preset_' + index + '"  title="{{lang.LABMESS99}}" data-toggle="tooltip" onclick="confirmPresetDeletion(this, ' + index + ')" data-placement="top"><i class="fa fa-trash"></i></button>' +
                                    '</div>' +
                                '</td>' +
                            '</tr>';
            index++;
        });
        html_list = '<table class="table cwp-messenger-presets-table table-striped table-bordered table-hover" style="width:100% !important;">' +
                        '<thead>' +
                            '<tr role="row">' +
                                '<th>{{lang.LABMESS82}}</th>' +
                                //'<th>Receivers</th>' +
                                '<th>{{lang.LABMESS86}}</th>' +
                            '</tr>' +
                        '</thead>' +
                        '<tbody id="contenttr">' +
                            html_content +
                        '</tbody>' +
                    '</table>';
    }else{
        html_list = '<div class="not-messenger-records-wrapper"><h5>{{lang.LABMESS100}}</h5></div>';
    }
    $('#_cwp_messenger_preset_table_wrapper_').html(html_list);
    if ($('.cwp-messenger-presets-table').length > 0){
        preset_table = $('.cwp-messenger-presets-table').DataTable({
            "autoWidth": false, // might need this
            columns: [ 
                null,
                { "width": "90px" },
            ]
        });
    }
}
function presetViewModalDetail(elem, identifier){
    let preset_item = $(elem).closest('tr').data('preset-item');
    $('#_cwp_mesenger_preset_detail_date_').text(preset_item.created_at);
    $('#_cwp_mesenger_preset_detail_subject_').text(preset_item.subject);
    let message_type_ico = '<i class="fa fa-square-o" aria-hidden="true"></i>';
    let message_content = preset_item.message;
    if (preset_item.message_html === true) {
        message_type_ico = '<i class="fa fa-check-square-o" aria-hidden="true"></i>';
        message_content = Base64.decode(message_content)
    }
    $('#_cwp_mesenger_preset_detail_messtype_').html(message_type_ico);
    $('#_cwp_mesenger_preset_detail_message_').html(message_content);
    $('#_cwp_messenger_preset_detail_modal_').modal('show');
}
function presetDeletionConfirmed(){
    let index = $('#_preset_deleting_index_').val();
    let tr_deleting = $('#_cwp_messenger_preset_item_' + index);
    tr_deleting.addClass('deleting_tr');
    tr_deleting.find('.btn').prop('disabled', true);
    let preset_data = tr_deleting.data('preset-item');
    handleButtons('#btn_del_preset_' + index, 'fa-trash');
    $('#_cwp_messenger_delete_preset_confirm_modal_').modal('hide');
    sendPresetDeletion(preset_data.identifier, function(){
        tr_deleting.slideUp('fast', function () {
            preset_table.row(this).remove().draw();
        });
        $.gritter.add({
            title: '{{lang.LABMESS88}}',
            text: '{{lang.LABMESS101}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
    }, function(){
        handleButtons('#btn_del_preset_' + index, 'fa-trash', true);
        tr_deleting.removeClass('deleting_tr');
        tr_deleting.find('.btn').prop('disabled', false);
    });
}
function sendPresetDeletion(identifier, success, onerror){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=cwp_messenger&acc=delete_preset",
        data: "identifier=" + identifier,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: 'Error',
                    text: 'An unknown error occurred.',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
                return;
            }
            console.log('resp_data', resp_data);
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = 'An unknown error occurred.';
                /*if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.DNSCLUSLAB46}}';
                    }
                }*/
                $.gritter.add({
                    title: 'Error',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
            }
        }
    });
}