let server_list = JSON.parse('{{mod_vars.server_list|json_encode()|raw}}');
let servers_table = null;
let syncing_now = {{(mod_vars.sync_running == true) ? 'true' : 'false' }};
let log_timer = null;
let log_lines = [];
function listServersInClsuster(){
    let html_table = '';
    console.log('server_list', server_list);
    if (server_list.length > 0) {
        server_list.forEach(function(server){
            let status_values = valuesForRenderServerStatus(server.status);
            let html_status = '<i class="fa fa-circle ' + status_values.circle_class + '"></i> <span>' + status_values.title_status + '</span>';
            html_table += '<tr class="cluster-dns-server-item">' + 
                            '<td>' + server.hostname + '</td>' + 
                            '<td>' + server.ip + '</td>' + 
                            '<td>' + server.user + '</td>' + 
                            '<td>' + columnServerRoleRender(server.role) + '</td>' + 
                            '<td>' + html_status + '</td>' + 
                            '<td class="dns-cluster-actions-td">' +
                                '<button data-toggle="tooltip" data-placement="top" title="{{lang.DNSCLUSLAB52}}" class="btn btn-xs btn-primary dns-cluster-btn-edit-server" onclick="showEditServer(this)" data-id="' + server.id + '"><i class="fa fa-edit"></i></button>' +
                                '<button data-toggle="tooltip" data-placement="top" title="{{lang.DNSCLUSLAB53}}" class="btn btn-xs btn-danger" data-id="' + server.id + '" data-hostname="' + server.hostname + '" onclick="confirmDeleteServer(this)"><i class="fa fa-trash"></i></button>' +
                            '</td>' + 
                        '</tr>';
        });
        html_table = '<table class="table dns-cluster-server-list table-striped table-bordered table-hover">' +
                        '<thead>' +
                            '<tr role="row">' +
                                '<th>Hostname</th>' +
                                '<th>{{lang.DNSCLUSLAB54}}</th>' +
                                '<th>{{lang.DNSCLUSLAB55}}</th>' +
                                '<th>{{lang.DNSCLUSLAB56}}</th>' +
                                '<th>{{lang.DNSCLUSLAB57}}</th>' +
                                '<th class="dns-cluster-actions-td">{{lang.DNSCLUSLAB58}}</th>' +
                            '</tr>' +
                        '</thead>' +
                        '<tbody id="contenttr">' +
                            html_table +
                        '</tbody>' +
                    '</table>';
        let legend_html = '<i class="fa fa-circle text-warning"></i> ' +
                            '<span>Disabled => DNS Cluster feature it\'s disabled in remote server.</span>';
        $('#_dns_cluster_table_wrapper_').html(html_table);
        servers_table = $('.dns-cluster-server-list').DataTable({
            columns: [
                null,
                null,
                null,
                null,
                null,
                { orderable: false },
            ],
            "dom": "<'row'<'col-sm-6'l><'col-sm-6'f>>" +
                    "<'row'<'col-sm-12'tr>>" +
                    "<'row'<'col-sm-12 mercoles'>>" +
                    "<'row'<'col-sm-6'i><'col-sm-6'p>>"
        });
        setTimeout(function(){
            $('.mercoles').html(legend_html);
        }, 400);
        $('[data-toggle="tooltip"]').tooltip();
        $('#_dns_cluster_manual_sync_btn').prop('disabled', false);
    }else{
        $('#_dns_cluster_manual_sync_btn').prop('disabled', true);
        let html_empty_list = '<div class="cluster-empty-servers-list">' +
                                    '<h4>{{lang.DNSCLUSLAB59}}</h4>' +
                                    '<button onclick="newServerForm()" class="btn btn-primary"><i class="fa fa-plus"></i> {{lang.DNSCLUSLAB60}}</button>' + 
                                '</div>';
        $('#_dns_cluster_table_wrapper_').html(html_empty_list);
    }
}
function columnServerRoleRender(role){
    let role_title = 'Standalone';
    let role_desc = 'This method fetches DNS records from the remote server, but does not write records from the local server to the remote server.';
    if (role == 'synchronize'){
        role_title = 'Synchronize';
        role_desc = 'This method synchronizes records between the local server and the remote server. Most administrators use this setting.';
    } else if (role == 'write'){
        role_title = 'Write-only';
        role_desc = 'This role is used to push the DNS records of the local server to be written to the remote server, it does not query the records of the remote server to write to the local server.';
    }
    return role_title
}
function sincronizeButton(){
    let modal_sync = '#modal_manual_sync_confim';
    if (syncing_now === true){
        modal_sync = '#modal_sync_log';  
    }
    $(modal_sync).modal('show');
}
const loader_log = '<div class="action-loader" id="_modal_log_loader">' +
                        '<span><i class="fa fa-circle-o-notch fa-spin"></i></span>' +
                        '<h5>{{lang.DNSCLUSLAB61}}</h5>' +
                    '</div>';
function viewLogModal(){
    $('#modal_sync_log .modal-body').html(loader_log);
    $('#modal_sync_log').modal('show');
}
function showLastSyncLog(){
    $('#modal_sync_log .modal-body').html(loader_log);
    $('#modal_sync_log').modal('show');
    setTimeout(function(){
        sendGetLastSyncLogRequest(function (response) {
            $('#modal_sync_log .modal-body').html('<div id="_modal_dns_cluster_log_panel"></div>');
            response.log.forEach(function(log_line){
                let p_style = logLineStyle(log_line);
                $('#_modal_dns_cluster_log_panel').append('<p class="' + p_style + '">' + log_line + '</p>');
                $('#_modal_dns_cluster_log_panel p').last().attr("tabindex", -1).focus();
            });
        }, function(){
            $('#modal_sync_log').modal('hide');
        });  
    }, 600);
}
function renderSyncLog(lines){
    log_lines = log_lines.concat(lines);
    if (log_timer === null){
        iterateLogLines();
    }
}
function logLineStyle(line){
    let p_style = '';
    let warning_regex = /(getting|sending)(.*)failed,(.*)DNS Cluster feature/i
    let error_regex = /((getting|sending)(.*)failed,)|errors found|error saving/i
    let success_regex = /(were found|succeed|saved|ended|successfully).?$/i
    let info_regex = /sending|getting|reading|saving|preparing|started.$|Sync started/i
    if (warning_regex.test(line)) {
        p_style = 'text-warning';
    } else if (error_regex.test(line)) {
        p_style = 'text-danger';
    } else if (success_regex.test(line)) {
        p_style = 'text-success';
    } else if (info_regex.test(line)) {
        p_style = 'text-info';
    }
    return p_style;
}
function iterateLogLines(){
    if (log_lines.length > 0){
        if($('#_modal_dns_cluster_log_panel').length == 0){
            let loader_bar_html = '<div id="_modal_log_sync_bar_loader_">' +
                                        '<div class="cluster-loader">' +
                                            '<div class="cluster-loader-bar"></div>' +
                                            '<div class="cluster-loader-bar"></div>' +
                                            '<div class="cluster-loader-bar"></div>' +
                                        '</div>' +
                                    '</div>';
                $('#modal_sync_log .modal-body').html(loader_bar_html + '<div id="_modal_dns_cluster_log_panel"></div>');
        }
        let p_style = logLineStyle(log_lines[0]);
        $('#_modal_dns_cluster_log_panel').append('<p class="' + p_style + '">' + log_lines[0] + '</p>');
        $('#_modal_dns_cluster_log_panel p').last().attr("tabindex", -1).focus();
        log_lines.shift();
        log_timer = setTimeout(function(){
            iterateLogLines();
        },30);
    }else{
        if (syncing_now === false){
            $('#_modal_log_sync_bar_loader_').fadeOut('fast');
        }
        log_timer = null;
    }
}
function checkIfSyncStillRunning(){
    sendIsSyncRunningRequest(function (response) {
        if(response.is_running === true){
            renderSyncLog(response.lines);
            setTimeout(function () {
                checkIfSyncStillRunning();
            }, 1000);
            
        }else{
            renderSyncLog(response.lines);
            $('#_cluster_view_curr_sync_btn').fadeOut('fast');
            handleButtons('#_dns_cluster_manual_sync_btn', 'fa-refresh', true);
            $('#_dns_cluster_manual_sync_btn').find('span').text('{{lang.DNSCLUSLAB29}}');
            syncing_now = false;
            let date_last_sync = moment.unix(response.is_running);
            if(date_last_sync.isValid() === true){
                $('#_dns_cluster_last_sync_date_').text(date_last_sync.fromNow());
            }
            if(!$('#_dns_cluster_history_logs_panel_').is(':visible')){
                $('#_dns_cluster_last_log_btn').show();
                $('#_dns_cluster_history_logs_panel_').slideDown('fast');
            } else if (!$('#_dns_cluster_last_log_btn').is(':visible')){
                $('#_dns_cluster_last_log_btn').slideDown('fast');
            }
            $('#_dns_cluster_last_log_btn').data('log', response.last_unique);
            if($('#_modal_log_sync_bar_loader_').is(':visible')){
                $('#_modal_log_sync_bar_loader_').fadeOut('fast');
            }
        }
    });
}
function manualSyncConfirmed(){
    $('#modal_manual_sync_confim').modal('hide');
    handleButtons('#_dns_cluster_manual_sync_btn', 'fa-refresh');
    $('#_dns_cluster_manual_sync_btn').find('span').text('{{lang.DNSCLUSLAB28}}');
    function resetBTN(){
        handleButtons('#_dns_cluster_manual_sync_btn', 'fa-refresh', true);
        $('#_dns_cluster_manual_sync_btn').find('span').text('{{lang.DNSCLUSLAB29}}');
    }
    sendManualSyncRequest(function(){
        $('#_cluster_view_curr_sync_btn').fadeIn('fast');
        // $('#_dns_cluster_manual_sync_btn').prop('disabled', false).removeClass('disabled');
        syncing_now = true;
        checkIfSyncStillRunning()
        viewLogModal();
    }, function(){
        resetBTN();
    });
}
function showEditServer(elem){
    let id_server = $(elem).data('id');
    $('#_dns_cluster_manual_sync_btn').prop('disabled', true);
    slideToggle('#_dns_cluster_loader_window', '#_dns_cluster_main_panel', function(){
        getInfoServerRequest('id_server=' + id_server, function (server_info) {
            slideToggle('#_dns_cluster_server_form', '#_dns_cluster_loader_window', function () {
                fillEditServer(server_info);
                $('#_dns_cluster_server_form_type').val(id_server);
                $('#_dns_cluster_server_form_title').text('{{lang.DNSCLUSLAB62}}');
            });
            $('#_dns_cluster_manual_sync_btn').prop('disabled', false);
        }, function () {
            slideToggle('#_dns_cluster_main_panel', '#_dns_cluster_loader_window');
            $('#_dns_cluster_manual_sync_btn').prop('disabled', false);
        });
    });
}
function valuesForRenderServerStatus(status){
    let circle_class = 'text-success';
    let title_status = '{{lang.DNSCLUSLAB63}}';
    if (status != 'online') {
        circle_class = 'text-danger';
        if(status == 'unauthenticated'){
            title_status = '{{lang.DNSCLUSLAB64}}'; 
        } else if (status == 'offline'){
            title_status = '{{lang.DNSCLUSLAB65}}'; 
        } else if (status == 'disabled') {
            circle_class = 'text-warning';
            title_status = 'Disabled';
        }else{
            title_status = '{{lang.DNSCLUSLAB66}}'; 
        }
    }
    return {
        circle_class : circle_class,
        title_status : title_status,
    }
}
function fillEditServer(server_info){
    $('#server_host').val(server_info.ip);
    $('#server_username').val(server_info.user);
    $('#server_token').val(server_info.token);
    $('#server_role').val(server_info.role);
    $('#_dns_cluster_edit_extra').show();
    $('#_dns_cluster_form_hostname').text(server_info.hostname);
    let status_values = valuesForRenderServerStatus(server_info.status);
    $('#_dns_cluster_form_status').find('i').removeClass().addClass('fa fa-circle ' + status_values.circle_class);
    $('#_dns_cluster_form_status').find('span').text(status_values.title_status);
    // let title = 'Editing server' + (server_info.hostname != '-' ? '  - hostname: ' + server_info.hostname : '') + ' online';
}
function handleDNSClusterStatus(elem){
    let action = $(elem).data('action');
    let title_loading = '{{lang.DNSCLUSLAB67}}';
    let btn_next_class = 'btn-danger';
    let btn_curr_class = 'btn-success';
    let next_action = 'disable';
    let next_btn_title = '{{lang.DNSCLUSLAB68}}';
    let led_next_class = 'label-success';
    let led_curr_class = 'label-danger';
    let led_next_ico = 'fa-check';
    let led_curr_ico = 'fa-ban';
    let led_title = '{{lang.DNSCLUSLAB69}}';
    if(action == 'disable'){
        next_btn_title = '{{lang.DNSCLUSLAB70}}';
        title_loading = '{{lang.DNSCLUSLAB71}}';
        btn_next_class = 'btn-success';
        btn_curr_class = 'btn-danger';
        next_action = 'enable';
        led_next_class = 'label-danger';
        led_curr_class = 'label-success';
        led_next_ico = 'fa-ban';
        led_curr_ico = 'fa-check';
        led_title = '{{lang.DNSCLUSLAB72}}';
    }
    $('#_dns_cluster_loader_window_title').text(title_loading);
    $('#_dns_cluster_manual_sync_btn').prop('disabled', true);
    slideToggle('#_dns_cluster_loader_window', '#_dns_cluster_main_panel', function(){
        sendDNSClusterStatusRequest(action, function () {
            let action_text = '';
            if (action == 'enable') {
                $('.active-dnscluster-options').addClass('active-cluster');
                action_text = 'enabled';
                $('#_dns_cluster_manual_sync_btn').prop('disabled', false);
            } else {
                action_text = 'disabled';
                $('.active-dnscluster-options').removeClass('active-cluster');
            }
            $.gritter.add({
                title: '{{lang.DNSCLUSLAB49}}',
                text: '{{lang.DNSCLUSLAB73}} ' + action_text + ' {{lang.DNSCLUSLAB74}}',
                time: 5000,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'success-notice'
            });
            $('#_dns_cluster_status_led').removeClass(led_curr_class).addClass(led_next_class);
            $('#_dns_cluster_status_led').find('i').removeClass(led_curr_ico).addClass(led_next_ico);
            $('#_dns_cluster_status_led').find('span').text(led_title);

            // label-success
            $('.btn-cluster-status-handler').removeClass(btn_curr_class).addClass(btn_next_class).text(next_btn_title);
            $('.btn-cluster-status-handler').data('action', next_action);
            slideToggle('#_dns_cluster_main_panel', '#_dns_cluster_loader_window');
        }, function () {
            slideToggle('#_dns_cluster_main_panel', '#_dns_cluster_loader_window')
        });
    });

}
function saveServerForm(){
    let valid = true;
    let ipformat = /^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;
    $('#_dns_cluster_server_form .required-field').each(function () {
        let err_placement = $(this).data('error-place') !== undefined ? $(this).data('error-place') : this;
        if ($(this).val() == '' || ($(this).hasClass('ipfield') && !$(this).val().match(ipformat))) {
            $(err_placement).addClass('error-field');
            if (valid === true) {
                $(this).focus();
                valid = false;
            }
        } else {
            $(err_placement).removeClass('error-field');
        }
    });
    if(!valid){
        $.gritter.add({
            title: '{{lang.DNSCLUSLAB44}}',
            text: '{{lang.DNSCLUSLAB75}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
        return;
    }
    
    $('#_dns_cluster_cancel_btn').prop('disabled', true);
    handleButtons('#_dns_cluster_save_btn', 'fa-floppy-o');
    function restoreBtns(){
        $('#_dns_cluster_cancel_btn').prop('disabled', false);
        handleButtons('#_dns_cluster_save_btn', 'fa-floppy-o', true);
        $('#_dns_cluster_manual_sync_btn').prop('disabled', false);
    }
    let action_type = 'save';
    let server_data = serverDataFromForm();
    if($('#_dns_cluster_server_form_type').val() !== 'save'){
        server_data.id = $('#_dns_cluster_server_form_type').val();
        action_type = 'edit';
    }
    $('#_dns_cluster_manual_sync_btn').prop('disabled', true);
    sendSaveServerRequest(JSON.stringify(server_data), action_type, function(){
        restoreBtns();
        cancelServerForm();
    },function(){
        restoreBtns();
    });
}
function handleServerSaveSuccessAlert(warning){
    if (warning === null){
        $.gritter.add({
            title: '{{lang.DNSCLUSLAB49}}',
            text: '{{lang.DNSCLUSLAB76}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'success-notice'
        });
    }else{
        let mess_warning = '{{lang.DNSCLUSLAB77}}>'
        if(warning == 1){
            mess_warning = '{{lang.DNSCLUSLAB78}}';
        }else if(warning == 2){
            mess_warning = '{{lang.DNSCLUSLAB79}}';
        }
        $.gritter.add({
            title: '{{lang.DNSCLUSLAB35}}',
            text: mess_warning,
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'warning-notice'
        });
    }
}
function serverDataFromForm(){
    return {
        ip: $('#server_host').val(),
        user: $('#server_username').val(),
        token: $('#server_token').val(),
        role: $('#server_role').val(),
        type: $('#server_type').val(),
    }
}
function confirmDeleteServer(elem){
    let hostname = $(elem).data('hostname');
    $('#confirm_server_delete_name').text(hostname);
    $('#modal_aserver_delete_confirm').modal('show');
    $('#_dns_cluster_server_confirm_del_btn').unbind('click').click(function(){
        $('#modal_aserver_delete_confirm').modal('hide');
        let tr = $(elem).closest('tr');
        tr.addClass('deleting_tr');
        tr.find('.btn').prop('disabled', true);
        handleButtons(elem, 'fa-trash');
        function restoreBtns() {
            tr.removeClass('deleting_tr');
            tr.find('.btn').prop('disabled', false);
            handleButtons(elem, 'fa-trash', true);
        }
        let server_id = $(elem).data('id');
        sendDeleteServerRequest(server_id, function(){
            tr.slideUp('fast', function () {
                servers_table.row(this).remove().draw();
            });
            restoreBtns();
        }, function(){
            restoreBtns();
        });
    });
}
function handleButtons(elem, icon_fa, type) {
    let icon = $(elem).find('.fa');
    if (type == undefined) {
        $(elem).addClass('disabled');
        $(elem).prop('disabled', true);
        icon.removeClass(icon_fa);
        icon.addClass('fa-spinner fa-spin');
    } else {
        icon.removeClass('fa-spinner fa-spin');
        icon.addClass(icon_fa);
        $(elem).removeClass('disabled');
        $(elem).prop('disabled', false);
    }
}
function newServerForm(){
    slideToggle('#_dns_cluster_server_form', '#_dns_cluster_main_panel');
} 
function cancelServerForm(){
    slideToggle('#_dns_cluster_main_panel', '#_dns_cluster_server_form', function(){
        $('#server_host').val('');
        $('#server_username').val('');
        $('#server_token').val('');
        $('#server_role').val('synchronize');
        $('#_dns_cluster_server_form_type').val('save');
        $('#_dns_cluster_server_form_title').text('{{lang.DNSCLUSLAB35}}');
        $('#_dns_cluster_edit_extra').hide();
        $('.error-field').removeClass('error-field');
    });
}
function slideToggle(show, hide, callback) {
    $(hide).slideUp('fast', function () {
        if (typeof callback == 'function') {
            callback();
        }
        $(show).slideDown('fast');
    });
}
$(document).ready(function () {
    listServersInClsuster();
    let last_sync_elem = $('#_dns_cluster_last_sync_date_');
    let last_sync_time = last_sync_elem.data('time');
    if (last_sync_time != null){
        let date_last_sync = moment.unix(last_sync_time);
        last_sync_elem.text(date_last_sync.fromNow());
    }
    $('[data-toggle="tooltip"]').tooltip();
    if (syncing_now){
        checkIfSyncStillRunning();
    }
});
