function sendDeleteServerRequest(server_id, success, onerror) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=dns_cluster&acc=delete_server",
        data: "server_id=" + server_id,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.DNSCLUSLAB44}}',
                    text: '{{lang.DNSCLUSLAB45}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success();
            } else {
                let message_error = '{{lang.DNSCLUSLAB45}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.DNSCLUSLAB46}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.DNSCLUSLAB44}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
            }
        }
    });
}
function getInfoServerRequest(data, success, onerror) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=dns_cluster&acc=info_server",
        data: data,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.DNSCLUSLAB44}}',
                    text: '{{lang.DNSCLUSLAB45}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data.info);
            } else {
                let message_error = '{{lang.DNSCLUSLAB45}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.DNSCLUSLAB46}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.DNSCLUSLAB44}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
            }
        }
    });
}
function sendDNSClusterStatusRequest(action, success, onerror) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=dns_cluster&acc=cluster_status",
        data: 'action=' + action,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.DNSCLUSLAB44}}',
                    text: '{{lang.DNSCLUSLAB45}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success();
            } else {
                let message_error = '{{lang.DNSCLUSLAB45}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = 'Invalid state';
                    }
                }
                $.gritter.add({
                    title: '{{lang.DNSCLUSLAB44}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
            }
        }
    });
}
function sendSaveServerRequest(data, action, success, onerror) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=dns_cluster&acc=save_server",
        data: 'server=' + data + '&action=' + action,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.DNSCLUSLAB44}}',
                    text: '{{lang.DNSCLUSLAB45}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                server_list = resp_data.list;
                handleServerSaveSuccessAlert(resp_data.warning);
                listServersInClsuster();
                success();
            } else {
                let message_error = '{{lang.DNSCLUSLAB45}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.DNSCLUSLAB48}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.DNSCLUSLAB44}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
            }
        }
    });
}
function sendManualSyncRequest(success, onerror) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=dns_cluster&acc=manual_sync",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.DNSCLUSLAB44}}',
                    text: '{{lang.DNSCLUSLAB45}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                server_list = resp_data.list;
                $.gritter.add({
                    title: '{{lang.DNSCLUSLAB49}}',
                    text: '{{lang.DNSCLUSLAB50}}',
                    time: 5500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'success-notice'
                });
                success();
            } else {
                let message_error = '{{lang.DNSCLUSLAB45}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.DNSCLUSLAB48}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.DNSCLUSLAB44}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
            }
        }
    });
}
function sendIsSyncRunningRequest(success) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=dns_cluster&acc=check_sync_status",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                // $.gritter.add({
                //     title: '{{lang.DNSCLUSLAB44}}',
                //     text: '{{lang.DNSCLUSLAB45}}',
                //     time: 3500,
                //     close_icon: '',
                //     icon: 'icomoon-icon-power',
                //     class_name: 'error-notice'
                // });
                // onerror();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            }
        }
    });
}
function sendGetLastSyncLogRequest(success, onerror) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=dns_cluster&acc=get_last_sync_log",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.DNSCLUSLAB44}}',
                    text: '{{lang.DNSCLUSLAB45}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.DNSCLUSLAB45}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.DNSCLUSLAB51}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.DNSCLUSLAB44}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                onerror();
            }
        }
    });
}