let users_list = JSON.parse('{{mod_vars.users_list|json_encode|raw}}');
let user_config = null;
let mongo_info = null;
$(document).ready(function(){
    {% if mod_vars.installed == true %}
        MongoDBList();
        BindUserModal();
        BindSettingsTab();
        user_config = JSON.parse('{{mod_vars.user_config|json_encode|raw}}');
        mongo_info = JSON.parse('{{mod_vars.mongo_info|json_encode|raw}}');
    {% endif %}
    $('#_mongo_manage_user_modal_').on('hidden.bs.modal', function () {
        CleanUserModal()
    });
    RenderUserInForm();
    BindConfigTab();
});
function setConfigValues(){
    if (user_config !== null){
        $('#_mongodb_conf_user_enabled_').prop('checked', user_config.user_enabled);
        if (user_config.user_enabled === true){
            $('#_mongo_users_select_wrapper_').show();
            $('#_mongodb_availability_select_').val(user_config.availability_type);
            if (user_config.availability_type == '2'){
                $('#_mongo_users_select_availability_').show();
            }
        }
        $('#_mongodb_conf_user_enabled_').prop('checked', user_config.user_enabled);
        $('#version_holder').text(mongo_info.version);
        $('#_mongodb_status_holder').text(statusTranslator(mongo_info.status));
        $('#_mongodb_status_holder_hidden_').val(mongo_info.status);
    }
}
function statusTranslator(status){
    return status == 'running' ? 'Running' : 'Stopped';
}
function unistallMongoDB(){
    $('#_mongo_uninstall_confirm_modal_').modal('show');
}
function MongoUninstallConfirmed(){
    slideToggle('#_mongodb_loader_screen_', '#_mongodb_dashboard_main_');
    $('#_mongo_uninstall_confirm_modal_').modal('hide');
    $('#_mongodb_loader_title_').text('Unistalling MongoDB, please wait.');
    sendMongoDBUninstallation(function(){
        users_db_list = [];
        users_db_table = null;
        database_list = [];
        user_config = {
            user_enabled: false,
            availability_type: '1',
            availability_users: []
        };
        setConfigValues();
        $.gritter.add({
            title: '{{lang.LABMONSUCCESS}}',
            text: 'MongoDB was successfully uninstalled',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        slideToggle('#_mongodb_not_installed_screen_', '#_mongodb_loader_screen_');
    },function(){
        slideToggle('#_mongodb_dashboard_main_', '#_mongodb_loader_screen_');
    });
}
function BindConfigTab(){
    let list_opts = {
        nonSelectedListLabel: 'User accounts list',
        selectedListLabel: 'MongoDB available (accounts)',
        selectorMinimalHeight: 200,
        filterTextClear: 'show all', // the text for the "Show All" button.
        filterPlaceHolder: 'Filter', // the placeholder for the input element for filtering elements.
        moveSelectedLabel: 'Move selected', // the label for the "Move Selected" button.
        moveAllLabel: 'Move all', // the label for the "Move All" button.
        removeSelectedLabel: 'Remove selected', // the label for the "Remove Selected" button.
        removeAllLabel: 'Remove all', // the label for the "Remove All" button.
    };
    $('#_mongodb_availability_select_users_').bootstrapDualListbox(list_opts);
    setConfigValues();
}
function mongoChangeUsersToAvailable(elem){
    if ($(elem).val() == '2'){
        $('#_mongo_users_select_availability_').slideDown('fast');
    }else{
        $('#_mongo_users_select_availability_').slideUp('fast', function(){
            // $('#_mongo_users_select_availability_ .removeall').trigger('click');
        });
    }
}
function MongoSaveConfigurations(elem){
    handleButtons(elem, 'fa-floppy-o');
    let users_availability = $('#_mongodb_availability_select_users_').val();
    let user_config = {
        user_enabled: $('#_mongodb_conf_user_enabled_').is(':checked'),
        availability_type: $('#_mongodb_availability_select_').val(),
        availability_users: users_availability === null ? [] : users_availability
    }
    sendMongoDBConfigurations(JSON.stringify(user_config), function(){
        handleButtons(elem, 'fa-floppy-o', true);
        $.gritter.add({
            title: '{{lang.LABMONSUCCESS}}',
            text: 'User panel configuration was saved.',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
    },function(){
        handleButtons(elem, 'fa-floppy-o', true);
    });
}
function changeUserAvailability(elem){
    if ($(elem).is(':checked')){
        $('#_mongo_users_select_wrapper_').slideDown('fast');
    }else{
        $('#_mongo_users_select_wrapper_').slideUp('fast');
        $('#_mongo_users_select_availability_').slideUp('fast', function () {
            // $('#_mongodb_availability_select_').val('1');
            // $('#_mongo_users_select_availability_ .removeall').trigger('click');
        });
    }
}
function getIfUserAvailable(user){
    return (user_config !== null && user_config.availability_users.find(function(usr){return usr == user}) != undefined) ? 'selected' : '';
}
function RenderUserInForm(){
    let users_select = '';
    let users_select_2 = '';
    users_list.forEach(function(user){
        let selected_user = getIfUserAvailable(user);
        users_select += '<option value="' + user + '" >' + user + '</option>';
        users_select_2 += '<option value="' + user + '" ' + selected_user + '>' + user + '</option>';
    });
    $('#_mongo_db_form_user').html('<select class="form-control" name="" id="_mongo_db_user_select_">' +
                                        '<option value="" id="" selected>{{lang.LABMON16}}</option>' +
                                        users_select + 
                                    + '</select>');
    $('#_mongo_users_select_availability_').html('<select name="_mongodb_availability_select_" multiple="" class="form-control" id="_mongodb_availability_select_users_">' +
                                        users_select_2 + 
                                    + '</select>');
    $("#_mongo_db_user_select_").select2({
        placeholder: "{{lang.LABMON17}}",
        allowClear: true
    });
}
function MongoInstallationModal(version) {
    $('#_mongodb_version_to_install_').html(version);
    $('#_mongo_install_confirm_modal_').modal('show');
}
function MongoSaveSettings(elem){

}
function copyPass(elem) {
    let field = document.getElementById(elem);
    field.select();
    document.execCommand('copy');
    $.gritter.add({
        title: '{{lang.LABMONSUCCESS}}',
        text: '{{lang.LABMONCOPIEDPASS}}',
        time: 3500,
        close_icon: '',
        icon: 'icomoon-icon-quill-2',
        class_name: 'success-notice'
    });
    // noti_bubble('{{lang.LABMONCOPIEDPASS}}', '{{lang.LABMONSUCCESS}}', 'success', false, false, '3000', true);
}
function openPGOPT(type, second) {
    let divelem = type == null ? '#pgopt_container' : type;
    if ($(divelem).is(':visible')) {
        $(divelem).slideUp('fast');
    } else {
        $(divelem).slideDown('fast');
        hideOnClickOutside(divelem, second);
    }
}
function hideOnClickOutside(selector, second) {
    let forhide = true;
    if (second === undefined) {
        second = '.show_options_button';
        forhide = true;
    }
    function outsideClickListener(event) {
        $target = $(event.target);
        if (!$target.closest(selector).length && !$target.closest(second).length && $(selector).is(':visible')) {
            if (forhide) {
                $(selector).slideUp('fast');
            } else {
                $(selector).remove();
            }
            removeClickListener();
        }
    }
    function removeClickListener() {
        document.removeEventListener('click', outsideClickListener)
    }
    document.addEventListener('click', outsideClickListener)
}
function generatePasswordRand(length, type) {
    switch (type) {
        case 'num':
            characters = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
            break;
        case 'alf':
            characters = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
            break;
        case 'rand':
            //FOR ↓
            break;
        default:
            characters = "0123456789/-_%*!^><.abcdefghijklmnopqrstuvwxyz/-_%*!^><.ABCDEFGHIJKLMNOPQRSTUVWXYZ/-_%*!^><.";
            break;
    }
    var pass = "";
    for (i = 0; i < length; i++) {
        if (type == 'rand') {
            pass += String.fromCharCode((Math.floor((Math.random() * 100)) % 94) + 33);
        } else {
            pass += characters.charAt(Math.floor(Math.random() * characters.length));
        }
    }
    return pass;
}
function generateNewPass(element) {
    let passmeter = $(element).parent().parent().find('.pass_container input');
    let lengthpass = $(element).parent().find('.general-password-generator-options .pwlength');
    let typepass = $(element).parent().find('.general-password-generator-options .pwtype');
    let confpass = 'ftppass2_ch';
    // if(type == 'userp'){
    //   passmeter = 'ftppass1';
    //   lengthpass = 'lengthpass';
    //   typepass = 'typepass';
    //   confpass = 'ftppass2';
    // }
    let lpass = lengthpass.val();
    let tpass = typepass.val();
    let new_pass = generatePasswordRand(lpass, tpass);
    passmeter.val(new_pass);
    passmeter.pwstrength("forceUpdate");
    // if(type == undefined || type == 'userp'){
    //   copyPass(passmeter);
    // }
    copyPass(passmeter.attr('id'));
}
function MongoInstallationConfirmed(){
    let version = $('#_mongodb_version_to_install_').text();
    $('#_mongodb_loader_title_').html('Installing MongoDB version ' + $('#_mongodb_version_to_install_').text());
    slideToggle('#_mongodb_loader_screen_', '#_mongodb_not_installed_screen_');
    $('#_mongo_install_confirm_modal_').modal('hide');
    sendMongoInstallation(version, function (response) {
        $('#_mongodb_list_link_tab_').trigger('click');
        database_list = response.db_list;
        mongo_info = response.mongo_info;
        mongo_settings = response.settings;
        MongoDBList();
        $('#_mongo_file_editor_area_').val(response.file_content);
        BindSettingsTab();
        slideToggle('#_mongodb_dashboard_main_','#_mongodb_loader_screen_', function(){
            statusOnInstall();
        });
    }, function () {
        slideToggle('#_mongodb_not_installed_screen_','#_mongodb_loader_screen_');
    });

}
function handleButtons(elem, icon_fa, type) {
    let icon = $(elem).find('.fa');
    if (type == undefined) {
        $(elem).addClass('disabled');
        $(elem).prop('disabled', true);
        icon.removeClass(icon_fa);
        icon.addClass('fa-spinner fa-spin');
    } else {
        icon.removeClass('fa-spinner fa-spin');
        icon.addClass(icon_fa);
        $(elem).removeClass('disabled');
        $(elem).prop('disabled', false);
    }
}
function saveMongoForm(){
    let db_data = MongoGetDBData();
    if(db_data){
        $('.btn-cancel').prop('disabled', true);
        handleButtons('.btn-save-mongo-db', 'fa-floppy-o');
        function cleaner(){
            $('.btn-cancel').prop('disabled', false);
            handleButtons('.btn-save-mongo-db', 'fa-floppy-o', false);
        }
        sendSaveMongoDB(db_data, function(){
            $.gritter.add({
                title: '{{lang.LABMON18}}',
                text: '{{lang.LABMON19}}',
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-quill-2',
                class_name: 'success-notice'
            });
            cleaner();
            updateDBTable(db_data);
            cancelForm();
        }, function(){
            cleaner();
        });
    }else{
        $.gritter.add({
            title: '{{lang.LABMON20}}',
            text: '{{lang.LABMON21}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
    }
}
function MongoGetDBData(){
    let valid = true;
    let user = $('#_mongo_db_user_select_').val();
    if(user == ''){
        valid = false;
        $('.select2-container .select2-choice').addClass('error-field');
    }else{
        $('.select2-container .select2-choice').removeClass('error-field');
    }
    let db_name = $('#_mongo_db_name_input_').val();
    if (/^[A-Za-z0-9\_\-]+$/.test(db_name) === false){
        valid = false;
        $('#_mongo_db_name_input_').addClass('error-field');
    }else{
        $('#_mongo_db_name_input_').removeClass('error-field');
    }
    
    return valid === true ? {
        'name': db_name,
        'user': user
    } : false;
}
function slideToggle(show, hide, callback) {
    $(hide).slideUp('fast', function () {
        if (typeof callback == 'function') {
            callback();
        }
        $(show).slideDown('fast');
    });
}
function ShowDeleteConfirmModal(elem, index){
    let db_name = $(elem).data('name')
    let db_user = $(elem).data('user')
    $('#_mongo_db_deleting_index_').val(index);
    $('#_mongodb_database_to_remove_').text(db_name);
    $('#_mongo_delete_confirm_modal_').modal('show');
}
function MongoDeletionConfirmed(){
    $('#_mongo_delete_confirm_modal_').modal('hide');
    let db_index = $('#_mongo_db_deleting_index_').val();
    let tr_deleting = $('#_mongo_db_item_' + db_index);
    tr_deleting.addClass('deleting_tr');
    tr_deleting.find('.btn-primary').prop('disabled', true);
    let btn_delete = tr_deleting.find('.btn-warning');
    let db_data = {
        name: btn_delete.data('name'),
        user: btn_delete.data('user'),
    }
    handleButtons(btn_delete, 'fa-trash');
    sendMongoDBDeletion(db_data, function(){
        tr_deleting.slideUp('fast', function () {
            mongo_db_table.row(this).remove().draw();
        });
        database_list.splice(db_index, 1);
        $.gritter.add({
            title: '{{lang.LABMON18}}',
            text: '{{lang.LABMON22}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
    }, function(){
        tr_deleting.removeClass('deleting_tr');
        tr_deleting.find('.btn-primary').prop('disabled', false);
        handleButtons(btn_delete, 'fa-trash', true)
    });

}
function cancelForm(){
    slideToggle('#_mongo_db_list_view_', '#_mongo_db_form_view_', function(){
        $('#_mongo_db_user_select_').val('');
        $('#_mongo_db_user_select_').trigger('change');
        $('#_mongo_db_name_input_').val('');
        $('.select2-container .select2-choice').removeClass('error-field');
        $('#_mongo_db_name_input_').removeClass('error-field');
    });
}
function MongoAddDBForm(){
    slideToggle('#_mongo_db_form_view_', '#_mongo_db_list_view_');
}
function sendMongoInstallation(version, success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mongodb_manager&acc=install_mongodb",
        data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMON20}}',
                    text: '{{lang.LABMON23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMON23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMON20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendSaveMongoDB(db_data, success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mongodb_manager&acc=save_mongo_db",
        data: 'name=' + db_data.name + '&user=' + db_data.user,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMON20}}',
                    text: '{{lang.LABMON23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMON23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABMON24}}';
                    } else if (resp_data.code == 2) {
                        message_error = '{{lang.LABMON25}}';
                    } else if (resp_data.code == 3) {
                        message_error = '{{lang.LABMON26}}';
                    } else if (resp_data.code == 4) {
                        message_error = '{{lang.LABMON27}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMON20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendMongoDBDeletion(db_data, success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mongodb_manager&acc=delete_mongo_db",
        data: 'name=' + db_data.name,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMON20}}',
                    text: '{{lang.LABMON23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMON23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABMON28}}';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABMON29}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMON20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendMongoDBConfigurations(user_config, success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mongodb_manager&acc=save_usr_config",
        data: 'user_config=' + user_config,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMON20}}',
                    text: '{{lang.LABMON23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMON23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABMON28}}';
                    } else if (resp_data.code == 1) {
                        message_error = 'Invalid data';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMON20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendMongoDBUninstallation(success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mongodb_manager&acc=uninstall_mongodb",
        data: 'user_config=' + user_config,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMON20}}',
                    text: '{{lang.LABMON23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMON23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABMON28}}';
                    } else if (resp_data.code == 1) {
                        message_error = 'Invalid data';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMON20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
var Base64 = {

    // private property
    _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

    // public method for encoding
    encode: function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;

        input = Base64._utf8_encode(input);

        while (i < input.length) {

            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);

            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }

            output = output +
                this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
                this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

        }

        return output;
    },

    // public method for decoding
    decode: function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;

        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        while (i < input.length) {

            enc1 = this._keyStr.indexOf(input.charAt(i++));
            enc2 = this._keyStr.indexOf(input.charAt(i++));
            enc3 = this._keyStr.indexOf(input.charAt(i++));
            enc4 = this._keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

        }

        output = Base64._utf8_decode(output);

        return output;

    },

    // private method for UTF-8 encoding
    _utf8_encode: function (string) {
        string = string.replace(/\r\n/g, "\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if ((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    },

    // private method for UTF-8 decoding
    _utf8_decode: function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while (i < utftext.length) {

            c = utftext.charCodeAt(i);

            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if ((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i + 1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i + 1);
                c3 = utftext.charCodeAt(i + 2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }

        }

        return string;
    }

}
{% include 'js/mongo_database_list.js' %}
{% include 'js/users_list.js' %}
{% include 'js/mongodb_status.js' %}
{% include 'js/mongo_settings_tab.js' %}