function mongoDBStatusStart(){
    // let visible_elem = $('#_mongodb_main_col .panel-default:visible').first();
    // console.log('#_mongodb_status_panel_', '#_not_running_screen_panel_');
    $('#_mongodb_status_loader_title_').text('{{lang.LABMON90}}');
    slideToggle('.mongodb-status-panel', '.mongodb-tabs-container-main');
    handleButtons('.on-not-running', 'fa-play');
    sendMongoDBUStatusHandler('start', function(response){
        database_list = response.database_list;
        MongoDBList();
        slideToggle('.mongodb-tabs-container-main', '.mongodb-status-panel', function(){
            $('.running-screen-twice').show();
            $('.not-running-screen').hide();
        });
        $('.on-not-running').fadeOut('fast', function(){
            $('.on-running').fadeIn('fast');
            handleButtons('.on-not-running', 'fa-play', true);
        });
        $.gritter.add({
            title: '{{lang.LABMON18}}',
            text: '{{lang.LABMON143}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        $('#_mongodb_status_holder_hidden_').val('running');
        $('#_mongodb_status_holder').text(statusTranslator('running'));
    }, function(){
        slideToggle('.mongodb-status-panel', '.mongodb-tabs-container-main');
        handleButtons('.on-not-running', 'fa-play', true);
        $.gritter.add({
            title: '{{lang.LABMON20}}',
            text: '{{lang.LABMON144}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
    });

}
function statusOnInstall(){
    if(mongo_info.status == 'running'){
        $('.mongodb-status-panel').hide();
        $('.mongodb-tabs-container-main').show();
        $('.on-not-running').hide();
        $('.on-running').show();
        $('.running-screen-twice').show();
        $('.not-running-screen').hide();
    }else{
        $('.mongodb-tabs-container-main').hide();
        $('.mongodb-status-panel').hide();
        $('.on-running').hide();
        $('.on-not-running').show();
        $('.running-screen-twice').hide();
        $('.not-running-screen').show();
    }
    $('#version_holder').text(mongo_info.version);
    $('#_mongodb_status_holder_hidden_').val(mongo_info.status);
    $('#_mongodb_status_holder').text(statusTranslator(mongo_info.status));
}
function mongoDBStatusStop(){
    // let visible_elem = $('#_mongodb_main_col .panel-default:visible').first();
    // console.log('#_mongodb_status_panel_', '#_not_running_screen_panel_');
    $('#_mongodb_status_loader_title_').text('{{lang.LABMON145}}');
    slideToggle('.mongodb-status-panel', '.mongodb-tabs-container-main');
    function handleBtns(st){
        handleButtons('#_btn_stop_sidebar_', 'fa-stop', st);
        handleButtons('#_btn_restart_sidebar_', 'fa-refresh', st);
    }
    handleBtns();
    sendMongoDBUStatusHandler('stop', function(response){
        slideToggle('.mongodb-tabs-container-main', '.mongodb-status-panel', function(){
            $('.running-screen-twice').hide();
            $('.not-running-screen').show();
        });
        $('.on-running').fadeOut('fast', function () {
            $('.on-not-running').fadeIn('fast');
            handleBtns(false);
        });
        $.gritter.add({
            title: '{{lang.LABMON18}}',
            text: '{{lang.LABMON146}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        $('#_mongodb_status_holder_hidden_').val('stopped');
        $('#_mongodb_status_holder').text(statusTranslator('stopped'));
    }, function(){
        slideToggle('.mongodb-tabs-container-main', '.mongodb-status-panel');
        handleBtns(false);
    });

}
function mongoDBStatusRestart(){
    // let visible_elem = $('#_mongodb_main_col .panel-default:visible').first();
    // console.log('#_mongodb_status_panel_', '#_not_running_screen_panel_');
    $('#_mongodb_status_loader_title_').text('{{lang.LABMON145}}');
    slideToggle('.mongodb-status-panel', '.mongodb-tabs-container-main');
    function handleBtns(st){
        handleButtons('#_btn_stop_sidebar_', 'fa-stop', st);
        handleButtons('#_btn_restart_sidebar_', 'fa-refresh', st);
    }
    handleBtns();
    sendMongoDBUStatusHandler('stop', function(response){
        slideToggle('.mongodb-tabs-container-main', '.mongodb-status-panel');
        handleBtns(false);
        $.gritter.add({
            title: '{{lang.LABMON18}}',
            text: '{{lang.LABMON147}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        $('#_mongodb_status_holder_hidden_').val('running');
        $('#_mongodb_status_holder').text(statusTranslator('running'));
    }, function(){
        $('.on-running').fadeOut('fast', function () {
            $('.on-not-running').fadeIn('fast');
            handleBtns(false);
        });
        slideToggle('.not-running-screen-panel', '.mongodb-status-panel', function(){
            $('.running-screen-twice').hide();
            $('.not-running-screen').show();
        });
        handleBtns(false);
        $.gritter.add({
            title: '{{lang.LABMON20}}',
            text: 'Mongo Database can not start.',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
        $('#_mongodb_status_holder_hidden_').val('stopped');
        $('#_mongodb_status_holder').text(statusTranslator('stopped'));
    });

}
function sendMongoDBUStatusHandler(type, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mongodb_manager&acc=status_handler",
        data: 'type=' + type,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMON20}}',
                    text: '{{lang.LABMON23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                // let message_error = '{{lang.LABMON23}}';
                if (!resp_data.hasOwnProperty('code')) {
                    // if (resp_data.code == 2) {
                    //     message_error = '{{lang.LABMON28}}';
                    // } else if (resp_data.code == 1) {
                    //     message_error = 'Invalid data';
                    // }
                    $.gritter.add({
                        title: '{{lang.LABMON20}}',
                        text: '{{lang.LABMON23}}',
                        time: 3500,
                        close_icon: '',
                        icon: 'icomoon-icon-power',
                        class_name: 'error-notice'
                    });
                }
                cleaner();
            }
        }
    });
}