let users_db_list = null;
let users_db_table = null;
function MongoValidateuserForm(){
    let valid = true;
    let uname = $('#_mongodb_username_input_').val();
    let dbname = $('#_mongo_user_modal_dbname_').val();
    let error_message = '{{lang.LABMON30}}';
    let is_new_user = $('#_mongodb_username_input_').is(':visible');
    if (is_new_user){
        if (/^[A-Za-z0-9\_\-]+$/.test(uname) === false) {
            valid = false;
            $('#_mongodb_username_input_').addClass('error-field');
        } else {
            uname = $('#_mongodb_user_modal_sysowner_').text() + uname;
            $('#_mongodb_username_input_').removeClass('error-field');
        }
        if ($('#_user_new_pass_field').val() == '') {
            valid = false;
            $('#_user_new_pass_field').addClass('error-field');
        } else {
            $('#_user_new_pass_field').removeClass('error-field');
        }
    }else{
        uname = $('#_mongodb_manage_username_wrapper_ span').text();
    }
    if ($('#_user_role').val() == ''){
        valid = false;
        $('#_user_role').addClass('error-field');
    }else{
        $('#_user_role').removeClass('error-field');
    }
    if ($('#_user_new_pass_field').val() != $('#_user_new_pass_field_confirm').val()){
        $('#_user_new_pass_field').addClass('error-field');
        $('#_user_new_pass_field_confirm').addClass('error-field');
        error_message = valid === true ? '{{lang.LABMON31}}' : error_message + '<br /><b>{{lang.LABMON31}}</b>';
        valid = false;
    } else if (!is_new_user || (is_new_user && $('#_user_new_pass_field').val() != '')){
        $('#_user_new_pass_field').removeClass('error-field');
        $('#_user_new_pass_field_confirm').removeClass('error-field');
    }
    if(valid === true){
        return {
            dbname: dbname,
            uname: uname,
            role: $('#_user_role').val(),
            pass: $('#_user_new_pass_field').val(),
        };
    }else{
        $.gritter.add({
            title: 'Error',
            text: error_message,
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
        return false;
    }
}
function LoadeDBUsers() {
    if ($('#_mongodb_status_holder_hidden_').val() != 'running'){
        return;
    }
    if (users_db_list === null){
        slideToggle('#_mongdb_users_loader_', '#_mongdb_users_list_wrapper_');
        getMongoDBUsersList(null, function(resp_data){
            users_db_list = resp_data.list;
            renderUsersList();
            slideToggle('#_mongdb_users_list_wrapper_', '#_mongdb_users_loader_');
        }, function(){
            $('#_mongdb_users_list_wrapper_').html('<div class="mongodb-user-list-error">' +
                                                        '<i class="fa fa-ban text-danger"></i>' +
                                                        '<h5>{{lang.LABMON32}}</h5>' +
                                                        '<button class="btn btn-primary">' +
                                                            '<i class="fa fa-refresh"></i> {{lang.LABMON33}}'+
                                                        '</button>' +
                                                    '</div>');
            slideToggle('#_mongdb_users_list_wrapper_', '#_mongdb_users_loader_');
        });
    }else{
        renderUsersList();
    }
}
function CleanUserModal(){
    $('#_mongodb_username_input_').val('');
    $('#_user_role').val('');
    $('#_user_new_pass_field').val('');
    $('#_user_new_pass_field').pwstrength("forceUpdate");
    $('#_user_new_pass_field_confirm').val('');
    $('#_mongo_manage_user_modal_ .error-field').removeClass('error-field');
}
function LockModalUserButtons(status){
    $('#_mongodb_modal_user_cancel_btn_').prop('disabled', status);
    handleButtons('#_mongodb_modal_user_save_btn_', 'fa-flopp-o', status === true ? undefined : false);
}
function AddMongoDBUser(elem, index){
    let owner = $(elem).data('owner');
    let dbname = $(elem).data('dbname');
    $('#_mongo_user_modal_dbname_').val(dbname);
    $('#_mongodb_modal_user_title_').text('Adding user to  database: ' + dbname);
    $('#_mongodb_manage_username_wrapper_').hide();
    $('#_mongodb_username_wrapper_').show();
    $('#_mongodb_user_modal_sysowner_').text(owner + '_');
    $('#_mongo_manage_user_modal_').modal('show');
    $('#_mongodb_modal_user_save_btn_').unbind('click').click(function(){
        MongoSendUserInfo('new', index);
    });
}
function MongoSendUserInfo(type, anchor){
    let user_data = MongoValidateuserForm();
    if (user_data){
        LockModalUserButtons(true);
        // let user_info = ;
        sendMongoDBUserInfo(JSON.stringify(user_data), type, function(){
            UpdateUserInfoInUI({
                user_data: user_data,
                type: type
            }, anchor);
            LockModalUserButtons(false);
            $('#_mongo_manage_user_modal_').modal('hide');
            $.gritter.add({
                title: '{{lang.LABMONSUCCESS}}',
                text: '{{lang.LABMON34}}',
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-quill-2',
                class_name: 'success-notice'
            });
        }, function(){
            LockModalUserButtons(false);
        });
    }
}
function renderUserDBItem(user, dbname, users_length, footprint, uindex){
    return '<div class="db_list_user_' + dbname + '_' + user.uname + ' mongo-userdb-item-wrapper' + (uindex > 1 ? ' mongo-userdb-item-hidden' : '') + '" id="_mongo_user_db_item_' + footprint + '_" data-role="' + user.role + '" data-dbname="' + dbname + '" data-uname="' + user.uname + '">' +
                '<div class="mongo-userdb-item' + (users_length === 1 ? ' mongo-userdb-item-alone' : '') + '">' +
                    '<span>' + user.uname + ' (<b><span class="user_item_role_' + dbname + '_' + user.uname + ' mongodb-user-role-container">' + parseRoleDisplay(user.role) + '</span></b>)</span> ' +
                    // '<button class="btn btn-success btn-xs" title="Change password" data-toggle="tooltip" data-placement="top"><i class="fa fa-lock"></i></button>' +
                    '<div>' +
                        '<button class="btn btn-primary btn-xs" title="{{lang.LABMON35}}" data-toggle="tooltip" data-placement="top" onclick="manageUsermodal(this)"><i class="fa fa-cogs"></i></button>' +
                        '<button class="btn btn-warning btn-xs" title="{{lang.LABMON36}}" data-toggle="tooltip" data-placement="top" onclick="ShowDeleteUserConfirm(this,\'' + footprint + '\')"><i class="fa fa-trash"></i></button>' +
                    '</div>' +
                '</div>' +
            '</div>';
}
function UpdateUserInfoInUI(user_info, anchor){
    if(user_info.type === 'edit'){
        anchor.data('role', user_info.user_data.role);
        let role_display = parseRoleDisplay(user_info.user_data.role);
        // anchor.find('.mongodb-user-role-container').text(role_display);
        $('.user_item_' + user_info.user_data.dbname + '_' + user_info.user_data.uname + ' .users-list-role-container').text(role_display);
        $('.user_item_role_' + user_info.user_data.dbname + '_' + user_info.user_data.uname + '.mongodb-user-role-container').text(role_display);
    }else{
        let users_container = $('#_mongo_db_item_' + anchor + ' .mongo-userdb-items');
        let dbname = $('#_mongo_db_item_' + anchor).data('name');
        let user_items = users_container.find('.mongo-userdb-item-wrapper');
        let uindex = user_items.length;
        let user = {
            uname: user_info.user_data.uname ,
            role: user_info.user_data.role ,
            dbname: user_info.user_data.dbname
        };
        if (users_db_list !== null){
            users_db_list.push({
                name: user_info.user_data.uname,
                database: user_info.user_data.dbname,
                role: user_info.user_data.role
            });
        }
        let html_user = renderUserDBItem(user, dbname, uindex + 1, anchor + '_' + uindex, uindex);
        if (uindex == 0){
            users_container.find('.mongo-userdb-not-users').remove();
            users_container.prepend(html_user);
        }else{
            user_items.last().after(html_user);
            if (users_container.find('.mongo-userdb-item-hidden').is(':visible')){
                $('#_mongo_user_db_item_' + anchor + '_' + uindex + '_').slideDown('fast');
            }
            if (uindex >= 2){
                users_container.find('.mongodb-users-display-control').slideDown('fast');
            }
            
        }
        $('[data-toggle="tooltip"]').tooltip();
    }
}
function parseRoleDisplay(role){
    if(role == 'read'){
        return '{{lang.LABMON37}}';
    }else{
        return '{{lang.LABMON38}}';
    }
}
function ShowDeleteUserConfirm(elem, footprint){
    let uname = /^user_/.test(footprint) ? $('.' + footprint).data('uname') : $('#_mongo_user_db_item_' + footprint + '_').data('uname');
    $('#_mongo_user_deleting_footprint_').val(footprint);
    $('#_mongodb_user_to_remove_').text(uname);
    $('#_mongo_delete_user_modal_').modal('show');
}
function OpenModaluser(parent_ancestor){
    let uname = parent_ancestor.data('uname');
    let dbname = parent_ancestor.data('dbname');
    let role = parent_ancestor.data('role');
    $('#_user_role').val(role);
    $('#_mongo_user_modal_dbname_').val(dbname);
    $('#_mongodb_username_wrapper_').hide();
    $('#_mongodb_manage_username_wrapper_').show();
    $('#_mongodb_manage_username_wrapper_ span').text(uname);
    $('#_mongodb_modal_user_title_').text('{{lang.LABMON39}}');
    $('#_mongo_manage_user_modal_').modal('show');
    $('#_mongodb_modal_user_save_btn_').unbind('click').click(function () {
        MongoSendUserInfo('edit', parent_ancestor);
    });
}
function manageUserFromList(elem){
    OpenModaluser($(elem).closest('.mongodb-user-list-item'));
}
function manageUsermodal(elem){
    OpenModaluser($(elem).closest('.mongo-userdb-item-wrapper'));
}
function showMoreOrLessUsers(elem, less){
    let toShow = 'vless-users-btn';
    let toHide = 'vmore-users-btn';
    let parent_items_hidden = $(elem).closest('.mongo-userdb-items').find('.mongo-userdb-item-hidden');
    if(less != undefined){
        toHide = 'vless-users-btn';
        toShow = 'vmore-users-btn';
        parent_items_hidden.slideUp('fast');
    }else{
        parent_items_hidden.slideDown('fast');
    }
    let control_div = $(elem).parent();
    control_div.find('.' + toHide).hide();
    control_div.find('.' + toShow).show();
}
function BindUserModal(){
    let optpass1 = {
        ui: {
            container: "#pass_container",
            showVerdictsInsideProgressBar: true,
            viewports: {
                progress: ".pwstrength_viewport_progress"
            }
        },
        common: {
            debug: false,
        }
    }
    $('#_user_new_pass_field').pwstrength(optpass1);
}
function MongoDBUserDeletionConfirmed(){
    let footprint = $('#_mongo_user_deleting_footprint_').val();
    let db_user_item = /^user_/.test(footprint) ? $('.' + footprint) : $('#_mongo_user_db_item_' + footprint + '_');
    let delete_button = db_user_item.find('.btn-warning');
    db_user_item.addClass('deleting_tr');
    handleButtons(delete_button, 'fa-trash');
    db_user_item.find('.btn').prop('disabled', true);
    $('#_mongo_delete_user_modal_').modal('hide');
    let user_data = {
        uname: db_user_item.data('uname'),
        dbname: db_user_item.data('dbname')
    };
    sendMongoDBUserDeletion(user_data, function(){
        
        function cleanUserList(user_data){
            let user_item_list = $('.user_item_' + user_data.dbname + '_' + user_data.uname);
            if (user_item_list.length > 0) {
                user_item_list.slideUp('fast', function () {
                    users_db_table.row(this).remove().draw();
                });
            }
        }
        if (/^user_/.test(footprint)) {
            db_user_item = $('.db_list_user_' + user_data.dbname + '_' + user_data.uname);
        }
        db_user_item.slideUp('fast', function(){
            let parent_ancestor = db_user_item.parent();
            if (db_user_item.hasClass('mongo-userdb-item-hidden')){
                db_user_item.remove();
                if (parent_ancestor.find('.mongo-userdb-item-hidden').length === 0) {
                    parent_ancestor.find('.mongodb-users-display-control').fadeOut('fast');
                }
            }else{
                let next_item = db_user_item.parent().find('.mongo-userdb-item-hidden').first();
                if (next_item.length === 0) {
                    let parent_ancestor = db_user_item.parent();
                    db_user_item.remove();
                    let item_wrappers = parent_ancestor.find('.mongo-userdb-item-wrapper');
                    if (item_wrappers.length === 1) {
                        item_wrappers.find(".mongo-userdb-item").animate({ height: "4.2rem" });
                    }
                } else if (next_item.is(':visible')) {
                    next_item.removeClass('mongo-userdb-item-hidden');
                    setUserItemVisibleEvent(next_item, db_user_item);
                } else {
                    next_item.slideDown('fast', function () {
                        setUserItemVisibleEvent(next_item, db_user_item);
                    });
                }
            }
            let item_wrappers_2 = parent_ancestor.find('.mongo-userdb-item-wrapper');
            if (item_wrappers_2.length == 0) {
                parent_ancestor.prepend('<div class="mongo-userdb-not-users"><h5>{{lang.LABMON55}}</h5></div>');
            }
            if (users_db_list !== null) {
                let user_index = users_db_list.findIndex(function (user) {
                    return user.name == user_data.uname && user.database == user_data.dbname;
                });
                if (user_index >= 0) {
                    users_db_list.splice(user_index, 1);
                }
            }
            cleanUserList(user_data);
        });
        $.gritter.add({
            title: '{{lang.LABMON18}}',
            text: '{{lang.LABMON66}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
    }, function(){
        db_user_item.removeClass('deleting_tr');
        handleButtons(delete_button, 'fa-trash', true);
        db_user_item.find('.btn').prop('disabled', false);
    });
}
function setUserItemVisibleEvent(elem, db_user_item){
    $(elem).removeClass('mongo-userdb-item-hidden');
    if (db_user_item.parent().find('.mongo-userdb-item-hidden').length === 0){
        db_user_item.parent().find('.mongodb-users-display-control').fadeOut('fast');
    }
    db_user_item.remove();
}
function renderUsersList(){
    let html_list = '';
    if (users_db_list.length > 0) {
        let html_content = '';
        index = 0;
        users_db_list.forEach(function (user) {
            let footprint = 'user_item_' + user.database + '_' + user.name;
            html_content += '<tr id="_mongo_db_user_item_' + index + '" class="mongodb-user-list-item  ' + footprint + '" data-role="' + user.role + '" data-dbname="' + user.database + '" data-uname="' + user.name + '">' +
                                '<td>' + user.name + '</td>' +
                                '<td>' + user.database + '</td>' +
                                '<td><span class="users-list-role-container">' + parseRoleDisplay(user.role) + '</span></td>' +
                                '<td width="90">' +
                                    '<div class="mongo-db-actions">' +
                                        '<button title="{{lang.LABMON39}}" data-toggle="tooltip" data-placement="top" onclick="manageUserFromList(this)" class="btn btn-primary btn-md"><i class="fa fa-cogs"></i></button>' +
                                        '<button class="btn btn-warning btn-md" data-name="' + user.name + '" data-user="' + user.user + '" title="{{lang.LABMON40}}" data-toggle="tooltip" data-placement="top" onclick="ShowDeleteUserConfirm(this,\'' + footprint + '\')"><i class="fa fa-trash"></i></button>' +
                                    '</div>' +
                                '</td>' +
                            '</tr>';
            index++;
        });
        html_list = '<table class="table mongodb_users_table table-striped table-bordered table-hover" style="width:100% !important;">' +
                        '<thead>' +
                            '<tr role="row">' +
                                '<th>{{lang.LABMON41}}</th>' +
                                '<th>{{lang.LABMON42}}</th>' +
                                '<th>{{lang.LABMON43}}</th>' +
                                '<th width="90">{{lang.LABMON44}}</th>' +
                            '</tr>' +
                        '</thead>' +
                        '<tbody id="contenttr">' +
                            html_content +
                        '</tbody>' +
                    '</table>';
        $('#_mongdb_users_list_wrapper_').html(html_list);
        users_db_table = $('.mongodb_users_table').removeAttr('width').DataTable({
            columnDefs: [
                { width: 50, targets: 3 }
            ],
            "bAutoWidth": false,
        });
    } else {
        html_list = '<div class="mongodb-empty-list-database">' +
                        '<h4>{{lang.LABMON45}}</h4>' +
                        // '<button class="btn btn-primary" onclick="addNewNodeJSApp()">' +
                        //     '<i class="fa fa-plus"></i> ' +
                        //     '{{lang.LABNODEJS115}}'
                        // '</button>' +
                    '</div>';
        $('#_mongdb_users_list_wrapper_').html(html_list);
    }
    $('[data-toggle="tooltip"]').tooltip();
}
function sendMongoDBUserDeletion(user_data, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mongodb_manager&acc=delete_mongodb_user",
        data: 'uname=' + user_data.uname + '&dbname=' + user_data.dbname,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMON20}}',
                    text: '{{lang.LABMON23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMON23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABMON46}}';
                    } else if (resp_data.code == 2) {
                        message_error = '{{lang.LABMON47}}';
                    } else if (resp_data.code == 3) {
                        message_error = '{{lang.LABMON48}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMON20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function getMongoDBUsersList(db_data, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mongodb_manager&acc=users_list",
        data: 'db_data=' + db_data ? db_data : '',
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMON20}}',
                    text: '{{lang.LABMON23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMON23}}';
                // if (resp_data.hasOwnProperty('code')) {
                    // if (resp_data.code == 2) {
                        // message_error = '';
                    // } else if (resp_data.code == 1) {
                        // message_error = '';
                    // }
                // }
                $.gritter.add({
                    title: '{{lang.LABMON20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendMongoDBUserInfo(user_data, type, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mongodb_manager&acc=save_user_info",
        data: 'user_data=' + user_data + '&type=' + type,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMON20}}',
                    text: '{{lang.LABMON23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMON23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABMON48}}';
                    } else if (resp_data.code == 2) {
                        message_error = '{{lang.LABMON49}}';
                    } else if (resp_data.code == 3) {
                        message_error = '{{lang.LABMON51}}';
                    } else if (resp_data.code == 5) {
                        message_error = '{{lang.LABMON52}}';
                    } else if (resp_data.code == 4) {
                        message_error = '{{lang.LABMON53}}';
                    } else if (resp_data.code == 6) {
                        message_error = '{{lang.LABMON54}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMON20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}