let database_list = JSON.parse('{{mod_vars.db_list|json_encode|raw}}');
let database_list_size = JSON.parse('{{mod_vars.db_list_size|json_encode|raw}}');
let mysql_disk_usage = {{ mod_vars.mysql_disk_usage }};
let my_sql_table = null;
function barsOnDBList(size, owner_quota) {
    let dbpercent = size * 100 / mysql_disk_usage;
    //console.log('size', size);
    //console.log('mysql_disk_usage', mysql_disk_usage);
    //console.log('dbpercent', dbpercent);
    let quota_percent = size / owner_quota;
    return '<div class="progress" style="height:10px"><div class="progress-bar" style="width:' + dbpercent + '%;height:20px"></div></div>' +
        (owner_quota > 0 ?
            '<div class="progress " style="height:10px"><div class="progress-bar progress-bar-danger" style="width:' + quota_percent + '%;height:20px"></div></div>'
            :
            ''
        );
}
function mysqlList() {
    let html_list = '';
    html_list = '<table class="table my_sql_table table-striped table-bordered table-hover">' +
        '<thead>' +
        '<tr role="row">' +
        '<th>{{lang.LABMYSQL61}}</th>' +
        '<th>Owner</th>' +
        '<th style="padding:10px !important;">{{lang.LABMYSQL63}}</th>' +
        '<th>{{lang.LABMYSQL64}}</th>' +
        '</tr>' +
        '</thead>' +
        '<tbody id="contenttr">' +
        //html_content +
        '</tbody>' +
        '</table>';
    $('#_my_sql_list_wrapper_').html(html_list);
    //console.log('mysql_disk_usage', mysql_disk_usage);
    my_sql_table = $('.my_sql_table').DataTable({
        "bAutoWidth": false,
        scrollX: false,
        serverSide: true,
        processing: true,
        ajax: {
            url: 'loader_ajax.php?ajax=mysql_manager&acc=mysql_list',
            type: 'POST',
            "dataSrc": function (json) {
                if (json.hasOwnProperty('last_error') && json.last_error != null) {
                    let error_message = '';
                    if (json.last_error.code == 100) {
                        error_message = 'An error occurred when listing databases.';
                    }
                    $('#_mysql_alert_main_module_').find('.mysql-alert-message').text(error_message);
                    $('#_mysql_alert_main_module_').slideDown('fast');
                }
                return json.data;
            }
        },
        searchDelay: 2050,
        columnDefs: [
            {
                targets: [0, 1, 2, 3],
                orderable: false
            }
        ],
        'fnCreatedRow': function (nRow, db, iDataIndex) {
            $(nRow).attr('id', '_my_sql_item_' + iDataIndex);
            $(nRow).addClass('mysql-db-list-item');
            $(nRow).data('name', db.name);
        },
        columns: [
            {
                render: function (data, type, db) {
                    return '<div class="dnname-list-wrapper">' +
                        '<div>' +
                        '<span>' + db.name + '</span>' +
                        //'<a onclick="openRenameDatabase(this)" href="javascript:void(0)">rename</a>' +
                        '</div>' +
                        '<div class="db-btn-actions-container">' +
                        '<button title="Optimize Database" class="btn btn-spacer btn-xs btn-default" onclick="operateMySQLDB(\'optimize\', this)"><i class="fa fa-tachometer"></i></button>' +
                        '<button title="Check Database" class="btn btn-spacer btn-xs btn-default" onclick="operateMySQLDB(\'check\', this)"><i class="fa fa-check-circle"></i></button>' +
                        '<button title="Repair Database" class="btn btn-spacer btn-xs btn-default" onclick="operateMySQLDB(\'repair\', this)"><i class="fa fa-wrench"></i></button>' +
                        '<button title="Backup Database" class="btn btn-xs btn-default" onclick="operateMySQLDB(\'backup\', this)"><i class="fa fa-database"></i></button>' +
                        '</div>' +
                        '</div>'
                }
            },
            {
                className: 'mysql-infodb-items',
                render: function (data, type, db) {
                    return '<i class="fa fa-user"></i> <span>' + db.system_user + '</span>';
                    //barsOnDBList(db.size, db.owner_quota)
                }
            },
            {
                className: "mysql-userdb-items",
                render: function (data, type, db) {
                    let html_users = '';
                    if (db.users.length > 0) {
                        db.users.forEach(function (user, uindex) {
                            // let footprint = index + '_' + uindex;
                            let footprint = db.name + '_' + user.uname;
                            html_users += renderUserDBItem(user, db.name, db.users.length, footprint, uindex);
                        });
                    } else {
                        html_users = '<div class="mysql-userdb-not-users"><h5>{{lang.LABMYSQL55}}</h5></div>'
                    }
                    html_users += '<div class="mysql-users-display-control"' + (db.users.length > 2 ? '' : ' style="display:none"') + '>' +
                        '<button class="btn btn-xs btn-default vmore-users-btn" onclick="showMoreOrLessUsers(this)">{{lang.LABMYSQL56}}</button>' +
                        '<button class="btn btn-xs btn-default vless-users-btn" onclick="showMoreOrLessUsers(this,true)">{{lang.LABMYSQL57}}</button>' +
                        '</div>';
                    return html_users;
                }
            },
            {
                render: function (data, type, db, meta) {
                    return (
                        db.system_user != 'root' && db.name != 'performance_schema' && db.name != 'information_schema' ?
                            '<div class="mysql-db-actions">' +
                            '<button title="{{lang.LABMYSQL58}}" data-dbname="' + db.name + '" data-owner="' + db.system_user + '" data-toggle="tooltip" data-placement="top" onclick="AddmysqlUser(this, ' + meta.row + ')" class="btn btn-primary btn-md"><i class="fa fa-user"></i></button>' +
                            '<button class="btn btn-warning btn-deletemysql btn-md" data-name="' + db.name + '" data-user="' + db.system_user + '" title="{{lang.LABMYSQL59}}" data-toggle="tooltip" data-placement="top" onclick="ShowDeleteConfirmModal(this,' + meta.row + ')"><i class="fa fa-trash"></i></button>' +
                            '</div>'
                            :
                            ''
                    )
                }
            }
        ]
    });
    let searcher_timeout = null;
    $(".dataTables_filter input")
        .unbind() // Unbind previous default bindings
        .bind("input", function (e) { // Bind our desired behavior
            // If the length is 3 or more characters, or the user pressed ENTER, search
            if (searcher_timeout !== null) {
                clearTimeout(searcher_timeout);
            }
            let this_value = this.value;
            searcher_timeout = setTimeout(function () {
                my_sql_table.search(this_value).draw();
                searcher_timeout = null;
            }, 300);
            // Ensure we clear the search if they backspace far enough
            if (this.value == "") {
                my_sql_table.search("").draw();
            }
            return;
        });
    return;
}
function openRenameDatabase(elem) {
    let dbname = $(elem).closest('tr').data('name');
    $('#_renaming_db_title_name_').text(dbname);
    $('#_renaming_db_input_').val(dbname);
    $('#_mysql_db_rename_modal_').modal('show');
}
function updateDBTable(response) {
    // database_list.push({
    //     name: response.user + '_' + response.name,
    //     system_user: response.user,
    //     users: []
    // });
    database_list = response.list;
    mysqlList();
}
function operateMySQLDB(operation, elem) {
    let tr_operating = $(elem).closest('.mysql-db-list-item');
    tr_operating.addClass('deleting_tr');
    tr_operating.find('.btn-primary').prop('disabled', true);
    tr_operating.find('.btn-warning').prop('disabled', true);
    tr_operating.find('.btn-default').prop('disabled', true);
    let btn_operate = tr_operating.find('.dnname-list-wrapper .btn-default');
    let db_data = {
        name: tr_operating.data('name'),
        //user: btn_operate.data('user'),
    }
    handleButtons(btn_operate, 'fa-cogs');
    function refreshState() {
        tr_operating.removeClass('deleting_tr');
        tr_operating.find('.btn-primary').prop('disabled', false);
        tr_operating.find('.btn-warning').prop('disabled', false);
        tr_operating.find('.btn-default').prop('disabled', false);
        handleButtons(btn_operate, 'fa-cogs', true);
    }
    sendmysqlOperation(db_data, operation, function (response) {
        refreshState();
        let message = "";
        let html_modal = "";
        if (operation == 'optimize') {
            message = "Your database was Optimized successfully.";
        } else if (operation == 'check') {
            message = "Your database was Checked successfully.";
        } else if (operation == 'repair') {
            message = "Your database was Repaired successfully.";
        } else if (operation == 'backup') {
            message = "Your backup was generated successfully.";
            html_modal = '<div class="container-fluid"><div class="row">' +
                '<div class="colmd-3">' +
                '<span class=""><b>Backup file:</b></span>' +
                '</div>' +
                '<div class="colmd-9">' +
                response.result.file_path +
                '</div>' +
                '</div>' +
                '<div class="row">' +
                '<div class="colmd-3">' +
                '<span class=""><b>Size:</b></span>' +
                '</div>' +
                '<div class="colmd-9">' +
                response.result.size +
                '</div>' +
                '</div></div>';
            /*'<div class="row">' + 
                '<div class="colmd-5">' +
                    '<span class="">Output</span>' +
                '</div>' +
            '</div>' +
            '<div class="row">' + 
                '<div class="colmd-12">' +
                    response.result.output + 
                '</div>' +
            '</div></div>';*/
        }
        $.gritter.add({
            title: '{{lang.LABMYSQL18}}',
            text: message,
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        if (response.result != "" && response.result !== null) {
            if (html_modal === '') {
                $('#_mysql_operation_html_').hide();
                $('#_mysql_operation_message_').show();
                $('#_mysql_operation_message_').text(response.result);
            } else {
                $('#_mysql_operation_message_').hide();
                $('#_mysql_operation_html_').show();
                $('#_mysql_operation_html_').html(html_modal);
            }
            setTimeout(function () {
                $('#_mysql_operation_message_modal_').modal('show');
            }, 1200);
        } else {

        }

    }, function () {
        refreshState();
    });

}
function mysqlDeletionConfirmed() {
    $('#_mysql_delete_confirm_modal_').modal('hide');
    let db_index = $('#_my_sql_deleting_index_').val();
    let tr_deleting = $('#_my_sql_item_' + db_index);
    tr_deleting.addClass('deleting_tr');
    tr_deleting.find('.btn-primary').prop('disabled', true);
    tr_deleting.find('.btn-warning').prop('disabled', true);
    let btn_delete = tr_deleting.find('.btn-deletemysql');
    let db_data = {
        name: btn_delete.data('name'),
        user: btn_delete.data('user'),
    }
    handleButtons(btn_delete, 'fa-trash');
    sendmysqlDeletion(db_data, function () {
        tr_deleting.slideUp('fast', function () {
            my_sql_table.row(this).remove().draw();
        });
        database_list.splice(db_index - 1, 1);
        $.gritter.add({
            title: '{{lang.LABMYSQL18}}',
            text: '{{lang.LABMYSQL22}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
    }, function () {
        tr_deleting.removeClass('deleting_tr');
        tr_deleting.find('.btn-primary').prop('disabled', false);
        tr_deleting.find('.btn-warning').prop('disabled', false);
        handleButtons(btn_delete, 'fa-trash', true)
    });

}
function sendmysqlOperation(db_data, operation, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mysql_manager&acc=mysql_db_operation",
        data: 'dbname=' + db_data.name + '&operation=' + operation,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: '{{lang.LABMYSQL23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMYSQL23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = 'Operation not allowed';
                    } else if (resp_data.code == 2) {
                        message_error = 'Invalid database';
                    } else if (resp_data.code == 3) {
                        message_error = 'Database does not exits';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendmysqlDeletion(db_data, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mysql_manager&acc=delete_mysql_db",
        data: 'name=' + db_data.name,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: '{{lang.LABMYSQL23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMYSQL23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 3) {
                        message_error = '{{lang.LABMYSQL28}}';
                    } else if (resp_data.code == 2) {
                        message_error = '{{lang.LABMYSQL29}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}