let users_list = JSON.parse('{{mod_vars.users_list|json_encode|raw}}');
let is_custom_version = false;
let user_config = null;
let mysql_info = null;
let mysql_grants_editor = null;
function ValidateIPaddress(ipaddress) {
    if (/^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/.test(ipaddress)) {
        return true;
    }
    return false;
}
function setInputFilter(textbox, inputFilter) {
    ["input", "keydown", "keyup", "mousedown", "mouseup", "select", "contextmenu", "drop"].forEach(function (event) {
        textbox.addEventListener(event, function () {
            if (inputFilter(this.value)) {
                this.oldValue = this.value;
                this.oldSelectionStart = this.selectionStart;
                this.oldSelectionEnd = this.selectionEnd;
            } else if (this.hasOwnProperty("oldValue")) {
                this.value = this.oldValue;
                this.setSelectionRange(this.oldSelectionStart, this.oldSelectionEnd);
            } else {
                this.value = "";
            }
        });
    });
}
$(document).ready(function(){
    mysqlList();
    BindUserModal();
    BindSettingsTab();
    user_config = JSON.parse('{{mod_vars.user_config|json_encode|raw}}');
    mysql_info = JSON.parse('{{mod_vars.mysql_info|json_encode|raw}}');
    renderUsersList();
    $('#_mysql_manage_user_modal_').on('hidden.bs.modal', function () {
        CleanUserModal();
        $('#_privs_collapsible_').hide();
        $('#_mysql_user_resources_').hide();
        $('.host-user-wrapper').show();
        $('.mysql-user-host-input').val('');
        $('.mysql-user-host-input').prop('disabled', true);
        $('.mysql-user-host-select').val('localhost');
        $('.mysql-user-host-select').val('localhost');
    });
    $('#_mysql_delete_user_modal_').on('hidden.bs.modal', function () {
        $('#_user_deletion_type_user').trigger('click');
    });
    mysql_grants_editor = CodeMirror.fromTextArea(document.getElementById("mysql_list_grants_area_"), {
        lineNumbers: true,
        matchBrackets: true,
        styleActiveLine: true,
        theme: "ambiance",
        readOnly: true,
    });
    setInputFilter(document.getElementById("maxqueryhour"), function (value) {
        return /^\d*$/.test(value);
    });
    setInputFilter(document.getElementById("maxupdhour"), function (value) {
        return /^\d*$/.test(value);
    });
    setInputFilter(document.getElementById("maxconnechour"), function (value) {
        return /^\d*$/.test(value);
    });
    setInputFilter(document.getElementById("maxuserconnec"), function (value) {
        return /^\d*$/.test(value);
    });
    RenderUserInForm();
    BindConfigTab();
});
function setConfigValues(){
    if (user_config !== null){
        $('#_mysql_conf_user_enabled_').prop('checked', user_config.user_enabled);
        if (user_config.user_enabled === true){
            $('#_mysql_users_select_wrapper_').show();
            $('#_mysql_availability_select_').val(user_config.availability_type);
            if (user_config.availability_type == '2'){
                $('#_mysql_users_select_availability_').show();
            }
        }
        $('#_mysql_conf_user_enabled_').prop('checked', user_config.user_enabled);
        $('#version_holder').text(mysql_info.version);
        $('#_mysql_status_holder').text(statusTranslator(mysql_info.status));
    }
}
function statusTranslator(status){
    return status == 'running' ? 'Running' : 'Stopped';
}
function unistallmysql(){
    $('#_mysql_uninstall_confirm_modal_').modal('show');
}
function mysqlUninstallConfirmed(){
    slideToggle('#_mysql_loader_screen_', '#_mysql_dashboard_main_');
    $('#_mysql_uninstall_confirm_modal_').modal('hide');
    $('#_mysql_loader_title_').text('{{lang.LABMYSQL95}}');
    sendmysqlUninstallation(function(){
        users_db_list = [];
        users_db_table = null;
        database_list = [];
        user_config = {
            user_enabled: false,
            availability_type: '1',
            availability_users: []
        };
        setConfigValues();
        $.gritter.add({
            title: '{{lang.LABMYSQLSUCCESS}}',
            text: '{{lang.LABMYSQL106}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        slideToggle('#_mysql_not_installed_screen_', '#_mysql_loader_screen_');
    },function(){
        slideToggle('#_mysql_dashboard_main_', '#_mysql_loader_screen_');
    });
}
function ListPermissionsTab(){
    $('#mysql_list_perm_wrapper').hide();
    $('#mysql_list_perm_loader').show();
    getMysqlGrants(function(response){
        mysql_grants_editor.setValue(response.grants);
        $('#mysql_list_perm_loader').hide();
        $('#mysql_list_perm_wrapper').show();
        setTimeout(function(){
            mysql_grants_editor.refresh();
        }, 100)
    }, function(){

    });
}
function BindConfigTab(){
    let list_opts = {
        nonSelectedListLabel: '{{lang.LABMYSQL107}}',
        selectedListLabel: '{{lang.LABMYSQL108}}',
        selectorMinimalHeight: 200,
        filterTextClear: '{{lang.LABMYSQL109}}', // the text for the "Show All" button.
        filterPlaceHolder: '{{lang.LABMYSQL110}}', // the placeholder for the input element for filtering elements.
        moveSelectedLabel: '{{lang.LABMYSQL111}}', // the label for the "Move Selected" button.
        moveAllLabel: '{{lang.LABMYSQL112}}', // the label for the "Move All" button.
        removeSelectedLabel: '{{lang.LABMYSQL113}}', // the label for the "Remove Selected" button.
        removeAllLabel: '{{lang.LABMYSQL114}}', // the label for the "Remove All" button.
    };
    $('#_mysql_availability_select_users_').bootstrapDualListbox(list_opts);
    setConfigValues();
}
function mysqlChangeUsersToAvailable(elem){
    if ($(elem).val() == '2'){
        $('#_mysql_users_select_availability_').slideDown('fast');
    }else{
        $('#_mysql_users_select_availability_').slideUp('fast', function(){
            // $('#_mysql_users_select_availability_ .removeall').trigger('click');
        });
    }
}
function mysqlSaveConfigurations(elem){
    handleButtons(elem, 'fa-floppy-o');
    let users_availability = $('#_mysql_availability_select_users_').val();
    let user_config = {
        user_enabled: $('#_mysql_conf_user_enabled_').is(':checked'),
        availability_type: $('#_mysql_availability_select_').val(),
        availability_users: users_availability === null ? [] : users_availability
    }
    sendmysqlConfigurations(JSON.stringify(user_config), function(){
        handleButtons(elem, 'fa-floppy-o', true);
        $.gritter.add({
            title: '{{lang.LABMYSQLSUCCESS}}',
            text: '{{lang.LABMYSQL115}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
    },function(){
        handleButtons(elem, 'fa-floppy-o', true);
    });
}
function changeUserAvailability(elem){
    if ($(elem).is(':checked')){
        $('#_mysql_users_select_wrapper_').slideDown('fast');
    }else{
        $('#_mysql_users_select_wrapper_').slideUp('fast');
        $('#_mysql_users_select_availability_').slideUp('fast', function () {
            // $('#_mysql_availability_select_').val('1');
            // $('#_mysql_users_select_availability_ .removeall').trigger('click');
        });
    }
}
function getIfUserAvailable(user){
    return (user_config !== null && user_config.availability_users.find(function(usr){return usr == user}) != undefined) ? 'selected' : '';
}
function RenderUserInForm(){
    let users_select = '';
    let users_select_2 = '';
    users_list.forEach(function(user){
        //let selected_user = getIfUserAvailable(user);
        users_select += '<option value="' + user + '" >' + user + '</option>';
        //users_select_2 += '<option value="' + user + '" ' + selected_user + '>' + user + '</option>';
    });
    $('#_my_sql_form_user').html('<select class="form-control" name="" id="_my_sql_user_select_">' +
                                        '<option value="" id="" selected>{{lang.LABMYSQL16}}</option>' +
                                        users_select + 
                                    + '</select>');
    /*$('#_mysql_users_select_availability_').html('<select name="_mysql_availability_select_" multiple="" class="form-control" id="_mysql_availability_select_users_">' +
                                        users_select_2 + 
                                    + '</select>');*/
    $("#_my_sql_user_select_").select2({
        placeholder: "{{lang.LABMYSQL17}}",
        allowClear: true
    });
}
function mysqlInstallationModal(version) {
    $('#_mysql_version_to_install_').html(version);
    $('#_mysql_install_confirm_modal_').modal('show');
}
function copyPass(elem) {
    let field = document.getElementById(elem);
    field.select();
    document.execCommand('copy');
    $.gritter.add({
        title: '{{lang.LABMYSQLSUCCESS}}',
        text: '{{lang.LABMYSQLCOPIEDPASS}}',
        time: 3500,
        close_icon: '',
        icon: 'icomoon-icon-quill-2',
        class_name: 'success-notice'
    });
    // noti_bubble('{{lang.LABMYSQLCOPIEDPASS}}', '{{lang.LABMYSQLSUCCESS}}', 'success', false, false, '3000', true);
}
function openPGOPT(type, second) {
    let divelem = type == null ? '#pgopt_container' : type;
    if ($(divelem).is(':visible')) {
        $(divelem).slideUp('fast');
    } else {
        $(divelem).slideDown('fast');
        hideOnClickOutside(divelem, second);
    }
}
function hideOnClickOutside(selector, second) {
    let forhide = true;
    if (second === undefined) {
        second = '.show_options_button';
        forhide = true;
    }
    function outsideClickListener(event) {
        $target = $(event.target);
        if (!$target.closest(selector).length && !$target.closest(second).length && $(selector).is(':visible')) {
            if (forhide) {
                $(selector).slideUp('fast');
            } else {
                $(selector).remove();
            }
            removeClickListener();
        }
    }
    function removeClickListener() {
        document.removeEventListener('click', outsideClickListener)
    }
    document.addEventListener('click', outsideClickListener)
}
function generatePasswordRand(length, type) {
    switch (type) {
        case 'num':
            characters = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
            break;
        case 'alf':
            characters = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
            break;
        case 'rand':
            //FOR ↓
            break;
        default:
            characters = "0123456789/-_%*!^><.abcdefghijklmnopqrstuvwxyz/-_%*!^><.ABCDEFGHIJKLMNOPQRSTUVWXYZ/-_%*!^><.";
            break;
    }
    var pass = "";
    for (i = 0; i < length; i++) {
        if (type == 'rand') {
            pass += String.fromCharCode((Math.floor((Math.random() * 100)) % 94) + 33);
        } else {
            pass += characters.charAt(Math.floor(Math.random() * characters.length));
        }
    }
    return pass;
}
function generateNewPass(element) {
    let passmeter = $(element).parent().parent().find('.pass_container input');
    let lengthpass = $(element).parent().find('.general-password-generator-options .pwlength');
    let typepass = $(element).parent().find('.general-password-generator-options .pwtype');
    let confpass = 'ftppass2_ch';
    // if(type == 'userp'){
    //   passmeter = 'ftppass1';
    //   lengthpass = 'lengthpass';
    //   typepass = 'typepass';
    //   confpass = 'ftppass2';
    // }
    let lpass = lengthpass.val();
    let tpass = typepass.val();
    let new_pass = generatePasswordRand(lpass, tpass);
    passmeter.val(new_pass);
    passmeter.pwstrength("forceUpdate");
    // if(type == undefined || type == 'userp'){
    //   copyPass(passmeter);
    // }
    copyPass(passmeter.attr('id'));
}
function mysqlInstallationConfirmed(){
    let version = $('#_mysql_version_to_install_').text();
    $('#_mysql_loader_title_').html('{{lang.LABMYSQL96}}: ' + $('#_mysql_version_to_install_').text());
    slideToggle('#_mysql_loader_screen_', '#_mysql_not_installed_screen_');
    $('#_mysql_install_confirm_modal_').modal('hide');
    sendmysqlInstallation(version, function (response) {
        $('#_mysql_list_link_tab_').trigger('click');
        database_list = response.db_list;
        mysql_info = response.mysql_info;
        mysql_settings = response.settings;
        is_custom_version = response.is_custom_version;
        $('#_mysql_file_editor_area_').val(response.file_content);
        $('#_mysql_file_path_').text(response.file_path);
        BindSettingsTab();
        mysqlList();
        // slideToggle('.mysql-tabs-container-main', '.mysql-status-panel');
        $('.on-not-running').fadeOut('fast', function(){
            $('.on-running').fadeIn('fast');
            handleButtons('.on-not-running', 'fa-play', true);
        });
        $('.not-running-screen').hide();
        $('.running-screen-twice').show();
        $('#version_holder').text(mysql_info.version);
        $('#_mysql_status_holder').text(statusTranslator(mysql_info.status));
        slideToggle('#_mysql_dashboard_main_','#_mysql_loader_screen_');
    }, function () {
        slideToggle('#_mysql_not_installed_screen_','#_mysql_loader_screen_');
    });

}
function handleButtons(elem, icon_fa, type) {
    let icon = $(elem).find('.fa');
    if (type == undefined) {
        $(elem).addClass('disabled');
        $(elem).prop('disabled', true);
        icon.removeClass(icon_fa);
        icon.addClass('fa-spinner fa-spin');
    } else {
        icon.removeClass('fa-spinner fa-spin');
        icon.addClass(icon_fa);
        $(elem).removeClass('disabled');
        $(elem).prop('disabled', false);
    }
}
function savemysqlForm(){
    let db_data = mysqlGetDBData();
    if(db_data){
        $('.btn-cancel').prop('disabled', true);
        handleButtons('.btn-save-mysql-db', 'fa-floppy-o');
        function cleaner(){
            $('.btn-cancel').prop('disabled', false);
            handleButtons('.btn-save-mysql-db', 'fa-floppy-o', false);
        }
        sendSavemysql(db_data, function(response){
            my_sql_table.ajax.reload(function (response) {
                $.gritter.add({
                    title: '{{lang.LABMYSQL18}}',
                    text: '{{lang.LABMYSQL19}}',
                    time: 5500,
                    close_icon: '',
                    icon: 'icomoon-icon-quill-2',
                    class_name: 'success-notice'
                });
                cleaner();
                //updateDBTable(response);
                //updateDBTable(response);
                cancelForm();
            }, false);
        }, function(){
            cleaner();
        });
    }else{
        $.gritter.add({
            title: '{{lang.LABMYSQL20}}',
            text: '{{lang.LABMYSQL21}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
    }
}
function mysqlGetDBData(){
    let valid = true;
    let user = $('#_my_sql_user_select_').val();
    if(user == ''){
        valid = false;
        $('.select2-container .select2-choice').addClass('error-field');
    }else{
        $('.select2-container .select2-choice').removeClass('error-field');
    }
    let db_name = $('#_my_sql_name_input_').val();
    if (/^[A-Za-z0-9\_\-]+$/.test(db_name) === false){
        valid = false;
        $('#_my_sql_name_input_').addClass('error-field');
    }else{
        $('#_my_sql_name_input_').removeClass('error-field');
    }
    
    return valid === true ? {
        'name': db_name,
        'user': user,
        'charset': $('#charsetonly').val(),
    } : false;
}
function slideToggle(show, hide, callback) {
    $(hide).slideUp('fast', function () {
        if (typeof callback == 'function') {
            callback();
        }
        $(show).slideDown('fast');
    });
}
function ShowDeleteConfirmModal(elem, index){
    let db_name = $(elem).data('name')
    let db_user = $(elem).data('user')
    $('#_my_sql_deleting_index_').val(index);
    $('#_mysql_database_to_remove_').text(db_name);
    $('#_mysql_delete_confirm_modal_').modal('show');
}
// function mysqlDeletionConfirmed(){
//     $('#_mysql_delete_confirm_modal_').modal('hide');
//     let db_index = $('#_my_sql_deleting_index_').val();
//     let tr_deleting = $('#_my_sql_item_' + db_index);
//     tr_deleting.addClass('deleting_tr');
//     tr_deleting.find('.btn-primary').prop('disabled', true);
//     let btn_delete = tr_deleting.find('.btn-warning');
//     let db_data = {
//         name: btn_delete.data('name'),
//         user: btn_delete.data('user'),
//     }
//     console.log('db_data', db_data); 
//     handleButtons(btn_delete, 'fa-trash');
//     sendmysqlDeletion(db_data, function(){
//         tr_deleting.slideUp('fast', function () {
//             my_sql_table.row(this).remove().draw();
//         });
//         database_list.splice(db_index, 1);
//         $.gritter.add({
//             title: '{{lang.LABMYSQL18}}',
//             text: '{{lang.LABMYSQL22}}',
//             time: 5500,
//             close_icon: '',
//             icon: 'icomoon-icon-quill-2',
//             class_name: 'success-notice'
//         });
//     }, function(){
//         tr_deleting.removeClass('deleting_tr');
//         tr_deleting.find('.btn-primary').prop('disabled', false);
//         handleButtons(btn_delete, 'fa-trash', true)
//     });

// }
function cancelForm(){
    slideToggle('#_my_sql_list_view_', '#_mysql_sql_form_view_', function(){
        $('#_my_sql_user_select_').val('');
        $('#_my_sql_user_select_').trigger('change');
        $('#_my_sql_name_input_').val('');
        $('#charsetonly').val('');
        $('.select2-container .select2-choice').removeClass('error-field');
        $('#_my_sql_name_input_').removeClass('error-field');
    });
}
function mysqlAddDBForm(){
    slideToggle('#_mysql_sql_form_view_', '#_my_sql_list_view_');
}
function sendmysqlInstallation(version, success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mysql_manager&acc=install_mysql",
        data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: '{{lang.LABMYSQL23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMYSQL23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function getMysqlGrants(success, cleaner){
    $.ajax({
        type: "GET",
        url: "./loader_ajax.php?ajax=mysql_manager&acc=get_grants",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: '{{lang.LABMYSQL23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMYSQL23}}';
                /*if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }*/
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendmysqlInstallation(version, success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mysql_manager&acc=install_mysql",
        data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: '{{lang.LABMYSQL23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMYSQL23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendSavemysql(db_data, success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mysql_manager&acc=save_mysql_db",
        data: 'name=' + db_data.name + '&charset='  + db_data.charset + '&user=' + db_data.user,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: '{{lang.LABMYSQL23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMYSQL23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABMYSQL24}}';
                    } else if (resp_data.code == 2) {
                        message_error = '{{lang.LABMYSQL25}}';
                    } else if (resp_data.code == 3) {
                        message_error = '{{lang.LABMYSQL26}}';
                    } else if (resp_data.code == 4) {
                        message_error = '{{lang.LABMYSQL27}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendmysqlConfigurations(user_config, success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mysql_manager&acc=save_usr_config",
        data: 'user_config=' + user_config,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: '{{lang.LABMYSQL23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMYSQL23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABMYSQL28}}';
                    } else if (resp_data.code == 1) {
                        message_error = 'Invalid data';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendmysqlUninstallation(success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mysql_manager&acc=uninstall_mysql",
        data: 'user_config=' + user_config,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: '{{lang.LABMYSQL23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMYSQL23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABMYSQL28}}';
                    } else if (resp_data.code == 1) {
                        message_error = 'Invalid data';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
{% include 'js/mysql_database_list.js' %}
{% include 'js/mysql_settings.js' %}
{% include 'js/users_list.js' %}
{% include 'js/mysql_status.js' %}
{% include 'js/mysql_base64.js' %} 
{% include 'js/mysql_process_manager.js' %}