let processes_list_table = null;
let monitor_processes_tick = null;
function showMySQLProccessesView(elem) {
    let parent = $(elem).parent();
    if (!parent.hasClass('active')) {

        /*$('.mysql_processes_table').DataTable({
            "processing": true,
            "serverSide": true,
            "ajax": "./loader_ajax.php?ajax=mysql_manager&acc=get_mysql_processes"
        });
        return;*/
        $('#_mysql_process_view_wrapper_').hide();
        $('#_mysql_process_view_loader_').show();
        getMySQLProcessesList(function (response) {
            renderProcessesTable(response.processes_list);
            slideToggle('#_mysql_process_view_wrapper_', '#_mysql_process_view_loader_');
            monitorMySQLProcesses(parent);
        }, function () {
            monitorMySQLProcesses(parent);
        });
    }
}
function monitorMySQLProcesses(tab) {
    monitor_processes_tick = setTimeout(function () {
        if (tab.hasClass('active')) {
            getMySQLProcessesList(function (response) {
                renderProcessesTable(response.processes_list);
                monitorMySQLProcesses(tab);
            }, function () {
                monitorMySQLProcesses(tab);
            });
        }
    }, 3000)
}
function renderProcessesTable(processes_list) {
    let html_list = '';
    if (processes_list.length > 0) {
        let html_content = '';
        index = 0;
        /*processes_list.forEach(function (proc) {
            html_content += '<tr class="mysql-processes-row">' +
                                '<td>' + proc.id + '</td>' +
                                '<td>' + proc.user + '</td>' +
                                '<td>' + proc.host + '</td>' +
                                '<td>' + proc.db + '</td>' +
                                '<td>' + proc.command + '</td>' +
                                '<td>' + proc.time + '</td>' +
                                '<td>' + proc.state + '</td>' +
                                '<td>' + proc.info + '</td>' +
                                '<td>' + proc.progress + '</td>' +
                            '</tr>';
            index++;
        });*/
        if ($('.mysql_processes_table').length == 0) {
            html_list = '<table class="table mysql_processes_table table-striped table-bordered table-hover" style="width:100% !important;">' +
                '<thead>' +
                '<tr role="row">' +
                '<th>Id</th>' +
                '<th>User</th>' +
                '<th>Host</th>' +
                '<th>Db</th>' +
                '<th>Command</th>' +
                '<th>Time</th>' +
                '<th>State</th>' +
                '<th>Info</th>' +
                '<th>Progress</th>' +
                '<th>&nbsp;</th>' +
                '</tr>' +
                '</thead>' +
                '<tbody id="_mysql_processes_table_content_">' +
                //html_content +
                '</tbody>' +
                '</table>';
            $('#_mysql_process_view_wrapper_').html(html_list);
        } else {
            $('#_mysql_processes_table_content_').html(html_content);
        }

        if (processes_list_table === null) {
            processes_list_table = $('.mysql_processes_table').DataTable({
                //"bAutoWidth": false,
                //scrollX: true,
                "dom": "<'row'<'col-sm-6'l><'col-sm-6'f>>" +
                    "<'row'<'col-sm-12'tr>>" +
                    "<'row'<'col-sm-5'i><'col-sm-7'p>>",
                columnDefs: [
                    {
                        targets: [9],
                        orderable: false
                    },
                    { className: "process-info-table", "targets": [7] }
                ],
                pageLength: 50
            });
        } else {
            //console.log('WIRO AND NOW?');
            processes_list_table.rows('tr').remove();
            //processes_list_table.rows.add(processes_list).draw();
            //processes_list_table.draw();
        }
        processes_list_table.rows.add(processes_list).draw();
    } else {
        html_list = '<div class="mysql-empty-list-database">' +
            '<h4>{{lang.LABMYSQL45}}</h4>' +
            // '<button class="btn btn-primary" onclick="addNewNodeJSApp()">' +
            //     '<i class="fa fa-plus"></i> ' +
            //     '{{lang.LABNODEJS115}}'
            // '</button>' +
            '</div>';
        $('#_mysql_process_view_wrapper_').html(html_list);
    }
    //$('[data-toggle="tooltip"]').tooltip();
}

function stopMySQLProcess(elem, process_id) {
    console.log('elem', elem);
    handleButtons(elem, 'fa-trash');
    sendStopMySQLProcess(process_id, function (response) {
        clearTimeout(monitor_processes_tick);
        $.gritter.add({
            title: 'Success!',
            text: 'Kill Process command was sent!',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        renderProcessesTable(response.processes_list);
        monitorMySQLProcesses($('#_tab_button_processes'));
    }, function () {
        handleButtons(elem, 'fa-trash', true);
    });
}
function sendStopMySQLProcess(process_id, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mysql_manager&acc=stop_mysql_process",
        data: "process_id=" + process_id,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: '{{lang.LABMYSQL23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMYSQL23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABMYSQL28}}';
                    } else if (resp_data.code == 1) {
                        message_error = 'Invalid data';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    })
}
function getMySQLProcessesList(success, cleaner) {
    $.ajax({
        type: "GET",
        url: "./loader_ajax.php?ajax=mysql_manager&acc=get_mysql_processes",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: '{{lang.LABMYSQL23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMYSQL23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABMYSQL28}}';
                    } else if (resp_data.code == 1) {
                        message_error = 'Invalid data';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}