let mysql_file_editor = null;
let mysql_vars_view_editor = null;
let mysql_settings = JSON.parse('{{mod_vars.mysql_settings|json_encode|raw}}');
let mysql_default_settings = JSON.parse('{{mod_vars.mysql_default_settings|json_encode|raw}}');
function BindSettingsTab(){
    $('[data-toggle="tooltip"]').tooltip()
    $('[data-toggle="popover"]').popover({
        container: 'body'
    });
    $('.btn-set-default-config').click(function(){
        let param_settings = $(this).data('settings');
        let input_accesor = $(this).parent().find('.mysql-settings-input');
        //console.log('input_accesor', input_accesor);
        //console.log('input_accesor.length', input_accesor.length);
        if (input_accesor.length > 0){
            if (input_accesor.hasClass('mysql-settings-input-tags')){
                $('#_mysql_settings_sql_mode').tagsinput('removeAll');
                let values = mysql_default_settings[param_settings].split(',');
                values.forEach(function (item) {
                    $('#_mysql_settings_sql_mode').tagsinput('add', item);
                });
            }else{
                input_accesor.val(mysql_default_settings[param_settings]);
            }
        }else{
            input_accesor = $(this).parent().find('.default-check');
            $(input_accesor).trigger('click');
        }
    });
    $("[data-toggle='popover']").on('show.bs.popover', function () {
        $("[data-toggle='tooltip']").tooltip('hide');
    });
    $('body').on('click', function (e) { // ADD LISTENER TO CLOSE POPOVER
        $('[data-toggle="popover"]').each(function () {
            //the 'is' for buttons that trigger popups
            //the 'has' for icons within a button that triggers a popup
            if (!$(this).is(e.target) && $(this).has(e.target).length === 0 && $('.popover').has(e.target).length === 0) {
                $(this).popover('hide');
            }
        });
    });
    $('#_mysql_settings_sql_mode').tagsinput({
        tagClass: 'cwp-tags-input',
    });
    $('#_mysql_settings_sql_mode').on('itemAdded', function (event) {
        $('.bootstrap-tagsinput input').attr('style', 'width: 0rem !important;');
    });
    /*$('#_mysql_settings_sql_mode').on('beforeItemAdd', function (event) {
        console.log(' event.item', event.item);
        event.item = 'KILSOOS'
    });*/
    $('.bootstrap-tagsinput input').keydown(function(){
        //$(this).width($(this).val().length);
        //$(this).attr('style', function (i, s) { return (s || '') + 'width: ' + ($(this).val().length + 1) + 'rem !important;' });
        $(this).attr('style', 'width: ' + ($(this).val().length + 1) + 'rem !important;');
    });
    setInputFilter(document.getElementById("_mysql_settings_max_connections"), function (value) {
        return /^\d*$/.test(value);
    });
    setInputFilter(document.getElementById("_mysql_settings_sql_mode"), function (value) {
        return /^\d*$/.test(value);
    });
    setInputFilter(document.getElementById("_mysql_settings_max_user_connections"), function (value) {
        return /^\d*$/.test(value);
    });
    setInputFilter(document.getElementById("_mysql_settings_max_execution_time"), function (value) {
        return /^\d*$/.test(value);
    });
    setInputFilter(document.getElementById("_mysql_settings_net_write_timeout"), function (value) {
        return /^\d*$/.test(value);
    });
    setInputFilter(document.getElementById("_mysql_settings_port"), function (value) {
        return /^\d*$/.test(value);
    });
    setInputFilter(document.getElementById("_mysql_settings_connect_timeout"), function (value) {
        return /^\d*$/.test(value);
    });
    setValuesToForm();
    mysql_file_editor = CodeMirror.fromTextArea(document.getElementById("_mysql_file_editor_area_"), {
        lineNumbers: true,
        matchBrackets: true,
        styleActiveLine: true,
        theme: "ambiance"
    });
    mysql_vars_view_editor = CodeMirror.fromTextArea(document.getElementById("_mysql_vars_view_area_"), {
        lineNumbers: true,
        matchBrackets: true,
        styleActiveLine: true,
        theme: "ambiance",
        readOnly: true,
    });
}
function setValuesToForm() {
    //console.log('mysql_settings', mysql_settings);
    $('#_mysql_settings_max_connections').val(mysql_settings.max_connections);
    $('#_mysql_settings_max_user_connections').val(mysql_settings.max_user_connections);
    $('#_mysql_settings_max_execution_time').val(mysql_settings.max_execution_time);
    $('#_mysql_settings_net_write_timeout').val(mysql_settings.net_write_timeout);
    $('#_mysql_settings_port').val(mysql_settings.port);
    $('#_mysql_settings_bind_address').val(mysql_settings.bind_address);
    $('#_mysql_settings_connect_timeout').val(mysql_settings.connect_timeout);
    $('#_mysql_settings_log_error_verbosity_').val(mysql_settings.log_error_verbosity);
    let sql_mode_values = mysql_settings.sql_mode.split(',');
    sql_mode_values.forEach(function(item){
        $('#_mysql_settings_sql_mode').tagsinput('add', item);
    });
    //$('#_mysql_settings_log_min_error_statement_').val(mysql_settings.log_min_error_statement);
    //$('#_mysql_settings_log_min_duration_statement_').val(mysql_settings.log_min_duration_statement);
    /*if(is_custom_version === true){
        $('#_mysql_settings_pw_enc_select').val(mysql_settings.password_encryption);
    }else{
        if (mysql_settings.password_encryption !== true) {
            $('#_mysql_settings_pw_enc_no').trigger('click');
        }
    }*/
    
    if (mysql_settings.foreign_key_checks !== true) {
        $('#_mysql_settings_foreign_key_checks_no').trigger('click');
    }
    if (mysql_settings.read_only === true) {
        $('#_mysql_settings_read_only_yes').trigger('click');
    }

}
function toggleMySQLConfEditor(type) {
    let show = '#_mysql_settings_wrapper_';
    let hide = '#_mysql_settings_file_editor_';
    if (type === 1) {
        hide = '#_mysql_settings_wrapper_';
        show = '#_mysql_settings_file_editor_';
    }
    slideToggle(show, hide, function () {
        advanceTab();
    });
}
function toggleMySQLVarsView(type) {
    let show = '#_mysql_settings_wrapper_';
    let hide = '#_mysql_settings_vars_view_';
    if (type === 1) {
        hide = '#_mysql_settings_wrapper_';
        show = '#_mysql_settings_vars_view_';
    }
    slideToggle(show, hide, function () {
        $('#_mysql_vars_view_loader_').show();
        $('#_mysql_vars_view_wrapper_').hide();
        getMySQLVars(function(){
            slideToggle('#_mysql_vars_view_wrapper_', '#_mysql_vars_view_loader_', function(){
                setTimeout(function () {
                    mysql_vars_view_editor.refresh();
                }, 20);
            });
        }, function(){
            slideToggle(hide, show);
        });
    });
}
function advanceTab() {
    setTimeout(function () {
        mysql_file_editor.refresh();
    }, 200);
}
function MySQLSaveSettingsFile(elem, restart) {
    MySQLSaveSettings(elem, restart, true);
}
function MySQLSaveSettings(elem, restart, file) {
    if (restart !== undefined) {
        $('#_mysqlsql_status_loader_title_').text('{{lang.LABMYSQL134}}');
        slideToggle('.mysqlsql-status-panel', '.mysqlsql-tabs-container-main');
        handleBtns();
    } else {
        handleButtons(elem, 'fa-floppy-o');
    }
    function UnlockUI(status) {
        if (restart !== undefined) {
            if (status == 'running') {
                slideToggle('.mysqlsql-tabs-container-main', '.mysqlsql-status-panel', function(){
                    $('.running-screen-twice').show();
                    $('.not-running-screen').hide();
                });
                $('.on-not-running').fadeOut('fast', function () {
                    $('.on-running').fadeIn('fast');
                    handleButtons('.on-not-running', 'fa-play', true);
                });
            } else {
                $('.on-running').fadeOut('fast', function () {
                    $('.on-not-running').fadeIn('fast');
                    handleBtns(false);
                });
                slideToggle('.mysqlsql-tabs-container-main', '.mysqlsql-status-panel', function(){
                    $('.running-screen-twice').hide();
                    $('.not-running-screen').show();
                });
            }
            handleBtns(false);
        } else {
            handleButtons(elem, 'fa-floppy-o', true);
        }
    }
    function handleBtns(st) {
        handleButtons('#_btn_stop_sidebar_', 'fa-stop', st);
        handleButtons('#_btn_restart_sidebar_', 'fa-refresh', st);
    }
    function alertSuccess(status) {
        let message = '{{lang.LABMYSQL135}}';
        let tag_style = 'success-notice';
        if (restart !== undefined && status != 'running') {
            message = '{{lang.LABMYSQL136}} "systemctl status postgresql.service"';
            tag_style = 'warning-notice';
            $('#_mongodb_status_holder').text(statusTranslator('stopped'));
        } else if (restart === undefined) {
            message = '{{lang.LABMYSQL137}}';
        }
        $.gritter.add({
            title: '{{lang.LABMYSQL18}}',
            text: message,
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: tag_style
        });
    }
    if (file === true) {
        let file_content = mysql_file_editor.getValue();
        sendMySQLSQLSettingsFile(file_content, restart === undefined ? 0 : 1,
            function (response) {
                mysql_settings = response.settings;
                setValuesToForm();
                UnlockUI(response.status_server);
                alertSuccess(response.status_server);
            }, function () {
                UnlockUI('running');
            });
    } else {
        let settings_form = {
            max_connections : $('#_mysql_settings_max_connections').val(),
            max_user_connections : $('#_mysql_settings_max_user_connections').val(),
            max_execution_time : $('#_mysql_settings_max_execution_time').val(),
            net_write_timeout : $('#_mysql_settings_net_write_timeout').val(),
            port : $('#_mysql_settings_port').val(),
            connect_timeout : $('#_mysql_settings_connect_timeout').val(),
            bind_address : $('#_mysql_settings_bind_address').val(),
            foreign_key_checks: $('#_mysql_settings_foreign_key_checks_yes').is(':checked') ? true : false,
            read_only: $('#_mysql_settings_read_only_yes').is(':checked') ? true : false,
            log_error_verbosity : $('#_mysql_settings_log_error_verbosity_').val(),
            sql_mode: $('#_mysql_settings_sql_mode').val(),
        };
        sendMySQLSQLSettings(JSON.stringify(settings_form), restart === undefined ? 0 : 1,
            function (response) {
                mysql_file_editor.setValue(response.file_content);
                UnlockUI(response.status_server);
                alertSuccess(response.status_server);
            }, function () {
                UnlockUI('running');
            });
    }
}
function getMySQLVars(success, cleaner) {
    $.ajax({
        type: "GET",
        url: "./loader_ajax.php?ajax=mysql_manager&acc=get_mysql_vars",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: '{{lang.LABMYSQL23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMYSQL23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABMYSQL28}}';
                    } else if (resp_data.code == 1) {
                        message_error = 'Invalid data';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendMySQLSQLSettings(settings, restart, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mysql_manager&acc=save_settings",
        data: 'settings=' + settings + '&restart=' + restart,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: '{{lang.LABMYSQL23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMYSQL23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABMYSQL28}}';
                    } else if (resp_data.code == 1) {
                        message_error = 'Invalid data';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendMySQLSQLSettingsFile(file_content, restart, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=mysql_manager&acc=save_settings_file",
        data: 'file_content=' + Base64.encode(file_content) + '&restart=' + restart,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: '{{lang.LABMYSQL23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABMYSQL23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABMYSQL28}}';
                    } else if (resp_data.code == 1) {
                        message_error = 'Invalid data';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABMYSQL20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}