let app_list = null;
function checkNodeAppsList(){
    if(app_list === null){
        loadNodeJSAppList(function(){
            renderNodeJSAppList();
            $('#_nodejs_apps_list_loader').fadeOut('fast', function(){
                $('#_nodejs_apps_list_wrapper').fadeIn('fast');
            });
            setTimeout(function () {
                listenForStatusChanges();
            }, 5000);
        });
    }else{
        listenForStatusChanges();
    }
}
function listenForStatusChanges(){
    requestStatusChanges(function(status_list){
        appUpdateStatusList(status_list);
        if ($('#nodejs_apps_tab').is(':visible')){
            setTimeout(function () {
                listenForStatusChanges();
            }, 5000);
        }
    });
    
}
function appUpdateStatusList(status_list){
    status_list.forEach(function(app){
        updateStatusAppTr(app.key, app.status);
    });
}
function cancelFormNodeJSApp(){
    if ($('#_nodejs_envars_list_container').is(':visible')) {
        $('#_nodejs_envvars_collapse').trigger('click');
    }
    slideToggle('#_nodejs_apps_list_container', '#_nodejs_apps_newform_window', function(){
        $('#_nodejs_app_desc_name').val('');
        $('#_nodejs_app_mode').val('development');
        $('#_nodejs_apps_newform_wrapper .error-field').removeClass('error-field');
        $('#_nodejs_app_start_file').val('');
        $('#_nodejs_app_uri').val('');
        $('#_nodejs_app_port').val('');
        $('#nodejs_app_quick_actions_container').hide();
        let def_ver = version_list.find(function (version) {
            return version.default === true;
        });
        $('#dirsel').text('/home/');
        $('#nodejs_app_quick_actions_container').removeClass('is-running');
        $('#_nodejs_envars_list_container').html('');
        if (def_ver !== undefined){
            $('#_nodejs_app_form_node_select').val(def_ver.ver);
        }
        
        // $('#nodejs_url_selector_domain').val(''); // Select the option with a value of '1'
        // $('#nodejs_url_selector_domain').trigger('change'); // Notify any JS components that the value changed
        // $('#_nodejs_path_wrapper').append(USER_FIRST_HTML);
        restoreAppPath();
        $('#nodejs_url_selector_select').html(USER_FIRST_HTML);
        
        $('#nodejs_user_selector_').val(''); // Select the option with a value of '1'
        $('#nodejs_user_selector_').trigger('change'); // Notify any JS components that the value changed
        $('#_nodejs_apps_loader').hide();
    });
}
function envVarTemplateHTML(index, key, val){
    return '<div class="row row-app-form app-env-var-item" id="_nodejs_apps_envar_' + index + '">' +
                '<div class="col-md-5">' +
                    '<input type="text" value="' + (key === undefined ? '' : key) + '" class="form-control env-var-key">' +
                '</div>' +
                '<div class="col-md-5">' +
                    '<input type="text" value="' + (val === undefined ? '' : val) + '" class="form-control env-var-value"">' +
                '</div>' +
                '<div class="col-md-2 env-vars-btn-container">' +
                    '<button class="btn btn-danger" onclick="deleteEnvVarApp(this)"><i class="fa fa-trash"></i></button>' +
                    '<button class="btn btn-primary" onclick="newEnvVarApp(this)"><i class="fa fa-plus"></i></button>' +
                '</div>' +
            '</div>';
}
function emptyEnvVarsAppRender(){
    $('#_nodejs_envars_list_header').slideUp('fast');
    $('#_nodejs_envars_list_container').html('<div class="nodejs-empty-env-vars"><button onclick="addInitialEnvVar()" class="btn btn-success">{{lang.LABNODEJS91}}</button></div>');
}
function deleteEnvVarApp(elem){
    $(elem).closest('.row-app-form').slideUp('fast', function(){
        $(this).remove();
        if ($('.app-env-var-item').length < 1) {
            emptyEnvVarsAppRender();
        }
    });
}
function addInitialEnvVar(){
    $('#_nodejs_envars_list_container').html('');
    newEnvVarApp();
}
function newEnvVarApp(){
    $('#_nodejs_envars_list_header').slideDown('fast');
    let index = $('#_nodejs_envars_list_container .row-app-form').length + 1;
    let html_vars = envVarTemplateHTML(index);
    $('#_nodejs_envars_list_container').append(html_vars);
}
function saveNewNodeJSApp(){
    let valid = true;
    $('#_nodejs_apps_newform_wrapper .required-data:not(.select2-container)').each(function(){
        let err_placement = $(this).data('error-place') !== undefined ? $(this).data('error-place') : this;
        if($(this).val() == ''){
            $(err_placement).addClass('error-field');
            if (valid === true){
                $(this).focus();
                valid = false;
            }
        }else{
            $(err_placement).removeClass('error-field');
        }
    });
    if ($('#nodejs_url_selector_domain').val() != '' && $('#_nodejs_app_port').val() == ''){
        $('#_nodejs_app_port').addClass('error-field')
        if (valid === true) {
            $('#_nodejs_app_port').focus();
            valid = false;
        }
    }else{
        $('#_nodejs_app_port').removeClass('error-field');
    }
    if(!valid){
        $.gritter.add({
            title: '{{lang.LABNODEJS92}}',
            text: '{{lang.LABNODEJS93}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
    }else{
        let data_app = getAppDataFromForm();
        let type_val = $('#_nodejs_app_form_type').val();
        let data_request = 'type=' + (type_val !== 'new' ? 'editing&key_id=' + type_val : 'new') + '&app=' + JSON.stringify(data_app);
        $('#_nodejs_apps_loader_title').text('{{lang.LABNODEJS94}}...');
        slideToggle('#_nodejs_apps_loader', '#_nodejs_apps_newform_window', function(){
            sendRequestSaveApp(data_request, function (resp_data) {
                app_list = resp_data.list;
                renderNodeJSAppList();
                cancelFormNodeJSApp();
            }, function () {
                slideToggle('#_nodejs_apps_newform_window', '#_nodejs_apps_loader');
            });
        });
    }
}
function isNumber(evt) {
    evt = (evt) ? evt : window.event;
    var charCode = (evt.which) ? evt.which : evt.keyCode;
    if (charCode > 31 && (charCode < 48 || charCode > 57)) {
        return false;
    }
    return true;
}
function getAppDataFromForm(){
    let env_variables = [];
    $('#_nodejs_envars_list_container .app-env-var-item').each(function(){
        let key = $(this).find('.env-var-key').val();
        if(key !== ''){
            env_variables.push({
                key: key,
                value: $(this).find('.env-var-value').val(),
            });
        }
    });
    return {
        type: 'node',
        version: $('#_nodejs_app_form_node_select').val(),
        name: $('#_nodejs_app_desc_name').val(),
        mode: $('#_nodejs_app_mode').val(),
        path: $('#dirsel').text(),
        user: $("#nodejs_user_selector_").val(),
        url: $('#nodejs_url_selector_domain').val(),
        extra_info: {
            startup_file: $('#_nodejs_app_start_file').val(),
            uri: $('#_nodejs_app_uri').val(),
            port: $('#_nodejs_app_port').val(),
            env_vars: env_variables
        }
    }
}
function renderEnvVars(env_vars){
    let html_vars = '';
    if (env_vars === undefined || env_vars.length < 1){
        emptyEnvVarsAppRender();
    }else{
        let index = 1;
        env_vars.forEach(function (env_var) {
            // console.log(`${property}: ${env_vars[property]}`);
            html_vars += envVarTemplateHTML(index, env_var.key, env_var.value);
            index++;
        });
        $('#_nodejs_envars_list_container').html(html_vars);
        if(!$('#_nodejs_envars_list_container').is(':visible')){
            $('#_nodejs_envvars_collapse').trigger('click');
        }
    }
}
function addNewNodeJSApp(){
    $('#_nodejs_form_title').text('{{lang.LABNODEJS95}}');
    $('#_nodejs_app_form_type').val('new');
    renderEnvVars();
    slideToggle('#_nodejs_apps_newform_window', '#_nodejs_apps_list_container');
}
function resetNPMInstallModal(){
    $('#_npm_install_log_loading').show();
    $('#_npm_install_log_loader').show();
    $('#_npm_install_log_container').hide();
    $('#_npm_install_log_container_log').html('');
}
function npmInstallNodeJSApp(elem){
    $('#nodejs_app_quick_actions_container .btn').prop('disabled', true);
    handleButtons(elem, 'fa-angle-right');
    let key = $('#nodejs_app_quick_actions_container').data('key');
    resetNPMInstallModal();
    sendNpmInstallApp(key, function(response){
        // handleButtons(elem, 'fa-angle-right', true);
        $('#nodejs_app_quick_actions_container .btn').prop('disabled', false);
        $('#modal_npm_install_log').modal('show');
        npmInstallLogger(key);
    }, function(){
        handleButtons(elem, 'fa-angle-right', true);
        $('#nodejs_app_quick_actions_container .btn').prop('disabled', false);
    });
}
function renderNpmInstallLog(lines, running){
    index = 0;
    function updateLogNpmInstall(){
        if (lines.length > index){
            let log_line = '<p>' + (lines[index] === '' ? '>' : lines[index]) + '</p>';
            $('#_npm_install_log_container_log').append(log_line);
            index++;
            $("#_npm_install_log_container_log p").last().attr("tabindex", -1).focus();
            setTimeout(function(){
                updateLogNpmInstall();
            },100);
        }else if(running !== true){
            $.gritter.add({
                title: '{{lang.LABNODEJS83}}',
                text: '{{lang.LABNODEJS96}}',
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'success-notice'
            });
            $('#_npm_install_log_container_log').append('<h5>{{lang.LABNODEJS97}}</h5>');
            $("#_npm_install_log_container_log h5").last().attr("tabindex", -1).focus();
            $('#_npm_install_log_loading').slideUp('fast');
            handleButtons('#_npm_install_btn_form', 'fa-angle-right', true)
        }
    }
    if (!$('#_npm_install_log_container').is(':visible')) {
        $('#_npm_install_log_loader').fadeOut('fast', function(){
            $('#_npm_install_log_container').fadeIn('fast');
        });
    }
    updateLogNpmInstall();
}
function npmInstallLogger(key){
    requestNPMInstallLog(key, function(resp_data){
        if (resp_data.pid_running === true){
            setTimeout(function(){
                npmInstallLogger(key);
            }, 1000);
        }
        renderNpmInstallLog(resp_data.lines, resp_data.pid_running);
    });
}
function editNodeJsAppWindow(app_data){
    $('#nodejs_user_selector_').val(app_data.user); // Select the option with a value of '1'
    $('#nodejs_user_selector_').trigger('change');
    // showAppDirSel(e.val);
    renderDomainForApps(app_data.user);
    $('#nodejs_url_selector_domain').val(app_data.url); // Select the option with a value of '1'
    $('#nodejs_url_selector_domain').trigger('change');
    $('#dirsel').text(app_data.path);
    $('#_nodejs_path_wrapper .nodejs-select-user-empty').fadeOut('fast', function () {
        $('#_nodejs_path_selector_wrapper').fadeIn('fast');
    });
    $('#_nodejs_app_desc_name').val(app_data.name);
    $('#_nodejs_app_mode').val(app_data.mode);
    $('#_nodejs_app_uri').val(app_data.extra_info.uri === undefined ? '' : app_data.extra_info.uri);
    $('#_nodejs_app_port').val(app_data.extra_info.port);
    
    if (app_data.status === 'running'){
        $('#nodejs_app_quick_actions_container').addClass('is-running');
    }
    if (app_data.npm_install_running === true){
        handleButtons('#_npm_install_btn_form', 'fa-angle-right');
        resetNPMInstallModal();
        $('#modal_npm_install_log').modal('show');
        npmInstallLogger(app_data.key);
    }
    $('#nodejs_app_quick_actions_container').data('key', app_data.key);
    $('#nodejs_app_quick_actions_container').data('name', app_data.name);
    $('#nodejs_app_quick_actions_container').data('cwp-key', app_data.cwp_key);
    $('#nodejs_app_quick_actions_container').show();
    $('#_nodejs_app_form_node_select').val(app_data.version);
    $('#_nodejs_app_start_file').val(app_data.extra_info.startup_file);
    renderEnvVars(app_data.extra_info.env_vars);
    slideToggle('#_nodejs_apps_newform_window', '#_nodejs_apps_loader');
}

function editNodeJSApp(app_key){
    $('#_nodejs_apps_loader_title').text('{{lang.LABNODEJS98}}...');
    $('#_nodejs_app_form_type').val(app_key);
    slideToggle('#_nodejs_apps_loader', '#_nodejs_apps_list_container', function(){
        loadNodeJSAppInfo(app_key, function (resp_data) {
            $('#_nodejs_form_title').text('{{lang.LABNODEJS99}}');
            editNodeJsAppWindow(resp_data.info);
        }, function () {
            slideToggle('#_nodejs_apps_list_container', '#_nodejs_apps_loader');
        });
    });
    
}
// function newAppFromVersion(ver) {
//     $('#_nodejs_form_title').text('Adding new NodeJs application.');
//     $('#_nodejs_apps_list_container').hide();
//     $('#_nodejs_apps_newform_window').show(); 
//     $('').trigger('click');
// }
function confirmAppDeletion(elem, app_name, index){
    $('#confirm_app_delete_name').text(app_name)
    $('#_nodejs_app_confirm_del_btn').unbind('click').click(function(){
        let tr_delete = $('#_nodejs_apps_item_' + index);
        tr_delete.addClass('deleting_tr');
        tr_delete.find('.btn').prop('disabled', true);
        function resetTR() {
            tr_delete.removeClass('deleting_tr');
            tr_delete.find('.btn').prop('disabled', false);
        }
        handleButtons(elem, 'fa-trash');
        $('#modal_app_delete_confirm').modal('hide');
        let key = $(elem).data('key');
        sendDeleteApplication(key, function(){
            tr_delete.slideUp('fast', function () {
                apps_table.row(this).remove().draw();
            });
            resetTR();
        },function(){
            resetTR();
            handleButtons(elem, 'fa-trash', true);
        });
    });
    $('#modal_app_delete_confirm').modal('show');
}
// function editNodeJSApplication(elem){
//     let app_data = $(elem).data('app');
//     console.log('app_data',app_data);
// }
function restartApplication(elem, index){
    handleButtons(elem, 'fa-refresh');
    let tr_app = $('#_nodejs_apps_item_' + index);
    tr_app.addClass('deleting_tr');
    function resetTR() {
        tr_app.removeClass('deleting_tr');
        tr_app.find('.btn').prop('disabled', false);
        handleButtons(elem, 'fa-refresh', true);
    }
    let app_key = tr_app.data('key');
    let cwp_key = tr_app.data('cwpkey');
    handleAppStatus('restart&cwp_key=' + cwp_key + '&key=' + app_key, function (response){
        if(response.app_status != 'running'){
            $(elem).fadeOut('fast');
            let status_btn = $('#_nodejs_apps_status_btn_' + index)
            status_btn.removeClass('btn-success').addClass('btn-danger');
        }else{
            $.gritter.add({
                title: '{{lang.LABNODEJS83}}',
                text: '{{lang.LABNODEJS100}}',
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'success-notice'
            });
            updateStatusAppTr(app_key, response.app_status)
        }
        resetTR();
    }, function () {
        resetTR();
    });
}
function nodeJSAppStatus(elem, index){
    let status = $(elem).data('status');
    let action = 'stop';
    let curr_ico = 'fa-stop';
    let next_ico = 'fa-play';
    let curr_btn = 'btn-success';
    let next_btn = 'btn-danger';
    let next_status = 'stoped';
    let next_title = '{{lang.LABNODEJS101}}';
    let message = 'stoped';
    if (status !== 'running'){
        action = 'start';
        next_ico = 'fa-stop';
        curr_ico = 'fa-play';
        next_btn = 'btn-success';
        curr_btn = 'btn-danger';
        next_status = 'running';
        next_title = '{{lang.LABNODEJS102}}';
        message = 'started'
    }
    let tr_app = $('#_nodejs_apps_item_' + index);
    tr_app.addClass('deleting_tr');
    tr_app.find('.btn').prop('disabled', true);
    function resetTR(){
        tr_app.removeClass('deleting_tr');
        tr_app.find('.btn').prop('disabled', false);
    }
    let app_key = tr_app.data('key');
    let cwp_key = tr_app.data('cwpkey');
    handleButtons(elem, curr_ico);
    handleAppStatus(action + '&cwp_key=' + cwp_key + '&key=' + app_key, function(resp_data){
        if (action == 'stop' || (action == 'start' && resp_data.app_status === 'running')){
            $(elem).addClass(next_btn).removeClass(curr_btn);
            $(elem).data('status', next_status);
            $(elem).attr('title', next_title);
            $(elem).attr('data-original-title', next_title);
            updateStatusAppTr(app_key, resp_data.app_status);
            $.gritter.add({
                title: '{{lang.LABNODEJS83}}',
                text: '{{lang.LABNODEJS103}} ' + message + ' {{lang.LABNODEJS104}}',
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'success-notice'
            });
            handleButtons(elem, next_ico, true);
        }else{
            $.gritter.add({
                title: '{{lang.LABNODEJS82}}',
                text: '{{lang.LABNODEJS105}}',
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'error-notice'
            });
            handleButtons(elem, curr_ico, true);
        }
        resetTR();
    }, function(){
        resetTR();
        handleButtons(elem, curr_ico, true);
    });
}
function nodeJSAppStatusInForm(elem, type){
    // handleButtons(elem, curr_ico);
    let ico_btn = 'fa-play';
    let message = 'started';
    if (type == 'stop'){
        ico_btn = 'fa-stop'
        message = 'stopped'
    } else if (type == 'restart'){
        ico_btn = 'fa-refresh'
        message = 'restarted'
    }
    let cwp_key = $('#nodejs_app_quick_actions_container').data('cwp-key');
    let app_key = $('#nodejs_app_quick_actions_container').data('key');
    handleButtons(elem, ico_btn);
    $('#nodejs_app_quick_actions_container .btn').prop('disabled', true);
    $('.nodejs-app-form-btn').prop('disabled', true);
    function resetButtons(){
        $('#nodejs_app_quick_actions_container .btn').prop('disabled', false);
        $('.nodejs-app-form-btn').prop('disabled', false);
        handleButtons(elem, ico_btn, true);
    }
    handleAppStatus(type + '&cwp_key=' + cwp_key + '&key=' + app_key, function(resp_data){
        if ((type == 'start' || type == 'restart') && resp_data.app_status === 'running'){
            $('#nodejs_app_quick_actions_container').addClass('is-running');
        }else if(type == 'stop'){
            $('#nodejs_app_quick_actions_container').removeClass('is-running');
        }else{
            $.gritter.add({
                title: '{{lang.LABNODEJS82}}',
                text: '{{lang.LABNODEJS105}}',
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'error-notice'
            });
            resetButtons();
            return;
        }
        $.gritter.add({
            title: '{{lang.LABNODEJS83}}',
            text: '{{lang.LABNODEJS103}} ' + message + ' {{lang.LABNODEJS104}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'success-notice'
        });
        resetButtons();
        updateStatusAppTr(app_key, resp_data.app_status)
    }, function(){
        resetButtons();
    });
}
function updateStatusAppTr(appkey, status){
    let class_circle = 'text-success';
    let btn_class_new = 'btn-danger';
    let btn_class_old = 'btn-success';
    let btn_ico_new = 'fa-stop';
    let btn_ico_old= 'fa-play';
    let next_title = "{{lang.LABNODEJS102}}";
    if(status != 'running'){
        class_circle = 'text-danger';
        btn_class_new = 'btn-success';
        btn_class_old = 'btn-danger';
        btn_ico_new = 'fa-play';
        btn_ico_old = 'fa-stop';
        next_title = "{{lang.LABNODEJS101}}";
        $('.app-tr-' + appkey).find('.btn-restart-app').fadeOut('fast');
    }else{
        $('.app-tr-' + appkey).find('.btn-restart-app').fadeIn('fast');
    }
    // if (status !== 'running') {
    //     $('#_nodejs_apps_restart_btn_' + index).fadeIn('fast');
    // } else {
    //     $('#_nodejs_apps_restart_btn_' + index).fadeOut('fast');
    // }
    $('.app-tr-' + appkey).find('.btn-status_main').removeClass(btn_class_old).addClass(btn_class_new).attr('data-original-title', next_title);
    $('.app-tr-' + appkey).find('.btn-status_main i').removeClass(btn_ico_old).addClass(btn_ico_new);
    $('.app-tr-' + appkey).find('.status-app-container i').removeClass().addClass('fa fa-circle ' + class_circle);
    $('.app-tr-' + appkey).find('.status-app-container span').text(status);
}
function refeshNodeJSAppLog(elem){
    $('#nodejs_app_log_wrapper').fadeOut('fast', function(){
        $('#nodejs_app_log_loader').fadeIn('fast');
        let key = $(elem).data('key');
        let lines = $('#_nodejs_app_logger_lines_qty').val();
        requestAppLog(key, lines, function (resp) {
            $('#nodejs_app_log_container').html(resp.log.map(function (log_line) {
                return '<p>' + log_line + '</p>';
            }).join(''));
            $('#nodejs_app_log_loader').fadeOut('fast', function () {
                $('#nodejs_app_log_wrapper').fadeIn('fast');
            });
        }, function () {
            $('#modal_nodejs_app_log').modal('hide');
        });
    });
}
function nodeJSAppViewLogInForm(){ 
    let key = $('#nodejs_app_quick_actions_container').data('key');
    let name = $('#nodejs_app_quick_actions_container').data('name'); 
    viewNodeJSAppLog(name, key);
}
function viewNodeJSAppLog(name, key){
    $('#_nodejs_app_logger_lines_qty').val(20);
    $('#_nodejs_app_logger_refresh_btn').data('key', key);
    $('#modal_nodejs_app_log_title').text(name + ' log');
    $('#nodejs_app_log_loader').show();
    $('#nodejs_app_log_wrapper').hide();
    $('#modal_nodejs_app_log').modal('show');
    requestAppLog(key, 20, function(resp){
        $('#nodejs_app_log_container').html(resp.log.map(function(log_line){
            return '<p>' + log_line + '</p>';
        }).join(''));
        $('#nodejs_app_log_loader').fadeOut('fast', function(){
            $('#nodejs_app_log_wrapper').fadeIn('fast', function(){
                $("#nodejs_app_log_container p").last().attr("tabindex", -1).focus();
            });
        });
    }, function(){
        $('#modal_nodejs_app_log').modal('hide');
    });
}
function renderNodeJSAppList(){
    let html_list = '';
    if (app_list.length > 0) {
        let html_content = '';
        index = 1;
        function renderAppUrlLink(app) {
            //let url_title = app.path;
            //let url_href = 'http://' + tomcat_host + ':' + tomcat_port + app.path;
            if (app.url != '' && app.url !== null) {
                let url_href = (app.uri_secured ? 'https' : 'http') + '://' + app.url;
                return '<br/>(<a target="_blank" href="' + url_href + '">' + app.url + '</a>)';
            }
            return '';
        }
        app_list.forEach(function (app) {
            let status_btn = '<button id="_nodejs_apps_status_btn_' + index + '" title="{{lang.LABNODEJS102}}" data-status="running" onclick="nodeJSAppStatus(this, ' + index + ')" data-toggle="tooltip" data-placement="top" class="btn btn-danger btn-xs btn-status_main"><i class="fa fa-stop"></i></button>';
            let status_class = 'success';
            let btn_restart = '';
            if (app.status != 'running'){
                status_class = 'danger';
                btn_restart = 'style="display:none"';
                status_btn = '<button id="_nodejs_apps_status_btn_' + index + '" title="{{lang.LABNODEJS101}}" data-status="stoped" onclick="nodeJSAppStatus(this, ' + index + ')" data-toggle="tooltip" data-placement="top" class="btn btn-success btn-xs btn-status_main"><i class="fa fa-play"></i></button>';
            }
            html_content += '<tr class="app-tr-' + app.key + '" id="_nodejs_apps_item_' + index + '" data-key="' + app.key + '" data-cwpkey="' + app.cwp_key + '">' +
                                '<td>' + app.name + renderAppUrlLink(app) + '</td>' +
                                '<td>' + app.version + '</td>' +
                                '<td>' + app.user + '</td>' +
                                '<td class="status-app-container">' +
                                    '<i class="fa fa-circle text-' + status_class + '" aria-hidden="true"></i> ' + 
                                    '<span>' + app.status + '</span>' +
                                '</td>' +
                                '<td>' + app.mode + '</td>' +
                                '<td>' +
                                    '<div class="nodejs-apps-actions">' +
                                        '<button title="{{lang.LABNODEJS99}}" data-toggle="tooltip" data-placement="top" onclick="editNodeJSApp(\'' + app.key + '\')" class="btn btn-primary btn-xs"><i class="fa fa-cogs"></i></button>' +
                                        status_btn +
                                        '<button ' + btn_restart + ' id="_nodejs_apps_restart_btn_' + index + '" onclick="restartApplication(this, ' + index + ')" title="{{lang.LABNODEJS107}}" data-toggle="tooltip" data-placement="top" class="btn btn-default btn-xs btn-restart-app"><i class="fa fa-refresh"></i></button>' +
                                        '<button class="btn btn-warning btn-xs" title="{{lang.LABNODEJS108}}" data-toggle="tooltip" data-key="' + app.key + '" data-placement="top" onclick="confirmAppDeletion(this, \'' + app.name + '\',' + index + ')"><i class="fa fa-trash"></i></button>' + 
                                        '<button class="btn btn-default btn-xs" title="{{lang.LABNODEJS109}}" data-toggle="tooltip" data-placement="top" onclick="viewNodeJSAppLog(\'' + app.name + '\', ' + app.key + ')"><i class="fa fa-file-text-o"></i></button>' + 
                                        '<button class="btn btn-default btn-console btn-xs" title="Run command on app" data-toggle="tooltip" data-placement="top" onclick="modalCommandOnApp(\'' + app.name + '\', ' + app.key + ')"><i class="fa fa-terminal"></i></button>' + 
                                    '</div>' +
                                '</td>' +
                            '</tr>';
            index++;
        });
        html_list = '<table class="table nodejs_apps_table table-striped table-bordered table-hover">' +
            '<thead>' +
            '<tr role="row">' +
                '<th>{{lang.LABNODEJS110}}</th>' +
                '<th style="width:120px">{{lang.LABNODEJS45}}</th>' +
                '<th style="width:140px">User</th>' +
                // '<th>{{lang.LABNODEJS112}}</th>' +
                '<th style="width:85px">{{lang.LABNODEJS113}}</th>' +
                '<th style="width:85px">{{lang.LABNODEJS114}}</th>' +
                '<th style="width:140px">{{lang.LABNODEJS71}}</th>' +
            '</tr>' +   
            '</thead>' + 
            '<tbody id="contenttr">' +
            html_content +
            '</tbody>' +
            '</table>';
            $('#_nodejs_apps_list_wrapper').html(html_list);
            apps_table = $('.nodejs_apps_table').DataTable({
                "autoWidth": false
            });
    } else {
        html_list = '<div class="nodejs-empty-list-version">' +
                        '<h4>{{lang.LABNODEJS129}}</h4>' +
                        '<button class="btn btn-primary" onclick="addNewNodeJSApp()">' +
                            '<i class="fa fa-plus"></i> ' +
                            '{{lang.LABNODEJS115}}'
                        '</button>' +
                    '</div>';
        $('#_nodejs_apps_list_wrapper').html(html_list);
    }
    $('[data-toggle="tooltip"]').tooltip();
}
let apps_table = null;
function sortDomainToList(a, b) {
    if (a.domain < b.domain) {
        return -1;
    }
    if (a.domain > b.domain) {
        return 1;
    }
    return 0;
}
const USER_FIRST_HTML = '<div class="nodejs-select-user-empty"><span>{{lang.LABNODEJS123}}</span></div>';
let domain_list = null;
function restoreAppPath(){
    $('#_nodejs_path_selector_wrapper').fadeOut('fast', function(){
        $('#_nodejs_path_wrapper .nodejs-select-user-empty').fadeIn('fast');
    });
}
function showAppDirSel(user){
    $('#dirsel').text('/home/' + user + '/');
    if($('#_nodejs_path_wrapper .nodejs-select-user-empty').is(':visible')){
        $('#_nodejs_path_wrapper .nodejs-select-user-empty').fadeOut('fast', function () {
            $('#_nodejs_path_selector_wrapper').fadeIn('fast');
        });
    }
}
function renderFormApps(domains, users){
    domain_list = domains.sort(sortDomainToList);;
    // domains = domains.sort(sortDomainToList);
    // let html_select = '<select id="nodejs_url_selector_domain">' +
    //                         '<option value="">{{lang.LABNODEJS119}}</option>';
    // domains.forEach(function(domain){
    //     html_select += '<option value="' + domain.domain_label + '">' + domain.domain_label + '</option>';
    // });
    // html_select +='</select>';
    // $('#nodejs_url_selector_select').html(html_select);
    // $("#nodejs_url_selector_domain").select2({
    //     placeholder: "{{lang.LABNODEJS119}}",
    //     allowClear: true
    // });
    $('#_nodejs_path_wrapper').append(USER_FIRST_HTML);
    $('#nodejs_url_selector_select').html(USER_FIRST_HTML);
    let html_select = '<select class="required-data" data-error-place="#_nodejs_app_form_user .select2-container a" id="nodejs_user_selector_">' +
        '<option value="">{{lang.LABNODEJS120}}</option>';
    users.forEach(function (user) {
        html_select += '<option value="' + user + '">' + user + '</option>';
    });
    html_select += '</select>';
    $('#_nodejs_app_form_user').html(html_select);
    $("#nodejs_user_selector_").select2({
        placeholder: "{{lang.LABNODEJS120}}",
        allowClear: true
    });
    $("#nodejs_user_selector_").on('select2-selected', function (e) {
        if(e.val == ''){
            restoreAppPath();
            $('#nodejs_url_selector_select').html(USER_FIRST_HTML);
        }else{
            showAppDirSel(e.val);
            renderDomainForApps(e.val);
        }

        // setTimeout(function(){
        //     $('#nodejs_user_selector_').val(''); // Select the option with a value of '1'
        //     $('#nodejs_user_selector_').trigger('change'); // Notify any JS components that the value changed
        // }, 5000);
    });
}
function renderDomainForApps(user, domain){
    let html_select = '<select id="nodejs_url_selector_domain">' +
                        '<option value="">{{lang.LABNODEJS119}}</option>';
    let found = false;
    domain_list.forEach(function(dom){
        if(dom.user === user){
            found = true;
            html_select += '<option value="' + dom.domain_label + '">' + dom.domain_label + '</option>';
        }
    });
    if(found === false){
        $('#nodejs_url_selector_select').html('<div class="nodejs-no-domains"><span>{{lang.LABNODEJS121}}</span></div>')
    }else{
        html_select += '</select>';
        $('#nodejs_url_selector_select').html(html_select);
        $("#nodejs_url_selector_domain").select2({
            placeholder: "{{lang.LABNODEJS119}}",
            allowClear: true
        });
    }
}
function sendDeleteApplication(app_key, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=delete_app",
        data: 'key_id=' + app_key,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: '{{lang.LABNODEJS81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABNODEJS81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
} 
function requestNPMInstallLog(key, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=app_npm_logger",
        data: 'key=' + key,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            }
        }
    });
}
function requestAppLog(key, lines, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=get_app_log",
        data: 'key=' + key + '&lines=' + lines,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: '{{lang.LABNODEJS81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABNODEJS81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABNODEJS116}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendNpmInstallApp(key, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=app_npminstall",
        data: 'key=' + key,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: '{{lang.LABNODEJS81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABNODEJS81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function handleAppStatus(action, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=app_status",
        data: 'action=' + action,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: '{{lang.LABNODEJS81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABNODEJS81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABNODEJS117}}';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABNODEJS116}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function requestStatusChanges(success) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=status_listener",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data.list);
            }
        }
    });
}
function sendRequestSaveApp(data, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=nodejs_app_save",
        data: data,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: '{{lang.LABNODEJS81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                $.gritter.add({
                    title: '{{lang.LABNODEJS83}}',
                    text: '{{lang.LABNODEJS118}}',
                    time: 5500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'success-notice'
                });
                success(resp_data);
            } else {
                let message_error = '{{lang.LABNODEJS81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = 'Invalid appication path';
                    } else if (resp_data.code == 2) {
                        message_error = 'Invalid NodeJS Version';
                    } else if (resp_data.code == 3) {
                        message_error = 'Invalid domain';
                    } else if (resp_data.code == 4) {
                        message_error = 'Invalid APP';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function loadNodeJSAppInfo(app_key, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=nodejs_app_info",
        data: 'key_id=' + app_key,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: '{{lang.LABNODEJS81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABNODEJS81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function loadNodeJSAppList(success){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=nodejs_apps",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: '{{lang.LABNODEJS81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                app_list = resp_data.list;
                renderFormApps(resp_data.domains, resp_data.users);
                success();
            } else {
                let message_error = '{{lang.LABNODEJS81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
            }
        }
    });
}

// SEPARATE FILE
