let app_command_running = false;
let timeout_logger = null;
let timeout_logger_render = null;
function modalCommandOnApp(name, key){
    app_command_running = false;
    $('#_modal_command_on_app_key_').val(key);
    $('#_modal_command_on_app_').val('');
    $('#_modal_command_on_app_').removeClass('error-field');
    $('#_console_command_app_name_').text(name);
    $('#_npm_command_app_log_container_').html('');
    $('#_npm_command_app_log_loading').hide();
    $('#_modal_command_prevent_close_wrapper_').hide();
    $('#_modal_command_prevent_handler_').show();
    if (timeout_logger !== null){
        clearTimeout(timeout_logger);
    }
    if (timeout_logger_render !== null){
        clearTimeout(timeout_logger_render);
    }
    $('#_modal_npm_command_app').modal('show');
}
function dismissModalCommand(){
    if (app_command_running === true){
        $('#_modal_command_prevent_handler_').fadeOut('fast', function(){
            $('#_modal_command_prevent_close_wrapper_').fadeIn('fast');
        })
    }else{
        $('#_modal_npm_command_app').modal('hide');
    }
}
function sendNpmCommandOnApp(btn){
    let command = $('#_modal_command_on_app_').val();
    if(command != ""){
        $('#_npm_command_app_log_container_').html('');
        let app_key = $('#_modal_command_on_app_key_').val();
        $('#_modal_command_on_app_').removeClass('error-field');
        handleButtons(btn, 'fa-play');
        sendRequestCommandOnApp(command, app_key, function(response){
            app_command_running = true;
            $.gritter.add({
                title: 'Success',
                text: 'Command sent successfully.',
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'success-notice'
            });
            //handleButtons(btn, 'fa-play', true);
            $('#_npm_command_app_log_loading').slideDown('fast');
            npmCommandLogger(app_key);
        }, function(){
            handleButtons(btn, 'fa-play', true);
        });
    }else{
        $('#_modal_command_on_app_').addClass('error-field');
    }   
}
function npmCommandLogger(app_key){
    requestNpmCommandLog(app_key, function (resp_data) {
        if (resp_data.pid_running === true) {
            timeout_logger = setTimeout(function () {
                npmCommandLogger(app_key);
            }, 1000);
        }
        renderNpmCommandLog(resp_data.lines, resp_data.pid_running);
    });
}
function renderNpmCommandLog(lines, running) {
    index = 0;
    function updateLogNpmCommandLog() {
        if (lines.length > index) {
            let log_line = '<p>' + (lines[index] === '' ? '>' : lines[index]) + '</p>';
            $('#_npm_command_app_log_container_').append(log_line);
            index++;
            $("#_npm_command_app_log_container_ p").last().attr("tabindex", -1).focus();
            timeout_logger_render = setTimeout(function () {
                updateLogNpmCommandLog();
            }, 100);
        } else if (running !== true) {
            $.gritter.add({
                title: 'Success',
                text: 'NPM Install complete.',
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'success-notice'
            });
            $('#_npm_command_app_log_container_').append('<h5>Command completed!</h5>');
            $("#_npm_command_app_log_container_ h5").last().attr("tabindex", -1).focus();
            $('#_npm_command_app_log_loading').slideUp('fast');
            app_command_running = false;
            handleButtons('#_button_modal_app_send_commad_', 'fa-play', true);
            $('#_modal_command_prevent_close_wrapper_').fadeOut('fast', function () {
                $('#_modal_command_prevent_handler_').fadeIn('fast');
            })
            //handleButtons('#_npm_install_btn_form', 'fa-angle-right', true)
        }
    }
    /*if (!$('#_npm_install_log_container').is(':visible')) {
        $('#_npm_install_log_loader').fadeOut('fast', function () {
            $('#_npm_install_log_container').fadeIn('fast');
        });
    }*/
    updateLogNpmCommandLog();
}
function requestNpmCommandLog(key, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=npm_command_logger",
        data: 'key=' + key,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            }
        }
    });
}
function sendRequestCommandOnApp(command, key, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=npm_command_on_app",
        data: "key=" + key + "&command=" + command,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: '{{lang.LABNODEJS81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABNODEJS81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = 'Invalid application!';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}