let installing = {{ mod_vars.installing == true ? 'true' : 'false'}};
let version_list = JSON.parse('{{mod_vars.ver_list|json_encode()|raw}}');
let version_availables = null;
let log_install_lines = [];
let log_install_lines_index = 0;
let logs_modal_time = null;
let ver_list_table = null;
function renderDashboard() {
    let html_list = '';
    let html_select = '';
    if (version_list.length > 0) {
        let html_content = '';
        index = 1;
        version_list.forEach(function (version) {
            html_content += '<tr class="nodejs-ver-item-tr' + (version.default === true ? ' ver-default' : '') + '" id="_nodejs_version_item_' + index + '">' +
                '<td>' + version.ver_name + '</td>' +
                '<td>' +
                '<span class="label label-success nodejs-default-label">{{lang.LABNODEJS64}}</span>' +
                '<button class="label label-primary nodejs-ver-overable nodejs-set-default-label" data-version="' + version.ver + '" onclick="setAsDefaultVersion(this)">' +
                '<i class="fa fa-check" aria-hidden="true"></i> ' +
                '<span>{{lang.LABNODEJS65}}</span>' +
                '</button>' +
                '</td>' +
                '<td class="text-right nodejs-ver-qty-apps">' + version.qty + '</td>' +
                '<td>' +
                '<div class="nodejs-td-actions">' +
                // '<button class="btn btn-xs btn-primary" onclick="newAppFromVersion(\'' + version.ver + '\')"><i class="fa fa-plus"></i> New App</button>' + 
                '<button class="btn btn-xs btn-info" data-path="' + version.path + '" onclick="copyNodeJSPath(this)"><i class="fa fa-copy"></i> {{lang.LABNODEJS66}}</button>' +
                '<button class="btn btn-xs btn-danger"' + (version.default === true ? ' disabled' : '') + ' onclick="modalUninstallConfirm(this)" data-version-name="' + version.ver_name + '" data-version="' + version.ver + '"><i class="fa fa-trash"></i> {{lang.LABNODEJS67}}</button>' +
                '</div>' +
                '</td>' +
                '</tr>';
            index++;
            html_select += '<option value="' + version.ver + '"' + (version.default === true ? ' selected' : '') + '>' + version.ver + '</option>';
        });
        html_list = '<table class="table nodejs_version_table table-striped table-bordered table-hover">' +
            '<thead>' +
            '<tr role="row">' +
            '<th>{{lang.LABNODEJS68}}</th>' +
            '<th style="width:140px">{{lang.LABNODEJS69}}</th>' +
            '<th style="width:140px" class="text-right">{{lang.LABNODEJS70}}</th>' +
            '<th style="width:150px">{{lang.LABNODEJS71}}</th>' +
            '</tr>' +
            '</thead>' +
            '<tbody id="contenttr">' +
            html_content +
            '</tbody>' +
            '</table>';
        $('#_nodejs_app_form_node').html('<select id="_nodejs_app_form_node_select" class="form-control">' + html_select + '</select>');

    } else {
        html_list = '<div class="nodejs-empty-list-version">' +
            '<h4>{{lang.LABNODEJS72}}</h4>' +
            '<button class="btn btn-primary" onclick="installationModal()">' +
            '<i class="fa fa-download"></i> ' +
            '{{lang.LABNODEJS73}}'
        '</button>' +
            '</div>';
        let html_install_ver_first = '<span class="nodejs-select-user-empty" onclick="installNodeJSVerFromAppForm()" id="_apps_form_install_nodejs">' +
            '<span>{{lang.LABNODEJS131}}</span>' +
            '<input type="hidden" class="required-data" data-error-place="#_apps_form_install_nodejs" value="">' +
            '</span>';
        $('#_nodejs_app_form_node').html(html_install_ver_first);
    }
    $('#_nodejs_main_table_wrapper').html(html_list);
    if (version_list.length > 0) {
        ver_list_table = $('.nodejs_version_table').DataTable({
            "dom": "<'row'<'col-sm-12'tr>>",
            columnDefs: [
                { targets: [1, 2, 3], orderable: false }
            ]
        });
    }
    $('#_nodejs_main_loader').fadeOut('fast', function () {
        $('#_nodejs_main_table').fadeIn('fast', function () {
            setTimeout(function () {
                msmc_width = $('#_nodejs_main_col').width();
            }, 300);
        });
    });
}
function installNodeJSVerFromAppForm() {
    $('#_tab_button_installed a').trigger('click');
    setTimeout(function () {
        if ($('#_nodejs_install_btn').is(':visible')) {
            $('#_nodejs_install_btn').trigger('click');
        }
    }, 200);
}
function saveUserConfig(elem) {
    let valid = true;
    $('.port-range-input').each(function () {
        if ($(this).val() == '') {
            valid = false;
            $(this).addClass('error-field');
        }
    });
    if (valid) {
        let data = {
            'user_enabled': $('#chk_enable_nodejs_usr').is(':checked'),
            'port_range': [
                $('#_port_range_max_').val(),
                $('#_port_range_min_').val()
            ]
        }
        handleButtons(elem, 'fa-floppy-o');
        setNodeJSUserConfig('usr_config=' + JSON.stringify(data), function () {
            handleButtons(elem, 'fa-floppy-o', true);
        });
    } else {
        $.gritter.add({
            title: '{{lang.LABNODEJS92}}',
            text: '{{lang.LABNODEJS93}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
    }
}
function setInputFilter(textbox, inputFilter) {
    ["input", "keydown", "keyup", "mousedown", "mouseup", "select", "contextmenu", "drop"].forEach(function (event) {
        textbox.addEventListener(event, function () {
            if (inputFilter(this.value)) {
                this.oldValue = this.value;
                this.oldSelectionStart = this.selectionStart;
                this.oldSelectionEnd = this.selectionEnd;
            } else if (this.hasOwnProperty("oldValue")) {
                this.value = this.oldValue;
                this.setSelectionRange(this.oldSelectionStart, this.oldSelectionEnd);
            } else {
                this.value = "";
            }
        });
    });
}
function setAsDefaultVersion(elem) {
    let version = $(elem).data('version');
    let tr = $(elem).closest('tr');
    tr.addClass('deleting_tr');
    tr.find('.btn').prop('disabled', true);
    $('.nodejs-set-default-label').removeClass('nodejs-ver-overable').prop('disabled', true);
    $(elem).addClass('nodejs-ver-overable-fixed');
    handleButtons(elem, 'fa-check');
    $(elem).find('span').text('{{lang.LABNODEJS74}}');
    setNodeJSVerAsDefault(version, function () {
        tr.removeClass('deleting_tr');
        tr.find('.btn-info').prop('disabled', false);
        $('.nodejs-ver-item-tr.ver-default').find('.btn-danger').prop('disabled', false);
        $('.nodejs-ver-item-tr.ver-default').removeClass('ver-default');
        tr.addClass('ver-default');
        handleButtons(elem, 'fa-check', true);
        $(elem).find('span').text('{{lang.LABNODEJS75}}');
        $(elem).removeClass('nodejs-ver-overable-fixed');
        $('.nodejs-set-default-label').addClass('nodejs-ver-overable').prop('disabled', false);
    }, function () {
        tr.removeClass('deleting_tr');
        tr.find('.btn').prop('disabled', false);
        handleButtons(elem, 'fa-check', true);
        $(elem).find('span').text('{{lang.LABNODEJS75}}');
        $(elem).removeClass('nodejs-ver-overable-fixed');
        $('.nodejs-set-default-label').addClass('nodejs-ver-overable').prop('disabled', false);
    });
}
function copyNodeJSPath(elem) {
    $('#_nodejs_ver_path_copy').val($(elem).data('path')).show();
    var copyText = document.getElementById("_nodejs_ver_path_copy");

    /* Select the text field */
    copyText.select();
    copyText.setSelectionRange(0, 99999); /* For mobile devices */

    /* Copy the text inside the text field */
    document.execCommand("copy");
    $('#_nodejs_ver_path_copy').hide();
}
function installationModal() {
    if (version_availables === null) {
        loadAvailableVersionToInstall(function () {
            $('#modal_nvm_install').modal('hide');
        });
        $('#modal_nvm_install').modal('show');
        return false;
    }
    renderInstallableVersions();
    $('#modal_nvm_install').modal('show');
}
function installNVM(elem) {
    handleButtons(elem, 'fa-download');
    sendInstallNVM(function (data) {
        version_list = data.list
        renderDashboard();
        $('#_nodejs_nvm_not_installed').slideUp('fast', function () {
            handleButtons(elem, 'fa-download', true);
            $('#_nodejs_main_screen').slideDown('fast');
        });
    }, function () {
        handleButtons(elem, 'fa-download', true);
    });
}
function renderInstallableVersions() {
    let html_content = '';
    let index = 1;
    // version_availables.forEach(function(version){
    for (const ver_number in version_availables) {
        let version = version_availables[ver_number];
        let exists = version_list.find(function (ver_ins) {
            return ver_ins.ver === version.ver;
        });
        if (exists === undefined) {
            html_content += '<li>' +
                '<div class="checkbox-custom">' +
                '<input class="nodejs-ver-toinstall" onchange="handleBtnModalInstall()" type="checkbox" id="_ver_toinstall_' + index + '" value="' + version.ver_name + '">' +
                '<label for="_ver_toinstall_' + index + '">' +
                '{{lang.LABNODEJS68}} <b>' + version.ver_name + '</b>' +
                '</label>' +
                '</div>' +
                '</li>';
            index++;
        }
    };
    if (html_content != '') {
        html_content = '<div class="nodejs-heading">' +
            '<h5>{{lang.LABNODEJS76}}</h5>' +
            '</div>' +
            '<div class="modal-installer-separator">' +
            '<div class="checkbox-custom">' +
            '<input onchange="checkAllToInstall(this)" type="checkbox" id="_ver_toinstall_all">' +
            '<label id="_nodejs_install_label" for="_ver_toinstall_all">' +
            '{{lang.LABNODEJS77}}' +
            '</label>' +
            '</div>' +
            '</div>' +
            '<div class="nodejs-ul-install-wrapper">' +
            '<ul class="nodejs-ul-install">' + html_content + '</ul>' +
            '</div>';
    } else {
        html_content = '<div class="nodejs-versions-all-installed">' +
            '<h4>{{lang.LABNODEJS78}}</h4>' +
            '</div>';
    }
    $('#_nvm_install_version_list').html(html_content);
}
function checkAllToInstall(elem) {
    if ($(elem).is(':checked')) {
        $('.nodejs-ver-toinstall').prop('checked', true);
        $('#_nodejs_install_label').text('{{lang.LABNODEJS79}}');
    } else {
        $('.nodejs-ver-toinstall').prop('checked', false);
        $('#_nodejs_install_label').text('{{lang.LABNODEJS77}}');
    }
    handleBtnModalInstall();
}
function confirmNodeJSInstall() {
    let data_install = 'versions=';
    let data_versions = [];
    $('#modal_nvm_install').modal('hide');
    $('.nodejs-ver-toinstall:checked').each(function () {
        let ver_pieces = $(this).val().split(' ');
        if (ver_pieces[0] != "") {
            data_versions.push({
                ver: ver_pieces[0],
                name: $(this).val().replace(/\s+/g, ' ').trim()
            });
        }
    });
    handleButtons('#_nodejs_install_btn', 'fa-plus');
    data_install += JSON.stringify(data_versions);
    sendInstallation(data_install, function () {
        handleButtons('#_nodejs_install_btn', 'fa-plus', true);
    });
}
function viewInstallationLogModal() {
    $('#_nvm_install_log_container').html('').hide();
    $('#_nvm_install_log_loader').show();
    $('#modal_nvm_install_log').modal('show');
}
function handleBtnModalInstall() {
    $('#_btn_mk_node_install').prop('disabled', $('.nodejs-ver-toinstall:checked').length > 0 ? false : true);
}
function handleButtons(elem, icon_fa, type) {
    let icon = $(elem).find('.fa');
    if (type == undefined) {
        $(elem).addClass('disabled');
        $(elem).prop('disabled', true);
        icon.removeClass(icon_fa);
        icon.addClass('fa-spinner fa-spin');
    } else {
        icon.removeClass('fa-spinner fa-spin');
        icon.addClass(icon_fa);
        $(elem).removeClass('disabled');
        $(elem).prop('disabled', false);
    }
}
function updateLogModal(lines) {
    log_install_lines = log_install_lines.concat(lines);
    function updateLogContainer() {
        logs_modal_time = setTimeout(function () {
            if (log_install_lines_index < log_install_lines.length) {
                let log_line = '<p>' + log_install_lines[log_install_lines_index] + '</p>';
                if (log_install_lines_index == 0) {
                    $('#_nvm_install_log_container').html(log_line);
                    $('#_nvm_install_log_loader').fadeOut('fast', function () {
                        $('#_nvm_install_log_container').fadeIn('fast');
                    });
                } else {
                    $('#_nvm_install_log_container').append(log_line);
                    $("#_nvm_install_log_container p").last().attr("tabindex", -1).focus();
                }
                log_install_lines_index++;
                updateLogContainer();
            } else {
                logs_modal_time = null;
            }
        }, 50);
    }
    if (logs_modal_time === null) {
        updateLogContainer();
    }
}
function modalUninstallConfirm(elem) {
    let version_name = $(elem).data('version-name');
    $('#_nodejs_del_alert_version').text(version_name);
    $('#_nodejs_confirmation_del_btn').unbind('click');
    $('#_nodejs_confirmation_del_btn').click(function () {
        unistallNodeJSComfirmed(elem);
    });
    $('#modal_nvm_uninstall_confirm').modal('show');
}
function confirmRemoveCWPNodeJS() {
    $('#modal_nvm_uninstall_cwpnodejs').modal('show');
}
function removeCWPNodeJSConfirmed() {
    $('#modal_nvm_uninstall_cwpnodejs').modal('hide');
    slideToggle('#_nvm_uninstall_all_loader', '#_nodejs_main_screen');
    sendWholeDeletionRequest(function () {
        slideToggle('#_nodejs_nvm_not_installed', '#_nvm_uninstall_all_loader');
    });
}
function unistallNodeJSComfirmed(elem) {
    let tr = $(elem).closest('tr');
    // let apps_qty = parsetInt(tr.find('.nodejs-ver-qty-apps').text());
    // if (apps_qty > 0){
    //     $.gritter.add({
    //         title: 'Apps found!',
    //         text: '',
    //         time: 3500,
    //         close_icon: '',
    //         icon: 'icomoon-icon-power',
    //         class_name: 'error-notice'
    //     });
    //     $('#modal_nvm_uninstall_confirm').modal('hide');
    //     return;
    // }
    let version = $(elem).data('version');
    tr.addClass('deleting_tr');
    handleButtons(elem, 'fa-trash');
    tr.find('.btn').prop('disabled', true);
    $('#modal_nvm_uninstall_confirm').modal('hide');
    sendUninstallNodeJS(version, function () {
        let ver_index = version_list.findIndex(function (ver) {
            return ver.ver == version;
        });
        version_list.splice(ver_index, 1);
        tr.slideUp('fast', function () {
            ver_list_table.row(this).remove().draw();
        })
    }, function () {
        tr.removeClass('deleting_tr');
        handleButtons(elem, 'fa-trash', true);
        tr.find('.btn').prop('disabled', false);
    });
}
function installNodeJSResponse(resp_data) {
    if (resp_data.running === false) {
        $.gritter.add({
            title: 'Success',
            text: '{{lang.LABNODEJS80}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'success-notice'
        });
        $('#_nodejs_installing_log_loader').fadeOut('fast', function () {
            $('#_nodejs_install_btn').fadeIn('fast');
        });
        version_list = resp_data.list;
        renderDashboard();
        if (resp_data.lines.length > 0) {
            updateLogModal(resp_data.lines)
        }
        return;
    } else if (resp_data.lines.length > 0) {
        updateLogModal(resp_data.lines)
    }
    setTimeout(function () {
        checkInstallationProcess();
    }, 1000);
}
function checkInstallationProcess() {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=node_install_status",
        data: 'verbose=' + ($('#modal_nvm_install_log').is(':visible') ? '1' : 0),
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                setTimeout(function () {
                    checkInstallationProcess()
                }, 1000);
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                installNodeJSResponse(resp_data);
                return;
            }
            setTimeout(function () {
                checkInstallationProcess()
            }, 1000);
        }
    });
}
function setNodeJSUserConfig(data, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=save_usr_config",
        data: data,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: '{{lang.LABNODEJS81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                $.gritter.add({
                    title: '{{lang.LABNODEJS83}}',
                    text: 'NodeJs User panel configurations saved',
                    time: 5500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'success-notice'
                });
                cleaner();
                // 
            } else {
                let message_error = '{{lang.LABNODEJS81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function setNodeJSVerAsDefault(version, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=set_as_default",
        data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: '{{lang.LABNODEJS81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                $.gritter.add({
                    title: '{{lang.LABNODEJS83}}',
                    text: '{{lang.LABNODEJS84}}',
                    time: 5500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'success-notice'
                });
                success();
                // 
            } else {
                let message_error = '{{lang.LABNODEJS81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendInstallNVM(success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=install_nvm",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: '{{lang.LABNODEJS81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                $.gritter.add({
                    title: '{{lang.LABNODEJS83}}',
                    text: '{{lang.LABNODEJS85}}',
                    time: 5500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'success-notice'
                });
                success(resp_data);
                // 
            } else {
                let message_error = '{{lang.LABNODEJS81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendWholeDeletionRequest(success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=whole_uninstall",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: '{{lang.LABNODEJS81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                $.gritter.add({
                    title: '{{lang.LABNODEJS83}}',
                    text: 'CWP NodeJS engine deleted!',
                    time: 5500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'success-notice'
                });
                success();
                // 
            } else {
                let message_error = '{{lang.LABNODEJS81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendUninstallNodeJS(version, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=uninstall_nodejs",
        data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: '{{lang.LABNODEJS81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                $.gritter.add({
                    title: '{{lang.LABNODEJS83}}',
                    text: '{{lang.LABNODEJS86}}',
                    time: 5500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'success-notice'
                });
                success();
                // 
            } else {
                let message_error = '{{lang.LABNODEJS81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABNODEJS87}}';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABNODEJS88}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendInstallation(data_install, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=install",
        data: data_install,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: '{{lang.LABNODEJS81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                $('#_nodejs_install_btn').fadeOut('fast', function () {
                    handleButtons('#_nodejs_install_btn', 'fa-plus', true);
                    $('#_nodejs_installing_log_loader').fadeIn('fast');
                    checkInstallationProcess()
                });
                // 
            } else {
                let message_error = '{{lang.LABNODEJS81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function loadAvailableVersionToInstall(cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=nodejs&acc=version_availables",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: '{{lang.LABNODEJS81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                version_availables = resp_data.list;
                renderInstallableVersions();
                // $('#modal_nvm_install .hide-in-modal').fadeIn('fast');
                $('#_nvm_install_loader').slideUp('fast', function () {
                    $('#_nvm_install_version_list').slideDown('fast');
                    $('#modal_nvm_install .hide-in-modal').slideDown('fast');
                });
                // 
            } else {
                let message_error = '{{lang.LABNODEJS81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABNODEJS82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}

function verifyTab(elem) {
    if ($(elem).attr('href') === '#nodejs_apps_tab') {
        $('#_nodejs_main_col').attr('style', '');
        $('#_nodejs_main_col').addClass('col-md-12').removeClass('col-md-9');
        $('#_nodejs_info_col').hide();
    } else if ($('#_tab_button_apps').hasClass('active')) {
        $('#_nodejs_main_col').animate({
            width: msmc_width * .72,
        }, 300, function () {
            $('#_nodejs_main_col').addClass('col-md-9').removeClass('col-md-12');
            $('#_nodejs_info_col').show('fast');
        });
    }
}
function slideToggle(show, hide, callback) {
    $(hide).slideUp('fast', function () {
        if (typeof callback == 'function') {
            callback();
        }
        $(show).slideDown('fast');
    });
}
let msmc_width = null;
$(document).ready(function () {
    renderDashboard();
    if (installing === true) {
        checkInstallationProcess();
    }
    $('#_nodejs_main_screen .nav-tabs a').click(function () {
        verifyTab(this);
    });
    verifyTab('#_tab_button_apps a');
    loadNodeJSAppList(function () {
        renderNodeJSAppList();
        $('#_nodejs_apps_list_loader').fadeOut('fast', function () {
            $('#_nodejs_apps_list_wrapper').fadeIn('fast');
        });
        setTimeout(function () {
            listenForStatusChanges();
        }, 5000);
    });
    setInputFilter(document.getElementById("_port_range_max_"), function (value) {
        return /^\d*\.?\d*$/.test(value); // Allow digits and '.' only, using a RegExp
    });
});

{% include 'js/nodejs_apps.js' %}
{% include 'js/file_explorer.js' %}
{% include 'js/nodejs_console.js' %}