function getPHPversionOptions(version, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_selector&acc=get_php_options",
        data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: '{{lang.LABPHPSEL78}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPHPSEL78}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }   
                }
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendCompilePHPVersions(selected_versions, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_selector&acc=compile_php_vesion",
        data: 'versions=' + JSON.stringify(selected_versions),
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: '{{lang.LABPHPSEL78}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPHPSEL78}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL80}}';
                    } else if (resp_data.code == 2) {
                        message_error = '{{lang.LABPHPSEL81}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendSaveIniFile(version, content, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_selector&acc=save_php_ini_content",
        data: 'version=' + version + '&content=' + content,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: '{{lang.LABPHPSEL78}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPHPSEL78}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function getPHPIniContent(version, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_selector&acc=get_php_ini_content",
        data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: '{{lang.LABPHPSEL78}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPHPSEL78}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function getPHPversionInfo(version, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_selector&acc=get_php_info",
        data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: '{{lang.LABPHPSEL78}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPHPSEL78}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = 'Invalid appication path';
                    } else if (resp_data.code == 2) {
                        message_error = 'Invalid NodeJS Version';
                    } else if (resp_data.code == 3) {
                        message_error = 'Invalid domain';
                    } else if (resp_data.code == 4) {
                        message_error = 'Invalid APP';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendPHPversionDelete(version, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_selector&acc=remove_php_version",
        data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: '{{lang.LABPHPSEL78}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPHPSEL78}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendPHPAutoUpdateChange(version, action, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_selector&acc=auto_update_change",
        data: 'version=' + version + "&action=" + action,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: '{{lang.LABPHPSEL78}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPHPSEL78}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    } else if (resp_data.code == 2) {
                        message_error = '{{lang.LABPHPSEL82}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function getPHPversionModules(version, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_selector&acc=get_php_modules",
        data: "version=" + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: '{{lang.LABPHPSEL78}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPHPSEL78}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendSavePHPOptions(data, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_selector&acc=save_php_options",
        data: data,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: '{{lang.LABPHPSEL78}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPHPSEL78}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    } else if (resp_data.code == 2) {
                        message_error = '{{lang.LABPHPSEL83}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function getLastBuildLog(success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_selector&acc=get_last_build_log",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: '{{lang.LABPHPSEL78}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPHPSEL78}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL84}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function getPHPVersionStatus(version, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_selector&acc=get_php_version_status",
        data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: '{{lang.LABPHPSEL78}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPHPSEL78}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL85}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendResetPHPOptions(version, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_selector&acc=reset_php_options",
        data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: '{{lang.LABPHPSEL78}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPHPSEL78}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendPHPStatusChange(version, action, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_selector&acc=change_php_status",
        data: 'version=' + version + "&action=" + action,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPHPSEL77}}',
                    text: '{{lang.LABPHPSEL78}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                if (!resp_data.hasOwnProperty('code') || resp_data.code != 4) {
                    let message_error = '{{lang.LABPHPSEL78}}';
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    } else if (resp_data.code == 2) {
                        message_error = '{{lang.LABPHPSEL82}}';
                    }
                    $.gritter.add({
                        title: '{{lang.LABPHPSEL77}}',
                        text: message_error,
                        time: 3500,
                        close_icon: '',
                        icon: 'icomoon-icon-power',
                        class_name: 'error-notice'
                    });
                }
                cleaner(resp_data);
            }
        }
    });
}
function checkCompilingStatus() {
    function localCall(){
        setTimeout(function () {
            checkCompilingStatus();
        }, INTERVAL_CHECK_STATUS);
    }
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_selector&acc=check_compile_status",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                localCall();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                rederStatusCompile(resp_data);
            } else {
                localCall();
            }
        }
    });
}