function phpHandleStatus(action, elem, ico) {
    let php_tr = $(elem).closest('.php-version-tr');
    let php_ver_info = php_tr.data('version-info');
    handleButtons($(elem), ico)
    php_tr.find('.btn-phpver-status').prop('disabled', true);
    sendPHPStatusChange(php_ver_info.ver, action, function (response) {
        let action_title = 'PHP-FPM ' + php_ver_info.ver + ' {{lang.LABPHPSEL86}}';
        if (action == 'stop') {
            php_tr.find('.btn-on-running').fadeOut('fast', function () {
                php_tr.find('.btn-on-stopped').fadeIn('fast');
            });
            action_title = 'PHP-FPM ' + php_ver_info.ver + ' {{lang.LABPHPSEL87}}';
            changePHPStatusOnRow(php_tr, action);
        } else if (action == 'reload') {
            action_title = 'PHP-FPM ' + php_ver_info.ver + ' {{lang.LABPHPSEL88}}';
        } else {
            php_tr.find('.btn-on-stopped').fadeOut('fast', function () {
                php_tr.find('.btn-on-running').fadeIn('fast');
            });
            changePHPStatusOnRow(php_tr, action);
        }
        handleButtons($(elem), ico, true);
        php_tr.find('.btn-phpver-status').prop('disabled', false);
        $.gritter.add({
            title: '{{lang.LABPHPSEL65}}',
            text: action_title,
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
    }, function (response) {
        if(response !== undefined){
            let message_error = '';
            if (action == 'start'){ //code_status: 11 = wont start
                message_error = 'PHP-FPM ' + php_ver_info.ver + ' {{lang.LABPHPSEL89}}';
            } else if (action == 'stop') { //code_status: 11 = wont stop
                message_error = 'PHP-FPM ' + php_ver_info.ver + ' {{lang.LABPHPSEL90}}';
            } else { //code_status: 13 = wont start after reload
                message_error = 'PHP-FPM ' + php_ver_info.ver + ' {{lang.LABPHPSEL91}}';
                php_tr.find('.btn-on-running').fadeOut('fast', function () {
                    php_tr.find('.btn-on-stopped').fadeIn('fast');
                });
                changePHPStatusOnRow(php_tr, 'stop');
            }
            $.gritter.add({
                title: 'Error',
                text: message_error,
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'error-notice'
            });   
        }
        handleButtons($(elem), ico, true);
        php_tr.find('.btn-phpver-status').prop('disabled', false);
    });
}
function showStatusInformationModalPHP(elem){
    let php_tr = $(elem).closest('.php-version-tr');
    let php_ver_info = $(elem).closest('.php-version-tr').data('version-info');
    console.log(php_ver_info);
    $('#_modal_php_status_information_ .modal-title').text('{{lang.LABPHPSEL92}} ' + php_ver_info.ver);
    $('#_modal_php_status_information_ .modal-body').html(LOADER_HTML);
    $('#_modal_php_status_information_').modal('show');
    getPHPVersionStatus(php_ver_info.ver, function(response){
        $('#_modal_php_status_information_ .modal-body .action-loader').fadeOut('fast', function(){
            $('#_modal_php_status_information_ .modal-body').html('<div id="_modal_php_status_container_">' + response.status_detail + '</div>');
            $('#_modal_php_status_container_').fadeIn('fast');
        });
    }, function(){
        $('#_modal_php_status_information_').modal('hide');
    });
}
function changePHPStatusOnRow(php_tr, action){
    let status_class = 'success';
    let status_title = '{{lang.LABPHPSEL40}}';
    if(action != 'start'){    
        status_class = 'danger';
        status_title = '{{lang.LABPHPSEL41}}';
    }
    php_tr.find('.tr-php-status-container').html('<i class="fa fa-circle text-' + status_class + '" aria-hidden="true"></i> ' + status_title);
}