const LOADER_HTML = '<div class="action-loader">' +
                        '<span><i class="fa fa-circle-o-notch fa-spin"></i></span>' +
                        '<h5 id="">{{lang.LABPHPSWITCH22}}...</h5>' +
                    '</div>';
let current_version = '{{mod_vars.current_version}}';
let compiling_log_lines = [];
let compiling_log_timeout = null;
function showVersionChanger(){
    $('#_php_version_selector_').fadeIn('fast');
}
function optionsCurrentVersion(){
    loadVersionOptions(current_version, true)
}
function loadVersionOptions(minor_version, is_current){
    function displayAndLoad(){
        $('#_php_version_options_container_ .panel-body').html(LOADER_HTML);
        $('#_php_version_options_container_').slideDown('fast', function () {
            let slices = minor_version.split('.')
            getPHPversionOptions((is_current === true ? 'last_build' : slices[0] + '.' + slices[1]), minor_version, function(response){
                displayOptionsTable(response.options, slices[0] + '.' + slices[1], minor_version);
            }, function(){
                $('#_php_version_options_container_').slideUp('fast', function () {
                    $('#php_switcher_main_container').slideDown('fast');
                });
            })
        });
    }
    $('#php_switcher_main_container').slideUp('fast', function(){
        $('#_php_switcher_version_options_title_').text(is_current === undefined ? '{{lang.LABPHPSWITCH23}} ' + minor_version : '{{lang.LABPHPSWITCH24}} (' + minor_version + ')')
        displayAndLoad();
    });
}
let table_options = null;
function cancelInstallationOptionWindow(){
    $('#_php_version_options_container_').slideUp('fast', function () {
        $('#php_version').val(current_version);
        $('#php_version').select2().trigger('change');
        $('#php_switcher_main_container').slideDown('fast');
    });
}
function resetOptionsFromInstaller(elem) {
    let version = $(elem).data('version');
    let minor_version = $(elem).data('minor');
    $('.btn-installer-options').prop('disabled', true);
    handleButtons(elem, 'fa-sliders');
    sendResetPHPOptions(version, function (response) {
        $.gritter.add({
            title: '{{lang.LABPHPSWITCH25}}',
            text: '{{lang.LABPHPSWITCH26}} ' + version + ' {{lang.LABPHPSWITCH27}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        $('#php_version_options_table_main').fadeOut('fast', function(){
            $('#_php_version_options_container_ .panel-body').html(renderPHPOptionsTable(response.options));
            createTableOptions(version, minor_version);
            $('#php_version_options_table_main').fadeIn('fast');
        });
        
        //$('.btn-installer-options').prop('disabled', false);
        handleButtons(elem, 'fa-sliders', true);
    }, function () {
        $('.btn-installer-options').prop('disabled', false);
        handleButtons(elem, 'fa-sliders', true);
    });
}
function handleButtons(elem, icon_fa, type) {
    let icon = $(elem).find('.fa');
    if (type == undefined) {
        $(elem).addClass('disabled');
        $(elem).prop('disabled', true);
        icon.removeClass(icon_fa);
        icon.addClass('fa-spinner fa-spin');
    } else {
        icon.removeClass('fa-spinner fa-spin');
        icon.addClass(icon_fa);
        $(elem).removeClass('disabled');
        $(elem).prop('disabled', false);
    }
}
function getSimpleEditorOptionsWithDependencies() {
    let options = [];
    let miss_include = {};
    let miss_exclude = [];
    let dependency_miss = false;
    let first_missing = '';
    //let table_options = from_installer === undefined ? normal_options_table : table_installer_options;
    //console.log('TABLE', $('.checkbox-option-item:checked', table.rows().nodes()));
    //console.log('NOMRL', $('.checkbox-option-item:checked'));
    $('.checkbox-option-item:checked', table_options.rows().nodes()).each(function () {
        options.push($(this).val());
        let include = $(this).data('include');
        let elem_value = $(this).val();
        if (include != '') {
            include = include.split(',');
            if (include.length > 0) {
                include.forEach(function (inc) {
                    if (!$('#_opt_' + inc, table_options.rows().nodes()).is(':checked')) {
                        if (!miss_include.hasOwnProperty(elem_value)) {
                            miss_include[elem_value] = [];
                        }
                        miss_include[elem_value].push(inc);
                        if (dependency_miss == false) {
                            first_missing = '#_opt_' + inc;
                        }
                        dependency_miss = true;
                    }
                });
            }
        }
        let exclude = $(this).data('exclude');
        if (exclude != '') {
            exclude = $(this).data('exclude').split(',');
            if (exclude.length > 0) {
                exclude.forEach(function (exc) {
                    if ($('#_opt_' + exc, table_options.rows().nodes()).is(':checked')) {
                        miss_exclude.push({
                            parent: elem_value,
                            miss: exc
                        });
                    }
                });
            }
        }
    });
    //miss_include['zlib'] = 'mexicano'
    //dependency_miss = true
    if (dependency_miss == true) {
        let html_content = '';
        Object.entries(miss_include).forEach(([key, miss_inc]) => {
            html_content = '<tr>' +
                '<td>' + key + '</td>' +
                '<td>' + miss_inc + '</td>' +
                '</tr>';
        });
        let html_list = '<table class="table php_missing_dependencies_table table-striped table-bordered table-hover">' +
                            '<thead>' +
                                '<tr role="row">' +
                                    '<th>{{lang.LABPHPSWITCH28}}</th>' +
                                    '<th>{{lang.LABPHPSWITCH29}}</th>' +
                                '</tr>' +
                            '</thead>' +
                            '<tbody id="contenttr">' +
                                html_content +
                            '</tbody>' +
                        '</table>';
        $('#_modal_missing_dependencies_container_').html(html_list);
        $('.php_missing_dependencies_table').DataTable({
            "autoWidth": false,
            "dom": "<'row'<'col-sm-12'f>>" +
                "<'row'<'col-sm-12'tr>>" +
                "<'row'<'col-sm-12'p>>",
        });
        $('#_modal_php_missing_dependencies_').modal('show');

    } else {
        $('#modal_installer_options_error').fadeOut('fast');
        $('#_modal_installer_options_').removeClass('installer-options-container-with-errors');
        $('#_modal_installer_options_ tr.tr-option-error').removeClass('tr-option-error');
    }
    return dependency_miss === true ? false : 'options=' + JSON.stringify(options) + '&type=simple';
}
function configureOptionsAndBuild(elem) {
    let data = getSimpleEditorOptionsWithDependencies();
    if (data === false) {
        return;
    }
    $('.btn-installer-options').prop('disabled', true);
    handleButtons(elem, 'fa-floppy-o');
    data += '&version=' + $(elem).data('version') + '&minor_version=' + $(elem).data('minor');
    sendSavePHPOptionsAndCompile(data, function () {
        $.gritter.add({
            title: '{{lang.LABPHPSWITCH25}}',
            text: '{{lang.LABPHPSWITCH30}} ' + $(elem).data('version') + ' {{lang.LABPHPSWITCH31}}',
            time: 6500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        handleButtons(elem, 'fa-floppy-o', true);
        $('.btn-installer-options').prop('disabled', false);
        $('#_php_version_options_container_').slideUp('fast', function () {
            $('.php-switcher-main-buttons').hide();
            $('#_php_version_selector_').hide();
            $('#_compiling_loader_wrapper_').show();
            $('#php_switcher_main_container').slideDown('fast');
        });
        $('#_modal_compiling_log_container_').html('');
        checkCompilingStatus();
    }, function () {
        handleButtons('.btn-installer-mkoptions', 'fa-floppy-o', true);
        $('.btn-installer-options').prop('disabled', false);
    });
}
function renderLogLine() {
    let log_line = '<p>' + compiling_log_lines[0] + '</p>';
    compiling_log_lines.shift();
    $('#_modal_compiling_log_container_').append(log_line);
    $("#_modal_compiling_log_container_ p").last().attr("tabindex", -1).focus();
}
function compilingLogHandler(response) {
    function addLineToLog() {
        if (compiling_log_lines.length > 0) {
            if (compiling_log_lines.length > 1000) {
                $('#_modal_compiling_log_container_').append('<p>' + compiling_log_lines.slice(0, 1000).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 1000);
            } else if (compiling_log_lines.length > 500) {
                $('#_modal_compiling_log_container_').append('<p>' + compiling_log_lines.slice(0, 500).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 500);
            } else if (compiling_log_lines.length > 400) {
                $('#_modal_compiling_log_container_').append('<p>' + compiling_log_lines.slice(0, 400).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 400);
            } else if (compiling_log_lines.length > 300) {
                $('#_modal_compiling_log_container_').append('<p>' + compiling_log_lines.slice(0, 300).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 300);
            } else if (compiling_log_lines.length > 200) {
                $('#_modal_compiling_log_container_').append('<p>' + compiling_log_lines.slice(0, 200).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 200);
            } else if (compiling_log_lines.length > 100) {
                $('#_modal_compiling_log_container_').append('<p>' + compiling_log_lines.slice(0, 100).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 100);
            } else {
                $('#_modal_compiling_log_container_').append('<p>' + compiling_log_lines[0] + '</p>');
                $("#_modal_compiling_log_container_ p").last().attr("tabindex", -1).focus();
                compiling_log_lines.shift();
            }
            let time_interval = 10;
            /*if (compiling_log_lines.lenght > 100 && compiling_log_lines.lenght < 500){
                time_interval = 6
            } else if (compiling_log_lines.lenght >= 500 && compiling_log_lines.lenght < 900){
                time_interval = 2
            }else{
                time_interval = 1
            }*/
            compiling_log_timeout = setTimeout(function () {
                addLineToLog();
            }, time_interval)
        } else {
            compiling_log_timeout = null;
            if (response.status != 'running') {
                endCompile();
            }
        }
    }
    function endCompile() {
        $.gritter.add({
            title: '{{lang.LABPHPSWITCH25}}',
            text: '{{lang.LABPHPSWITCH32}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        $('#_modal_php_compiling_log_ .compiling-loader').fadeOut('fast');
        $('#_compiling_loader_wrapper_').fadeOut('fast', function () {
            //$('.btn-installer-opener').prop('disabled', false);
            $('#_php_version_selector_').fadeIn('fast');
            $('.php-switcher-main-buttons').fadeIn('fast');
            $('#_current_version_span_').text(response.current_version);
            current_version = response.current_version;
        });
        //php_versions_installed = response.php_versions_installed;
        //$('#_btn_view_last_build_log_').fadeIn('fast');
        //renderPHpVersionList();
    }
    compiling_log_lines = compiling_log_lines.concat(response.lines);

    if (compiling_log_timeout === null) {
        addLineToLog()
    }
}
const INTERVAL_CHECK_STATUS = 2000;
function viewCompilingLog() {
    $('#_modal_php_compiling_log_').modal('show');
}
function rederStatusCompile(response) {
    compilingLogHandler(response);
    if (response.status == 'running') {
        setTimeout(function () {
            checkCompilingStatus();
        }, INTERVAL_CHECK_STATUS);
    }
}
function backFromModules(){
    $('#php_modules_container').slideUp('fast', function () {
        $('#php_switcher_main_container').slideDown('fast');
    });
}
function modulesCurrentVersion(){
    $('#php_switcher_main_container').slideUp('fast', function () {
        $('#_php_switcher_version_options_title_').text('{{lang.LABPHPSWITCH33}} (' + current_version + ')')
        $('#php_modules_container .panel-body').append(LOADER_HTML);
        $('#php_modules_container .panel-body .inside-panel').hide();
        $('#_version_modules_container_title_').text('{{lang.LABPHPSWITCH34}} ' + current_version);
        $('#php_modules_container').slideDown('fast');
        getModulesForCurrentVersion(function(response) {
            //$('#_php_version_options_container_ .panel-body').append('<div id="_php_version_modules_"></div>');
            renderPHPModules(response.php_modules, 'php');
            renderPHPModules(response.zend_modules, 'zend');
            $('#php_modules_container .panel-body .action-loader').fadeOut('fast', function(){
                $('#php_modules_container .panel-body .action-loader').remove();
                $('#php_modules_container .panel-body .inside-panel').fadeIn('fast');

            });
        }, function(){

        });
    });
}
function renderPHPModules(modules, type){
    let html_content = '';
    if(modules.length > 0){
        let table_content = '';
        modules.forEach(function (module) {
            table_content += '<tr>' + 
                                '<td>' + module + '</td>' +
                            '</tr>';
        });
        html_content = '<div id="_' + type + '_modules_table_main">' +
                            '<table class="table ' + type + '_modules_table table-striped table-bordered table-hover">' +
                                '<thead>' +
                                    '<tr role="row">' +
                                        '<th>{{lang.LABPHPSWITCH35}}</th>' +
                                    '</tr>' +
                                '</thead>' +
                                '<tbody id="contenttr">' +
                                    table_content +
                                '</tbody>' +
                            '</table>' +
                        '</div>';
        $('#_' + type + '_modules_wrapper_').html(html_content);
        $('.' + type + '_modules_table').DataTable({
            "autoWidth": false,
            "pageLength": 20,
            /*"dom": "<'row'<'col-sm-12 col-table-modules'f>>" +
                    "<'row'<'col-sm-12 col-table-modules tr-table-modules'tr>>" +
                    "<'row'<'col-sm-12 col-table-modules'p>>",*/
        });
        $('#_' + type + '_modules_table_main .dataTables_length select').addClass('form-control');
        $('#_' + type + '_modules_table_main .dataTables_filter input').addClass('form-control');
    }
}
function createTableOptions(version, minor_version){
    table_options = $('.php_version_options_table').DataTable({
        "autoWidth": false,
        "pageLength": 100,
        "dom": "<'row.options-row-separator'<'col-md-7'f><'col-md-5.installer-options-buttons'>>" +
            "<'row'<'col-md-12.options-table-row'tr>>" +
            "<'row.options-row-separator-b'<'col-md-12.installer-options-buttons'>>",
    });
    $('.installer-options-buttons').html('<button data-version="' + version + '" onclick="cancelInstallationOptionWindow()" class="btn btn-warning btn-md btn-installer-options"><i class="fa fa-ban"></i> {{lang.LABPHPSWITCH36}}</button>' +
        '<button data-version="' + version + '" data-minor="' + minor_version + '" onclick="resetOptionsFromInstaller(this)" class="btn btn-default btn-md btn-installer-options"><i class="fa fa-sliders"></i> {{lang.LABPHPSWITCH37}}</button>' +
        '<button data-version="' + version + '" data-minor="' + minor_version + '" onclick="configureOptionsAndBuild(this)" class="btn btn-primary btn-md btn-installer-options btn-installer-mkoptions"><i class="fa fa-floppy-o"></i> {{lang.LABPHPSWITCH38}}</button>');
    $('#php_version_options_table_main .dataTables_length select').addClass('form-control');
    $('#php_version_options_table_main .dataTables_filter input').addClass('form-control');
}
function displayOptionsTable(options, version, minor_version){
    $('#_php_version_options_container_ .panel-body').append(renderPHPOptionsTable(options));
    createTableOptions(version, minor_version);
    $('#_php_version_options_container_ .action-loader').fadeOut('fast', function(){
        $('#php_version_options_table_main').fadeIn('fast');
    });
}
function checkOptionDependencies(elem) {
    if ($(elem).is(':checked')) {
        let include = $(elem).data('include').split(',');
        if (include.length > 0) {
            include.forEach(function (inc) {
                if (!$('#_opt_' + inc).is(':checked')) {
                    $('#_opt_' + inc).trigger('click');
                }
            });
        }
        let exclude = $(elem).data('exclude').split(',');
        if (exclude.length > 0) {
            exclude.forEach(function (exc) {
                if ($('#_opt_' + exc).is(':checked')) {
                    $('#_opt_' + exc).trigger('click');
                }
            });
        }
        //exclude
    }
}
function renderPHPOptionsTable(options, installer){
    let html_content = '';
    options.forEach(function (option) {
        let checked_status = '';
        if (option.active === true) {
            checked_status = 'checked';
        }
        html_content += '<tr>' +
                            '<td>' +
                                '<div class="toggle-custom toggle-inline">' +
                                '<label class="toggle tip" data-original-title="ON/OFF" data-on="ON" data-off="OFF">' +
                                '<input onchange="checkOptionDependencies(this)" ' + (option.required === true ? 'disabled ' : '') + ' data-include="' + option.include + '" data-exclude="' + option.exclude + '" class="checkbox-option-item" value="' + option.name + '"type="checkbox" id="_opt_' + option.name + '" ' + checked_status + '>' +
                                '<span class="button-checkbox"></span>' +
                                '<input type="hidden" id="val_' + option.name + '" value="">' +
                                '</label>' +
                                '</div>' +
                            '</td>' +
                            '<td>' + option.name + '</td>' +
                            '<td>' + option.desc + '</td>' +
                        '</tr>';
    });
    return '<div id="' + (installer === undefined ? 'php_version_options_table_main' : '_modal_installer_options_') + '">' +
                '<div class="alert alert-info">{{lang.LABPHPSWITCH39}} /usr/local/php/php.d/</div>' +
                '<table class="table ' + (installer === undefined ? 'php_version_options_table' : 'php_version_options_table_installer') + ' table-striped table-bordered table-hover">' +
                    '<thead>' +
                        '<tr role="row">' +
                            '<th>{{lang.LABPHPSWITCH40}}</th>' +
                            '<th>{{lang.LABPHPSWITCH41}}</th>' +
                            '<th>{{lang.LABPHPSWITCH42}}</th>' +
                        '</tr>' +
                    '</thead>' +
                    '<tbody id="contenttr">' +
                        html_content +
                    '</tbody>' +
                '</table>' +
            '</div>';
}
$(document).ready(function () {
    {% if mod_vars.is_php_compiling == true %}
        checkCompilingStatus();
    {% endif %}
    $("#php_version").select2({
        dropdownParent: $('#_php_version_selector_')
    }).on('select2-selected', function (e) {
        console.log(e.val);
        loadVersionOptions(e.val);
    });
});



{% include 'js/php_switcher_services.js' %}