function getPHPversionOptions(version, minor_version, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_switcher&acc=get_php_options",
        data: 'version=' + version + '&minor_version=' + minor_version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: 'Error',
                    text: 'Unknown error ocurred.',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = 'Unknown error ocurred.';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: 'Error',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendResetPHPOptions(version, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_switcher&acc=reset_php_options",
        data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: 'Error',
                    text: 'Unknown error ocurred.',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = 'Unknown error ocurred.';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: 'Error',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function checkCompilingStatus() {
    function localCall() {
        setTimeout(function () {
            checkCompilingStatus();
        }, INTERVAL_CHECK_STATUS);
    }
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_switcher&acc=check_compile_status",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                localCall();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                rederStatusCompile(resp_data);
            } else {
                localCall();
            }
        }
    });
}
function getModulesForCurrentVersion(success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_switcher&acc=get_modules",
        data: 'version=' + current_version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: 'Error',
                    text: 'Unknown error ocurred.',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = 'Unknown error ocurred.';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: 'Error',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendSavePHPOptionsAndCompile(data, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=php_switcher&acc=save_options_compile",
        data: data,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: 'Error',
                    text: 'Unknown error ocurred.',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = 'Unknown error ocurred.';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: 'Error',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}