let options_advanced_editor = null;
function managePHPOptions(elem) {
    let php_ver_info = $(elem).closest('.php-version-tr').data('version-info');
    $('#_btn_save_php_options_').prop('disabled', true);
    $('#php_fpm_main_container').fadeOut('fast', function () {
        $('#_version_manage_options_title_').text('{{lang.LABPHPSEL93}} ' + php_ver_info.ver);
        $('#_version_manage_options_container_').html(LOADER_HTML);
        $('#_version_manage_options_advanced_container_').html(LOADER_HTML);
        $('#php_fpm_options_container').slideDown('fast');
        getPHPversionOptions(php_ver_info.ver, function (response) {
            $('#_php_version_editing_options_').val(php_ver_info.ver);
            $('#_php_version_minor_editing_options_').val(php_ver_info.installed_version);
            renderPHPVersionOptions(response.options);
            renderPHPVersionOptionsAdvanced(response.content, response.file_path);
            $('#_btn_save_php_options_').prop('disabled', false);
        }, function () {
            $('#php_fpm_options_container').fadeOut('fast', function () {
                $('#php_fpm_main_container').slideDown('fast');
            });
        });
    });
}
function renderPHPVersionOptionsAdvanced(content, file_path){
    $('#_version_manage_options_advanced_container_').html('<h4>{{lang.LABPHPSEL94}}: ' + file_path + '</h4><textarea id="_php_options_editor_area_">' + content + '</textarea>');
    options_advanced_editor = CodeMirror.fromTextArea(document.getElementById("_php_options_editor_area_"), {
        lineNumbers: true,
        matchBrackets: true,
        styleActiveLine: true,
        theme: "ambiance",
    });
}
function getSimpleEditorOptionsWithDependencies(from_installer){
    let options = [];
    let miss_include = {};
    let miss_exclude = [];
    let dependency_miss = false;
    let first_missing = '';
    let table_options = from_installer === undefined ? normal_options_table : table_installer_options;
    $('.checkbox-option-item:checked', table_options.rows().nodes()).each(function () {
        options.push($(this).val());
        let include = $(this).data('include');
        let elem_value = $(this).val();
        if(include != ''){
            include = include.split(',');
            if (include.length > 0) {
                include.forEach(function (inc) {
                    if (!$('#_opt_' + inc, table_options.rows().nodes()).is(':checked')) {
                        if (!miss_include.hasOwnProperty(elem_value)){
                            miss_include[elem_value] = [];
                        }
                        miss_include[elem_value].push(inc);
                        if (dependency_miss == false){
                            first_missing = '#_opt_' + inc;
                        }
                        dependency_miss = true;
                    }
                });
            }
        }
        let exclude = $(this).data('exclude');
        if (exclude != ''){
            exclude = $(this).data('exclude').split(',');
            if (exclude.length > 0) {
                exclude.forEach(function (exc) {
                    if ($('#_opt_' + exc, table_options.rows().nodes()).is(':checked')) {
                        miss_exclude.push({
                            parent: elem_value,
                            miss: exc
                        });
                    }
                });
            }
        }
    });
    if (dependency_miss == true){
        if(from_installer === undefined){
            let html_content = '';
            Object.entries(miss_include).forEach(([key, miss_inc]) => {
                html_content = '<tr>' +
                                    '<td>' + key + '</td>' +
                                    '<td>' + miss_inc + '</td>' +
                                '</tr>';
            });
            let html_list = '<table class="table php_missing_dependencies_table table-striped table-bordered table-hover">' +
                                '<thead>' +
                                    '<tr role="row">' +
                                        '<th>{{lang.LABPHPSEL95}}</th>' +
                                        '<th>{{lang.LABPHPSEL96}}</th>' +
                                    '</tr>' +
                                '</thead>' +
                                '<tbody id="contenttr">' +
                                    html_content +
                                '</tbody>' +
                            '</table>';
            $('#_modal_missing_dependencies_container_').html(html_list);
            $('.php_missing_dependencies_table').DataTable({
                "autoWidth": false,
                "dom": "<'row'<'col-sm-12'f>>" +
                    "<'row'<'col-sm-12'tr>>" +
                    "<'row'<'col-sm-12'p>>",
            });
            $('#_modal_php_missing_dependencies_').modal('show');
        }else{
            $('#_modal_installer_options_').addClass('installer-options-container-with-errors');
            $('#modal_installer_options_error').fadeIn('fast');
            let html_content = [];
            //$('#modal_installer_missing_dependencies_').fadeIn('fast');
            Object.entries(miss_include).forEach(([key, miss_inc]) => {
                html_content.push('<span class="label label-danger"><i class="fa fa-exclamation-circle" aria-hidden="true"></i> ' + miss_inc + '</span>');
                console.log($('#_opt_' + miss_inc).attr('class'));
                $('#_opt_' + miss_inc).closest('tr').addClass('tr-option-error')
            });
            $(first_missing).closest('tr').attr("tabindex", -1).focus();
            $('#modal_installer_missing_dependencies_').html(html_content.join(' - '));
        }
        
    }else{
        $('#modal_installer_options_error').fadeOut('fast');
        $('#_modal_installer_options_').removeClass('installer-options-container-with-errors');
        $('#_modal_installer_options_ tr.tr-option-error').removeClass('tr-option-error');
    }
    return dependency_miss === true ? false : 'options=' + JSON.stringify(options) + '&type=simple';
}
let table_installer_options = null;
let normal_options_table = null;
function modalInstallerOPtionsRender(options, version, minor){
    let html_table = renderPHPOptionsTable(options, true);
    $('#_modal_installer_options_').remove();
    $('#_modal_php_versions_installer_ .modal-body').append(html_table);
    table_installer_options = $('.php_version_options_table_installer').DataTable({
        "autoWidth": false,
        "pageLength": 100,
        "dom": "<'row.modal-options-header-row'<'#_modal_installer_options_title_.col-sm-4'><'col-sm-5'f><'#_modal_installer_options_buttons_.col-sm-3'>>" +
            "<'row'<'col-sm-12'tr>>" +
            "<'row'<'col-sm-12'p>>",
    });
    $('#_modal_installation_options_btn_mkinstall_').data('version', version);
    $('#_modal_installation_options_btn_mkinstall_').data('minor', minor);
    $('#_modal_installer_options_buttons_').html('<button data-minor="' + minor + '" data-version="' + version + '" onclick="resetOptionsFromInstaller(this)" class="btn btn-default btn-md btn-installer-modal"><i class="fa fa-sliders"></i> {{lang.LABPHPSEL34}}</button>' +
        '<button data-version="' + version + '" onclick="cancelInstallationOptionWindow()" class="btn btn-warning btn-md btn-installer-modal"><i class="fa fa-ban"></i> {{lang.LABPHPSEL14}}</button>' +
        '<button data-minor="' + minor + '" data-version="' + version + '" onclick="modalInstallerOPtionsConfigure(this)" class="btn btn-primary btn-md btn-installer-modal btn-installer-mkoptions"><i class="fa fa-floppy-o"></i> {{lang.LABPHPSEL35}}</button>');
    $('#_modal_installer_options_title_').html('<h4>{{lang.LABPHPSEL112}} ' + version + '</h4>');
    $('#_modal_installer_options_ .dataTables_filter input').addClass('form-control');
    $('#_modal_installation_buttons_container').fadeOut('fast', function () {
        $('#_modal_installation_options_buttons_container').fadeIn('fast');
    });

    $('#_installer_modal_main_container_').fadeOut('fast', function () {
        $('#_modal_installer_options_').fadeIn('fast');
        $("#_modal_php_versions_installer_ .modal-dialog").animate({
            'max-width': '1500px'
        }, 500, function () {

        });
    });
}
function modalInstallerOPtions(elem){
    installer_tr_version_option = $(elem).closest('.php-version-install-item');
    handleButtons(elem, 'fa-cogs');
    let version = $(elem).data('version');
    $('#_modal_installation_buttons_container .btn').prop('disabled', true);
    getPHPversionOptions(version, function (response) {
        handleButtons(elem, 'fa-cogs', true);
        let minor = $(elem).closest('.php-version-install-item').find('select').val()
        console.log('BALLo');
        modalInstallerOPtionsRender(response.options, version, minor);
        
    }, function () {
        handleButtons(elem, 'fa-cogs', true);
        $('#_modal_installation_buttons_container .btn').prop('disabled', false);
    });
}
function resetOptionsFromInstaller(elem){
    let version = $(elem).data('version');
    let minor = $(elem).data('minor');
    $('.btn-installer-modal').prop('disabled', true);
    handleButtons(elem, 'fa-sliders');
    sendResetPHPOptions(version, function (response) {
        $.gritter.add({
            title: '{{lang.LABPHPSEL65}}',
            text: 'PHP ' + version + ' {{lang.LABPHPSEL99}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        modalInstallerOPtionsRender(response.options, version, minor);
        installer_tr_version_option.find('.php-installer-version').find('.label-warning').remove();
        $('.btn-installer-modal').prop('disabled', false);
        handleButtons(elem, 'fa-sliders', true);
    }, function () {
        $('.btn-installer-modal').prop('disabled', false);
        handleButtons(elem, 'fa-sliders', true);
    });
}
function modalInstallerOPtionsConfigure(elem){
    let data = getSimpleEditorOptionsWithDependencies(true);
    if (data === false) {
        return;
    }
    $('.btn-installer-modal').prop('disabled', true);
    handleButtons('.btn-installer-mkoptions', 'fa-floppy-o');
    data += '&version=' + $(elem).data('version') + '&minor=' + $(elem).data('minor');
    sendSavePHPOptions(data, function () {
        $.gritter.add({
            title: '{{lang.LABPHPSEL65}}',
            text: '{{lang.LABPHPSEL97}} PHP ' + $(elem).data('version') + ' {{lang.LABPHPSEL98}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        handleButtons('.btn-installer-mkoptions', 'fa-floppy-o', true);
        $('.btn-installer-modal').prop('disabled', false);
        let name_container = installer_tr_version_option.find('.php-installer-version');
        if (name_container.find('.label-warning').length == 0){
            name_container.append('<span class="label label-warning" style="margin-left: 1rem;">Custom config.</span>');
        }
        
        cancelInstallationOptionWindow();
        php_versions_available = php_versions_available.map(function(ver){
            if (ver.ver == $(elem).data('version')){
                ver.custom_config = true 
            }
            return ver;
        });
        /*$('.btn-options-handler').prop('disabled', false);
        handleButtons(elem, 'fa-floppy-o', true);
        $('#_custom_config_file_' + version.replace('.', '') + '_').show();*/
    }, function () {
        handleButtons('.btn-installer-mkoptions', 'fa-floppy-o', true);
        $('.btn-installer-modal').prop('disabled', false);
    });
}
function savePHPOptions(elem){
    let data = '';
    if($('#_version_manage_options_container_').is(':visible')){
        data = getSimpleEditorOptionsWithDependencies();
        if(data === false){
            return;
        }
    }else{
        data = 'content=' + encodeURIComponent(options_advanced_editor.getValue()) + '&type=advanced'
    }
    let version = $('#_php_version_editing_options_').val();
    $('.btn-options-handler').prop('disabled', true);
    handleButtons(elem, 'fa-floppy-o');
    data += '&version=' + version + '&minor=' + $('#_php_version_minor_editing_options_').val();
    sendSavePHPOptions(data, function(){
        $.gritter.add({
            title: '{{lang.LABPHPSEL65}}',
            text: '{{lang.LABPHPSEL97}} PHP-FPM ' + version + ' {{lang.LABPHPSEL98}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        $('.btn-options-handler').prop('disabled', false);
        handleButtons(elem, 'fa-floppy-o', true);
        $('#_custom_config_file_' + version.replace('.', '') + '_').show();
    }, function(){
        $('.btn-options-handler').prop('disabled', false);
        handleButtons(elem, 'fa-floppy-o', true);
    });
}
function confirmedResetPHPOptions(){
    let version = $('#_php_version_editing_options_').val();
    $('#_modal_php_confirm_reset_options_').modal('hide');
    $('.btn-options-handler').prop('disabled', true);
    handleButtons('#_btn_reset_php_options_', 'fa-sliders');
    sendResetPHPOptions(version, function(response){
        $.gritter.add({
            title: '{{lang.LABPHPSEL65}}',
            text: 'PHP-FPM ' + version + ' {{lang.LABPHPSEL99}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        let html_list = renderPHPOptionsTable(response.options);
        $('#_version_manage_options_container_').html(html_list);
        normal_options_table = $('.php_version_options_table').DataTable({
            "autoWidth": false,
            "pageLength": 50,
        });
        $('#php_version_options_table_main .dataTables_length select').addClass('form-control');
        $('#php_version_options_table_main .dataTables_filter input').addClass('form-control');
        $('#php_version_options_table_main').fadeIn('fast');
        $('.btn-options-handler').prop('disabled', false);
        handleButtons('#_btn_reset_php_options_', 'fa-sliders', true);
        $('#_custom_config_file_' + version.replace('.', '') + '_').hide();
    }, function(){
        $('.btn-options-handler').prop('disabled', false);
        handleButtons('#_btn_reset_php_options_', 'fa-sliders', true);
    });
}
function resetPHPOptions(elem){
    $('#_modal_php_reset_options_ver_').text($('#_php_version_editing_options_').val());
    $('#_modal_php_confirm_reset_options_').modal('show');
}
function renderPHPOptionsTable(options, installer){
    let html_content = '';
    options.forEach(function (option) {
        let checked_status = '';
        if (option.active === true) {
            checked_status = 'checked';
        }
        html_content += '<tr>' +
                            '<td>' +
                                '<div class="toggle-custom toggle-inline">' +
                                '<label class="toggle tip" data-original-title="ON/OFF" data-on="ON" data-off="OFF">' +
                                '<input onchange="checkOptionDependencies(this)" ' + (option.required === true ? 'disabled ' : '') + ' data-include="' + option.include + '" data-exclude="' + option.exclude + '" class="checkbox-option-item" value="' + option.name + '"type="checkbox" id="_opt_' + option.name + '" ' + checked_status + '>' +
                                '<span class="button-checkbox"></span>' +
                                '<input type="hidden" id="val_' + option.name + '" value="">' +
                                '</label>' +
                                '</div>' +
                            '</td>' +
                            '<td>' + option.name + '</td>' +
                            '<td>' + option.desc + '</td>' +
                        '</tr>';
    });
    return '<div id="' + (installer === undefined ? 'php_version_options_table_main' : '_modal_installer_options_') + '">' +
                        '<table class="table ' + (installer === undefined ? 'php_version_options_table' : 'php_version_options_table_installer') + ' table-striped table-bordered table-hover">' +
                            '<thead>' +
                                '<tr role="row">' +
                                    '<th>{{lang.LABPHPSEL59}}</th>' +
                                    '<th>{{lang.LABPHPSEL95}}</th>' +
                                    '<th>{{lang.LABPHPSEL100}}</th>' +
                                '</tr>' +
                            '</thead>' +
                            '<tbody id="contenttr">' +
                                html_content +
                            '</tbody>' +
                        '</table>' +
                    '</div>';
}
function renderPHPVersionOptions(options) {
    let html_list = renderPHPOptionsTable(options);
    $('#_version_manage_options_container_ .action-loader').fadeIn('fast', function () {
        $('#_version_manage_options_container_').html(html_list);
        normal_options_table = $('.php_version_options_table').DataTable({
            "autoWidth": false,
            "pageLength": 50,
        });
        $('#php_version_options_table_main .dataTables_length select').addClass('form-control');
        $('#php_version_options_table_main .dataTables_filter input').addClass('form-control');
        $('#php_version_options_table_main').fadeIn('fast');
    });

    //$('#_php_versions_table_').html(html_list);
}
function checkOptionDependencies(elem){
    if($(elem).is(':checked')){
        let include = $(elem).data('include').split(',');
        if (include.length > 0){
            include.forEach(function(inc){
                if (!$('#_opt_' + inc).is(':checked')){
                    $('#_opt_' + inc).trigger('click');
                }
            });
        }
        let exclude = $(elem).data('exclude').split(',');
        if (exclude.length > 0){
            exclude.forEach(function(exc){
                if ($('#_opt_' + exc).is(':checked')){
                    $('#_opt_' + exc).trigger('click');
                }
            });
        }
        //exclude
    }
}
function showOptionsAdvancedEditor(elem){
    let new_btn_title = "{{lang.LABPHPSEL33}}";
    let panel_show = '#_version_manage_options_container_';
    let panel_hide = '#_version_manage_options_advanced_container_';
    if($('#_version_manage_options_container_').is(':visible')){
        new_btn_title = "{{lang.LABPHPSEL101}}";
        panel_show = '#_version_manage_options_advanced_container_';
        panel_hide = '#_version_manage_options_container_';
    }
    $(panel_hide).slideUp('fast', function(){
        $(panel_show).slideDown('fast', function(){
            options_advanced_editor.refresh();
        });
    });
    $(elem).find('span').text(new_btn_title);

}