let php_versions_installed = JSON.parse('{{mod_vars.php_versions_installed|json_encode|raw}}');
let php_versions_available = JSON.parse('{{mod_vars.php_versions_available|json_encode|raw}}');
let versions_table = null;
const INTERVAL_CHECK_STATUS = 1500;
let compiling_log_lines = [];
let compiling_log_timeout = null
const LOADER_HTML = '<div class="action-loader">' +
                        '<span><i class="fa fa-circle-o-notch fa-spin"></i></span>' +
                        '<h5 id="">{{lang.LABPHPSEL39}}...</h5>' +
                    '</div>';
let php_ini_editor = null;
function phpVerCheckChanged(){
    if ($('.checkbox-php-version:checked').length > 0){
        $('#_btn_compile_php_version_').prop('disabled', false).removeClass('disabled');
    }else{
        $('#_btn_compile_php_version_').prop('disabled', true).addClass('disabled');
    }
}
function renderPHpVersionList(){
    if (php_versions_installed.length > 0) {
        let html_content = '';
        let index = 0;
        php_versions_installed.forEach(function (version) {
            let status_class = 'success';
            let status_title = '{{lang.LABPHPSEL40}}';
            let status_running_display = '';
            let status_stopped_display = 'style="display:none"';
            if(version.status != 'running'){
                status_class = 'danger';
                status_title = '{{lang.LABPHPSEL41}}';
                status_running_display = 'style="display:none"';
                status_stopped_display = '';
            }
            let installed_disabled = version.installed_version !== null ? '' : 'disabled';
            let short_ver = version.ver.replace('.', '');
            let options_available_html = '<option value="" selected>Select a version to ' + (version.installed_version === null ? 'install' : 'rebuild') + '</option>';
            version.available.forEach(function (option) {
                options_available_html += '<option value="' + option + '">' + option + (option == version.installed_version ? ' (current version)' : '') + '</option>';
            });
            let status_btn = version.installed_version !== null ? ('<button class="btn btn-default btn-sm btn-on-running btn-phpver-status" data-toggle="tooltip" ' + status_running_display + ' onclick="phpHandleStatus(\'reload\', this, \'fa-refresh\')" data-placement="top" title="{{lang.LABPHPSEL42}}"><i class="fa fa-refresh"></i></button>' +
                            '<button class="btn btn-danger btn-sm btn-on-running btn-phpver-status" data-toggle="tooltip" ' + status_running_display + ' onclick="phpHandleStatus(\'stop\', this, \'fa-stop\')" data-placement="top" title="{{lang.LABPHPSEL43}}"><i class="fa fa-stop"></i></button>' +
                            '<button class="btn btn-success btn-sm  btn-on-stopped btn-phpver-status" ' + status_stopped_display + ' onclick="phpHandleStatus(\'start\', this, \'fa-play\')" data-toggle="tooltip" data-placement="top" title="{{lang.LABPHPSEL44}}"><i class="fa fa-play"></i></button>' +
                            '<button class="btn btn-primary btn-sm  btn-phpver-status" onclick="showStatusInformationModalPHP(this)" data-toggle="tooltip" data-placement="top" title="{{lang.LABPHPSEL45}}"><i class="fa fa-info-circle"></i></button>') : ''; 
            html_content += '<tr data-installed="' + version.installed_version + '" class="php-version-tr" data-version-info=\'' + JSON.stringify(version) + '\'>' +
                                //'<td><input type="checkbox" onchange="phpVerCheckChanged()" class="checkbox-php-version" id="_check_php_' + short_ver + '_"></td>' +
                                '<td class="td-version-name" data-major="' + version.ver + '" data-installed="' + version.installed_version + '">' +
                                    '<label for="_check_php_' + short_ver + '_">PHP-FPM ' + version.ver + '</label>' +
                                    '<select class="form-control" onchange="selectedVersionToBuild(this)">' + options_available_html + '</select>' +
                                    (version.installed_version !== null ? 
                                        '<span data-toggle="popover" class="btn-php-info-path" title="PHP-FPM ' + version.ver + '" data-content="' + version.path + '">' +
                                            '<a href="#" class="btn btn-default btn-sm" data-placement="top" data-toggle="tooltip" title="{{lang.LABPHPSEL47}}">' + 
                                                '<i class="fa fa-question-circle"></i>' + 
                                            '</a>' + 
                                        '</span>' : 
                                        ''
                                    ) +
                                    '<span id="_custom_config_file_' + short_ver + '_" class="label label-warning" style="margin-left: 1rem;' + (version.custom_config !== true ? 'display:none;' : '') + '">{{lang.LABPHPSEL46}}</span>' +
                                '</td>' +
                                '<td class="php-table-status-td php-table-version-td">' +
                                    '<div>' + 
                                        (version.installed_version !== null ? version.installed_version : '<span class="label label-warning">Not installed</span>') + 
                                        //'<button class="btn btn-primary btn-sm btn-installer-opener" onclick="modalReInstallPHPVersion(this)" data-toggle="tooltip" data-placement="top" title="Change installed version"><i class="fa fa-pencil-square-o"></i></button>' +
                                    '</div>' +
                                '</td>' +
                                '<td class="php-table-status-td php-table-status-controls-td">' +
                                    (version.installed_version !== null ? '<span class="tr-php-status-container"><i class="fa fa-circle text-' + status_class + '" aria-hidden="true"></i> ' + status_title + '</span>' : '-') +
                                    status_btn +
                                '</td>' +
                                '<td class="php-table-status-td php-table-autoupdate-td">' +
                                    (version.installed_version !== null ? (version.auto_update === true ? 
                                        '<span class="label label-success label-auto-update">{{lang.LABPHPSEL48}}</span>' +
                                        '<button class="btn btn-warning btn-sm" data-auto-update="true" onclick="modalConfirmAutoUpdate(this)" data-toggle="tooltip" data-placement="top" title="{{lang.LABPHPSEL49}}"><i class="fa fa-ban"></i></button>'
                                    : 
                                        '<span class="label label-warning label-auto-update">{{lang.LABPHPSEL51}}</span>' +
                                        '<button class="btn btn-success btn-sm" data-auto-update="false" onclick="modalConfirmAutoUpdate(this)" data-toggle="tooltip" data-placement="top" title="{{lang.LABPHPSEL50}}"><i class="fa fa-check"></i></button>'
                                    ) : '-') +
                                '</td>' +
                                '<td>' +
                                    '<div class="version-actions-container">' +
                                        '<button class="btn btn-primary btn-sm manage-options-btn" onclick="managePHPOptions(this)" data-toggle="tooltip" data-placement="top" title="{{lang.LABPHPSEL52}}"><i class="fa fa-bars"></i></button>' +
                                        //'<button class="btn btn-default btn-sm" data-toggle="tooltip" data-placement="top" title="Autoupdate"><i class="fa fa-retweet"></i></button>' +
                                        '<button ' + installed_disabled + ' class="btn btn-success btn-sm not-installed-disabled ' + installed_disabled + '" onclick="showPHPModules(this)" data-toggle="tooltip" data-placement="top" title="{{lang.LABPHPSEL53}}"><i class="fa fa-list-ul"></i></button>' +
                                        '<button ' + installed_disabled + ' class="btn btn-primary btn-sm not-installed-disabled ' + installed_disabled + '" onclick="showModalPHPInfo(this)" data-toggle="tooltip" data-placement="top" title="{{lang.LABPHPSEL54}}"><i class="fa fa-info-circle"></i></button>' +
                                        '<button ' + installed_disabled + ' class="btn btn-default btn-sm not-installed-disabled ' + installed_disabled + '" onclick="showPHPIniEditor(this)" data-toggle="tooltip" data-placement="top" title="{{lang.LABPHPSEL55}}"><i class="fa fa-cogs"></i></button>' +
                                        '<button ' + installed_disabled + ' class="btn btn-danger btn-sm not-installed-disabled ' + installed_disabled + '" data-index="' + index + '" onclick="showConfirmPHP(this)" data-toggle="tooltip" data-placement="top" title="{{lang.LABPHPSEL56}}"><i class="fa fa-trash"></i></button>' +
                                    '</div>' +
                                '</td>' +
                            '</tr>';
            index++;
        });
        let html_list = '<div id="_main_versions_table_container_"><table class="table fpm_versions_table table-striped table-bordered table-hover">' +
                            '<thead>' +
                                '<tr role="row">' +
                                    //'<th style="width:1px">&nbsp;</th>' +
                                    '<th>{{lang.LABPHPSEL57}}</th>' +
                                    '<th style="width:120px">{{lang.LABPHPSEL58}}</th>' +
                                    '<th style="width:220px">{{lang.LABPHPSEL59}}</th>' +
                                    '<th style="width:120px">{{lang.LABPHPSEL60}}</th>' +
                                    '<th style="width:200px">{{lang.LABPHPSEL61}}</th>' +
                                '</tr>' +
                            '</thead>' +
                            '<tbody id="contenttr">' +
                                html_content +
                            '</tbody>' +
                        '</table><input type="text" class="popover-copy-path-input" id="popover_copy_path_input"></div>';
        $('#_php_versions_table_').html(html_list);
        versions_table = $('.fpm_versions_table').DataTable({
            "autoWidth": false,
            /*columnDefs: [
                { orderable: false, targets: 0 }
            ],*/
            "dom": "<'row'<'col-sm-2'l><'#filter_versions_container.col-sm-6'><'col-sm-4'f>>" +
                "<'row'<'col-sm-12'tr>>" +
                "<'row'<'col-sm-12'p>>",
            order: [[0  , 'asc']],
            "pageLength": 25,
        });
        $('#_main_versions_table_container_ .dataTables_length select').addClass('form-control');
        $('#_main_versions_table_container_ .dataTables_filter input').addClass('form-control');
        $('#filter_versions_container').html('<input type="radio" checked name="radio-filter-option" value="1" id="_radio_filter_all_" class="radio-filter-versions"><label for="_radio_filter_all_">All versions</label>' +
                                                '<input type="radio" name="radio-filter-option" value="2" id="_radio_filter_installed_" class="radio-filter-versions"><label for="_radio_filter_installed_">Installed versions</label>' +
                                                '<input type="radio" name="radio-filter-option" value="3" id="_radio_filter_notinstalled_" class="radio-filter-versions"><label for="_radio_filter_notinstalled_">Not installed versions</label>');
        $('.radio-filter-versions').change(function(){
            let filter_type = $('.radio-filter-versions:checked').val();
            if (filter_type == '1'){
                versions_table.column(1).search('').draw();
            }else if(filter_type == '2'){
                versions_table.column(1).search('^((?!Not installed).)*$', true, false).draw();
            }else if(filter_type == '3'){
                versions_table.column(1).search('^Not installed', true, false).draw();
            }
            
        });
        $('[data-toggle="popover"]').popover({
            template: '<div class="popover app-popover-fw" role="popover">' +
                        '<div class="arrow"></div>' +
                        '<h3 class="popover-title"></h3>' +
                        '<div class="popover-php-path">' +
                            '<span><i class="fa fa-folder-open-o" aria-hidden="true"></i>&nbsp;</span>' +
                            '<div class="popover-content"></div>' +
                            '<div>' +
                                '<button class="btn btn-primary btn-xs btn-popover-copy-path" data-placement="top" onclick="popoverCopyPath(this)" title="{{lang.LABPHPSEL62}}"><i class="fa fa-copy"></i></button>' +
                            '</div>' +
                        '</div>' +
                    '</div>'
        });
        $('[data-toggle="popover"]').on('shown.bs.popover', function (){
            $('.btn-popover-copy-path').tooltip({
                container: 'body'
            });   
        });
        $('[data-toggle="tooltip"]').tooltip(); 
        $('#_btn_compile_php_version_').prop('disabled', true); 
    }else{
        $('#_php_versions_table_').html('<div id="_none_php_ver_installed_">' +
                                            '<h4>{{lang.LABPHPSEL63}}</h4>' +
                                            '<button class="btn btn-primary btn-installer-opener">' +
                                                '<i class="fa fa-plus"></i> {{lang.LABPHPSEL64}}' +
                                            '</button>' +
                                        '</div>');
    }
    
}
function popoverCopyPath(elem){
    let parent_container = $(elem).closest('.popover-php-path');
    console.log(parent_container.find('.popover-content').text());
    $('#popover_copy_path_input').val(parent_container.find('.popover-content').text());
    console.log($('#popover_copy_path_input').val());
    let hiddenPut = document.getElementById('popover_copy_path_input');
    hiddenPut.select();
    document.execCommand('copy');
    $.gritter.add({
        title: '{{lang.LABPHPSEL65}}',
        text: '{{lang.LABPHPSEL66}}',
        time: 3500,
        close_icon: '',
        icon: 'icomoon-icon-quill-2',
        class_name: 'success-notice'
    });
}
function backFromOptions(){
    $('#php_fpm_options_container').fadeOut('fast', function () {
        $('#php_fpm_main_container').slideDown('fast');
        $('#_version_manage_options_advanced_container_').hide();
        $('#_version_manage_options_container_').show();
    });
}
function backFromIniEditor(){
    $('#php_fpm_ini_editor_container').fadeOut('fast', function () {
        $('#php_fpm_main_container').slideDown('fast');
    });
}
function backFromModules(){
    $('#php_fpm_modules_container').fadeOut('fast', function () {
        $('#php_fpm_main_container').slideDown('fast');
    });
}
function showConfirmPHP(elem){
    let tr_elem = $(elem).closest('.php-version-tr');
    let php_ver_info = tr_elem.data('version-info');
    $('#_modal_php_delete_ver_').text(php_ver_info.ver);
    $('#_modal_php_confirm_delete_version_').modal('show');
    $('#_btn_confirmed_php_delete_').unbind('click').click(function(){
        $('#_modal_php_confirm_delete_version_').modal('hide');
        tr_elem.addClass('tr-deleting');
        tr_elem.find('.btn').prop('disabled', true);
        handleButtons($(elem), 'fa-trash');
        sendPHPversionDelete(php_ver_info.ver, function(){
            $.gritter.add({
                title: '{{lang.LABPHPSEL65}}',
                text: 'PHP-FPM ' + php_ver_info.ver + ' {{lang.LABPHPSEL67}}',
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-quill-2',
                class_name: 'success-notice'
            });
            
            /*tr_elem.slideUp('fast', function () {
                php_versions_installed.splice($(elem).data('index'),1);
                versions_table.row(this).remove().draw();
            });*/
            tr_elem.find('.php-table-version-td').html('<span class="label label-warning">Not installed</span>');
            tr_elem.find('.php-table-status-controls-td').html('-');
            tr_elem.find('.php-table-autoupdate-td').html('-');
            tr_elem.find('.btn-php-info-path').hide();
            tr_elem.find('select').prepend('<option value="">Select version to install.</option>');
            tr_elem.find('select').val("");
            tr_elem.find('.td-version-name').data("installed", null);
            tr_elem.find('select option:contains("current version")').text(tr_elem.data('installed'));
            tr_elem.data('installed', null);
            tr_elem.removeClass('php-installer-version-selected');
            tr_elem.removeClass('tr-deleting');
            tr_elem.find('.manage-options-btn').prop('disabled', false);
            handleButtons($(elem), 'fa-trash', true);
            $(elem).prop('disabled', true);
        }, function(){
            tr_elem.removeClass('tr-deleting');
            tr_elem.find('.btn').prop('disabled', false);
            handleButtons($(elem), 'fa-trash', true);
        });
    });
}
function showPHPIniEditor(elem){
    let php_ver_info = $(elem).closest('.php-version-tr').data('version-info');
    $('#_php_ini_editor_container_title_').text('{{lang.LABPHPSEL68}} PHP-FPM ' + php_ver_info.ver);
    $('#_php_ini_editor_wrapper_').html(LOADER_HTML);
    $('#_php_ver_editing_ini_file_').val(php_ver_info.ver);
    $('#_btn_save_php_ini_file_').prop('disabled', true);
    $('#php_fpm_main_container').fadeOut('fast', function () {
        $('#php_fpm_ini_editor_container').slideDown('fast');
        getPHPIniContent(php_ver_info.ver, function(response){
            $('#_php_ini_editor_wrapper_ .action-loader').fadeOut('fast', function(){
                $('#_php_ini_editor_wrapper_').html('<div id="_php_version_ini_editor_wrapper_">' +
                                                    '<h4>{{lang.LABPHPSEL69}}: ' + response.file_path + '</h4>' +
                                                    '<span class="ini-editor-legend">{{lang.LABPHPSEL113}} (Ctrl-F / Cmd-F) - {{lang.LABPHPSEL114}} (Ctrl-G / Cmd-G) - {{lang.LABPHPSEL115}} (Shift-Ctrl-G / Shift-Cmd-G)</span>' +
                                                    '<textarea id="_php_version_ini_editor_">' + response.content + '</textarea></div>');
                php_ini_editor = CodeMirror.fromTextArea(document.getElementById("_php_version_ini_editor_"), {
                    lineNumbers: true,
                    matchBrackets: true,
                    styleActiveLine: true,
                    theme: "ambiance",
                });
                $('#_php_version_ini_editor_wrapper_').fadeIn('fast', function(){
                    php_ini_editor.refresh();
                    php_ini_editor.focus();
                    $('#_btn_save_php_ini_file_').prop('disabled', false);
                });
            });
            
        }, function(){

        });
    });
}
function savePHPIniFile(elem){
    $('.btn-ini-handler').prop('disabled', true);
    handleButtons($(elem), 'fa-floppy-o');
    let version = $('#_php_ver_editing_ini_file_').val();
    sendSaveIniFile(version, encodeURIComponent(Base64.encode(php_ini_editor.getValue())), function(){
        $('.btn-ini-handler').prop('disabled', false);
        handleButtons($(elem), 'fa-floppy-o', true);
        $.gritter.add({
            title: '{{lang.LABPHPSEL65}}',
            text: '{{lang.LABPHPSEL70}} ' + version + ' {{lang.LABPHPSEL71}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
    }, function(){
        $('.btn-ini-handler').prop('disabled', false);
        handleButtons($(elem), 'fa-floppy-o', true);
    });
}
function showModalPHPInfo(elem){
    let php_ver_info = $(elem).closest('.php-version-tr').data('version-info');
    $('#_php_info_modal_title').text(php_ver_info.ver);
    $('#_modal_php_info_ .modal-body').html(LOADER_HTML);
    $("#_modal_php_info_ .modal-dialog").css({'max-width': '400px'});
    $('#_modal_php_info_').modal('show');
    getPHPversionInfo(php_ver_info.ver, function(response){
        $('#_modal_php_info_ .modal-body .action-loader').fadeOut('fast', function(){
            $('#_modal_php_info_ .modal-body').html('<div id="_modal_php_info_wrapper_">' + response.info + '</div>');
            $('#_modal_php_info_wrapper_').fadeIn('fast');
            $("#_modal_php_info_ .modal-dialog").animate({
                'max-width': '1500px'
            }, 500, function () {
                // Animation complete.
            });
        });
        
    }, function(){
        $('#_modal_php_info_').modal('hide');
    });
}

function handleButtons(elem, icon_fa, type) {
    let icon = $(elem).find('.fa');
    if (type == undefined) {
        $(elem).addClass('disabled');
        $(elem).prop('disabled', true);
        icon.removeClass(icon_fa);
        icon.addClass('fa-spinner fa-spin');
    } else {
        icon.removeClass('fa-spinner fa-spin');
        icon.addClass(icon_fa);
        $(elem).removeClass('disabled');
        $(elem).prop('disabled', false);
    }
}
function capitalize(str) {
    const lower = str.toLowerCase();
    return str.charAt(0).toUpperCase() + lower.slice(1);
}
function modalConfirmAutoUpdate(elem){
    let php_ver_info = $(elem).closest('.php-version-tr').data('version-info');
    $('#_modal_php_auto_update_action_').text($(elem).data('auto-update') === true ? 'disable' : 'enable');
    $('#_modal_php_auto_update_ver_').text(php_ver_info.ver);
    $('#_btn_confirm_php_change_autoupdate_').unbind('click').click(function(){
        let btn_ico = 'fa-check';
        let btn_class = 'success';
        let btn_new_ico = 'fa-ban';
        let btn_new_class = 'warning';
        let success_message = '{{lang.LABPHPSEL72}}';
        let new_title = '{{lang.LABPHPSEL73}}';
        let action = 'enable';
        if ($(elem).data('auto-update') === true){
            btn_ico = 'fa-ban';
            btn_class = 'warning';
            btn_new_ico = 'fa-check';
            btn_new_class = 'success';
            success_message = '{{lang.LABPHPSEL74}}';
            action = 'disable';
            new_title = '{{lang.LABPHPSEL75}}';
        }
        handleButtons($(elem), btn_ico);
        $('#_modal_php_confirm_auto_update_').modal('hide');
        sendPHPAutoUpdateChange(php_ver_info.ver, action, function (){
            handleButtons($(elem), btn_ico, true);
            $(elem).data('auto-update', action == 'enable')
            $(elem).removeClass('btn-' + btn_class).addClass('btn-' + btn_new_class);
            $(elem).find('i').removeClass(btn_ico).addClass(btn_new_ico);
            $(elem).attr('data-original-title', new_title + ' auto-update');
            $(elem).closest('.php-version-tr').find('.label-auto-update').removeClass('label-' + btn_new_class).addClass('label-' + btn_class).text(capitalize(success_message));
            $.gritter.add({
                title: '{{lang.LABPHPSEL65}}',
                text: '{{lang.LABPHPSEL76}} ' + success_message ,
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-quill-2',
                class_name: 'success-notice'
            });
        }, function(){
            handleButtons($(elem), btn_ico, true);
        });
    });
    $('#_modal_php_confirm_auto_update_').modal('show');
}

$(document).ready(function () {
    renderPHpVersionList();
    {% if mod_vars.is_php_compiling == true %}
        compilingAfterReload();
    {% endif %}
    $('html').on('mouseup', function (e) {
        if (!$(e.target).closest('.popover').length) {
            $('.popover').each(function () {
                $(this.previousSibling).popover('hide');
            });
        }
    });
});

{% include 'js/php_fpm_services.js' %}
{% include 'js/base64.js' %}

{% include 'js/phpfpm_status_handler.js' %}
{% include 'js/phpfpm_options_handler.js' %}
{% include 'js/phpfpm_modules_handler.js' %}
{% include 'js/phpfpm_installer.js' %}