let pgre_file_editor = null;
let pgre_settings = JSON.parse('{{mod_vars.pgre_settings|json_encode|raw}}');
function BindSettingsTab(){
    $('[data-toggle="tooltip"]').tooltip()
    $('[data-toggle="popover"]').popover({
        container: 'body'
    });
    $("[data-toggle='popover']").on('show.bs.popover', function () {
        $("[data-toggle='tooltip']").tooltip('hide');
    });
    $('body').on('click', function (e) { // ADD LISTENER TO CLOSE POPOVER
        $('[data-toggle="popover"]').each(function () {
            //the 'is' for buttons that trigger popups
            //the 'has' for icons within a button that triggers a popup
            if (!$(this).is(e.target) && $(this).has(e.target).length === 0 && $('.popover').has(e.target).length === 0) {
                $(this).popover('hide');
            }
        });
    });
    setValuesToForm();
    pgre_file_editor = CodeMirror.fromTextArea(document.getElementById("_pgre_file_editor_area_"), {
        lineNumbers: true,
        matchBrackets: true,
        styleActiveLine: true,
        theme: "ambiance"
    });
}
function setValuesToForm() {
    $('#_pgre_settings_listening_port').val(pgre_settings.port);
    $('#_pgre_settings_listening').val(pgre_settings.listen_addresses);
    $('#_pgre_settings_max_connections').val(pgre_settings.max_connections);
    $('#_pgre_settings_authentication_timeout').val(pgre_settings.authentication_timeout);
    $('#_pgre_settings_log_directory_').val(pgre_settings.log_directory);
    $('#_pgre_settings_log_filename_').val(pgre_settings.log_filename);
    $('#_pgre_settings_log_min_messages_').val(pgre_settings.log_min_messages);
    $('#_pgre_settings_log_min_error_statement_').val(pgre_settings.log_min_error_statement);
    $('#_pgre_settings_log_min_duration_statement_').val(pgre_settings.log_min_duration_statement);
    if(is_custom_version === true){
        $('#_pgre_settings_pw_enc_select').val(pgre_settings.password_encryption);
    }else{
        if (pgre_settings.password_encryption !== true) {
            $('#_pgre_settings_pw_enc_no').trigger('click');
        }
    }
    
    if (pgre_settings.logging_collector !== true) {
        $('#_pgre_settings_log_collector_no').trigger('click');
    }

}
function togglePgreConfEditor(type) {
    let show = '#_pgre_settings_wrapper_';
    let hide = '#_pgre_settings_file_editor_';
    if (type === 1) {
        hide = '#_pgre_settings_wrapper_';
        show = '#_pgre_settings_file_editor_';
    }
    slideToggle(show, hide, function () {
        advanceTab();
    });
}
function advanceTab() {
    setTimeout(function () {
        pgre_file_editor.refresh();
    }, 200);
}
function PgreSaveSettingsFile(elem, restart) {
    PgreSaveSettings(elem, restart, true);
}
function PgreSaveSettings(elem, restart, file) {
    if (restart !== undefined) {
        $('#_pgresql_status_loader_title_').text('{{lang.LABPGRE134}}');
        slideToggle('.pgresql-status-panel', '.pgresql-tabs-container-main');
        handleBtns();
    } else {
        handleButtons(elem, 'fa-floppy-o');
    }
    function UnlockUI(status) {
        if (restart !== undefined) {
            if (status == 'running') {
                slideToggle('.pgresql-tabs-container-main', '.pgresql-status-panel', function(){
                    $('.running-screen-twice').show();
                    $('.not-running-screen').hide();
                });
                $('.on-not-running').fadeOut('fast', function () {
                    $('.on-running').fadeIn('fast');
                    handleButtons('.on-not-running', 'fa-play', true);
                });
            } else {
                $('.on-running').fadeOut('fast', function () {
                    $('.on-not-running').fadeIn('fast');
                    handleBtns(false);
                });
                slideToggle('.pgresql-tabs-container-main', '.pgresql-status-panel', function(){
                    $('.running-screen-twice').hide();
                    $('.not-running-screen').show();
                });
            }
            handleBtns(false);
        } else {
            handleButtons(elem, 'fa-floppy-o', true);
        }
    }
    function handleBtns(st) {
        handleButtons('#_btn_stop_sidebar_', 'fa-stop', st);
        handleButtons('#_btn_restart_sidebar_', 'fa-refresh', st);
    }
    function alertSuccess(status) {
        let message = '{{lang.LABPGRE135}}';
        let tag_style = 'success-notice';
        if (restart !== undefined && status != 'running') {
            message = '{{lang.LABPGRE136}} "systemctl status postgresql.service"';
            tag_style = 'warning-notice';
            $('#_mongodb_status_holder').text(statusTranslator('stopped'));
        } else if (restart === undefined) {
            message = '{{lang.LABPGRE137}}';
        }
        $.gritter.add({
            title: '{{lang.LABPGRE18}}',
            text: message,
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: tag_style
        });
    }
    if (file === true) {
        let file_content = pgre_file_editor.getValue();
        sendPgreSQLSettingsFile(file_content, restart === undefined ? 0 : 1,
            function (response) {
                pgre_settings = response.settings;
                setValuesToForm();
                UnlockUI(response.status_server);
                alertSuccess(response.status_server);
            }, function () {
                UnlockUI('running');
            });
    } else {
        let settings_form = {
            port: $('#_pgre_settings_listening_port').val(),
            listen_addresses: $('#_pgre_settings_listening').val(),
            max_connections: $('#_pgre_settings_max_connections').val(),
            authentication_timeout: $('#_pgre_settings_authentication_timeout').val(),
            password_encryption: is_custom_version ? $('#_pgre_settings_pw_enc_select').val() : $('#_pgre_settings_pw_enc_yes').is(':checked'),
            logging_collector: $('#_pgre_settings_log_collector_yes').is(':checked'),
            log_directory: $('#_pgre_settings_log_directory_').val(),
            log_filename: $('#_pgre_settings_log_filename_').val(),
            log_min_messages: $('#_pgre_settings_log_min_messages_').val(),
            log_min_error_statement: $('#_pgre_settings_log_min_error_statement_').val(),
            log_min_duration_statement: $('#_pgre_settings_log_min_duration_statement_').val(),
        };
        sendPgreSQLSettings(JSON.stringify(settings_form), restart === undefined ? 0 : 1,
            function (response) {
                pgre_file_editor.setValue(response.file_content);
                UnlockUI(response.status_server);
                alertSuccess(response.status_server);
            }, function () {
                UnlockUI('running');
            });
    }
}
function sendPgreSQLSettings(settings, restart, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=postgresql_manager&acc=save_settings",
        data: 'settings=' + settings + '&restart=' + restart,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPGRE20}}',
                    text: '{{lang.LABPGRE23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPGRE23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABPGRE28}}';
                    } else if (resp_data.code == 1) {
                        message_error = 'Invalid data';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPGRE20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendPgreSQLSettingsFile(file_content, restart, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=postgresql_manager&acc=save_settings_file",
        data: 'file_content=' + Base64.encode(file_content) + '&restart=' + restart,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPGRE20}}',
                    text: '{{lang.LABPGRE23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPGRE23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABPGRE28}}';
                    } else if (resp_data.code == 1) {
                        message_error = 'Invalid data';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPGRE20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}