let users_list = JSON.parse('{{mod_vars.users_list|json_encode|raw}}');
let is_custom_version = {{(mod_vars.pgre_is_custom_version ? 'true' : 'false') }};
let user_config = null;
let pgre_info = null;
$(document).ready(function(){
    {% if mod_vars.installed == true %}
        pgresqlList();
        BindUserModal();
        BindSettingsTab();
        user_config = JSON.parse('{{mod_vars.user_config|json_encode|raw}}');
        pgre_info = JSON.parse('{{mod_vars.pgre_info|json_encode|raw}}');
        renderUsersList();
    {% endif %}
    $('#_pgre_manage_user_modal_').on('hidden.bs.modal', function () {
        CleanUserModal()
    });
    $('#_pgre_delete_user_modal_').on('hidden.bs.modal', function () {
        $('#_user_deletion_type_user').trigger('click');
    });
    RenderUserInForm();
    BindConfigTab();
});
function setConfigValues(){
    if (user_config !== null){
        $('#_pgresql_conf_user_enabled_').prop('checked', user_config.user_enabled);
        if (user_config.user_enabled === true){
            $('#_pgre_users_select_wrapper_').show();
            $('#_pgresql_availability_select_').val(user_config.availability_type);
            if (user_config.availability_type == '2'){
                $('#_pgre_users_select_availability_').show();
            }
        }
        $('#_pgresql_conf_user_enabled_').prop('checked', user_config.user_enabled);
        $('#version_holder').text(pgre_info.version);
        $('#_pgresql_status_holder').text(statusTranslator(pgre_info.status));
    }
}
function statusTranslator(status){
    return status == 'running' ? 'Running' : 'Stopped';
}
function unistallpgresql(){
    $('#_pgre_uninstall_confirm_modal_').modal('show');
}
function pgreUninstallConfirmed(){
    slideToggle('#_pgresql_loader_screen_', '#_pgresql_dashboard_main_');
    $('#_pgre_uninstall_confirm_modal_').modal('hide');
    $('#_pgresql_loader_title_').text('{{lang.LABPGRE95}}');
    sendpgresqlUninstallation(function(){
        users_db_list = [];
        users_db_table = null;
        database_list = [];
        user_config = {
            user_enabled: false,
            availability_type: '1',
            availability_users: []
        };
        setConfigValues();
        $.gritter.add({
            title: '{{lang.LABPGRESUCCESS}}',
            text: '{{lang.LABPGRE106}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        slideToggle('#_pgresql_not_installed_screen_', '#_pgresql_loader_screen_');
    },function(){
        slideToggle('#_pgresql_dashboard_main_', '#_pgresql_loader_screen_');
    });
}
function BindConfigTab(){
    let list_opts = {
        nonSelectedListLabel: '{{lang.LABPGRE107}}',
        selectedListLabel: '{{lang.LABPGRE108}}',
        selectorMinimalHeight: 200,
        filterTextClear: '{{lang.LABPGRE109}}', // the text for the "Show All" button.
        filterPlaceHolder: '{{lang.LABPGRE110}}', // the placeholder for the input element for filtering elements.
        moveSelectedLabel: '{{lang.LABPGRE111}}', // the label for the "Move Selected" button.
        moveAllLabel: '{{lang.LABPGRE112}}', // the label for the "Move All" button.
        removeSelectedLabel: '{{lang.LABPGRE113}}', // the label for the "Remove Selected" button.
        removeAllLabel: '{{lang.LABPGRE114}}', // the label for the "Remove All" button.
    };
    $('#_pgresql_availability_select_users_').bootstrapDualListbox(list_opts);
    setConfigValues();
}
function pgreChangeUsersToAvailable(elem){
    if ($(elem).val() == '2'){
        $('#_pgre_users_select_availability_').slideDown('fast');
    }else{
        $('#_pgre_users_select_availability_').slideUp('fast', function(){
            // $('#_pgre_users_select_availability_ .removeall').trigger('click');
        });
    }
}
function pgreSaveConfigurations(elem){
    handleButtons(elem, 'fa-floppy-o');
    let users_availability = $('#_pgresql_availability_select_users_').val();
    let user_config = {
        user_enabled: $('#_pgresql_conf_user_enabled_').is(':checked'),
        availability_type: $('#_pgresql_availability_select_').val(),
        availability_users: users_availability === null ? [] : users_availability
    }
    sendpgresqlConfigurations(JSON.stringify(user_config), function(){
        handleButtons(elem, 'fa-floppy-o', true);
        $.gritter.add({
            title: '{{lang.LABPGRESUCCESS}}',
            text: '{{lang.LABPGRE115}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
    },function(){
        handleButtons(elem, 'fa-floppy-o', true);
    });
}
function changeUserAvailability(elem){
    if ($(elem).is(':checked')){
        $('#_pgre_users_select_wrapper_').slideDown('fast');
    }else{
        $('#_pgre_users_select_wrapper_').slideUp('fast');
        $('#_pgre_users_select_availability_').slideUp('fast', function () {
            // $('#_pgresql_availability_select_').val('1');
            // $('#_pgre_users_select_availability_ .removeall').trigger('click');
        });
    }
}
function getIfUserAvailable(user){
    return (user_config !== null && user_config.availability_users.find(function(usr){return usr == user}) != undefined) ? 'selected' : '';
}
function RenderUserInForm(){
    let users_select = '';
    let users_select_2 = '';
    users_list.forEach(function(user){
        let selected_user = getIfUserAvailable(user);
        users_select += '<option value="' + user + '" >' + user + '</option>';
        users_select_2 += '<option value="' + user + '" ' + selected_user + '>' + user + '</option>';
    });
    $('#_pgre_sql_form_user').html('<select class="form-control" name="" id="_pgre_sql_user_select_">' +
                                        '<option value="" id="" selected>{{lang.LABPGRE16}}</option>' +
                                        users_select + 
                                    + '</select>');
    $('#_pgre_users_select_availability_').html('<select name="_pgresql_availability_select_" multiple="" class="form-control" id="_pgresql_availability_select_users_">' +
                                        users_select_2 + 
                                    + '</select>');
    $("#_pgre_sql_user_select_").select2({
        placeholder: "{{lang.LABPGRE17}}",
        allowClear: true
    });
}
function pgreInstallationModal(version) {
    $('#_pgresql_version_to_install_').html(version);
    $('#_pgre_install_confirm_modal_').modal('show');
}
function copyPass(elem) {
    let field = document.getElementById(elem);
    field.select();
    document.execCommand('copy');
    $.gritter.add({
        title: '{{lang.LABPGRESUCCESS}}',
        text: '{{lang.LABPGRECOPIEDPASS}}',
        time: 3500,
        close_icon: '',
        icon: 'icomoon-icon-quill-2',
        class_name: 'success-notice'
    });
    // noti_bubble('{{lang.LABPGRECOPIEDPASS}}', '{{lang.LABPGRESUCCESS}}', 'success', false, false, '3000', true);
}
function openPGOPT(type, second) {
    let divelem = type == null ? '#pgopt_container' : type;
    if ($(divelem).is(':visible')) {
        $(divelem).slideUp('fast');
    } else {
        $(divelem).slideDown('fast');
        hideOnClickOutside(divelem, second);
    }
}
function hideOnClickOutside(selector, second) {
    let forhide = true;
    if (second === undefined) {
        second = '.show_options_button';
        forhide = true;
    }
    function outsideClickListener(event) {
        $target = $(event.target);
        if (!$target.closest(selector).length && !$target.closest(second).length && $(selector).is(':visible')) {
            if (forhide) {
                $(selector).slideUp('fast');
            } else {
                $(selector).remove();
            }
            removeClickListener();
        }
    }
    function removeClickListener() {
        document.removeEventListener('click', outsideClickListener)
    }
    document.addEventListener('click', outsideClickListener)
}
function generatePasswordRand(length, type) {
    switch (type) {
        case 'num':
            characters = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
            break;
        case 'alf':
            characters = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
            break;
        case 'rand':
            //FOR ↓
            break;
        default:
            characters = "0123456789/-_%*!^><.abcdefghijklmnopqrstuvwxyz/-_%*!^><.ABCDEFGHIJKLMNOPQRSTUVWXYZ/-_%*!^><.";
            break;
    }
    var pass = "";
    for (i = 0; i < length; i++) {
        if (type == 'rand') {
            pass += String.fromCharCode((Math.floor((Math.random() * 100)) % 94) + 33);
        } else {
            pass += characters.charAt(Math.floor(Math.random() * characters.length));
        }
    }
    return pass;
}
function generateNewPass(element) {
    let passmeter = $(element).parent().parent().find('.pass_container input');
    let lengthpass = $(element).parent().find('.general-password-generator-options .pwlength');
    let typepass = $(element).parent().find('.general-password-generator-options .pwtype');
    let confpass = 'ftppass2_ch';
    // if(type == 'userp'){
    //   passmeter = 'ftppass1';
    //   lengthpass = 'lengthpass';
    //   typepass = 'typepass';
    //   confpass = 'ftppass2';
    // }
    let lpass = lengthpass.val();
    let tpass = typepass.val();
    let new_pass = generatePasswordRand(lpass, tpass);
    passmeter.val(new_pass);
    passmeter.pwstrength("forceUpdate");
    // if(type == undefined || type == 'userp'){
    //   copyPass(passmeter);
    // }
    copyPass(passmeter.attr('id'));
}
function pgreInstallationConfirmed(){
    let version = $('#_pgresql_version_to_install_').text();
    $('#_pgresql_loader_title_').html('{{lang.LABPGRE96}}: ' + $('#_pgresql_version_to_install_').text());
    slideToggle('#_pgresql_loader_screen_', '#_pgresql_not_installed_screen_');
    $('#_pgre_install_confirm_modal_').modal('hide');
    sendpgreInstallation(version, function (response) {
        $('#_pgresql_list_link_tab_').trigger('click');
        database_list = response.db_list;
        pgre_info = response.pgre_info;
        pgre_settings = response.settings;
        is_custom_version = response.is_custom_version;
        $('#_pgre_file_editor_area_').val(response.file_content);
        $('#_pgre_file_path_').text(response.file_path);
        BindSettingsTab();
        pgresqlList();
        // slideToggle('.pgresql-tabs-container-main', '.pgresql-status-panel');
        $('.on-not-running').fadeOut('fast', function(){
            $('.on-running').fadeIn('fast');
            handleButtons('.on-not-running', 'fa-play', true);
        });
        $('.not-running-screen').hide();
        $('.running-screen-twice').show();
        $('#version_holder').text(pgre_info.version);
        $('#_pgresql_status_holder').text(statusTranslator(pgre_info.status));
        slideToggle('#_pgresql_dashboard_main_','#_pgresql_loader_screen_');
    }, function () {
        slideToggle('#_pgresql_not_installed_screen_','#_pgresql_loader_screen_');
    });

}
function handleButtons(elem, icon_fa, type) {
    let icon = $(elem).find('.fa');
    if (type == undefined) {
        $(elem).addClass('disabled');
        $(elem).prop('disabled', true);
        icon.removeClass(icon_fa);
        icon.addClass('fa-spinner fa-spin');
    } else {
        icon.removeClass('fa-spinner fa-spin');
        icon.addClass(icon_fa);
        $(elem).removeClass('disabled');
        $(elem).prop('disabled', false);
    }
}
function savepgreForm(){
    let db_data = pgreGetDBData();
    if(db_data){
        $('.btn-cancel').prop('disabled', true);
        handleButtons('.btn-save-pgre-db', 'fa-floppy-o');
        function cleaner(){
            $('.btn-cancel').prop('disabled', false);
            handleButtons('.btn-save-pgre-db', 'fa-floppy-o', false);
        }
        sendSavepgresql(db_data, function(response){
            $.gritter.add({
                title: '{{lang.LABPGRE18}}',
                text: '{{lang.LABPGRE19}}',
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-quill-2',
                class_name: 'success-notice'
            });
            cleaner();
            updateDBTable(response);
            cancelForm();
        }, function(){
            cleaner();
        });
    }else{
        $.gritter.add({
            title: '{{lang.LABPGRE20}}',
            text: '{{lang.LABPGRE21}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
    }
}
function pgreGetDBData(){
    let valid = true;
    let user = $('#_pgre_sql_user_select_').val();
    if(user == ''){
        valid = false;
        $('.select2-container .select2-choice').addClass('error-field');
    }else{
        $('.select2-container .select2-choice').removeClass('error-field');
    }
    let db_name = $('#_pgre_sql_name_input_').val();
    if (/^[A-Za-z0-9\_\-]+$/.test(db_name) === false){
        valid = false;
        $('#_pgre_sql_name_input_').addClass('error-field');
    }else{
        $('#_pgre_sql_name_input_').removeClass('error-field');
    }
    
    return valid === true ? {
        'name': db_name,
        'user': user
    } : false;
}
function slideToggle(show, hide, callback) {
    $(hide).slideUp('fast', function () {
        if (typeof callback == 'function') {
            callback();
        }
        $(show).slideDown('fast');
    });
}
function ShowDeleteConfirmModal(elem, index){
    let db_name = $(elem).data('name')
    let db_user = $(elem).data('user')
    $('#_pgre_sql_deleting_index_').val(index);
    $('#_pgresql_database_to_remove_').text(db_name);
    $('#_pgre_delete_confirm_modal_').modal('show');
}
// function pgreDeletionConfirmed(){
//     $('#_pgre_delete_confirm_modal_').modal('hide');
//     let db_index = $('#_pgre_sql_deleting_index_').val();
//     let tr_deleting = $('#_pgre_sql_item_' + db_index);
//     tr_deleting.addClass('deleting_tr');
//     tr_deleting.find('.btn-primary').prop('disabled', true);
//     let btn_delete = tr_deleting.find('.btn-warning');
//     let db_data = {
//         name: btn_delete.data('name'),
//         user: btn_delete.data('user'),
//     }
//     console.log('db_data', db_data); 
//     handleButtons(btn_delete, 'fa-trash');
//     sendpgresqlDeletion(db_data, function(){
//         tr_deleting.slideUp('fast', function () {
//             pgre_sql_table.row(this).remove().draw();
//         });
//         database_list.splice(db_index, 1);
//         $.gritter.add({
//             title: '{{lang.LABPGRE18}}',
//             text: '{{lang.LABPGRE22}}',
//             time: 5500,
//             close_icon: '',
//             icon: 'icomoon-icon-quill-2',
//             class_name: 'success-notice'
//         });
//     }, function(){
//         tr_deleting.removeClass('deleting_tr');
//         tr_deleting.find('.btn-primary').prop('disabled', false);
//         handleButtons(btn_delete, 'fa-trash', true)
//     });

// }
function cancelForm(){
    slideToggle('#_pgre_sql_list_view_', '#_pgre_sql_form_view_', function(){
        $('#_pgre_sql_user_select_').val('');
        $('#_pgre_sql_user_select_').trigger('change');
        $('#_pgre_sql_name_input_').val('');
        $('.select2-container .select2-choice').removeClass('error-field');
        $('#_pgre_sql_name_input_').removeClass('error-field');
    });
}
function pgreAddDBForm(){
    slideToggle('#_pgre_sql_form_view_', '#_pgre_sql_list_view_');
}
function sendpgreInstallation(version, success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=postgresql_manager&acc=install_pgresql",
        data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPGRE20}}',
                    text: '{{lang.LABPGRE23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPGRE23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPGRE20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendSavepgresql(db_data, success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=postgresql_manager&acc=save_pgre_sql",
        data: 'name=' + db_data.name + '&user=' + db_data.user,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPGRE20}}',
                    text: '{{lang.LABPGRE23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPGRE23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPGRE24}}';
                    } else if (resp_data.code == 2) {
                        message_error = '{{lang.LABPGRE25}}';
                    } else if (resp_data.code == 3) {
                        message_error = '{{lang.LABPGRE26}}';
                    } else if (resp_data.code == 4) {
                        message_error = '{{lang.LABPGRE27}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPGRE20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendpgresqlDeletion(db_data, success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=postgresql_manager&acc=delete_pgre_sql",
        data: 'name=' + db_data.name,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPGRE20}}',
                    text: '{{lang.LABPGRE23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPGRE23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 3) {
                        message_error = '{{lang.LABPGRE28}}';
                    } else if (resp_data.code == 2) {
                        message_error = '{{lang.LABPGRE29}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPGRE20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendpgresqlConfigurations(user_config, success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=postgresql_manager&acc=save_usr_config",
        data: 'user_config=' + user_config,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPGRE20}}',
                    text: '{{lang.LABPGRE23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPGRE23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABPGRE28}}';
                    } else if (resp_data.code == 1) {
                        message_error = 'Invalid data';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPGRE20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendpgresqlUninstallation(success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=postgresql_manager&acc=uninstall_pgresql",
        data: 'user_config=' + user_config,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPGRE20}}',
                    text: '{{lang.LABPGRE23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABPGRE23}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABPGRE28}}';
                    } else if (resp_data.code == 1) {
                        message_error = 'Invalid data';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABPGRE20}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
{% include 'js/pgre_database_list.js' %}
{% include 'js/users_list.js' %}
{% include 'js/pgresql_status.js' %}
{% include 'js/pgre_settings.js' %}
{% include 'js/pgre_base64.js' %}