function pgresqlStatusStart(){
    // let visible_elem = $('#_pgresql_main_col .panel-default:visible').first();
    // console.log('#_pgresql_status_panel_', '#_not_running_screen_panel_');
    $('#_pgresql_status_loader_title_').text('{{lang.LABPGRE90}}');
    slideToggle('.pgresql-status-panel', '.pgresql-tabs-container-main');
    handleButtons('.on-not-running', 'fa-play');
    sendpgresqlUStatusHandler('start', function(response){
        database_list = response.database_list;
        users_db_list = response.pgre_user_list;
        pgresqlList();
        renderUsersList();
        slideToggle('.pgresql-tabs-container-main', '.pgresql-status-panel', function(){
            $('.running-screen-twice').show();
            $('.not-running-screen').hide();
        });
        $('.on-not-running').fadeOut('fast', function(){
            $('.on-running').fadeIn('fast');
            handleButtons('.on-not-running', 'fa-play', true);
        });
        $.gritter.add({
            title: '{{lang.LABPGRE18}}',
            text: '{{lang.LABPGRE118}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        $('#_pgresql_status_holder').text(statusTranslator('running'));
    }, function(){
        slideToggle('.pgresql-tabs-container-main', '.pgresql-status-panel');
        handleButtons('.on-not-running', 'fa-play', true);
        $.gritter.add({
            title: '{{lang.LABPGRE20}}',
            text: '{{lang.LABPGRE117}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
    });

}
function pgresqlStatusStop(){
    // let visible_elem = $('#_pgresql_main_col .panel-default:visible').first();
    // console.log('#_pgresql_status_panel_', '#_not_running_screen_panel_');
    $('#_pgresql_status_loader_title_').text('{{lang.LABPGRE119}}');
    slideToggle('.pgresql-status-panel', '.pgresql-tabs-container-main');
    function handleBtns(st){
        handleButtons('#_btn_stop_sidebar_', 'fa-stop', st);
        handleButtons('#_btn_restart_sidebar_', 'fa-refresh', st);
    }
    handleBtns();
    sendpgresqlUStatusHandler('stop', function(response){
        slideToggle('.pgresql-tabs-container-main', '.pgresql-status-panel', function(){
            $('.running-screen-twice').hide();
            $('.not-running-screen').show();
        });
        $('.on-running').fadeOut('fast', function () {
            $('.on-not-running').fadeIn('fast');
            handleBtns(false);
        });
        $.gritter.add({
            title: '{{lang.LABPGRE18}}',
            text: '{{lang.LABPGRE120}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        $('#_pgresql_status_holder').text(statusTranslator('stopped'));
    }, function(){
        slideToggle('.pgresql-tabs-container-main', '.pgresql-status-panel');
        handleBtns(false);
    });

}
function pgresqlStatusRestart(){
    // let visible_elem = $('#_pgresql_main_col .panel-default:visible').first();
    // console.log('#_pgresql_status_panel_', '#_not_running_screen_panel_');
    $('#_pgresql_status_loader_title_').text('{{lang.LABPGRE119}}');
    slideToggle('.pgresql-status-panel', '.pgresql-tabs-container-main');
    function handleBtns(st){
        handleButtons('#_btn_stop_sidebar_', 'fa-stop', st);
        handleButtons('#_btn_restart_sidebar_', 'fa-refresh', st);
    }
    handleBtns();
    sendpgresqlUStatusHandler('restart', function(response){
        database_list = response.database_list;
        users_db_list = response.pgre_user_list;
        pgresqlList();
        renderUsersList();
        slideToggle('.pgresql-tabs-container-main', '.pgresql-status-panel');
        handleBtns(false);
        $.gritter.add({
            title: '{{lang.LABPGRE18}}',
            text: '{{lang.LABPGRE121}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        $('#_pgresql_status_holder').text(statusTranslator('running'));
    }, function(){
        $('.on-running').fadeOut('fast', function () {
            $('.on-not-running').fadeIn('fast');
            handleBtns(false);
        });
        slideToggle('.not-running-screen-panel', '.pgresql-status-panel', function(){
            $('.running-screen-twice').hide();
            $('.not-running-screen').show();
        });
        handleBtns(false);
        $.gritter.add({
            title: '{{lang.LABPGRE20}}',
            text: '{{lang.LABPGRE117}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
        $('#_pgresql_status_holder').text(statusTranslator('stopped'));
    });

}
function sendpgresqlUStatusHandler(type, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=postgresql_manager&acc=status_handler",
        data: 'type=' + type,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABPGRE20}}',
                    text: '{{lang.LABPGRE23}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('status') && resp_data.status === 'success') {
                success(resp_data);
            } else {
                // let message_error = '{{lang.LABPGRE23}}';
                if (!resp_data.hasOwnProperty('code')) {
                    // if (resp_data.code == 2) {
                    //     message_error = '{{lang.LABPGRE28}}';
                    // } else if (resp_data.code == 1) {
                    //     message_error = 'Invalid data';
                    // }
                    $.gritter.add({
                        title: '{{lang.LABPGRE20}}',
                        text: '{{lang.LABPGRE23}}',
                        time: 3500,
                        close_icon: '',
                        icon: 'icomoon-icon-power',
                        class_name: 'error-notice'
                    });
                }
                cleaner();
            }
        }
    });
}