let python_apps_table = null;
function appStatusrenderer(status){
    return (status != 'running' ? '<i class="fa fa-circle text-danger" aria-hidden="true"></i>' : '<i class="fa fa-circle text-success" aria-hidden="true"></i>') + ' ' + appStatusTranslator(status);
}
function listPythonApps(){
    if(apps_map.length > 0){
        let table_body = ''
        apps_map.forEach(function(app){
            let status_app_circle = appStatusrenderer(app.status);
            table_body += '<tr data-app=\'' + JSON.stringify(app) + '\' id="_tr_app_' + app.app_key + '">' +
                                '<td>' + app.name + '</td>' +
                                '<td>' + app.domain + '</td>' +
                                '<td>' + app.user + '</td>' +
                                '<td>' + app.python + '</td>' +
                                '<td class="app-status-container" data-status="' + app.status + '">' + status_app_circle + '</td>' +
                                '<td>' +
                                    '<div class="table-actions-container">' +
                                        '<button data-toggle="tooltip" onclick="editApplication(this)" title="Edit application" data-placement="top" class="btn btn-xs btn-primary"><i class="fa fa-cogs"></i></button>' +
                                        '<button data-toggle="tooltip" title="Start application." ' + (app.status == 'running' ? 'style="display:none;"' : '') + ' data-placement="top" onclick="handleAppStatus(this, \'' + app.app_key + '\', \'start\')" class="btn btn-xs btn-success btn-status btn-status-on-stopped"><i class="fa fa-play"></i></button>' +
                                        '<button data-toggle="tooltip" title="Stop application." ' + (app.status == 'running' ? '' : 'style="display:none;"') + ' data-placement="top" onclick="handleAppStatus(this, \'' + app.app_key + '\', \'stop\')" class="btn btn-xs btn-danger btn-status btn-status-on-running"><i class="fa fa-stop"></i></button>' +
                                        '<button data-toggle="tooltip" title="Restart application." ' + (app.status == 'running' ? '' : 'style="display:none;"') + ' data-placement="top" onclick="handleAppStatus(this, \'' + app.app_key + '\', \'restart\')" class="btn btn-xs btn-default btn-status btn-status-on-running"><i class="fa fa-refresh"></i></button>' +
                                        '<button data-toggle="tooltip" title="Delete application." data-placement="top" class="btn btn-xs btn-warning" onclick="pythonAppDelete(this)"><i class="fa fa-trash"></i></button>' +
                                    '</div>' +
                                    //'<button data-toggle="tooltip" data-placement="top" class="btn btn-xs"></button>' +
                                '</td>' +
                            '</tr>';
        });
        $('#_python_apps_table_container_').html('<table class="table python_apps_table table-striped table-bordered table-hover">' +
                                                    '<thead>' +
                                                        '<tr role="row">' +
                                                            '<th>Name</th>' +
                                                            '<th style="width:250px;">Domain</th>' +
                                                            '<th style="width:100px;">User</th>' +
                                                            '<th style="width:80px;">Python</th>' +
                                                            '<th style="width:120px;">Status</th>' +
                                                            '<th style="width:110px;">Action</th>' +
                                                        '</tr>' +
                                                    '</thead>' +
                                                    '<tbody id="contenttr">' +
                                                        table_body +
                                                    '</tbody>' +
                                                '</table>');
        python_apps_table = $('.python_apps_table').DataTable({
            "autoWidth": false,
            /*columnDefs: [
                { orderable: false, targets: 0 }
            ],
            "dom": "<'row'<'col-sm-2'l><'#filter_versions_container.col-sm-6'><'col-sm-4'f>>" +
                "<'row'<'col-sm-12'tr>>" +
                "<'row'<'col-sm-12'p>>",
            order: [[0  , 'asc']],
            "pageLength": 25,*/
        });
        $('[data-toggle="tooltip"]').tooltip(); 
    } 
}
function changeAppStatusRendered(app_key, status){
    $('#_tr_app_' + app_key).find('.app-status-container').data('status', status).html(appStatusrenderer(status));
}
function pythonAppDelete(elem){
    let tr_deleting = $(elem).closest('tr');
    let app_data = tr_deleting.data('app');
    $('#_modal_app_remove_title_').text(app_data.name);
    $('#_btn_remove_python_app_').unbind('click').click(function(){
        tr_deleting.addClass('deleting_tr');
        handleButtons(elem, 'fa-trash');
        tr_deleting.find('.btn').prop('disabled', true);
        $('#_modal_python_app_confirm_remove_').modal('hide');
        sendAppRemove(app_data.app_key, function(){
            tr_deleting.slideUp('fast', function () {
                python_apps_table.row(this).remove().draw();
            });
            $.gritter.add({
                title: 'Success.',
                text: 'Application was removed.',
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-quill-2',
                class_name: 'success-notice'
            });
        }, function(){

        });
    });
    $('#_modal_python_app_confirm_remove_').modal('show');
}
function handleAppStatus(elem, app_key, action){
    let div_actions = $(elem).closest('.table-actions-container');
    div_actions.find('.btn-status').prop('disabled', true);
    let btn_ico = 'fa-play';
    let action_name = 'started';
    if(action == 'stop'){
        btn_ico = 'fa-stop';
        action_name = 'stopped';
    }else if(action == 'restart'){
        btn_ico = 'fa-refresh';
        action_name = 'restarted';
    }
    handleButtons(elem, btn_ico);
    sendAppStatusChange(app_key, action, function(response){
        if(((action == 'start' || action == 'restart') && response.status != 'running') || (action == 'stop' && response.status == 'running')){
            $.gritter.add({
                title: 'Error',
                text: 'Application can not be ' + action_name,
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'error-notice'
            });
            if(action == 'restart'){
               $('.btn-status-on-running').fadeOut('fast', function(){
                    $('.btn-status-on-stopped').fadeIn('fast');
                });
                changeAppStatusRendered(app_key, response.status);
            }
            div_actions.find('.btn-status').prop('disabled', false);
            handleButtons(elem, btn_ico, true);
        }else{
            $.gritter.add({
                title: 'Success.',
                text: 'Application was ' + action_name,
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-quill-2',
                class_name: 'success-notice'
            });
            div_actions.find('.btn-status').prop('disabled', false);
            handleButtons(elem, btn_ico, true);
            if(action != 'restart'){
                let show_btns = '.btn-status-on-stopped';
                let hide_btns = '.btn-status-on-running';
                if(action == 'start'){
                    show_btns = '.btn-status-on-running';
                    hide_btns = '.btn-status-on-stopped';
                }
                changeAppStatusRendered(app_key, response.status);
                div_actions.find(hide_btns).fadeOut('fast', function(){
                    div_actions.find(show_btns).fadeIn('fast');
                });
            }
        }
    }, function(){
        div_actions.find('.btn-status').prop('disabled', false);
        handleButtons(elem, btn_ico, true);
    });
}
function editApplication(elem){
    let app_data = $(elem).closest('tr').data('app');
    $('#_python_apps_form_wrapper_').hide();
    $('#_python_apps_form_loader_').show();
    $('#_python_apps_form_title_').text('Editing application.')
    $('#_python_apps_tab_table_wrapper_').fadeOut('fast', function(){
        $('#_python_apps_form_container_').fadeIn('fast');
        getAppInfo(app_data.app_key, function(response){
            renderAppEditor(response.app_data)
        }, function(){
            $('#_python_apps_form_container_').fadeOut('fast', function(){
                $('#_python_apps_tab_table_wrapper_').fadeIn('fast');
            });
        });
    });
}
function startStatusListener(){
    setTimeout(function(){
        checkAppsStatus(function(response){
            renderAppStatusChecker(response.apps_status);
            startStatusListener();
        }, function(){

        });
    }, 3500)
}
function renderAppStatusChecker(apps_status){
    apps_status.forEach(function(app_info){
        if($('#_tr_app_' + app_info.app_key).find('.app-status-container').data('status') != app_info.status){
            let show_btns = '.btn-status-on-stopped';
            let hide_btns = '.btn-status-on-running';
            if(app_info.status == 'running'){
                show_btns = '.btn-status-on-running';
                hide_btns = '.btn-status-on-stopped';
            }
            changeAppStatusRendered(app_info.app_key, app_info.status);
            let div_actions = $('#_tr_app_' + app_info.app_key).find('.table-actions-container');
            div_actions.find(hide_btns).fadeOut('fast', function(){
                div_actions.find(show_btns).fadeIn('fast');
            });
        }
    });
}
function renderAppEditor(app_data){
    //console.log(app_data);
    $('#_python_apps_form_python_select_').val(app_data.python);
    $('#_python_apps_form_users_select_').val(app_data.user).trigger('change');
    $('#_python_app_name_').val(app_data.name);
    $('#_python_app_entry_point_').val(app_data.entry);
    $('#_python_apps_form_loader_').fadeOut('fast', function(){
        $('#_python_apps_form_wrapper_').fadeIn('fast');
    });
}
function appStatusTranslator(status){
    return status != 'running' ? 'stopped' : 'running';
}
function showAppForm(){
    $('#_python_apps_form_title_').text('Adding new application.');
    $('#_python_apps_tab_table_wrapper_').fadeOut('fast', function(){
        $('#_python_apps_form_container_').fadeIn('fast');
    });
}
function cancelAppForm(){
    $('#_python_apps_form_container_').fadeOut('fast', function(){
        $('#_python_apps_tab_table_wrapper_').fadeIn('fast');
        $('#_python_apps_form_python_select_').val('');
        $('#_python_app_name_').val('');
        $('#_python_app_entry_point_').val('');
        $('#_python_apps_form_users_select_').val('').trigger('change');
    });
}