let apps_map = JSON.parse('{{mod_vars.apps_map|json_encode()|raw}}');
let user_list = JSON.parse('{{mod_vars.user_list|json_encode()|raw}}');
let python_versions = JSON.parse('{{mod_vars.python_versions|json_encode()|raw}}');
let available_to_install = JSON.parse('{{mod_vars.available_to_install|json_encode()|raw}}');
let python_installed = {{(mod_vars.python_installed == true ? 'true' : 'false')}};
let python_installing = {{(mod_vars.python_installing == true ? 'true' : 'false')}};
const LOADER_HTML = '<div class="action-loader">' +
                        '<span><i class="fa fa-circle-o-notch fa-spin"></i></span>' +
                        '<h5 id="">{{lang.LABPHPSEL39}}...</h5>' +
                    '</div>';

function openFileExplorerSelector(){
    $('#_modal_python_file_selector_').modal('show');
}
function shownInstallationConfirm(){
    $('#_modal_python_install_confirm_').modal('show');
}
function initialRender(){
    listPythonApps();
    startStatusListener();
    renderUsersSelector();
    renderInstalledVersions()
}
function renderUsersSelector(){
    let select_html = '<option value="">Select an user</option>';
    
    user_list.forEach(function(user){
        select_html += '<option value="' + user + '">' + user + '</option>';
    })
    select_html = '<select class="form-control" id="_python_apps_form_users_select_">' +
                        select_html +
                    '</select>';
    $('#_python_apps_form_users_container_').html(select_html);
    $("#_python_apps_form_users_select_").select2({
        placeholder: "Select a user.",
        allowClear: true
    });
}
function checkManagerInstallStatus(){
    setTimeout(function(){
        getManagerInstallStatus(function(response){
            if(response.status == 'running'){
                checkManagerInstallStatus();
            }else{
                $.gritter.add({
                    title: 'Success.',
                    text: 'CWP Python manager installation ended.',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-quill-2',
                    class_name: 'success-notice'
                });
                onManagerInstalled();
            }
        }, function(){
            checkManagerInstallStatus();
        });
    }, 3000)
}
function onManagerInstalled(){
    initialRender();
    $('#_python_manager_not_installed_container_').fadeOut('fast', function(){
        $('#_python_manager_dashboard_container_').fadeIn();
    });
}
function installationConfirmed(elem){
    handleButtons(elem, 'fa-check');
    $('#_cancel_modal_installation_').prop('disabled', true);
    function resetButtons(){
        handleButtons(elem, 'fa-check', true);
        $('#_cancel_modal_installation_').prop('disabled', false);
    }
    sendStartManagerInstallation(function(){
        $('#_modal_python_install_confirm_').modal('hide');
        $('#_python_manager_installer_screen_').fadeOut('fast', function(){
            $('#_python_manager_installing_screen_').fadeIn('fast');
        });
        resetButtons();
        checkManagerInstallStatus();
    }, function(){
        resetButtons();
    });
}
function handleButtons(elem, icon_fa, type) {
    let icon = $(elem).find('.fa');
    if (type == undefined) {
        $(elem).addClass('disabled');
        $(elem).prop('disabled', true);
        icon.removeClass(icon_fa);
        icon.addClass('fa-spinner fa-spin');
    } else {
        icon.removeClass('fa-spinner fa-spin');
        icon.addClass(icon_fa);
        $(elem).removeClass('disabled');
        $(elem).prop('disabled', false);
    }
}
$(document).ready(function () {
    if(python_installed === true){
        initialRender();
    }else if(python_installing === true){
        checkManagerInstallStatus();
    }
    
});
{% include 'js/python_manager_services.js' %}
{% include 'js/python_versions.js' %}
{% include 'js/python_apps.js' %}