function sendAppRemove(app_key, success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=python_manager&acc=app_remove",
        data: 'app_key=' + app_key,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: 'Error',
                    text: 'Unknown error ocurred.',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = 'Unknown error ocurred';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: 'Error',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function checkAppsStatus(){
    
}
function getAppInfo(app_key, success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=python_manager&acc=get_app_data",
        data: 'app_key=' + app_key,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: 'Error',
                    text: 'Unknown error ocurred.',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = 'Unknown error ocurred';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: 'Error',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendAppStatusChange(app_key, action, success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=python_manager&acc=change_app_status",
        data: 'app_key=' + app_key + '&action='+ action,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: 'Error',
                    text: 'Unknown error ocurred.',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = 'Unknown error ocurred';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: 'Errordddd',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendversionToRemove(version,success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=python_manager&acc=uninstall_python_version",
        data: 'versions=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: 'Error',
                    text: 'Unknown error ocurred.',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = 'Unknown error ocurred';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: 'Error',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendversionsToInstall(versions,success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=python_manager&acc=start_manager_install",
        data: 'versions=' + versions,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: 'Error',
                    text: 'Unknown error ocurred.',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = 'Unknown error ocurred';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: 'Error',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function getVersionsInstallerLog(success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=python_manager&acc=get_version_installer_log",
        //data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: 'Error',
                    text: 'Unknown error ocurred.',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = 'Unknown error ocurred';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: 'Error',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendStartManagerInstallation(success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=python_manager&acc=start_python_version_install",
        //data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: 'Error',
                    text: 'Unknown error ocurred.',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = 'Unknown error ocurred';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = '{{lang.LABPHPSEL79}}';
                    }
                }
                $.gritter.add({
                    title: 'Error',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function getManagerInstallStatus(success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=python_manager&acc=manager_install_status",
        //data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                cleaner();
            }
        }
    });
}
function getVersionInstallerStatus(success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=python_manager&acc=version_install_status",
        //data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                cleaner();
            }
        }
    });
}
function checkAppsStatus(success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=python_manager&acc=check_apps_status",
        //data: 'version=' + version,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                cleaner();
            }
        }
    });
}