let table_versions = null;
function renderInstalledVersions(){
    let select_html = '';
    let table_html = '';
    python_versions.forEach(function(ver){
        select_html += '<option value="' + ver.version + '">' + ver.version + '</option>';
        table_html += '<tr>' + 
                            '<td>' + ver.version + '</td>' + 
                            '<td>' +
                                '<div class="versions-actions">' +
                                    '<button class="btn btn-primary btn-xs" data-path="' + ver.path + '" onclick="copyVersionPath(this)"><i class="fa fa-copy"></i> Copy path</button>' + 
                                    '<button class="btn btn-warning btn-xs" data-version="' + ver.version + '" onclick="confirmPythonVersionUninstall(this)"><i class="fa fa-trash"></i> Uninstall</button>' + 
                                '</div>' + 
                            '</td>' + 
                        '</tr>';
    });
    $('#_python_versions_table_wrapper_').html('<table class="table python_versions_table table-striped table-bordered table-hover">' +
                                                    '<thead>' +
                                                        '<tr role="row">' +
                                                            '<th>Name</th>' +
                                                            '<th style="width:180px;">Actions</th>' +
                                                        '</tr>' +
                                                    '</thead>' +
                                                    '<tbody id="contenttr">' +
                                                        table_html +
                                                    '</tbody>' +
                                                '</table><input type="text" class="popover-copy-path-input" id="popover_copy_path_input">');
    table_versions = $('.python_versions_table').DataTable({
        "autoWidth": false,
    });
    $('[data-toggle="tooltip"]').tooltip(); 
    select_html = '<select class="form-control" id="_python_apps_form_python_select_">' +
                        '<option value="">Select version</option>' + 
                        select_html +
                    '</select>';
    $('#_python_apps_form_pythonver_container_').html(select_html);
}
function markUnmarkAllVersions(elem){
    let check_status = false;
    let check_title = 'Check all versions.';
    if($(elem).is(':checked')){
        check_status = true;
        check_title = 'Uncheck all versions.'
    }
    $('.python-ver-toinstall').prop('checked', check_status);
    $('#_check_all_versions_label_').html('<b>' + check_title + '</b>');
    checkIfMArkedToInstall();
}
function copyVersionPath(elem){
    let path = $(elem).data('path');
    $('#popover_copy_path_input').val(path);
    let hiddenPut = document.getElementById('popover_copy_path_input');
    hiddenPut.select();
    document.execCommand('copy');
    $.gritter.add({
        title: 'Success!',
        text: 'Python version path copied,',
        time: 3500,
        close_icon: '',
        icon: 'icomoon-icon-quill-2',
        class_name: 'success-notice'
    });
}
function installSelectedPythonVersions(elem){
    handleButtons(elem, 'fa-download');
    $('#_btn_cancel_install_pythons_versions_').prop('disabled', true);
    function resetButtons(){
        handleButtons(elem, 'fa-download', true);
        $('#_btn_cancel_install_pythons_versions_').prop('disabled', false);
    }
    sendversionsToInstall('sjsjsjsjs', function(){
        $.gritter.add({
            title: 'Success.',
            text: 'Versions installation started.',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
        versionInstallerStarted();
        $('#_modal_python_versions_installer_').modal('hide');
        resetButtons();
    }, function(){
        resetButtons();
    });
}
function versionInstallerStarted(){
    $('#_btn_display_python_ver_installer_').fadeOut('fast', function(){
        $('.installingver-loader-wrapper').fadeIn('fast')
    });
    checkVersionInstallerStatus();
}
let compiling_log_lines = [];
let compiling_log_timeout = null;
function compilingLogHandler(response) {
    function addLineToLog() {
        if (compiling_log_lines.length > 0) {
            let log_container = '#_modal_version_installer_log_container_';
            if (compiling_log_lines.length > 1000){
                $(log_container).append('<p>' + compiling_log_lines.slice(0, 1000).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 1000);
            } else if (compiling_log_lines.length > 500){
                $(log_container).append('<p>' + compiling_log_lines.slice(0, 500).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 500);
            } else if (compiling_log_lines.length > 400) {
                $(log_container).append('<p>' + compiling_log_lines.slice(0, 400).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 400);
            } else if (compiling_log_lines.length > 300) {
                $(log_container).append('<p>' + compiling_log_lines.slice(0, 300).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 300);
            } else if (compiling_log_lines.length > 200) {
                $(log_container).append('<p>' + compiling_log_lines.slice(0, 200).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 200);
            } else if (compiling_log_lines.length > 100) {
                $(log_container).append('<p>' + compiling_log_lines.slice(0, 100).join('</p><p>') + '</p>');
                compiling_log_lines.splice(0, 100);
            } else {
                $(log_container).append('<p>' + compiling_log_lines[0] + '</p>');
                compiling_log_lines.shift();
            }
            $(log_container + " p").last().attr("tabindex", -1).focus();
            let time_interval = 10;
            setTimeout(function () {
                addLineToLog();
            }, time_interval)
        } else {
            compiling_log_timeout = null;
        }
    }
    compiling_log_lines = compiling_log_lines.concat(response.lines);

    if (compiling_log_timeout === null) {
        addLineToLog()
    }
}
function confirmPythonVersionUninstall(elem){
    let version = $(elem).data('version');
    $('#_version_touninstall_title_').text(version);
    $('#_btn_uninstall_python_version_').unbind('click').click(function(){
        $('#_modal_python_versions_confirm_uninstall_').modal('hide');
        handleButtons(elem, 'fa-trash');
        let tr_deleting = $(elem).closest('tr');
        tr_deleting.addClass('deleting_tr');
        $(elem).closest('.versions-actions').find('.btn').prop('disabled', true);
        sendversionToRemove(version, function(){
            $.gritter.add({
                title: 'Success.',
                text: 'Python version uninstalled.',
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-quill-2',
                class_name: 'success-notice'
            });
            tr_deleting.slideUp('fast', function () {
                table_versions.row(this).remove().draw();
            });
            //console.log(python_versions);
            python_versions  = python_versions.filter(function(ver){
                return ver.version != version
            });
            available_to_install.push(version);
            //console.log(python_versions);
        }, function(){
            
        });
    });
    $('#_modal_python_versions_confirm_uninstall_').modal('show');
}
function checkVersionInstallerStatus(){
    setTimeout(function(){
        getVersionInstallerStatus(function(response){
            compilingLogHandler(response);
            if(response.status == 'running'){
                checkVersionInstallerStatus();
            }else{
                onVersionInstallerEnded(response);
            }
        });
    }, 2500)
}
function onVersionInstallerEnded(response){
    $.gritter.add({
        title: 'Success.',
        text: 'Python versions installer ended.',
        time: 3500,
        close_icon: '',
        icon: 'icomoon-icon-quill-2',
        class_name: 'success-notice'
    });
    python_versions = response.installed_versions;
    $('.installingver-loader-wrapper').fadeOut('fast', function(){
        $('#_btn_display_python_ver_installer_').fadeIn('fast')
    });
    renderInstalledVersions();
}
function checkIfMArkedToInstall(){
    $('#_btn_install_pythons_selected_').prop('disabled', !($('.python-ver-toinstall:checked').length > 0));
}
function viewVersionInstallerLog(){
    /*$('#_modal_python_versions_installer_log_ .modal-body').html(LOADER_HTML);
    getVersionsInstallerLog(function(response){
        console.log(response);
        $('#_modal_python_versions_installer_log_ .modal-body').append('<div id="_modal_version_installer_log_container_"></div>');
        $('#_modal_python_versions_installer_log_ .action-loader').fadeOut('fast', function(){
            $('#_modal_version_installer_log_container_').fadeIn('fast');
        }); 
    }, function(){
        $('#_modal_python_versions_installer_log_').modal('hide');
    });*/
    $('#_modal_python_versions_installer_log_').modal('show');
}
function shownVersionInstallModal(){
    let html_versions = '';
    available_to_install.forEach(function(version, index){
        html_versions += '<li>' +
                            '<div class="checkbox-custom">' +
                                '<input class="python-ver-toinstall" onchange="checkIfMArkedToInstall()" type="checkbox" id="_ver_toinstall_' + (index + 1) + '" value="' + version + '">' +
                                '<label for="_ver_toinstall_' + (index + 1) + '">' +
                                'Version <b>' + version + '</b>' +
                                '</label>' +
                            '</div>' +
                        '</li>';
    });
    html_versions = '<h5 class="versions-installer-header">Select versions to install</h5>' +
                    '<div class="checkbox-custom check-all-versions">' +
                        '<input class="python-ver-toinstall" onchange="markUnmarkAllVersions(this)" type="checkbox" id="_ver_toinstall_all">' +
                        '<label id="_check_all_versions_label_" for="_ver_toinstall_all">' +
                            '<b>Check all versions.</b>' +
                        '</label>' +
                    '</div>' + 
                    '<ul class="python-versions-list-ul">' + 
                        html_versions +
                    '</ul>'
    $('#_modal_python_versions_installer_ .modal-body').html(html_versions);
    $('#_modal_python_versions_installer_').modal('show');
}