let app_list = null;
let current_editing_context = null;
function checkTomcatAppsList(){
    if(app_list === null){
        loadTomCatAppList(function(){
            renderTomCatAppList();
            $('#_tomcat_apps_list_loader').fadeOut('fast', function(){
                $('#_tomcat_apps_list_wrapper').fadeIn('fast');
            });
            setTimeout(function () {
                listenForStatusChanges();
            }, 5000);
        });
    }else{
        listenForStatusChanges();
    }
}
function listenForStatusChanges(){
    requestStatusChanges(function(status_list){
        appUpdateStatusList(status_list);
        if ($('#tomcat_apps_tab').is(':visible')){
            setTimeout(function () {
                listenForStatusChanges();
            }, 20000);
        }
    });
}
function appUpdateStatusList(status_list){
    status_list.forEach(function(app){
        updateStatusAppTr(app.key, app.status);
    });
}
function appEditingContextChange(elem){
    let title = '{{lang.LABTOMCAT157}}';
    let input_disabled = true;
    let input_elem = $('#_tomcat_app_context_path_');
    if (input_elem.prop('disabled') === true){
        title = '{{lang.LABTOMCAT158}}';
        input_disabled = false;
    }else{
        input_elem.val(current_editing_context);
    }
    input_elem.prop('disabled', input_disabled);
    $('#_tomcat_edit_app_change_context_ span').text(title);
}
function cancelFormTomCatApp(){
    slideToggle('#_tomcat_apps_list_container', '#_tomcat_apps_newform_window', function(){
        $('#_tomcat_app_domain_container_').html(HTML_DOMAIN_SELECTOR);
        $('#_tomcat_app_user_owner_').select2('val', '');
        $('#_tomcat_apps_newform_wrapper .error-field').removeClass('error-field');
        $('#_tomcat_app_context_path_').val('');
        current_editing_context = null;
        $('#_tomcat_app_context_path_').prop('disabled', false);
        $('.tomcat-deploy-type input').prop('disabled', false); 
        $('#_tomcat_app_deploy_type_').prop('disabled', false); 
        //$('#_tomcat_app_confg_file_').val('');
        $('#tomcat_deploy_type_xml .file-path-selector').data('pathfile','');
        $('#tomcat_deploy_type_xml .file-path-selector').data('pathdir','');
        $('#tomcat_deploy_type_xml .file-path-selector').find('.path-selected').text('{{lang.LABTOMCAT219}}');
        $('#tomcat_deploy_type_war .file-path-selector').data('pathfile','');
        $('#tomcat_deploy_type_war .file-path-selector').data('pathdir','');
        $('#tomcat_deploy_type_war .file-path-selector').find('.path-selected').text('{{lang.LABTOMCAT219}}');
        $('#_tomcat_app_desc_name').val('');
        $('#_tomcat_app_war_path_').val('');
        $('#_tomcat_app_war_file_').val('');
        $('#_tomcat_app_deploy_type_').val('upload_file');
        $('#_tomcat_apps_loader').hide();
        $('.item-hide-on-edit').show();
        $('.hide-deploy-type').hide();
        $('#tomcat_app_quick_actions_container').hide();
        $('#_tomcat_edit_app_change_context_').hide();
    });
}
function changedDeploymentType(elem, val){
    let to_show = '#tomcat_deploy_type_upload';
    let deploy_type = $(elem).val();
    if(deploy_type == 'xml_configuration'){
        to_show = '#tomcat_deploy_type_xml';
    }else if(deploy_type == 'war_local_file'){
        to_show = '#tomcat_deploy_type_war';
    }
    $('.tomcat-deploy-type').removeClass('error-field');
    $('.tomcat-deploy-type:visible').slideUp('fast', function(){
        $(to_show).find('input').val(val !== undefined ? val : '')
        $(to_show).slideDown('fast');
    });

}
function saveNewTomCatApp(){
    let valid = true;
    let type_val = $('#_tomcat_app_form_type').val();
    //$('#_tomcat_apps_newform_wrapper .required-data:not(.select2-container)').each(function(){
    $('#_tomcat_apps_newform_wrapper .required-data').each(function(){
        let err_placement = $(this).data('error-place') !== undefined ? $(this).data('error-place') : this;
        if($(this).val() == ''){
            $(err_placement).addClass('error-field');
            if (valid === true){
                $(this).focus();
                valid = false;
            }
        }else{
            $(err_placement).removeClass('error-field');
        }
    });
    let deploy_type = $('#_tomcat_app_deploy_type_').val();
    let selector_input = deploy_type == 'upload_file' ? '.tomcat-deploy-type:visible input' : '.tomcat-deploy-type:visible .file-path-selector';
    let deploy_type_item = $(selector_input);
    let val_input = deploy_type == 'upload_file' ? deploy_type_item.val() : getFileExplorerValue('.tomcat-deploy-type:visible .file-path-selector');
    if (val_input == ''){
        deploy_type_item.addClass('error-field');
        if (valid === true) {
            deploy_type_item.focus();
            valid = false;
        }
    }else{
        deploy_type_item.removeClass('error-field');
    }
    if(!valid){
        $.gritter.add({
            title: '{{lang.LABTOMCAT92}}',
            text: '{{lang.LABTOMCAT93}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
    }else{
        let data_app = getAppDataFromForm();
        //let data_request = 'type=' + (type_val !== 'new' ? 'editing&key_id=' + type_val : 'new') + '&app=' + JSON.stringify(data_app);
        $('#_tomcat_apps_loader_title').text('{{lang.LABTOMCAT94}}...');
        var data_request = new FormData();
        data_request.append('deploy_type', deploy_type);
        if (deploy_type == 'upload_file'){
            data_request.append('war_file', $('#_tomcat_app_war_file_')[0].files[0]);
        }
        if (type_val !== 'new'){
            data_request.append('type', 'edit');
            data_request.append('key_to_edit', type_val);
        }else{
            data_request.append('type', 'new');
        }
        
        data_request.append('app', JSON.stringify(data_app));
        slideToggle('#_tomcat_apps_loader', '#_tomcat_apps_newform_window', function(){
            sendRequestSaveApp(data_request, function (resp_data) {
                app_list = resp_data.list;
                renderTomCatAppList();
                cancelFormTomCatApp();
            }, function () {
                slideToggle('#_tomcat_apps_newform_window', '#_tomcat_apps_loader');
            });
        });
    }
}
function isNumber(evt) {
    evt = (evt) ? evt : window.event;
    var charCode = (evt.which) ? evt.which : evt.keyCode;
    if (charCode > 31 && (charCode < 48 || charCode > 57)) {
        return false;
    }
    return true;
}
function getFileExplorerValue(elem){
    let file_explorer_elem = $(elem);
    return (file_explorer_elem.data('pathdir') !== undefined ? file_explorer_elem.data('pathdir') : '')  +
            (file_explorer_elem.data('pathfile') !== undefined ? file_explorer_elem.data('pathfile') : '');
}
function getAppDataFromForm(){
    let context_path = $('#_tomcat_app_context_path_').val();
    let url_elem = $('#_tomcat_app_domain_select_');
    return {
        type: 'tomcat',
        user: $("#_tomcat_app_user_owner_").val(),
        url: url_elem.length > 0 ? url_elem.val() : '',
        context: (context_path.charAt(0) != '/' ? '/' : '') + context_path,
        conf_file: getFileExplorerValue('#tomcat_deploy_type_xml .file-path-selector'),
        war_path: getFileExplorerValue('#tomcat_deploy_type_war .file-path-selector'),
    }
}
function addNewTomCatApp(){
    $('#_tomcat_form_title').text('{{lang.LABTOMCAT95}}');
    $('#_tomcat_app_form_type').val('new');
    slideToggle('#_tomcat_apps_newform_window', '#_tomcat_apps_list_container');
}
function editTomCatAppWindow(app_data, domain_list){
    $('#_tomcat_app_user_owner_').val(app_data.user); 
    $('#_tomcat_app_context_path_').val(app_data.context); 
    current_editing_context = app_data.context;
    $('.item-hide-on-edit').hide();
    $('#_tomcat_app_context_path_').prop('disabled', true); 
    changedDeploymentType('#_tomcat_app_deploy_type_', app_data.hasOwnProperty('deploy_type') && app_data.deploy_type != 'upload_file' ? app_data.deploy_file : '');
    $('#_tomcat_app_user_owner_').trigger('change');
    $('#_tomcat_edit_app_change_context_').show();
    renderDomainForApps(app_data.user, domain_list, app_data.url);
    $('#_tomcat_app_desc_name').val(app_data.name);
    if (app_data.status === 'running'){
        $('#tomcat_app_quick_actions_container').addClass('is-running');
    }
    $('#tomcat_app_quick_actions_container').data('cwpkey', app_data.cwp_key);
    $('#tomcat_app_quick_actions_container').data('name', app_data.name);
    $('#tomcat_app_quick_actions_container').data('tomcat_path', app_data.context);
    $('#tomcat_app_quick_actions_container').show();
    slideToggle('#_tomcat_apps_newform_window', '#_tomcat_apps_loader');
}
function editTomCatApp(app_key){
    $('#_tomcat_apps_loader_title').text('{{lang.LABTOMCAT98}}...');
    $('#_tomcat_app_form_type').val(app_key);
    slideToggle('#_tomcat_apps_loader', '#_tomcat_apps_list_container', function(){
        loadTomCatAppInfo(app_key, function (resp_data) {
            $('#_tomcat_form_title').text('{{lang.LABTOMCAT99}}');
            editTomCatAppWindow(resp_data.info, resp_data.user_domains);
        }, function () {
            slideToggle('#_tomcat_apps_list_container', '#_tomcat_apps_loader');
        });
    });
}
function confirmAppDeletion(elem, app_name){
    $('#confirm_app_delete_name').text(app_name)
    $('#_tomcat_app_confirm_del_btn').unbind('click').click(function(){
        let tr_delete = $(elem).closest('tr');
        tr_delete.addClass('deleting_tr');
        tr_delete.find('.btn').prop('disabled', true);
        function resetTR() {
            tr_delete.removeClass('deleting_tr');
            tr_delete.find('.btn').prop('disabled', false);
        }
        handleButtons(elem, 'fa-trash');
        $('#modal_app_delete_confirm').modal('hide');
        let context = $(elem).data('context');
        let cwpkey = $(elem).data('cwpkey');
        cwpkey = /^CWP_/.test(cwpkey) ? '' : cwpkey;
        sendDeleteApplication(context, cwpkey, function(){
            tr_delete.slideUp('fast', function () {
                apps_table.row(this).remove().draw();
            });
            resetTR();
        },function(){
            resetTR();
            handleButtons(elem, 'fa-trash', true);
        });
    });
    $('#modal_app_delete_confirm').modal('show');
}
function restartApplication(elem, index){
    handleButtons(elem, 'fa-refresh');
    let tr_app = $('#_tomcat_apps_item_' + index);
    tr_app.addClass('deleting_tr');
    function resetTR() {
        tr_app.removeClass('deleting_tr');
        tr_app.find('.btn').prop('disabled', false);
        handleButtons(elem, 'fa-refresh', true);
    }
    let app_key = tr_app.data('key');
    let tomcat_path = tr_app.data('path');
    handleAppStatus('restart&tomcat_path=' + tomcat_path + '&key=' + app_key, function (response){
        if(response.app_status != 'running'){
            $(elem).fadeOut('fast');
            let status_btn = $('#_tomcat_apps_status_btn_' + index)
            status_btn.removeClass('btn-success').addClass('btn-danger');
        }else{
            $.gritter.add({
                title: '{{lang.LABTOMCAT83}}',
                text: '{{lang.LABTOMCAT100}}',
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'success-notice'
            });
            updateStatusAppTr(app_key, response.app_status)
        }
        resetTR();
    }, function () {
        resetTR();
    });
}
function tomCatAppStatus(elem, index){
    let status = $(elem).data('status');
    let action = 'stop';
    let curr_ico = 'fa-stop';
    let next_ico = 'fa-play';
    let curr_btn = 'btn-success';
    let next_btn = 'btn-danger';
    let next_status = 'stoped';
    let next_title = '{{lang.LABTOMCAT101}}';
    let message = 'stoped';
    if (status !== 'running'){
        action = 'start';
        next_ico = 'fa-stop';
        curr_ico = 'fa-play';
        next_btn = 'btn-success';
        curr_btn = 'btn-danger';
        next_status = 'running';
        next_title = '{{lang.LABTOMCAT102}}';
        message = 'started'
    }
    let tr_app = $('#_tomcat_apps_item_' + index);
    tr_app.addClass('deleting_tr');
    tr_app.find('.btn').prop('disabled', true);
    function resetTR(){
        tr_app.removeClass('deleting_tr');
        tr_app.find('.btn').prop('disabled', false);
    }
    let app_key = tr_app.data('key');
    let tomcat_path = tr_app.data('path');
    handleButtons(elem, curr_ico);
    handleAppStatus(action + '&tomcat_path=' + tomcat_path + '&key=' + app_key, function(resp_data){
        if (action == 'stop' || (action == 'start' && resp_data.app_status === 'running')){
            $(elem).addClass(next_btn).removeClass(curr_btn);
            $(elem).data('status', next_status);
            $(elem).attr('title', next_title);
            $(elem).attr('data-original-title', next_title);
            updateStatusAppTr(app_key, resp_data.app_status);
            $.gritter.add({
                title: '{{lang.LABTOMCAT83}}',
                text: '{{lang.LABTOMCAT103}} ' + message + ' {{lang.LABTOMCAT104}}',
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'success-notice'
            });
            handleButtons(elem, next_ico, true);
        }else{
            $.gritter.add({
                title: '{{lang.LABTOMCAT82}}',
                text: '{{lang.LABTOMCAT105}}',
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'error-notice'
            });
            handleButtons(elem, curr_ico, true);
        }
        resetTR();
    }, function(){
        resetTR();
        handleButtons(elem, curr_ico, true);
    });
}
function tomCatAppStatusInForm(elem, type){
    // handleButtons(elem, curr_ico);
    let ico_btn = 'fa-play';
    let message = 'started';
    if (type == 'stop'){
        ico_btn = 'fa-stop'
        message = 'stopped'
    } else if (type == 'restart'){
        ico_btn = 'fa-refresh'
        message = 'restarted'
    }
    let tomcat_path = $('#tomcat_app_quick_actions_container').data('tomcat_path');
    let app_key = $('#tomcat_app_quick_actions_container').data('cpkey');
    handleButtons(elem, ico_btn);
    $('#tomcat_app_quick_actions_container .btn').prop('disabled', true);
    $('.tomcat-app-form-btn').prop('disabled', true);
    function resetButtons(){
        $('#tomcat_app_quick_actions_container .btn').prop('disabled', false);
        $('.tomcat-app-form-btn').prop('disabled', false);
        handleButtons(elem, ico_btn, true);
    }
    handleAppStatus(type + '&tomcat_path=' + tomcat_path + '&cwp_key=' + app_key, function(resp_data){
        if ((type == 'start' || type == 'restart') && resp_data.app_status === 'running'){
            $('#tomcat_app_quick_actions_container').addClass('is-running');
        }else if(type == 'stop'){
            $('#tomcat_app_quick_actions_container').removeClass('is-running');
        }else{
            $.gritter.add({
                title: '{{lang.LABTOMCAT82}}',
                text: '{{lang.LABTOMCAT105}}',
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'error-notice'
            });
            resetButtons();
            return;
        }
        $.gritter.add({
            title: '{{lang.LABTOMCAT83}}',
            text: '{{lang.LABTOMCAT103}} ' + message + ' {{lang.LABTOMCAT104}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'success-notice'
        });
        resetButtons();
        updateStatusAppTr(app_key, resp_data.app_status)
    }, function(){
        resetButtons();
    });
}
function updateStatusAppTr(appkey, status){
    let class_circle = 'text-success';
    let btn_class_new = 'btn-danger';
    let btn_class_old = 'btn-success';
    let btn_ico_new = 'fa-stop';
    let btn_ico_old= 'fa-play';
    let next_title = "{{lang.LABTOMCAT102}}";
    if(status != 'running'){
        class_circle = 'text-danger';
        btn_class_new = 'btn-success';
        btn_class_old = 'btn-danger';
        btn_ico_new = 'fa-play';
        btn_ico_old = 'fa-stop';
        next_title = "{{lang.LABTOMCAT101}}";
        $('.app-tr-' + appkey).find('.btn-restart-app').fadeOut('fast');
    }else{
        $('.app-tr-' + appkey).find('.btn-restart-app').fadeIn('fast');
    }
    $('.app-tr-' + appkey).find('.btn-status_main').removeClass(btn_class_old).addClass(btn_class_new).attr('data-original-title', next_title);
    $('.app-tr-' + appkey).find('.btn-status_main i').removeClass(btn_ico_old).addClass(btn_ico_new);
    $('.app-tr-' + appkey).find('.status-app-container i').removeClass().addClass('fa fa-circle ' + class_circle);
    $('.app-tr-' + appkey).find('.status-app-container span').text(status);
}
function refeshTomCatAppLog(elem){
    $('#tomcat_app_log_wrapper').fadeOut('fast', function(){
        $('#tomcat_app_log_loader').fadeIn('fast');
        let key = $(elem).data('key');
        let lines = $('#_tomcat_app_logger_lines_qty').val();
        requestAppLog(key, lines, function (resp) {
            $('#tomcat_app_log_container').html(resp.log.map(function (log_line) {
                return '<p>' + log_line + '</p>';
            }).join(''));
            $('#tomcat_app_log_loader').fadeOut('fast', function () {
                $('#tomcat_app_log_wrapper').fadeIn('fast');
            });
        }, function () {
            $('#modal_tomcat_app_log').modal('hide');
        });
    });
}
function tomCatAppViewLogInForm(){ 
    let key = $('#tomcat_app_quick_actions_container').data('key');
    let name = $('#tomcat_app_quick_actions_container').data('name'); 
    viewTomCatAppLog(name, key);
}
function viewTomCatAppLog(name, key){
    $('#_tomcat_app_logger_lines_qty').val(20);
    $('#_tomcat_app_logger_refresh_btn').data('key', key);
    $('#modal_tomcat_app_log_title').text(name + ' log');
    $('#tomcat_app_log_loader').show();
    $('#tomcat_app_log_wrapper').hide();
    $('#modal_tomcat_app_log').modal('show');
    requestAppLog(key, 20, function(resp){
        $('#tomcat_app_log_container').html(resp.log.map(function(log_line){
            return '<p>' + log_line + '</p>';
        }).join(''));
        $('#tomcat_app_log_loader').fadeOut('fast', function(){
            $('#tomcat_app_log_wrapper').fadeIn('fast', function(){
                $("#tomcat_app_log_container p").last().attr("tabindex", -1).focus();
            });
        });
    }, function(){
        $('#modal_tomcat_app_log').modal('hide');
    });
}
let tomcat_port = '{{mod_vars.tomcat_port}}';
let tomcat_host = '{{mod_vars.tomcat_host}}'
function renderTomCatAppList(){
    let html_list = '';
    if (app_list.length > 0) {
        let html_content = '';
        index = 1;
        function renderAppUrlLink(app){
            let url_title = app.path;
            let url_href = 'http://' + tomcat_host + ':' + tomcat_port + app.path;
            if (app.url != '' && app.url !== null) {
                url_href = (app.uri_secured ? 'https' : 'http') + '://' + app.url;
                url_title = app.url;
            }
            
            return '<br/>(<a target="_blank" href="' + url_href + '">' + url_title + '</a>)';
        }
        app_list.forEach(function (app) {
            let is_manager = app.path === '/manager' ? true : false;
            let status_btn = '<button ' + (!is_manager ? '' : 'disabled') + ' id="_tomcat_apps_status_btn_' + index + '" title="{{lang.LABTOMCAT102}}" data-status="running" onclick="tomCatAppStatus(this, ' + index + ')" data-toggle="tooltip" data-placement="top" class="btn btn-danger btn-xs btn-status_main' + (!is_manager ? '' : ' disabled') + '"><i class="fa fa-stop"></i></button>';
            let status_class = 'success';
            let btn_restart = '';
            
            if (app.status != 'running'){
                status_class = 'danger';
                btn_restart = 'style="display:none"';
                status_btn = '<button ' + (!is_manager ? '' : 'disabled') + ' id="_tomcat_apps_status_btn_' + index + '" title="{{lang.LABTOMCAT101}}" data-status="stoped" onclick="tomCatAppStatus(this, ' + index + ')" data-toggle="tooltip" data-placement="top" class="btn btn-success btn-xs btn-status_main' + (!is_manager ? '' : ' disabled') + '"><i class="fa fa-play"></i></button>';
            }
            
            html_content += '<tr class="app-tr-' + app.key + ' tomcat-app-tr-item" id="_tomcat_apps_item_' + index + '" data-key="' + app.key + '" data-path="' + app.path + '">' +
                                '<td>' + app.name + renderAppUrlLink(app) + '</td>' +
                                '<td>' + app.path + '</td>' +
                                '<td>' + app.user + '</td>' +
                                '<td class="status-app-container">' +
                                    '<i class="fa fa-circle text-' + status_class + '" aria-hidden="true"></i> ' + 
                                    '<span>' + app.status + '</span>' +
                                '</td>' +
                                '<td class="text-right">' + app.sessions + '</td>' +
                                '<td>' +
                                    '<div class="tomcat-apps-actions">' +
                                        '<button ' + (app.editable && !is_manager ? '' : 'disabled') + ' title="{{lang.LABTOMCAT99}}" data-toggle="tooltip" data-placement="top" onclick="editTomCatApp(\'' + app.cwp_key + '\')" class="btn btn-primary btn-xs' + (app.editable && !is_manager ? '' : ' disabled') + '"><i class="fa fa-cogs"></i></button>' +
                                        status_btn +
                                        '<button ' + (!is_manager ? '' : 'disabled') + ' ' + btn_restart + ' id="_tomcat_apps_restart_btn_' + index + '" onclick="restartApplication(this, ' + index + ')" title="{{lang.LABTOMCAT107}}" data-toggle="tooltip" data-placement="top" class="btn btn-default btn-xs btn-restart-app' + (!is_manager ? '' : ' disabled') + '"><i class="fa fa-refresh"></i></button>' +
                                        //'<button class="btn btn-default btn-xs" title="{{lang.LABTOMCAT109}}" data-toggle="tooltip" data-placement="top" onclick="viewTomCatAppLog(\'' + app.name + '\', ' + app.key + ')"><i class="fa fa-file-text-o"></i></button>' +
                                        '<button class="btn btn-default btn-xs" title="Expire sessions" data-toggle="tooltip" data-placement="top" onclick="showModalKillSessionsTomCat(\'' + app.name + '\', \'' + app.path + '\')"><i class="fa fa-users"></i></button>' +
                                        '<button ' + (!is_manager ? '' : 'disabled') + ' class="btn btn-warning btn-xs' + (!is_manager ? '' : ' disabled') + '" title="{{lang.LABTOMCAT108}}" data-toggle="tooltip" data-key="' + app.key + '" data-cwpkey="' + app.cwp_key + '" data-context="' + app.path + '" data-placement="top" onclick="confirmAppDeletion(this, \'' + app.name + '\')"><i class="fa fa-trash"></i></button>' + 
                                    '</div>' +
                                '</td>' +
                            '</tr>';
            index++;
        });
        html_list = '<table class="table tomcat_apps_table table-striped table-bordered table-hover">' +
            '<thead>' +
            '<tr role="row">' +
                '<th>{{lang.LABTOMCAT110}}</th>' +
                '<th>{{lang.LABTOMCAT112}}</th>' +
                '<th>{{lang.LABTOMCAT134}}</th>' +
                // '<th>{{lang.LABTOMCAT112}}</th>' +
                '<th style="width:85px">{{lang.LABTOMCAT113}}</th>' +
                '<th style="width:85px">{{lang.LABTOMCAT135}}</th>' +
                //'<th style="width:85px">x{{lang.LABTOMCAT114}}</th>' +
                '<th style="width:155px">{{lang.LABTOMCAT71}}</th>' +
            '</tr>' +   
            '</thead>' + 
            '<tbody id="contenttr">' +
            html_content +
            '</tbody>' +
            '</table>';
            $('#_tomcat_apps_list_wrapper').html(html_list);
            apps_table = $('.tomcat_apps_table').DataTable({
                "autoWidth": false
            });
    } else {
        html_list = '<div class="tomcat-empty-list-version">' +
                        '<h4>{{lang.LABTOMCAT129}}</h4>' +
                        '<button class="btn btn-primary" onclick="addNewTomCatApp()">' +
                            '<i class="fa fa-plus"></i> ' +
                            '{{lang.LABTOMCAT115}}'
                        '</button>' +
                    '</div>';
        $('#_tomcat_apps_list_wrapper').html(html_list);
    }
    $('[data-toggle="tooltip"]').tooltip();
}
let apps_table = null;
function sortDomainToList(a, b) {
    if (a.domain < b.domain) {
        return -1;
    }
    if (a.domain > b.domain) {
        return 1;
    }
    return 0;
}
const USER_FIRST_HTML = '<div class="tomcat-select-user-empty"><span>{{lang.LABTOMCAT123}}</span></div>';
//let domain_list = JSON.parse('{{mod_vars.domain_list|json_encode()|raw}}');
function restoreAppPath(){
    $('#_tomcat_path_selector_wrapper').fadeOut('fast', function(){
        $('#_tomcat_path_wrapper .tomcat-select-user-empty').fadeIn('fast');
    });
}
function showAppDirSel(user){
    $('#dirsel').text('/home/' + user + '/');
    if($('#_tomcat_path_wrapper .tomcat-select-user-empty').is(':visible')){
        $('#_tomcat_path_wrapper .tomcat-select-user-empty').fadeOut('fast', function () {
            $('#_tomcat_path_selector_wrapper').fadeIn('fast');
        });
    }
}
function renderFormApps(domains, users){
    domain_list = domains.sort(sortDomainToList);
    // domains = domains.sort(sortDomainToList);
    // let html_select = '<select id="tomcat_url_selector_domain">' +
    //                         '<option value="">{{lang.LABTOMCAT119}}</option>';
    // domains.forEach(function(domain){
    //     html_select += '<option value="' + domain.domain_label + '">' + domain.domain_label + '</option>';
    // });
    // html_select +='</select>';   
    // $('#tomcat_url_selector_select').html(html_select);
    // $("#tomcat_url_selector_domain").select2({
    //     placeholder: "{{lang.LABTOMCAT119}}",
    //     allowClear: true
    // });
    $('#_tomcat_path_wrapper').append(USER_FIRST_HTML);
    $('#tomcat_url_selector_select').html(USER_FIRST_HTML);
    let html_select = '<select class="required-data" data-error-place="#_tomcat_app_form_user .select2-container a" id="tomcat_user_selector_">' +
        '<option value="">{{lang.LABTOMCAT120}}</option>';
    users.forEach(function (user) {
        html_select += '<option value="' + user + '">' + user + '</option>';
    });
    html_select += '</select>';
    $('#_tomcat_app_form_user').html(html_select);
    $("#tomcat_user_selector_").select2({
        placeholder: "{{lang.LABTOMCAT120}}",
        allowClear: true
    });
    $("#tomcat_user_selector_").on('select2-selected', function (e) {
        if(e.val == ''){
            restoreAppPath();
            $('#tomcat_url_selector_select').html(USER_FIRST_HTML);
        }else{
            showAppDirSel(e.val);
            renderDomainForApps(e.val);
        }

        // setTimeout(function(){
        //     $('#tomcat_user_selector_').val(''); // Select the option with a value of '1'
        //     $('#tomcat_user_selector_').trigger('change'); // Notify any JS components that the value changed
        // }, 5000);
    });
}
function renderDomainForApps(user, domain_list, domain){
    if(user != "" && user != 'root'){
        let html_select = '<select id="_tomcat_app_domain_select_">' +
            '<option value="">{{lang.LABTOMCAT119}}</option>';
        let found = false;
        domain_list.sort(sortDomainToList).forEach(function (dom) {
            html_select += '<option value="' + dom.domain_label + '"' + (domain == dom.domain_label ? ' selected' : '') + '>' + dom.domain_label + '</option>';
        });
        if (domain_list.length == 0) {
            $('#tomcat_url_selector_select').html('<div class="tomcat-no-domains"><span>{{lang.LABTOMCAT121}}</span></div>')
        } else {
            html_select += '</select>';
            $('#_tomcat_app_domain_container_').html(html_select);
            $("#_tomcat_app_domain_select_").select2({
                placeholder: "{{lang.LABTOMCAT119}}",
                allowClear: true
            });
        }
    }
}
function showModalKillSessionsTomCat(name, path) {
    $('#_modal_tomcat_sessions_appname_').text(name);
    $('#_modal_tomcat_sessions_time_').val('30');
    $('#_modal_tomcat_sessions_').modal('show');
    $('#_btn_kill_sessions_modal_').unbind('click').click(function(){
        clickKillSessionsBtn($(this), path);
    });
}
function clickKillSessionsBtn(btn, app_path){
    handleButtons(btn, 'fa-check');
    let minutes = $('#_modal_tomcat_sessions_time_').val();
    sendKillSessionsApp(app_path, minutes, function(){
        $.gritter.add({
            title: '{{lang.LABTOMCAT83}}',
            text: 'Sessions killed!',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'success-notice'
        });
        $('#_modal_tomcat_sessions_').modal('hide');
        handleButtons(btn, 'fa-check', true);
    }, function(){
        handleButtons(btn, 'fa-check', true);
    });
}
function startTomcatAppList(){
    renderTomCatAppList();
    $('#_tomcat_apps_list_loader').fadeOut('fast', function () {
        $('#_tomcat_apps_list_wrapper').fadeIn('fast');
    });
    setTimeout(function () {
        listenForStatusChanges();
    }, 5000);
}
const HTML_DOMAIN_SELECTOR = '<h5 class="tomcat-app-domain-container-title">Select a user to bind a domain.</h5>';
function getUserDomainsForTomcat(user){
    if(user == ""){
        $('#_tomcat_app_domain_container_').fadeOut('fast', function () {
            $(this).html(HTML_DOMAIN_SELECTOR);
            $(this).fadeIn('fast')
        });
        if (current_domain_request != null) {
            current_domain_request.abort();
        }
        return;
    }
    $('#_tomcat_app_domain_container_').fadeOut('fast', function() {
        $(this).html('<span class="mini-loader-app-ui"><i class="fa fa-circle-o-notch fa-spin text-primary"></i> Loading domains information...</span>');
        $(this).fadeIn('fast')
    });
    getUserDomainAjax(user, function(response){
        let domains_select_html = '<option value="" selected>Select a domain</option>';
        response.domain_list.sort(sortDomainToList).forEach(function (domain) {
            //let selected_user = getIfUserAvailable(user);
            let domain_selected = '';
            domains_select_html += '<option value="' + domain.domain_label + '" ' + domain_selected + '>' + domain.domain_label + '</option>';
        });
        $('#_tomcat_app_domain_container_').fadeIn('fast', function(){
            $(this).html('<select id="_tomcat_app_domain_select_">' + domains_select_html + '</select>');
            $("#_tomcat_app_domain_select_").select2({
                placeholder: "Select domain.",
                allowClear: true
            });
        });
        /*$('#domains_select_html').on('select2-selected', function (e) {
            getUserDomainsForTomcat(e.val);
        });*/
    }, function(){

    });
}
let current_domain_request = null;
function getUserDomainAjax(user, success, cleaner) {
    current_domain_request = $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=getuserdomains",
        data: 'user=' + user,
        beforeSend: function () {
            if (current_domain_request != null) {
                current_domain_request.abort();
            }
        },
        complete: function (response) {
            let resp_data = {}
            if (response.readyState == 0) {
                return;
            }
            current_domain_request = null;
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendKillSessionsApp(app_path, minutes, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=kill_sessions",
        data: 'minutes=' + minutes + '&tomcat_path=' + app_path,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = 'Invalid idle minutes.';
                    } else if (resp_data.code == 1) {
                        message_error = 'Invalid path.';
                    } else if (resp_data.code == 3) {
                        message_error = 'Tomcat server timeout.';
                    } else if (resp_data.code == 4) {
                        message_error = resp_data.message;
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendDeleteApplication(context, cwp_key, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=delete_app",
        data: 'context=' + context  + "&cwp_key=" + cwp_key,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
} 
function requestNPMInstallLog(key, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=app_npm_logger",
        data: 'key=' + key,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            }
        }
    });
}
function requestAppLog(key, lines, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=get_app_log",
        data: 'key=' + key + '&lines=' + lines,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABTOMCAT116}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendNpmInstallApp(key, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=app_npminstall",
        data: 'key=' + key,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function handleAppStatus(action, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=app_status",
        data: 'action=' + action,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABTOMCAT117}}';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABTOMCAT116}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function requestStatusChanges(success) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=status_listener",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data.list);
            }
        }
    });
}
function sendRequestSaveApp(data, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=tomcat_app_save",
        data: data,
        processData: false,  // tell jQuery not to process the data
        contentType: false,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT83}}',
                    text: '{{lang.LABTOMCAT118}}',
                    time: 5500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'success-notice'
                });
                success(resp_data);
            } else {
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 1) {
                        message_error = 'Invalid APP data';
                    } else if (resp_data.code == 2) {
                        message_error = 'Application context already in use';
                    } else if (resp_data.code == 3) {
                        message_error = 'Invalid File to deploy';
                    } else if (resp_data.code == 4) {
                        message_error = 'Application can not be saved.';
                    } else if (resp_data.code == 5) {
                        message_error = resp_data.message_error;
                    } else if (resp_data.code == 6) {
                        message_error = 'Invalid domain/user combination.';
                    } else if (resp_data.code == 7) {
                        message_error = 'Invalid application.';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function loadTomCatAppInfo(app_key, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=tomcat_app_info",
        data: 'cwp_key=' + app_key,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function loadTomCatAppList(success){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=tomcat_apps",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                app_list = resp_data.list;
                //renderFormApps(resp_data.domains, resp_data.users);
                success();
            } else {
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
            }
        }
    });
}