let current_file_request = null;
tomcat_file_editor = null;
$(document).ready(function () {
    $('.tomcat-accordion-header').click(function () {
        let elem_panel = $($(this).data('panel'));
        let ico_status = $(this).find('.ico-status');
        console.log('ico_status', ico_status); 
        if ($(elem_panel).is(':visible')) {
            $(elem_panel).slideUp('fast');
            ico_status.removeClass('fa-minus').addClass('fa-plus');
        } else {
            ico_status.removeClass('fa-plus').addClass('fa-minus');
            $(elem_panel).slideDown('fast');
        }
    });
    $('#_tomcat_config_file_select_').change(function () {
        let selected_val = $(this).val();
        if (selected_val == "") {
            cancelTomCatEditFile();
            return;
        }
        let html_loader = '<div class="action-loader">' +
            '<span><i class="fa fa-circle-o-notch fa-spin"></i></span>' +
            '<h5>Loading configuration file</h5>' +
            '</div>';
        let editor_wrapper = $('#_tomcat_config_file_editor_wrapper_');
        if (!editor_wrapper.is(':visible') && editor_wrapper.find('.action-loader').length == 0) {
            editor_wrapper.html(html_loader);
            editor_wrapper.slideDown('fast');
        } else if ($('#_tomcat_config_file_editor_').length > 0) {
            $('#_tomcat_config_file_editor_').fadeIn('fast', function () {
                $(this).html('<div class="action-loader-hider" style="display:none">' + html_loader + '</div>');
                $('.action-loader-hider').fadeIn('fast');
            });
        }
        getTomcatConfigFile(selected_val, function (response) {
            renderTomCatFileEditor(response, editor_wrapper);
        }, function () {

        });
    });
});
function BindConfigTab() {
    let list_opts = {
        nonSelectedListLabel: 'User accounts list',
        selectedListLabel: 'Tomcat serevr available (accounts)',
        selectorMinimalHeight: 200,
        filterTextClear: 'show all', // the text for the "Show All" button.
        filterPlaceHolder: 'Filter', // the placeholder for the input element for filtering elements.
        moveSelectedLabel: 'Move selected', // the label for the "Move Selected" button.
        moveAllLabel: 'Move all', // the label for the "Move All" button.
        removeSelectedLabel: 'Remove selected', // the label for the "Remove Selected" button.
        removeAllLabel: 'Remove all', // the label for the "Remove All" button.
    };
    $('#_tomcat_availability_users_select_').bootstrapDualListbox(list_opts);
    //setConfigValues();
}
function renderTomCatFileEditor(response, editor_wrapper) {
    let html_editor = '<div id="_tomcat_config_file_editor_">' +
        '<div class="tomcat-config-file-editor-header">' +
        '<h5>Editing ' + response.file_path + '</h5>' +
        '<input type="hidden" value="' + response.file_path + '" id="_tomcat_config_file_name_">' +
        '<div class="tomcat-config-file-editor-buttons">' +
        '<button class="btn btn-sm btn-primary" onclick="saveTomCatConfigFile(this)"><i class="fa fa-floppy-o"></i> Save file</button>' +
        '<button class="btn btn-sm btn-danger" onclick="saveTomCatConfigFile(this,true)"><i class="fa fa-refresh"></i> Save file & reload server</button>' +
        '<button class="btn btn-sm btn-warning" onclick="cancelTomCatEditFile()"><i class="fa fa-ban"></i> Cancel</button>' +
        '</div>' +
        '</div>' +
        '<textarea id="_tomcat_config_file_editor_area_">' + response.file_content + '</textarea>' +
        '</div>';
    editor_wrapper.find('.action-loader').fadeOut('fast', function () {
        editor_wrapper.html(html_editor);
        tomcat_file_editor = CodeMirror.fromTextArea(document.getElementById("_tomcat_config_file_editor_area_"), {
            lineNumbers: true,
            matchBrackets: true,
            styleActiveLine: true,
            theme: "ambiance",
        });
        $('#_tomcat_config_file_editor_').fadeIn('fast', function () {
            tomcat_file_editor.refresh();
        });
    });
}
function saveTomCatConfigFile(elem, reload) {
    let icon_btn = $(elem).find('.fa-floppy-o').length > 0 ? 'fa-floppy-o' : 'fa-refresh';
    handleButtons(elem, icon_btn);
    $('.tomcat-config-file-editor-buttons .btn').prop('disabled', true);
    $('#_tomcat_config_file_select_').prop('disabled', true);
    function clearer() {
        handleButtons(elem, icon_btn, true);
        $('.tomcat-config-file-editor-buttons .btn').prop('disabled', false);
        $('#_tomcat_config_file_select_').prop('disabled', false);
    }
    sendSaveTomCatConfigFile(encodeURIComponent(tomcat_file_editor.getValue()), $('#_tomcat_config_file_name_').val(), reload, function () {
        clearer();
    }, function () {
        clearer();
    });
}
function cancelTomCatEditFile() {
    $('#_tomcat_config_file_editor_').fadeIn('fast');
    $('#_tomcat_config_file_editor_wrapper_').slideUp('fast', function () {
        $(this).html('');
        $('#_tomcat_config_file_select_').val("");
    });
}
function changeUserAvailability(elem) {
    if ($(elem).is(':checked')) {
        $('#_tomcat_config_users_select_wrapper_').slideDown('fast');
    } else {
        $('#_tomcat_config_users_select_wrapper_').slideUp('fast');
        $('#_tomcat_users_select_availability_').slideUp('fast');
        /*$('#_mongo_users_select_availability_').slideUp('fast', function () {
            // $('#_mongodb_availability_select_').val('1');
            // $('#_mongo_users_select_availability_ .removeall').trigger('click');
        });*/
    }
}
function tomcatChangeUsersToAvailable(elem) {
    if ($(elem).val() == '2') {
        $('#_tomcat_users_select_availability_').slideDown('fast');
    } else {
        $('#_tomcat_users_select_availability_').slideUp('fast', function () {
            // $('#_tomcat_users_select_availability_ .removeall').trigger('click');
        });
    }
}
function TomCatSaveUserConfigurations(elem) {
    handleButtons(elem, 'fa-floppy-o');
    let users_availability = $('#_tomcat_availability_users_select_').val();
    let user_config = {
        user_enabled: $('#_tomcat_conf_user_enabled_').is(':checked'),
        availability_type: $('#_tomcat_availability_select_').val(),
        availability_users: users_availability === null ? [] : users_availability
    }
    sendTomCatUserConfigurations(JSON.stringify(user_config), function () {
        handleButtons(elem, 'fa-floppy-o', true);
        $.gritter.add({
            title: 'Success!',
            text: 'User panel configuration was saved.',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-quill-2',
            class_name: 'success-notice'
        });
    }, function () {
        handleButtons(elem, 'fa-floppy-o', true);
    });
}
function sendTomCatUserConfigurations(config, success, cleaner) {   
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=saveuserconfig",
        data: 'config=' + config,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success();
                // 
            } else {
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABTOMCAT160}}';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABTOMCAT159}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendSaveTomCatConfigFile(content, file_name, reload_server, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=saveconfigfile",
        data: 'content=' + content + '&file=' + file_name + '&reload_server=' + (reload_server === true ? '1' : '0'),
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT83}}',
                    text: 'The Configuration file was saved successfully.',
                    time: 5500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'success-notice'
                });
                success();
                // 
            } else {
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABTOMCAT87}}';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABTOMCAT161}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function getTomcatConfigFile(file, success, cleaner) {
    current_file_request = $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=getconfigfile",
        data: 'file=' + file,
        beforeSend: function () {
            if (current_file_request != null) {
                current_file_request.abort();
            }
        },
        complete: function (response) {
            if (response.readyState == 0) {
                return;
            }
            current_file_request = null;
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                success(resp_data);
            } else {
                lo
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABTOMCAT87}}';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABTOMCAT159}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}