let installing = {{mod_vars.installing == true ? 'true' : 'false'}};
let tomcat_installed = {{ mod_vars.tomcat_installed == true ? 'true' : 'false'}};
//let version_list = JSON.parse('{{mod_vars.ver_list|json_encode()|raw}}');
let users_list = JSON.parse('{{mod_vars.users_list|json_encode()|raw}}');
let usr_config = JSON.parse('{{mod_vars.usr_config|json_encode()|raw}}');
let version_availables = null;
let log_install_lines = [];
let log_install_lines_index = 0;
let logs_modal_time = null;
let ver_list_table = null;
function installTomCatVerFromAppForm(){
    $('#_tab_button_installed a').trigger('click');
    setTimeout(function(){
        if ($('#_tomcat_install_btn').is(':visible')){
            $('#_tomcat_install_btn').trigger('click');
        }
    }, 200);
}
function saveUserConfig(elem){
    let valid = true;
    $('.port-range-input').each(function(){
        if($(this).val() == ''){
            valid = false;
            $(this).addClass('error-field');
        }
    });
    if (valid){
        let data = {
            'user_enabled': $('#chk_enable_tomcat_usr').is(':checked'),
            'port_range': [
                $('#_port_range_max_').val(),
                $('#_port_range_min_').val()
            ]
        }
        handleButtons(elem, 'fa-floppy-o');
        setTomCatUserConfig('usr_config=' + JSON.stringify(data),function(){
            handleButtons(elem, 'fa-floppy-o', true);
        });
    }else{
        $.gritter.add({
            title: '{{lang.LABTOMCAT92}}',
            text: '{{lang.LABTOMCAT93}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
    }
}
function setInputFilter(textbox, inputFilter) {
    ["input", "keydown", "keyup", "mousedown", "mouseup", "select", "contextmenu", "drop"].forEach(function (event) {
        textbox.addEventListener(event, function () {
            if (inputFilter(this.value)) {
                this.oldValue = this.value;
                this.oldSelectionStart = this.selectionStart;
                this.oldSelectionEnd = this.selectionEnd;
            } else if (this.hasOwnProperty("oldValue")) {
                this.value = this.oldValue;
                this.setSelectionRange(this.oldSelectionStart, this.oldSelectionEnd);
            } else {
                this.value = "";
            }
        });
    });
}
function setAsDefaultVersion(elem){
    let version = $(elem).data('version');
    let tr = $(elem).closest('tr');
    tr.addClass('deleting_tr');
    tr.find('.btn').prop('disabled', true);
    $('.tomcat-set-default-label').removeClass('tomcat-ver-overable').prop('disabled', true);
    $(elem).addClass('tomcat-ver-overable-fixed');
    handleButtons(elem, 'fa-check');
    $(elem).find('span').text('{{lang.LABTOMCAT74}}');
    setTomCatVerAsDefault(version, function(){
        tr.removeClass('deleting_tr');
        tr.find('.btn-info').prop('disabled', false);
        $('.tomcat-ver-item-tr.ver-default').find('.btn-danger').prop('disabled', false);
        $('.tomcat-ver-item-tr.ver-default').removeClass('ver-default');
        tr.addClass('ver-default');
        handleButtons(elem, 'fa-check', true);
        $(elem).find('span').text('{{lang.LABTOMCAT75}}');
        $(elem).removeClass('tomcat-ver-overable-fixed');
        $('.tomcat-set-default-label').addClass('tomcat-ver-overable').prop('disabled', false);
    }, function(){
        tr.removeClass('deleting_tr');
        tr.find('.btn').prop('disabled', false);
        handleButtons(elem, 'fa-check', true);
        $(elem).find('span').text('{{lang.LABTOMCAT75}}');
        $(elem).removeClass('tomcat-ver-overable-fixed');
        $('.tomcat-set-default-label').addClass('tomcat-ver-overable').prop('disabled', false);
    });
}
function copyTomCatPath(elem){
    $('#_tomcat_ver_path_copy').val($(elem).data('path')).show();
    var copyText = document.getElementById("_tomcat_ver_path_copy");

    /* Select the text field */
    copyText.select();
    copyText.setSelectionRange(0, 99999); /* For mobile devices */

    /* Copy the text inside the text field */
    document.execCommand("copy");
    $('#_tomcat_ver_path_copy').hide();
}
/*function installationModal(){
    if(version_availables === null){
        loadAvailableVersionToInstall(function(){
            $('#modal_nvm_install').modal('hide');
        });
        $('#modal_nvm_install').modal('show');
        return false;
    }
    renderInstallableVersions();
    $('#modal_nvm_install').modal('show');
}*/

function renderInstallableVersions(){
    let html_content = '';
    let index = 1;
    // version_availables.forEach(function(version){
    for (const ver_number in version_availables) {
        let version = version_availables[ver_number];
        let exists = version_list.find(function(ver_ins){
            return ver_ins.ver === version.ver;
        });
        if(exists === undefined){
            html_content += '<li>' + 
                                '<div class="checkbox-custom">' +
                                    '<input class="tomcat-ver-toinstall" onchange="handleBtnModalInstall()" type="checkbox" id="_ver_toinstall_' + index + '" value="' + version.ver_name + '">' +
                                    '<label for="_ver_toinstall_' + index + '">' +
                                        '{{lang.LABTOMCAT68}} <b>' + version.ver_name + '</b>' +
                                    '</label>' +
                                '</div>' +
                            '</li>';
            index++;
        }
    };
    if(html_content != ''){
        html_content = '<div class="tomcat-heading">' +
                            '<h5>{{lang.LABTOMCAT76}}</h5>' +
                        '</div>' +
                        '<div class="modal-installer-separator">' +
                            '<div class="checkbox-custom">' +
                                '<input onchange="checkAllToInstall(this)" type="checkbox" id="_ver_toinstall_all">' +
                                '<label id="_tomcat_install_label" for="_ver_toinstall_all">' +
                                    '{{lang.LABTOMCAT77}}' +
                                '</label>' +
                            '</div>' +
                        '</div>' +
                        '<div class="tomcat-ul-install-wrapper">' +
                            '<ul class="tomcat-ul-install">' + html_content + '</ul>' +
                        '</div>';
    }else{
        html_content = '<div class="tomcat-versions-all-installed">' +
                            '<h4>{{lang.LABTOMCAT78}}</h4>' +
                        '</div>';
    }
    $('#_nvm_install_version_list').html(html_content);
}
function checkAllToInstall(elem){
    if($(elem).is(':checked')){
        $('.tomcat-ver-toinstall').prop('checked', true);
        $('#_tomcat_install_label').text('{{lang.LABTOMCAT79}}');
    }else{
        $('.tomcat-ver-toinstall').prop('checked', false);
        $('#_tomcat_install_label').text('{{lang.LABTOMCAT77}}');
    }
    handleBtnModalInstall();
}
/*function confirmTomCatInstall(){
    let data_install = 'versions=';
    let data_versions = [];
    $('#modal_nvm_install').modal('hide');
    $('.tomcat-ver-toinstall:checked').each(function(){
        let ver_pieces = $(this).val().split(' ');
        data_versions.push({
            ver: ver_pieces[0],
            name: $(this).val().replace(/\s+/g, ' ').trim()
        });
    });
    handleButtons('#_tomcat_install_btn', 'fa-plus');
    data_install += JSON.stringify(data_versions);
    sendInstallation(data_install, function(){
        handleButtons('#_tomcat_install_btn', 'fa-plus', true);
    });
}*/
function viewInstallationLogModal(){
    $('#_nvm_install_log_container').html('').hide();
    $('#_nvm_install_log_loader').show();
    $('#modal_nvm_install_log').modal('show');
}
function handleBtnModalInstall(){
    $('#_btn_mk_tomcat_install').prop('disabled', $('.tomcat-ver-toinstall:checked').length > 0 ? false : true);
}
function handleButtons(elem, icon_fa, type){
    let icon = $(elem).find('.fa');
    if(type == undefined){
        $(elem).addClass('disabled');
        $(elem).prop('disabled', true);
        icon.removeClass(icon_fa);
        icon.addClass('fa-spinner fa-spin');
    }else{
        icon.removeClass('fa-spinner fa-spin');
        icon.addClass(icon_fa);
        $(elem).removeClass('disabled');
        $(elem).prop('disabled', false);
    }
}
function updateLogModal(lines){
    log_install_lines = log_install_lines.concat(lines);
    function updateLogContainer(){
        logs_modal_time = setTimeout(function(){
            if(log_install_lines_index < log_install_lines.length){
                let log_line = '<p>' + log_install_lines[log_install_lines_index] + '</p>';
                if(log_install_lines_index == 0){
                    $('#_nvm_install_log_container').html(log_line);
                    $('#_nvm_install_log_loader').fadeOut('fast', function(){
                        $('#_nvm_install_log_container').fadeIn('fast');
                    });
                }else{
                    $('#_nvm_install_log_container').append(log_line);
                    $("#_nvm_install_log_container p").last().attr("tabindex",-1).focus();
                }
                log_install_lines_index++;
                updateLogContainer();
            }else{
                logs_modal_time = null;
            }
        }, 50);
    }
    if(logs_modal_time === null){
        updateLogContainer();
    }
}
function modalUninstallConfirm(elem){
    let version_name = $(elem).data('version-name');
    $('#_tomcat_del_alert_version').text(version_name);
    $('#_tomcat_confirmation_del_btn').unbind('click');
    $('#_tomcat_confirmation_del_btn').click(function(){
        unistallTomCatComfirmed(elem);
    });
    $('#modal_nvm_uninstall_confirm').modal('show');
}
function confirmRemoveCWPTomCat(){
    $('#modal_nvm_uninstall_cwptomcat').modal('show');
}
function removeCWPTomCatConfirmed(){
    $('#modal_nvm_uninstall_cwptomcat').modal('hide');
    slideToggle('#_nvm_uninstall_all_loader','#_tomcat_main_screen');
    sendWholeDeletionRequest(function(){
        slideToggle('#_tomcat_not_installed','#_nvm_uninstall_all_loader');
    });
}
function renderDashboard(resp_data){
    $('#_tomcat_dashboard_status_version_').text(resp_data.server_dashboard.tomcat_version);
    $('#_tomcat_dashboard_status_port_').text(resp_data.server_dashboard.port);
    $('#_tomcat_monitor_info_version_').text(resp_data.server_dashboard.tomcat_version);
    $('#_tomcat_monitor_info_jvshort_').text(resp_data.server_dashboard.jvm_version_short);
    $('#_tomcat_monitor_info_jvendor_').text(resp_data.server_dashboard.jvm_vendor);
    $('#_tomcat_monitor_info_osname_').text(resp_data.server_dashboard.os_name);
    $('#_tomcat_monitor_info_osversion_').text(resp_data.server_dashboard.os_version);
    $('#_tomcat_monitor_info_osarch_').text(resp_data.server_dashboard.os_arch);
    $('#_tomcat_monitor_info_hostname_').text(resp_data.server_dashboard.hostname);
    $('#_tomcat_monitor_info_ip_').text(resp_data.server_dashboard.ip_address);
    $('#_tomcat_dashboard_java_info_').html(resp_data.server_dashboard.java_info);
    app_list = resp_data.app_list;
    startTomcatAppList();
}
function installTomCatResponse(resp_data){
    if(resp_data.running === false){
        if (resp_data.installed === true){
            $.gritter.add({
                title: 'Success',
                text: '{{lang.LABTOMCAT80}}',
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'success-notice'
            });
            tomcat_port = resp_data.hasOwnProperty('server_dashboard') && resp_data.server_dashboard.hasOwnProperty('port') ? resp_data.server_dashboard.port : '';
            renderDashboard(resp_data);
            if (resp_data.server_dashboard != false){
                $('#_tomcat_mdashboard_not_running').fadeOut('fast', function () {
                    $('#_tomcat_mdashboard_running').fadeIn('fast');
                    $('#_tab_button_apps').removeClass('disabled').find('a').attr("data-toggle", "tab");
                    $('#_tab_button_monitor').removeClass('disabled').find('a').attr("data-toggle", "tab");
                });
            }
            $('#_tomcat_not_installed').fadeOut('fast', function(){
                $('#_tomcat_main_screen').fadeIn('fast');
                $('#_tomcat_installer_running_wrapper_').hide();
                $('#_tomcat_installer_main_wrapper_').show();
                $('#_tomcat_installer_version_select_').val("");
                
            });
        }else{
            $('#_tomcat_installer_running_wrapper_').fadeOut('fast', function(){
                $('#_tomcat_installer_main_wrapper_').fadeIn('fast');
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: 'Tomcat Server cannot be installed.',
                    time: 5500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
            });
        }
        return;
    }else if(resp_data.lines.length > 0){
        //updateLogModal(resp_data.lines)
    }
    setTimeout(function(){
        checkInstallationProcess();
    }, 2000);
}
function clickInstallTomCat(){
    let version = $('#_tomcat_installer_version_select_').val();
    if (version == "") {
        $.gritter.add({
            title: '{{lang.LABTOMCAT82}}',
            text: '{{lang.LABTOMCAT136}}',
            time: 3500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'error-notice'
        });
        return;
    }
    $('#_modal_install_version_tomcat_title').text(versionTitleTranslator(version));
    $('#_modal_tomcat_install').modal('show');
}
function versionTitleTranslator(version){
    let ver_title = '';
    if(version == '8'){
        ver_title = '8.0.14';
    } else if (version == '9'){
        ver_title = '9.0.56';
    } else if (version == '10') {
        ver_title = '10.0.16';
    }
    return ver_title;
}
function confirmTomCatInstall(elem){
    let version = $('#_tomcat_installer_version_select_').val();
    handleButtons(elem, 'fa-check   ');
    $('#_modal_tomcat_install .btn').prop('disabled', true);
    sendInstallTomCatServer(version, function (data) {
        $.gritter.add({
            title: '{{lang.LABTOMCAT83}}',
            text: '{{lang.LABTOMCAT138}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'success-notice'
        });
        TomCatInstallationStarted();
        handleButtons(elem, 'fa-check   ', true);
        $('#_modal_tomcat_install .btn').prop('disabled', false);
        $('#_modal_tomcat_install').modal('hide');
    }, function () {
        handleButtons(elem, 'fa-check   ', true);
        $('#_modal_tomcat_install .btn').prop('disabled', false);
    });
}
function TomCatInstallationStarted(){
    $('#_tomcat_installer_main_wrapper_').fadeOut('fast', function(){
        $('#_tomcat_installer_running_wrapper_').fadeIn('fast');
        checkInstallationProcess()
        setTimeout(function () {
        }, 2000);
    });
}
function clickTomcatUninstall(){
    $('#modal_tomcat_uninstall_confirm').modal('show');
}
function unistallTomCatComfirmed(elem) {
    handleButtons(elem, 'fa-check');
    sendUninstallTomCat(function () {
        $('#_tomcat_main_screen').fadeOut('fast', function(){
            $('#_tomcat_not_installed').fadeIn('fast');
        });
        $('#modal_tomcat_uninstall_confirm').modal('hide');
        $.gritter.add({
            title: '{{lang.LABTOMCAT83}}',
            text: '{{lang.LABTOMCAT86}}',
            time: 5500,
            close_icon: '',
            icon: 'icomoon-icon-power',
            class_name: 'success-notice'
        });
        handleButtons(elem, 'fa-check', true);   
    }, function () {
        handleButtons(elem, 'fa-check', true);
    });
}
function startTomcatServerNow(elem){
    handleButtons(elem, 'fa-play');
    sendTomCatServerStatus('start', function (response) {
        if (response.server_dashboard != false){
            renderDashboard(response);
            $('#_tomcat_mdashboard_not_running').fadeOut('fast', function(){
                $('#_tomcat_mdashboard_running').fadeIn('fast');
            });
            $('#_tab_button_apps').removeClass('disabled').find('a').attr("data-toggle","tab");
            $('#_tab_button_monitor').removeClass('disabled').find('a').attr("data-toggle","tab");
            $.gritter.add({
                title: '{{lang.LABTOMCAT83}}',
                text: '{{lang.LABTOMCAT152}}',
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'success-notice'
            });
        }else{
            $.gritter.add({
                title: '{{lang.LABTOMCAT82}}',
                text: '{{lang.LABTOMCAT150}}',
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'error-notice'
            });
        }
        handleButtons(elem, 'fa-play', true);
    }, function () {
        handleButtons(elem, 'fa-play', true);
    });
}
function clickStopTomCatSever(elem) {
    blockTomCatRunningUI(elem, 'fa-stop');
    sendTomCatServerStatus('stop', function (response) {
        if (response.server_dashboard == false) {
            onStopTomCatServer();
            $.gritter.add({
                title: '{{lang.LABTOMCAT83}}',
                text: '{{lang.LABTOMCAT153}}',
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'success-notice'
            });
        } else {
            $.gritter.add({
                title: '{{lang.LABTOMCAT82}}',
                text: '{{lang.LABTOMCAT151}}',
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'error-notice'
            });
        }
        handleButtons(elem, 'fa-stop', true);
        $('#_tomcat_mdashboard_running button').prop('disabled', false);
    }, function () {
        unBlockTomCatRunningUI(elem, 'fa-stop');
    });
}
function onStopTomCatServer() {
    $('#_tomcat_mdashboard_running').fadeOut('fast', function () {
        $('#_tomcat_mdashboard_not_running').fadeIn('fast');
    });
    console.log('OFICINA');
    $('#_tab_button_apps').addClass('disabled');
    //.find('a').removeAttr("data-toggle");
    //$('#_tab_button_monitor').addClass('disabled').find('a').removeAttr("data-toggle");
}
function blockTomCatRunningUI(elem, ico){
    handleButtons(elem, ico);
    $('#_tomcat_mdashboard_running button').prop('disabled', true);
    $('#_tab_button_apps').addClass('disabled').find('a').removeAttr("data-toggle");
    $('#_tab_button_monitor').addClass('disabled').find('a').removeAttr("data-toggle");
}
function unBlockTomCatRunningUI(elem, ico){
    handleButtons(elem, ico, true);
    $('#_tomcat_mdashboard_running button').prop('disabled', false);
    $('#_tab_button_apps').removeClass('disabled').find('a').attr("data-toggle", "tab");
    $('#_tab_button_monitor').removeClass('disabled').find('a').attr("data-toggle", "tab");
}
function clickRestartTomCatSever(elem) {
    blockTomCatRunningUI(elem, 'fa-refresh');
    sendTomCatServerStatus('start', function (response) {
        if (response.server_dashboard == false) {
            $.gritter.add({
                title: '{{lang.LABTOMCAT82}}',
                text: '{{lang.LABTOMCAT150}}',
                time: 3500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'error-notice'
            });
            onStopTomCatServer();
            handleButtons(elem, 'fa-refresh', true);
            $('#_tomcat_mdashboard_running button').prop('disabled', false);
        } else {
            $.gritter.add({
                title: '{{lang.LABTOMCAT83}}',
                text: '{{lang.LABTOMCAT154}}',
                time: 5500,
                close_icon: '',
                icon: 'icomoon-icon-power',
                class_name: 'success-notice'
            });
            unBlockTomCatRunningUI(elem, 'fa-refresh');
        }
    }, function () {
        unBlockTomCatRunningUI(elem, 'fa-refresh');
    });
}

function sendTomCatServerStatus(type, success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=tomcatserverstatus",
        data: "type=" + type,
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {

                success(resp_data);
                // 
            } else {
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABTOMCAT87}}';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABTOMCAT88}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendUninstallTomCat(success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=uninstall_tomcat",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {
                
                success();
                // 
            } else {
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '{{lang.LABTOMCAT87}}';
                    } else if (resp_data.code == 1) {
                        message_error = '{{lang.LABTOMCAT88}}';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function checkInstallationProcess(){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=tomcat_install_status",
        data : 'verbose=' +  ($('#modal_nvm_install_log').is(':visible') ? '1' : 0),
        complete: function(response){
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                setTimeout(function(){
                    checkInstallationProcess()
                }, 2000);
                return;
            }
            if(resp_data.hasOwnProperty('result') && resp_data.result === 'success'){
                installTomCatResponse(resp_data);
                return;
            }
            setTimeout(function(){
                checkInstallationProcess()
            }, 2000);
        }
    });
}
function setTomCatUserConfig(data, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager_manager&acc=save_usr_config",
        data: data,
        complete: function(response){
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if(resp_data.hasOwnProperty('status') && resp_data.status === 'success'){
                $.gritter.add({
                    title: '{{lang.LABTOMCAT83}}',
                    text: 'NodeJs User panel configurations saved',
                    time: 5500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'success-notice'
                });
                cleaner();
                // 
            }else{
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function setTomCatVerAsDefault(version, success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=set_as_default",
        data: 'version=' + version,
        complete: function(response){
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if(resp_data.hasOwnProperty('result') && resp_data.result === 'success'){
                $.gritter.add({
                    title: '{{lang.LABTOMCAT83}}',
                    text: '{{lang.LABTOMCAT84}}',
                    time: 5500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'success-notice'
                });
                success();
                // 
            }else{
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}
function sendInstallTomCatServer(version, success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=installtomcat",
        data: "version=" + version,
        complete: function(response){
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if(resp_data.hasOwnProperty('result') && resp_data.result === 'success'){
               
                success(resp_data);
                // 
            }else{
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}

/*function sendWholeDeletionRequest(success, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=whole_uninstall",
        complete: function(response){
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if(resp_data.hasOwnProperty('result') && resp_data.result === 'success'){
                $.gritter.add({
                    title: '{{lang.LABTOMCAT83}}',
                    text: 'CWP TomCat engine deleted!',
                    time: 5500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'success-notice'
                });
                success();
                // 
            }else{
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}*/

/*function sendInstallation(data_install, cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=install",
        data: data_install,
        complete: function(response){
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if(resp_data.hasOwnProperty('result') && resp_data.result === 'success'){
                $('#_tomcat_install_btn').fadeOut('fast', function(){
                    handleButtons('#_tomcat_install_btn', 'fa-plus', true);
                    $('#_tomcat_installing_log_loader').fadeIn('fast');
                    checkInstallationProcess()
                });
                // 
            }else{
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}*/
function loadAvailableVersionToInstall(cleaner){
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=version_availables",
        complete: function(response){
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if(resp_data.hasOwnProperty('result') && resp_data.result === 'success'){
                version_availables = resp_data.list;
                renderInstallableVersions();
                // $('#modal_nvm_install .hide-in-modal').fadeIn('fast');
                $('#_nvm_install_loader').slideUp('fast', function(){
                    $('#_nvm_install_version_list').slideDown('fast');
                    $('#modal_nvm_install .hide-in-modal').slideDown('fast');
                });
                // 
            }else{
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
            }
        }
    });
}

function verifyTab(elem) {
    if ($(elem).attr('href') === '#tomcat_apps_tab') {
        $('#_tomcat_main_col').attr('style', '');
        $('#_tomcat_main_col').addClass('col-md-12').removeClass('col-md-9');
        $('#_tomcat_info_col').hide();
    } else if ($('#_tab_button_apps').hasClass('active')) {
        $('#_tomcat_main_col').animate({
            width: msmc_width * .72,
        }, 300, function () {
            $('#_tomcat_main_col').addClass('col-md-9').removeClass('col-md-12');
            $('#_tomcat_info_col').show('fast');
        });
    }
}
function slideToggle(show, hide, callback) {
    $(hide).slideUp('fast', function () {
        if (typeof callback == 'function') {
            callback();
        }
        $(show).slideDown('fast');
    });
}
let msmc_width = null;
function RenderUserInForm(availability_users) {
    let users_select = '';
    let users_select_2 = '<option value="" selected>Select a user</option>';
    users_list.forEach(function (user) {
        let selected_user = availability_users.find(function(user_selected){
            return user_selected == user;
        }) !== undefined ? 'selected' : '';
        users_select += '<option value="' + user + '" ' + selected_user + '>' + user + '</option>';
        users_select_2 += '<option value="' + user + '">' + user + '</option>';
    });
    $('#_tomcat_users_select_availability_').html('<select name="_tomcat_availability_users_select_" multiple="" class="form-control" id="_tomcat_availability_users_select_">' +
        users_select +
        + '</select>');
    $('#_tomcat_app_user_owner_container_').html('<select name="_tomcat_app_user_owner_" class="form-control" id="_tomcat_app_user_owner_">' +
        users_select_2 +
        + '</select>');
    BindConfigTab();
    $("#_tomcat_app_user_owner_").select2({
        placeholder: "Select username",
        allowClear: true
    });
    $('#_tomcat_app_user_owner_').on('select2-selected', function (e) {
        getUserDomainsForTomcat(e.val);
    });
}
function setUsrConfig(usr_config){
    $('#_tomcat_conf_user_enabled_').prop('checked', usr_config.user_enabled);
    if (usr_config.user_enabled === true){
        $('#_tomcat_config_users_select_wrapper_').show();
        $('#_tomcat_availability_select_').val(usr_config.availability_type);
        if (usr_config.availability_type == "2"){
            //$('#mySelect2').val(usr_config.availability_users);
            //$('#mySelect2').trigger('change'); 
            $('#_tomcat_users_select_availability_').show();
        }
    }
}
$( document ).ready(function() {
    //renderDashboard();
    if(installing === true){
        checkInstallationProcess();
    }
    RenderUserInForm(usr_config.hasOwnProperty('availability_users') ? usr_config.availability_users : []);
    if(tomcat_installed){
        setUsrConfig(usr_config);
        loadTomCatAppList(function () {
            startTomcatAppList();
        });
    }
    setInputFilter(document.getElementById("_modal_tomcat_sessions_time_"), function (value) {
        return /^\d*$/.test(value); // Allow digits and '.' only, using a RegExp
    });
    setInputFilter(document.getElementById("_tomcat_app_context_path_"), function (value) {
        return /^[A-Za-z0-9_\/]*$/.test(value); // Allow digits and '.' only, using a RegExp
    });
});
{% include 'js/tomcat_apps.js' %}
{% include 'js/tomcat_monitor.js' %}
{% include 'js/file_explorer.js' %}
{% include 'js/tomcat_configurations.js' %}