let jvm_monitor_table = null;
function viewMoreServerInfo(elem) {
    if ($('.tomcat-server-info-item-hidden').is(':visible')) {
        $('.tomcat-server-info-item-hidden').fadeOut('fast');
        $(elem).text('{{lang.LABTOMCAT50}}');
    } else {
        $('.tomcat-server-info-item-hidden').fadeIn('fast');
        $(elem).text('{{lang.LABTOMCAT51}}');
    }
}
function renderJVMMonitor(jvm_monitor) {
    console.log('jvm_monitor', jvm_monitor);
    if (jvm_monitor.items.length > 0) {
        let html_content = '';
        let html_list = '';
        jvm_monitor.items.forEach(function (item) {
            html_content += '<tr>' +
                '<td>' + item.mem_pool + '</td>' +
                '<td>' + item.type + '</td>' +
                '<td>' + item.initial + '</td>' +
                '<td>' + item.total + '</td>' +
                '<td>' + item.max + '</td>' +
                '<td>' + item.used + '</td>' +
                '</tr>';
        })
        html_list = '<table style="margin-top: 2px !important;" class="table tomcat-jvm-monitor-table table-striped table-bordered table-hover">' +
            '<thead>' +
            '<tr role="row">' +
            '<th>{{lang.LABTOMCAT191}}</th>' +
            '<th>{{lang.LABTOMCAT192}}</th>' +
            '<th>{{lang.LABTOMCAT193}}</th>' +
            '<th>{{lang.LABTOMCAT194}}</th>' +
            //'<th style="width:85px">x{{lang.LABTOMCAT114}}</th>' +
            '<th>{{lang.LABTOMCAT195}}</th>' +
            '<th>{{lang.LABTOMCAT196}}</th>' +
            '</tr>' +
            '</thead>' +
            '<tbody id="contenttr">' +
            html_content +
            '</tbody>' +
            '</table>';
        $('#_tomcat_monitor_jvm_container_').html(html_list);
        jvm_monitor_table = $('.tomcat-jvm-monitor-table').DataTable({
            "autoWidth": false,
            "paging": false,
            "info": false,
            "bFilter": false
        });
    } else {
        //NO JVM MONITOR
    }
    $('#_tomcat_monitor_jvm_container_').append('<div class="tomcat-jvm-monitor-meminfo"><p>' +
        '{{lang.LABTOMCAT190}}: <span id="_tc_jvm_meminfo_free"></span>' +
        ' {{lang.LABTOMCAT197}}: <span id="_tc_jvm_meminfo_total"></span>' +
        ' {{lang.LABTOMCAT198}}: <span id="_tc_jvm_meminfo_max"></span>' +
        '</p></div>');
    $('#_tc_jvm_meminfo_free').text(jvm_monitor.mem_info.free);
    $('#_tc_jvm_meminfo_total').text(jvm_monitor.mem_info.total);
    $('#_tc_jvm_meminfo_max').text(jvm_monitor.mem_info.max);
}
function renderTomcatServerHttpConnectors(connectors) {
    let html_connectors = '';
    connectors.forEach(function (conn) {
        html_connectors += '<div class="conn-monitor-wrapper" id="_tomcat_monitor_' + conn.key + '_">' +
            '<div class="tomcat-heading tomcat-heading-gradient">' +
            '<h4>' + conn.name + ' Monitor</h4>' +
            '</div>' +
            '<div id="_tomcat_monitor_' + conn.key + '_container_">' +
            renderTcHttpConnectorsTable(conn) +
            '</div>' +
            '</div>';
    });
    $('#_tomcat_monitor_http_connectors_').html(html_connectors);
    connectors.forEach(function (conn) {
        $('.tomcat-' + conn.key + '-monitor-table').DataTable({
            "autoWidth": false,
            "paging": false,
            "info": false,
            "bFilter": false
        });
        setTimeout(function () {
            $('#_tomcat_monitor_' + conn.key + '_').fadeIn('fast');
        }, 300);
    });
}
function renderTcHttpConnectorsTable(conn) {
    if (conn.threads.length > 0) {
        let html_content = '';
        conn.threads.forEach(function (thread) {
            html_content = '<tr>' +
                '<td>' + thread.stage + '</td>' +
                '<td>' + thread.time + '</td>' +
                '<td>' + thread.b_sent + '</td>' +
                '<td>' + thread.b_recv + '</td>' +
                '<td>' + thread.client_forwarded + '</td>' +
                '<td>' + thread.client_actual + '</td>' +
                '<td>' + thread.vhost + '</td>' +
                '<td style="width:220px">' +
                '<div class="connector-request">' + thread.request + '</div>' +
                '</td>' +
                '</tr>';
        });
        return '<table style="margin-top: 2px !important;" class="table tomcat-' + conn.key + '-monitor-table table-striped table-bordered table-hover">' +
            '<thead>' +
            '<tr role="row">' +
            '<th>{{lang.LABTOMCAT200}}</th>' +
            '<th>{{lang.LABTOMCAT201}}</th>' +
            '<th>{{lang.LABTOMCAT202}}</th>' +
            '<th>{{lang.LABTOMCAT203}}</th>' +
            '<th>{{lang.LABTOMCAT204}}</th>' +
            '<th>{{lang.LABTOMCAT205}}</th>' +
            '<th>VHost</th>' +
            '<th>Request</th>' +
            '</tr>' +
            '</thead>' +
            '<tbody id="contenttr">' +
            html_content +
            '</tbody>' +
            '</table>' +
            '<div class="connector-monitor-info">' +
            '<p>{{lang.LABTOMCAT199}}: ' + conn.conn_info.max + ' {{lang.LABTOMCAT206}}: ' + conn.conn_info.count + ' {{lang.LABTOMCAT207}}: '
            + conn.conn_info.busy + ' {{lang.LABTOMCAT208}}: ' + conn.conn_info.kepp_a +
            '</p>' +
            '<p>{{lang.LABTOMCAT209}}: ' + conn.conn_info.max_time + ' {{lang.LABTOMCAT210}}: ' + conn.conn_info.proc_time +
            ' {{lang.LABTOMCAT211}}: ' + conn.conn_info.req_count + ' {{lang.LABTOMCAT212}}: ' + conn.conn_info.err_count + ' {{lang.LABTOMCAT213}}: ' +
            conn.conn_info.b_recv + ' {{lang.LABTOMCAT214}}: ' + conn.conn_info.b_sent +
            '</p>' +
            '</div>';
        //$('#_tomcat_monitor_' + conn.key + '_container_').html(html_list);   
    }
}
function clickMonitorTab() {
    if ($('#_tomcat_monitor_jvm_loader').length > 0) {
        getServerInfoStatus(function (server_info) {
            renderJVMMonitor(server_info.jvm_monitor);
            renderTomcatServerHttpConnectors(server_info.http_connectors);
        });
    } else {
        //SEND UPDATE DASHBOARD
    }
}
function getServerInfoStatus(success, cleaner) {
    $.ajax({
        type: "POST",
        url: "./loader_ajax.php?ajax=tomcat_manager&acc=monitor_status",
        complete: function (response) {
            let resp_data = {}
            try {
                resp_data = response.hasOwnProperty('responseJson') ? response.responseJson : JSON.parse(response.responseText);
            } catch (error) {
                $.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: '{{lang.LABTOMCAT81}}',
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });
                cleaner();
                return;
            }
            if (resp_data.hasOwnProperty('result') && resp_data.result === 'success') {

                success(resp_data);
                // 
            } else {
                let message_error = '{{lang.LABTOMCAT81}}';
                if (resp_data.hasOwnProperty('code')) {
                    if (resp_data.code == 2) {
                        message_error = '';
                    } else if (resp_data.code == 1) {
                        message_error = '';
                    }
                }
                /*$.gritter.add({
                    title: '{{lang.LABTOMCAT82}}',
                    text: message_error,
                    time: 3500,
                    close_icon: '',
                    icon: 'icomoon-icon-power',
                    class_name: 'error-notice'
                });*/
                cleaner();
            }
        }
    });
}