
var Base64 = {

    // private property
    _keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

    // public method for encoding
    encode : function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;

        input = Base64._utf8_encode(input);

        while (i < input.length) {

            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);

            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }

            output = output +
                this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
                this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

        }

        return output;
    },

    // public method for decoding
    decode : function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;

        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        while (i < input.length) {

            enc1 = this._keyStr.indexOf(input.charAt(i++));
            enc2 = this._keyStr.indexOf(input.charAt(i++));
            enc3 = this._keyStr.indexOf(input.charAt(i++));
            enc4 = this._keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

        }

        output = Base64._utf8_decode(output);

        return output;

    },

    // private method for UTF-8 encoding
    _utf8_encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    },

    // private method for UTF-8 decoding
    _utf8_decode : function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while ( i < utftext.length ) {

            c = utftext.charCodeAt(i);

            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }

        }

        return string;
    }

}
function createFile(){
    estatus='createFile';
    $("#home3").show();
    $("#home3li").show();
    $('#myTab a[href="#home3"]').tab('show'); // Select first ta b
}

function ShowDeleteConfirmModal(accion,path,valor,type,div){
    $('#_webserver_deleting_index_').val(path);
    $('#_webserver_deleting_valor_').val(valor);
    $('#_webserver_deleting_type_').val(type);
    $('#_webserver_deleting_div_').val(div);
    //$('#nameFileDelete').html(valor);
    $('#pathFileDelete').html('<b>Path:</b> '+path);
    $('#_webserver_delete_confirm_modal_').modal('show');
}
function executeDelete(){
    let path = $('#_webserver_deleting_index_').val();
    let valor = $('#_webserver_deleting_valor_').val();
    let type = $('#_webserver_deleting_type_').val();
    let div = $('#_webserver_deleting_div_').val();
    $('#_webserver_deleting_index_').val('');
    $('#_webserver_deleting_valor_').val('');
    $('#_webserver_deleting_type_').val('');
    $('#_webserver_deleting_div_').val('');
    $('#_webserver_delete_confirm_modal_').modal('hide');
    ediDele('delete',path,valor,type,div);
}
function changeDiv(idDiv,tipo){
    console.log(idDiv);
    var editor;
    if(tipo=='create'){
        $("#filesdiv"+idDiv).slideUp('slow');
        $("#formsdiv"+idDiv).show();
        if(idDiv=='nginx'){
            editor= editorNginx;
        }else if(idDiv=='httpd'){
            editor= editorHttpd;
        }else if(idDiv=='varnish'){
            editor= editorVarnish;
        }else if(idDiv=='phpfpm'){
            editor= editorPhpfpm;
        }
        editor.setSize(800, 600);
        editor.focus();
        editor.refresh();
    }else if(tipo=='cancel'){

        $("#formsdiv"+idDiv).slideUp('slow');
        $("#filesdiv"+idDiv).show();
    }
}
var tableHttpd='';
var tableNginx='';
var tableVarnish='';
var tablePhpfpm='';

//var tablesub='';

var estatus='createFile';
var editorNginx;
var editorHttpd;
var editorPhpfpm;
var editorVarnish;
var editorModal;
var elementos = ["nginx","varnish","httpd","phpfpm"];
$(document).ready(function(){
    $(".files").DataTable({
        "pageLength": 25,
        "columnDefs": [ {
            "targets": [3],
            "orderable": false
        } ]
    });
    $(".dataTables_filter input[type='search']").addClass('form-control');
    editorNginx = CodeMirror.fromTextArea(document.getElementById("contentEditnginx"), {
        value:" ",
        lineNumbers: true,
        matchBrackets: true,
        styleActiveLine: true,
        autoCloseTags: true,
        autofocus:true,
        mode: "application/x-httpd-php",
        extraKeys: {"Alt-F": "find"},
        autoCloseBrackets: true,
        lineWrapping : true
    });

    editorHttpd = CodeMirror.fromTextArea(document.getElementById("contentEdithttpd"), {
        value:" ",
        lineNumbers: true,
        matchBrackets: true,
        styleActiveLine: true,
        autoCloseTags: true,
        autofocus:true,
        mode: "application/x-httpd-php",
        extraKeys: {"Alt-F": "find"},
        autoCloseBrackets: true,
        lineWrapping : true
    });

    editorPhpfpm = CodeMirror.fromTextArea(document.getElementById("contentEditphpfpm"), {
        value:" ",
        lineNumbers: true,
        matchBrackets: true,
        styleActiveLine: true,
        autoCloseTags: true,
        autofocus:true,
        mode: "application/x-httpd-php",
        extraKeys: {"Alt-F": "find"},
        autoCloseBrackets: true,
        lineWrapping : true
    });

    editorVarnish = CodeMirror.fromTextArea(document.getElementById("contentEditvarnish"), {
        value:" ",
        lineNumbers: true,
        matchBrackets: true,
        styleActiveLine: true,
        autoCloseTags: true,
        autofocus:true,
        mode: "application/x-httpd-php",
        extraKeys: {"Alt-F": "find"},
        autoCloseBrackets: true,
        lineWrapping : true
    });
    editorModal = CodeMirror.fromTextArea(document.getElementById("contenedorTexto"), {
        value:" ",
        alineNumbers: true,
        matchBrackets: true,
        styleActiveLine: true,
        autoCloseTags: true,
        autofocus:true,
        mode: "application/x-httpd-php",
        extraKeys: {"Alt-F": "find"},
        autoCloseBrackets: true,
        lineWrapping : true
    });


    $("#myModal").addClass("modal");

    for(i=0;i<elementos.length;i++){
        $("#filesdiv"+elementos[i]).addClass("active in");
        $("#myTab"+elementos[i]).addClass("nav nav-tabs");
        //console.log("#myTab"+elementos[i]);
        $("#divPrincipal"+elementos[i]).addClass("tabs");
        $("#myTabContent"+elementos[i]).addClass("tab-content");
        $("#myTabContent"+elementos[i]).css("border","none");
    }

    $("#myTab").addClass("nav nav-tabs");
    $("#divPrincipal").addClass("tabs");
    $("#myTabContent2").addClass("tab-content");
    $('a .disabled').on('click', false);
});

function viewFile(path,nameFile){
    $.ajax({
        type: "POST",
        url: "loader_ajax.php\?ajax=WebServers_tpl_editor",
        data: "action=viewFile&archivo="+path,
        beforeSend: function (){
            muestraTransparenciaNuevo();
        },
        complete: function(datos){

            $("#myModal").removeClass("modal");
            editorModal.focus();
            editorModal.setValue(Base64.decode(datos.responseText));
            editorModal.refresh();
            editorModal.setSize(850, 500);
            $("#myModal").addClass("modal");
            $('#myModal').modal('show');
            $("#myModal #nameFile").html(nameFile);
            cierraTransparenciaNuevo();
        }
    });
}
function reloadEdit(){
    $("#home3").hide();
    $("#home3li").hide();
}

function buble(title,text,clase){
    $.gritter.add({
        title: title,
        text: text,
        time: '',
        //close_icon: 'entypo-icon-cancel s12',
        close_icon: '',
        icon: 'icomoon-icon-power',
        class_name: clase
    });
}
function reloadTable(tableName,name,type){
    $.ajax({
        type: "POST",
        url: "loader_ajax.php\?ajax=WebServers_tpl_editor",
        data: "action=reloadTable&name="+name+"&type="+type,
        beforeSend: function (){
            muestraTransparenciaNuevo();
        },
        complete: function(datos){
            cierraTransparenciaNuevo();
            $("#"+tableName).html(datos.responseText);
        }
    });
}
function ediDele(accion,path,valor,type,div){
    var original=accion;
    if(accion=='clone'){
        accion='edit';
    }
    var datosSend='';
    $("#formsdiv"+div+" :input").each(function(){
        if($(this).attr("id")!=undefined && $(this).attr("id")!="type" ){
            datosSend+=$(this).attr("id")+"="+$(this).val()+"&";
        }
    });

    if(original=='edit'){
        estatus='updateFile';
    }

    if(div=='nginx'){
        editor= editorNginx;
    }else if(div=='httpd'){
        editor= editorHttpd;
    }else if(div=='varnish'){
        editor= editorVarnish;
    }else if(div=='phpfpm'){
        editor= editorPhpfpm;
    }
    $.ajax({
        type: "POST",
        url: "loader_ajax.php\?ajax=WebServers_tpl_editor",
        data: "action="+accion+"File&archivo="+path+"&type="+encodeURI(type)+"&"+datosSend,
        beforeSend: function (){
            muestraTransparenciaNuevo();
            if(accion=='delete'){

            }else{
                changeDiv(div,'create');
                //$('#myTab'+div+' a[href="#formsdiv'+div+'"]').tab('show');
            }
        },
        complete: function(datos){
            cierraTransparenciaNuevo();
            if(accion=='delete'){
                //$("#"+div+"trLis"+valor).remove();
                reloadTable("tablediv"+div,div,type);
            }else{
                editor.focus();
                var myObj = JSON.parse(datos.responseText);

                for(i=0;i<myObj['records'].length;i++){
                    if(myObj['records'][i]['name']=='contentEdit'){

                        editor.focus();
                        if(myObj['records'][i]['value']==null){
                            editor.setValue(" ");
                        }else{
                            editor.setValue(Base64.decode(myObj['records'][i]['value']));
                        }
                        editor.refresh();
                        editor.focus();
                    }else{
                        $("#formsdiv"+div+" #"+myObj['records'][i]['name']).val(myObj['records'][i]['value']);
                    }
                }
                if(original=='edit'){

                    $("#fileFinal"+div).val(path);
                }else{
                    $("#formsdiv"+div+" #name_file").val('');
                }

            }

        }

    });
}
function cleanInput(tipo){
    $("#formsdiv"+tipo+" :input").each(function(){

        if($(this).attr("id")!=undefined && $(this).attr("id")!="template"){
            $(this).val("");
        }

    });
    if(tipo=='nginx'){
        editorNginx.setValue('');
        $("#fileFinal"+tipo).val('');
    }
    if(tipo=='phpfpm'){
        editorPhpfpm.setValue('');
        $("#fileFinal"+tipo).val('');
    }
    if(tipo=='httpd'){
        editorHttpd.setValue('');
        $("#fileFinal"+tipo).val('');

    }
    if(tipo=='varnish'){
        editorVarnish.setValue('');
        $("#fileFinal"+tipo).val('');
    }
}
function saveFile(tipo){

    var datosSend='';
    var typeDiv= $("#formsdiv"+tipo+" #type").val();
    $("#formsdiv"+tipo+" :input").each(function(){
        if($(this).attr("id")!=undefined){
            datosSend+=$(this).attr("id")+"="+$(this).val()+"&";
        }

    });

    if(tipo=='nginx'){
        datosSend+="contentEdit="+encodeURIComponent(editorNginx.getValue().replace(/\+/gi, "~~@@~~"))+"&fileFinal="+$("#fileFinal"+tipo).val();
    }
    if(tipo=='phpfpm'){
        datosSend+="contentEdit="+encodeURIComponent(editorPhpfpm.getValue().replace(/\+/gi, "~~@@~~"))+"&fileFinal="+$("#fileFinal"+tipo).val();
    }
    if(tipo=='httpd'){
        datosSend+="contentEdit="+encodeURIComponent(editorHttpd.getValue().replace(/\+/gi, "~~@@~~"))+"&fileFinal="+$("#fileFinal"+tipo).val();
    }
    if(tipo=='varnish'){
        datosSend+="contentEdit="+encodeURIComponent(editorVarnish.getValue().replace(/\+/gi, "~~@@~~"))+"&fileFinal="+$("#fileFinal"+tipo).val();
    }
    $.ajax({
        type: "POST",
        url: "loader_ajax.php?ajax=WebServers_tpl_editor",
        data: "action="+estatus+"&"+datosSend,
        beforeSend: function (){
            muestraTransparenciaNuevo();
        },
        complete: function(datos){
            estatus='createFile';
            reloadTable("tablediv"+tipo,tipo,typeDiv);
            cierraTransparenciaNuevo();
            buble("Success","File saved","success-notice");
            cleanInput(tipo);
            changeDiv('cancel',tipo);
        }
    });
}
function changeLock(ruta,nombre,id){

    if($("#locked_"+id).attr("checked")){
        var status='on';
    }else{
        var status='off';
    }
    if(status=='on'){
        $("#edit_"+id).addClass("disabled");
        $("#delete_"+id).addClass("disabled");
        $('a .disabled').on('click', false);
    }else{
        $("#edit_"+id).removeClass("disabled");
        $("#delete_"+id).removeClass("disabled");
        $('a .disabled').on('click', true);
    }

    $.ajax({
        type: "POST",
        url: "loader_ajax.php\?ajax=WebServers_tpl_editor",
        data: "action=changeStatus&ruta="+ruta+"&nombre="+nombre+"&status="+status,
        beforeSend: function (){
            muestraTransparenciaNuevo();
        },
        complete: function(datos){
            cierraTransparenciaNuevo();
        }
    });

}
function  muestraTransparenciaNuevo(){
    $("#transparenciaNuevo").css('display','block');
    $("#transparenciaMensajeNuevo").html('<img src="design/images/loader.gif">');
    $("#transparenciaMensajeNuevo").css('display','block');
}
function cierraTransparenciaNuevo(){
    $("#transparenciaNuevo").css('display','none');
}
