server {
	listen %ip%:%nginx_port%;	
	server_name %ip%;
	root %docroot%;
	index index.php index.html index.htm;
	access_log /usr/local/apache/domlogs/%ip%.bytes bytes;
	access_log /usr/local/apache/domlogs/%ip%.log combined;
	error_log /usr/local/apache/domlogs/%ip%.error.log error;

	location / {

		location ~.*\.(3gp|gif|jpg|jpeg|png|ico|wmv|avi|asf|asx|mpg|mpeg|mp4|pls|mp3|mid|wav|swf|flv|html|htm|txt|js|css|exe|zip|tar|rar|gz|tgz|bz2|uha|7z|doc|docx|xls|xlsx|pdf|iso|woff|ttf|svg|eot|sh)$ {			
			expires max;
		}
		
		location ~ [^/]\.php(/|$) {
			fastcgi_param SCRIPT_FILENAME $document_root$fastcgi_script_name;
			if (!-f $document_root$fastcgi_script_name) {
				return  404;
			}

			fastcgi_pass    %backend_fcgi%;
			fastcgi_index   index.php;
			include         /etc/nginx/fastcgi_params;
		}

	}

	location ~* "/\.(htaccess|htpasswd)$" {deny all;return 404;}

	disable_symlinks if_not_owner from=%docroot%;

	location /.well-known/acme-challenge {
		default_type "text/plain";
		alias /usr/local/apache/autossl_tmp/.well-known/acme-challenge;
	}

	location /pma {
		proxy_pass  https://127.0.0.1:2031;
		include proxy.inc;
	}

	location /roundcube {
		proxy_pass  https://127.0.0.1:2031;
		include proxy.inc;
	}
}
